encapsulated package CodegenC
"
  file:        CodegenC.mo
  package:     CodegenC
  description: Generated by Susan.
"

public import Tpl;

public import SimCode;
public import SimCodeUtil;
public import BackendDAE;
public import System;
public import Absyn;
public import DAE;
public import ClassInf;
public import SCode;
public import SCodeDump;
public import Util;
public import List;
public import ComponentReference;
public import Expression;
public import ExpressionDump;
public import Config;
public import Flags;
public import Settings;
public import Patternm;
public import Error;
public import Values;
public import ValuesUtil;
public import BackendQSS;
public import BackendVariable;
public import DAEDump;
public import Algorithm;
public import DAEUtil;
public import Types;
public import FMI;
public import HpcOmSimCodeMain;
public import HpcOmSimCode;
public import HpcOmMemory;
public import CodegenUtil;

protected function fun_34
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCode.Function> in_a_modelInfo_functions;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_functions, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.Function> a_modelInfo_functions;
      String a_fileNamePrefix;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelInfo_functions,
           a_fileNamePrefix )
      equation
        txt_0 = simulationParModelicaKernelsFile(Tpl.emptyTxt, a_fileNamePrefix, a_modelInfo_functions);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_kernels.cl"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_34;

public function translateModel
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      list<String> i_sc_externalFunctionIncludes;
      list<SimCode.RecordDeclaration> i_recordDecls;
      list<SimCode.Function> i_modelInfo_functions;
      list<DAE.Exp> i_literals;
      String i_fileNamePrefix;
      SimCode.SimCode i_sc;
      Boolean ret_15;
      Tpl.Text l_0__;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text txt_10;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      String ret_1;
      Tpl.Text l_target;

    case ( txt,
           (i_sc as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(functions = i_modelInfo_functions), fileNamePrefix = i_fileNamePrefix, literals = i_literals, recordDecls = i_recordDecls, externalFunctionIncludes = i_sc_externalFunctionIncludes)),
           a_guid )
      equation
        ret_1 = Config.simulationCodeTarget();
        l_target = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        System.tmpTickResetIndex(0, 2);
        txt_2 = simulationMakefile(Tpl.emptyTxt, Tpl.textString(l_target), i_sc);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(".makefile"));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
        txt_4 = simulationLiteralsFile(Tpl.emptyTxt, i_fileNamePrefix, i_literals);
        txt_5 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("_literals.h"));
        Tpl.textFile(txt_4, Tpl.textString(txt_5));
        txt_6 = simulationFunctionsHeaderFile(Tpl.emptyTxt, i_fileNamePrefix, i_modelInfo_functions, i_recordDecls);
        txt_7 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING("_functions.h"));
        Tpl.textFile(txt_6, Tpl.textString(txt_7));
        txt_8 = simulationFunctionsFile(Tpl.emptyTxt, i_fileNamePrefix, i_modelInfo_functions, i_sc_externalFunctionIncludes);
        txt_9 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("_functions.c"));
        Tpl.textFileConvertLines(txt_8, Tpl.textString(txt_9));
        txt_10 = recordsFile(Tpl.emptyTxt, i_fileNamePrefix, i_recordDecls);
        txt_11 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING("_records.c"));
        Tpl.textFile(txt_10, Tpl.textString(txt_11));
        txt_12 = simulationHeaderFile(Tpl.emptyTxt, i_sc, a_guid);
        txt_13 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING("_model.h"));
        Tpl.textFile(txt_12, Tpl.textString(txt_13));
        l_0__ = generateSimulationFiles(Tpl.emptyTxt, i_sc, a_guid, i_fileNamePrefix);
        ret_15 = Config.acceptParModelicaGrammar();
        txt = fun_34(txt, ret_15, i_modelInfo_functions, i_fileNamePrefix);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end translateModel;

protected function fun_36
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_simulationSettingsOpt;
  input String in_a_fileNamePrefix;
  input String in_a_guid;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simulationSettingsOpt, in_a_fileNamePrefix, in_a_guid, in_a_simCode)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      String a_guid;
      SimCode.SimCode a_simCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           NONE(),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix,
           a_guid,
           a_simCode )
      equation
        txt_0 = simulationInitFile(Tpl.emptyTxt, a_simCode, a_guid);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_init.xml"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_36;

protected function fun_37
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_init.xml"));
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_init.c"));
        ret_2 = System.covertTextFileToCLiteral(Tpl.textString(txt_0), Tpl.textString(txt_1));
        txt = Tpl.writeStr(txt, Tpl.booleanString(ret_2));
      then txt;
  end match;
end fun_37;

public function translateInitFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      String i_fileNamePrefix;
      SimCode.SimCode i_sc;
      Option<SimCode.SimulationSettings> i_simulationSettingsOpt;
      Boolean ret_3;
      String ret_2;
      Tpl.Text l_0___1;
      Tpl.Text l_0__;

    case ( txt,
           (i_sc as SimCode.SIMCODE(simulationSettingsOpt = i_simulationSettingsOpt, fileNamePrefix = i_fileNamePrefix)),
           a_guid )
      equation
        l_0__ = fun_36(Tpl.emptyTxt, i_simulationSettingsOpt, i_fileNamePrefix, a_guid, i_sc);
        ret_2 = Config.simCodeTarget();
        ret_3 = stringEq(ret_2, "JavaScript");
        l_0___1 = fun_37(Tpl.emptyTxt, ret_3, i_fileNamePrefix);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end translateInitFile;

protected function fun_39
  input Tpl.Text in_txt;
  input Option<SimCode.Function> in_a_mainFunction;
  input Tpl.Text in_a_filePrefix;
  input SimCode.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction, in_a_filePrefix, in_a_functionCode)
    local
      Tpl.Text txt;
      Tpl.Text a_filePrefix;
      SimCode.FunctionCode a_functionCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           NONE(),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_filePrefix,
           a_functionCode )
      equation
        txt_0 = functionsMakefile(Tpl.emptyTxt, a_functionCode);
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_filePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".makefile"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_39;

protected function fun_40
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCode.Function> in_a_functions;
  input Option<SimCode.Function> in_a_mainFunction;
  input Tpl.Text in_a_filePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_functions, in_a_mainFunction, in_a_filePrefix)
    local
      Tpl.Text txt;
      list<SimCode.Function> a_functions;
      Option<SimCode.Function> a_mainFunction;
      Tpl.Text a_filePrefix;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_functions,
           a_mainFunction,
           a_filePrefix )
      equation
        txt_0 = functionsParModelicaKernelsFile(Tpl.emptyTxt, Tpl.textString(a_filePrefix), a_mainFunction, a_functions);
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_filePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_kernels.cl"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_40;

public function translateFunctions
  input Tpl.Text in_txt;
  input SimCode.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionCode)
    local
      Tpl.Text txt;
      list<DAE.Exp> i_literals;
      list<String> i_externalFunctionIncludes;
      list<SimCode.RecordDeclaration> i_extraRecordDecls;
      list<SimCode.Function> i_functions;
      SimCode.FunctionCode i_functionCode;
      Option<SimCode.Function> i_mainFunction;
      String i_name;
      Boolean ret_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text l_0__;
      Tpl.Text l_filePrefix;

    case ( txt,
           (i_functionCode as SimCode.FUNCTIONCODE(name = i_name, mainFunction = i_mainFunction, functions = i_functions, extraRecordDecls = i_extraRecordDecls, externalFunctionIncludes = i_externalFunctionIncludes, literals = i_literals)) )
      equation
        System.tmpTickResetIndex(0, 2);
        l_filePrefix = Tpl.writeStr(Tpl.emptyTxt, i_name);
        l_0__ = fun_39(Tpl.emptyTxt, i_mainFunction, l_filePrefix, i_functionCode);
        txt_2 = functionsHeaderFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_mainFunction, i_functions, i_extraRecordDecls, i_externalFunctionIncludes);
        txt_3 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
        txt_4 = functionsFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_mainFunction, i_functions, i_literals);
        txt_5 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING(".c"));
        Tpl.textFileConvertLines(txt_4, Tpl.textString(txt_5));
        txt_6 = recordsFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_extraRecordDecls);
        txt_7 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING("_records.c"));
        Tpl.textFile(txt_6, Tpl.textString(txt_7));
        ret_8 = Config.acceptParModelicaGrammar();
        txt = fun_40(txt, ret_8, i_functions, i_mainFunction, l_filePrefix);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end translateFunctions;

protected function fun_42
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> i_timeEvents;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      String ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), timeEvents = i_timeEvents) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Simulation code for "));
        txt = CodegenUtil.dotPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" generated by the OpenModelica Compiler "));
        ret_0 = Settings.getVersionNr();
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(". */\n"));
        txt = variableDefinitions(txt, i_modelInfo, i_timeEvents);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_42;

public function simulationHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_42(txt, a_simCode);
end simulationHeaderFile;

protected function fun_44
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_35;
      Tpl.Text txt_34;
      Tpl.Text txt_33;
      Tpl.Text txt_32;
      Tpl.Text txt_31;
      Tpl.Text txt_30;
      Tpl.Text txt_29;
      Tpl.Text txt_28;
      Tpl.Text txt_27;
      Tpl.Text txt_26;
      Tpl.Text txt_25;
      Tpl.Text txt_24;
      Tpl.Text txt_23;
      Tpl.Text txt_22;
      Tpl.Text txt_21;
      Tpl.Text l_mixheader;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      Tpl.Text txt_16;
      Tpl.Text txt_15;
      Tpl.Text txt_14;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text txt_10;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix)),
           a_guid )
      equation
        txt_0 = simulationFile_exo(Tpl.emptyTxt, i_simCode, a_guid);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_01exo.c"));
        Tpl.textFileConvertLines(txt_0, Tpl.textString(txt_1));
        txt_2 = simulationFile_nls(Tpl.emptyTxt, i_simCode, a_guid);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("_02nls.c"));
        Tpl.textFileConvertLines(txt_2, Tpl.textString(txt_3));
        txt_4 = simulationFile_lsy(Tpl.emptyTxt, i_simCode, a_guid);
        txt_5 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("_03lsy.c"));
        Tpl.textFileConvertLines(txt_4, Tpl.textString(txt_5));
        txt_6 = simulationFile_set(Tpl.emptyTxt, i_simCode, a_guid);
        txt_7 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING("_04set.c"));
        Tpl.textFileConvertLines(txt_6, Tpl.textString(txt_7));
        txt_8 = simulationFile_evt(Tpl.emptyTxt, i_simCode, a_guid);
        txt_9 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("_05evt.c"));
        Tpl.textFileConvertLines(txt_8, Tpl.textString(txt_9));
        txt_10 = simulationFile_inz(Tpl.emptyTxt, i_simCode, a_guid);
        txt_11 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING("_06inz.c"));
        Tpl.textFileConvertLines(txt_10, Tpl.textString(txt_11));
        txt_12 = simulationFile_dly(Tpl.emptyTxt, i_simCode, a_guid);
        txt_13 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING("_07dly.c"));
        Tpl.textFileConvertLines(txt_12, Tpl.textString(txt_13));
        txt_14 = simulationFile_bnd(Tpl.emptyTxt, i_simCode, a_guid);
        txt_15 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_15 = Tpl.writeTok(txt_15, Tpl.ST_STRING("_08bnd.c"));
        Tpl.textFileConvertLines(txt_14, Tpl.textString(txt_15));
        txt_16 = simulationFile_alg(Tpl.emptyTxt, i_simCode, a_guid);
        txt_17 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_17 = Tpl.writeTok(txt_17, Tpl.ST_STRING("_09alg.c"));
        Tpl.textFileConvertLines(txt_16, Tpl.textString(txt_17));
        txt_18 = simulationFile_asr(Tpl.emptyTxt, i_simCode, a_guid);
        txt_19 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_19 = Tpl.writeTok(txt_19, Tpl.ST_STRING("_10asr.c"));
        Tpl.textFileConvertLines(txt_18, Tpl.textString(txt_19));
        l_mixheader = Tpl.emptyTxt;
        (txt_21, l_mixheader) = simulationFile_mix(Tpl.emptyTxt, i_simCode, a_guid, l_mixheader);
        txt_22 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_22 = Tpl.writeTok(txt_22, Tpl.ST_STRING("_11mix.c"));
        Tpl.textFileConvertLines(txt_21, Tpl.textString(txt_22));
        txt_23 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_23 = Tpl.writeTok(txt_23, Tpl.ST_STRING("_11mix.h"));
        Tpl.textFile(l_mixheader, Tpl.textString(txt_23));
        txt_24 = simulationFile_jac(Tpl.emptyTxt, i_simCode, a_guid);
        txt_25 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_25 = Tpl.writeTok(txt_25, Tpl.ST_STRING("_12jac.c"));
        Tpl.textFileConvertLines(txt_24, Tpl.textString(txt_25));
        txt_26 = simulationFile_jac_header(Tpl.emptyTxt, i_simCode, a_guid);
        txt_27 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_STRING("_12jac.h"));
        Tpl.textFile(txt_26, Tpl.textString(txt_27));
        txt_28 = simulationFile_opt(Tpl.emptyTxt, i_simCode, a_guid);
        txt_29 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_29 = Tpl.writeTok(txt_29, Tpl.ST_STRING("_13opt.c"));
        Tpl.textFileConvertLines(txt_28, Tpl.textString(txt_29));
        txt_30 = simulationFile_opt_header(Tpl.emptyTxt, i_simCode, a_guid);
        txt_31 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_31 = Tpl.writeTok(txt_31, Tpl.ST_STRING("_13opt.h"));
        Tpl.textFile(txt_30, Tpl.textString(txt_31));
        txt_32 = simulationFile_lnz(Tpl.emptyTxt, i_simCode, a_guid);
        txt_33 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_33 = Tpl.writeTok(txt_33, Tpl.ST_STRING("_14lnz.c"));
        Tpl.textFileConvertLines(txt_32, Tpl.textString(txt_33));
        txt_34 = simulationFile(Tpl.emptyTxt, i_simCode, a_guid);
        txt_35 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_35 = Tpl.writeTok(txt_35, Tpl.ST_STRING(".c"));
        Tpl.textFileConvertLines(txt_34, Tpl.textString(txt_35));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_44;

public function generateSimulationFiles
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_44(txt, a_simCode, a_guid);
end generateSimulationFiles;

protected function fun_46
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ExtObjInfo i_extObjInfo;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(extObjInfo = i_extObjInfo)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* External objects file */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionCallExternalObjectConstructors(txt, i_extObjInfo, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_1 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionCallExternalObjectDestructors(txt, i_extObjInfo, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_46;

public function simulationFile_exo
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_46(txt, a_simCode);
end simulationFile_exo;

protected function lm_48
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> i_jacobianEquations;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           ({(i_jacobianEquations, _, _)}, _, _, _, _, _, _) :: rest,
           a_modelNamePrefixStr )
      equation
        txt = functionNonLinearResiduals(txt, i_jacobianEquations, Tpl.textString(a_modelNamePrefixStr));
        txt = Tpl.nextIter(txt);
        txt = lm_48(txt, rest, a_modelNamePrefixStr);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr )
      equation
        txt = lm_48(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_48;

protected function fun_49
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_initialEquations;
      String i_simCode_fileNamePrefix;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      SimCode.SimCode i_simCode;
      Tpl.Text l_jacobianbody;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(jacobianMatrixes = i_jacobianMatrixes, fileNamePrefix = i_simCode_fileNamePrefix, initialEquations = i_initialEquations, parameterEquations = i_parameterEquations, allEquations = i_allEquations)) )
      equation
        l_modelNamePrefixStr = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_jacobianbody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                         "\n",
                                                                                         "\n"
                                                                                     }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_jacobianbody = lm_48(l_jacobianbody, i_jacobianMatrixes, l_modelNamePrefixStr);
        l_jacobianbody = Tpl.popIter(l_jacobianbody);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Non Linear Systems */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* dummy REAL_ATTRIBUTE */\n",
                                    "const REAL_ATTRIBUTE dummyREAL_ATTRIBUTE = omc_dummyRealAttribute;\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = functionNonLinearResiduals(txt, i_initialEquations, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = functionNonLinearResiduals(txt, i_parameterEquations, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = functionNonLinearResiduals(txt, i_allEquations, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_jacobianbody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionInitialNonLinearSystems(txt, i_initialEquations, i_parameterEquations, i_allEquations, i_jacobianMatrixes, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_49;

public function simulationFile_nls
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_49(txt, a_simCode);
end simulationFile_nls;

protected function fun_51
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_initialEquations;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, initialEquations = i_initialEquations, parameterEquations = i_parameterEquations, allEquations = i_allEquations, jacobianMatrixes = i_jacobianMatrixes)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Linear Systems */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionSetupLinearSystems(txt, i_initialEquations, i_parameterEquations, i_allEquations, i_jacobianMatrixes, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_1 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialLinearSystems(txt, i_initialEquations, i_parameterEquations, i_allEquations, i_jacobianMatrixes, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_51;

public function simulationFile_lsy
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_51(txt, a_simCode);
end simulationFile_lsy;

protected function fun_53
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> i_stateSets;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, stateSets = i_stateSets)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Initial State Set */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_11mix.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialStateSets(txt, i_stateSets, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_53;

public function simulationFile_set
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_53(txt, a_simCode);
end simulationFile_set;

protected function fun_55
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> i_discreteModelVars;
      list<BackendDAE.ZeroCrossing> i_relations;
      list<SimCode.SimEqSystem> i_equationsForZeroCrossings;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      list<BackendDAE.TimeEvent> i_timeEvents;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(timeEvents = i_timeEvents, zeroCrossings = i_zeroCrossings, equationsForZeroCrossings = i_equationsForZeroCrossings, relations = i_relations, discreteModelVars = i_discreteModelVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Events: Sample, Zero Crossings, Relations, Discrete Changes */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitSample(txt, i_timeEvents, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_1 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionZeroCrossing(txt, i_zeroCrossings, i_equationsForZeroCrossings, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_2 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionRelations(txt, i_relations, Tpl.textString(txt_2));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_3 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionCheckForDiscreteChanges(txt, i_discreteModelVars, Tpl.textString(txt_3));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_55;

public function simulationFile_evt
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_55(txt, a_simCode);
end simulationFile_evt;

protected function fun_57
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_removedInitialEquations;
      list<SimCode.SimEqSystem> i_initialEquations;
      Boolean i_useSymbolicInitialization;
      list<SimCode.SimEqSystem> i_residualEquations;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, residualEquations = i_residualEquations, useSymbolicInitialization = i_useSymbolicInitialization, initialEquations = i_initialEquations, removedInitialEquations = i_removedInitialEquations, parameterEquations = i_parameterEquations, allEquations = i_allEquations, jacobianMatrixes = i_jacobianMatrixes)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Initialization */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_11mix.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialResidual(txt, i_residualEquations, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt_1 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialEquations(txt, i_useSymbolicInitialization, i_initialEquations, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt_2 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionRemovedInitialEquations(txt, i_useSymbolicInitialization, i_removedInitialEquations, Tpl.textString(txt_2));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_3 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialMixedSystems(txt, i_initialEquations, i_parameterEquations, i_allEquations, i_jacobianMatrixes, Tpl.textString(txt_3));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_57;

public function simulationFile_inz
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_57(txt, a_simCode);
end simulationFile_inz;

protected function fun_59
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.DelayedExpression i_delayedExps;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(delayedExps = i_delayedExps)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Delay */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionStoreDelayed(txt, i_delayedExps, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_59;

public function simulationFile_dly
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_59(txt, a_simCode);
end simulationFile_dly;

protected function fun_61
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Equations */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_61;

public function simulationFile_eqs
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_61(txt, a_simCode);
end simulationFile_eqs;

protected function fun_63
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_maxValueEquations;
      list<SimCode.SimEqSystem> i_minValueEquations;
      list<SimCode.SimEqSystem> i_nominalValueEquations;
      list<SimCode.SimEqSystem> i_startValueEquations;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(startValueEquations = i_startValueEquations, nominalValueEquations = i_nominalValueEquations, minValueEquations = i_minValueEquations, maxValueEquations = i_maxValueEquations, parameterEquations = i_parameterEquations)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* update bound parameters and variable attributes (start, nominal, min, max) */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionUpdateBoundVariableAttributes(txt, i_startValueEquations, i_nominalValueEquations, i_minValueEquations, i_maxValueEquations, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_1 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionUpdateBoundParameters(txt, i_parameterEquations, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_63;

public function simulationFile_bnd
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_63(txt, a_simCode);
end simulationFile_bnd;

protected function fun_65
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> i_algebraicEquations;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(algebraicEquations = i_algebraicEquations)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Algebraic */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionAlgebraic(txt, i_algebraicEquations, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_65;

public function simulationFile_alg
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_65(txt, a_simCode);
end simulationFile_alg;

protected function fun_67
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_algorithmAndEquationAsserts;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(algorithmAndEquationAsserts = i_algorithmAndEquationAsserts)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Asserts */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionAssertsforCheck(txt, i_algorithmAndEquationAsserts, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_67;

public function simulationFile_asr
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_67(txt, a_simCode);
end simulationFile_asr;

protected function fun_69
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_a_simCode, in_a_header)
    local
      Tpl.Text txt;
      Tpl.Text a_header;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_initialEquations;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, initialEquations = i_initialEquations, parameterEquations = i_parameterEquations, allEquations = i_allEquations, jacobianMatrixes = i_jacobianMatrixes)),
           a_header )
      equation
        l_modelNamePrefixStr = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Mixed Systems */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_11mix.h\"\n"));
        (txt, a_header) = functionSetupMixedSystems(txt, i_initialEquations, i_parameterEquations, i_allEquations, i_jacobianMatrixes, a_header, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_header);

    case ( txt,
           _,
           a_header )
      then (txt, a_header);
  end match;
end fun_69;

public function simulationFile_mix
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;
  input Tpl.Text a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) := fun_69(txt, a_simCode, a_header);
end simulationFile_mix;

protected function fun_71
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix, jacobianMatrixes = i_jacobianMatrixes)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Jacobians */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_12jac.h\"\n"));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionAnalyticJacobians(txt, i_jacobianMatrixes, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_71;

public function simulationFile_jac
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_71(txt, a_simCode);
end simulationFile_jac;

protected function fun_73
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(jacobianMatrixes = i_jacobianMatrixes)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Jacobians */\n"));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = variableDefinitionsJacobians(txt, i_jacobianMatrixes, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_73;

public function simulationFile_jac_header
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_73(txt, a_simCode);
end simulationFile_jac_header;

protected function fun_75
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ClassAttributes> i_classAttributes;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix, classAttributes = i_classAttributes)) )
      equation
        l_modelNamePrefixStr = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Optimization */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = optimizationComponents(txt, i_classAttributes, i_simCode, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_75;

public function simulationFile_opt
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_75(txt, a_simCode);
end simulationFile_opt;

protected function fun_77
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)) )
      equation
        l_modelNamePrefixStr = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "  extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short*);\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short *, short *);\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_77;

public function simulationFile_opt_header
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_77(txt, a_simCode);
end simulationFile_opt_header;

protected function fun_79
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Linearization */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionlinearmodel(txt, i_modelInfo, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_79;

public function simulationFile_lnz
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_79(txt, a_simCode);
end simulationFile_lnz;

protected function fun_81
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_INIT();"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mmc_init_nogc();\n",
                                    "omc_alloc_interface = omc_alloc_interface_pooled;"
                                }, false));
      then txt;
  end match;
end fun_81;

protected function fun_82
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.simCodeTarget();
        ret_1 = stringEq(ret_0, "JavaScript");
        txt = fun_81(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mmc_init_nogc();\n",
                                    "omc_alloc_interface = omc_alloc_interface_pooled;"
                                }, false));
      then txt;
  end match;
end fun_82;

protected function fun_83
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Flags.isSet(Flags.PARMODAUTO);
        txt = fun_82(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mmc_init_nogc();\n",
                                    "omc_alloc_interface = omc_alloc_interface_pooled;"
                                }, false));
      then txt;
  end match;
end fun_83;

protected function fun_84
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PM_Model_init(\""));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", &simulation_data, functionODE_systems);"));
      then txt;
  end match;
end fun_84;

protected function fun_85
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;
  end match;
end fun_85;

protected function fun_86
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.profileAll();
        txt = fun_85(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_86;

protected function fun_87
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.profileSome();
        txt = fun_86(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("5"));
      then txt;
  end match;
end fun_87;

protected function fun_88
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_simulationSettingsOpt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simulationSettingsOpt)
    local
      Tpl.Text txt;
      String i_settings_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_settings_method)) )
      equation
        txt = Tpl.writeStr(txt, i_settings_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_88;

protected function fun_89
  input Tpl.Text in_txt;
  input Boolean in_a_useSymbolicInitialization;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useSymbolicInitialization)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_89;

protected function fun_90
  input Tpl.Text in_txt;
  input Boolean in_a_useHomotopy;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useHomotopy)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_90;

protected function fun_91
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("terminateHpcOmThreads();"));
      then txt;
  end match;
end fun_91;

protected function fun_92
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dump_times();"));
      then txt;
  end match;
end fun_92;

public function simulationFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      SimCode.DelayedExpression i_delayedExps;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Boolean i_useHomotopy;
      Boolean i_useSymbolicInitialization;
      String i_simCode_fileNamePrefix;
      Option<HpcOmSimCode.Schedule> i_hpcOmSchedule;
      Option<SimCode.SimulationSettings> i_simulationSettingsOpt;
      list<list<SimCode.SimEqSystem>> i_odeEquations;
      list<SimCode.SimWhenClause> i_whenClauses;
      list<SimCode.SimEqSystem> i_allEquations;
      SimCode.ModelInfo i_modelInfo;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Boolean ret_13;
      Boolean ret_12;
      Tpl.Text txt_11;
      Boolean ret_10;
      Tpl.Text l_mainBody;
      Boolean ret_8;
      Tpl.Text l_pminit;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      String ret_3;
      Boolean ret_2;
      Tpl.Text l_mainInit;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = (i_simCode_fileNamePrefix as i_fileNamePrefix), modelInfo = i_modelInfo, allEquations = i_allEquations, whenClauses = i_whenClauses, odeEquations = i_odeEquations, simulationSettingsOpt = i_simulationSettingsOpt, hpcOmSchedule = i_hpcOmSchedule, useSymbolicInitialization = i_useSymbolicInitialization, useHomotopy = i_useHomotopy, jacobianMatrixes = i_jacobianMatrixes, delayedExps = i_delayedExps)),
           a_guid )
      equation
        l_modelNamePrefixStr = CodegenUtil.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        ret_2 = Flags.isSet(Flags.HPCOM);
        ret_3 = Flags.getConfigString(Flags.HPCOM_CODE);
        ret_4 = stringEq(ret_3, "pthreads_spin");
        ret_5 = boolNot(ret_4);
        ret_6 = boolAnd(ret_2, ret_5);
        l_mainInit = fun_83(Tpl.emptyTxt, ret_6);
        l_mainInit = Tpl.writeTok(l_mainInit, Tpl.ST_STRING("omc_alloc_interface.init();"));
        ret_8 = Flags.isSet(Flags.PARMODAUTO);
        l_pminit = fun_84(Tpl.emptyTxt, ret_8, i_fileNamePrefix);
        l_mainBody = symbolName(Tpl.emptyTxt, Tpl.textString(l_modelNamePrefixStr), "setupDataStruc");
        l_mainBody = Tpl.writeTok(l_mainBody, Tpl.ST_LINE("(&simulation_data);\n"));
        l_mainBody = Tpl.writeText(l_mainBody, l_pminit);
        l_mainBody = Tpl.softNewLine(l_mainBody);
        l_mainBody = Tpl.writeTok(l_mainBody, Tpl.ST_STRING_LIST({
                                                  "simulation_data.threadData = threadData;\n",
                                                  "res = _main_SimulationRuntime(argc, argv, &simulation_data);"
                                              }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Main Simulation File */\n"));
        txt = simulationFileHeader(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#define prefixedName_performSimulation "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "performSimulation");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include <simulation/solver/perform_simulation.c>\n",
                                    "\n",
                                    "/* dummy VARINFO and FILEINFO */\n",
                                    "const FILE_INFO dummyFILE_INFO = omc_dummyFileInfo;\n",
                                    "const VAR_INFO dummyVAR_INFO = omc_dummyVarInfo;\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "int measure_time_flag = "
                                }, false));
        ret_10 = Config.profileHtml();
        txt = fun_87(txt, ret_10);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
        txt = functionInput(txt, i_modelInfo, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionOutput(txt, i_modelInfo, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionDAE(txt, i_allEquations, i_whenClauses, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_11 = fun_88(Tpl.emptyTxt, i_simulationSettingsOpt);
        (txt, txt_11) = functionODE(txt, i_odeEquations, txt_11, i_hpcOmSchedule, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* forward the main in the simulation runtime */\n",
                                    "extern int _main_SimulationRuntime(int argc, char**argv, DATA *data);\n",
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_13opt.h\"\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callExternalObjectConstructors");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callExternalObjectDestructors");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *_data);\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialNonLinearSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int nNonLinearSystems, NONLINEAR_SYSTEM_DATA *data);\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialLinearSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int nLinearSystems, LINEAR_SYSTEM_DATA *data);\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialMixedSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int nMixedSystems, MIXED_SYSTEM_DATA *data);\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initializeStateSets");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int nStateSets, STATE_SET_DATA* statesetData, DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionAlgebraics");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_storeDelayed");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "updateBoundVariableAttributes");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern const char* "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialResidualDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initial_residual");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, double* initialResiduals);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionRemovedInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "updateBoundParameters");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "checkForAsserts");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_ZeroCrossingsEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_ZeroCrossings");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, double* gout);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_updateRelations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, int evalZeroCross);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "checkForDiscreteChanges");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern const char* "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i, int **out_EquationIndexes);\n",
                                    "extern const char* "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i);\n",
                                    "extern void "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_initSample");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianG");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianA");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianB");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianC");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianD");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacG_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacA_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacB_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacC_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacD_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data);\n",
                                    "extern const char* "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short *);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short *, short *);\n",
                                    "extern int "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);\n",
                                    "\n",
                                    "struct OpenModelicaGeneratedFunctionCallbacks "
                                }, false));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callback");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int (*)(DATA *, void *)) "));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "performSimulation");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callExternalObjectConstructors");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callExternalObjectDestructors");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialNonLinearSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialLinearSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialMixedSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initializeStateSets");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionODE");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionAlgebraics");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionDAE");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "input_function");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "input_function_init");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "output_function");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_storeDelayed");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "updateBoundVariableAttributes");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialResidualDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initial_residual");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = fun_89(txt, i_useSymbolicInitialization);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* useSymbolicInitialization */,\n"));
        txt = fun_90(txt, i_useHomotopy);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* useHomotopy */,\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionRemovedInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "updateBoundParameters");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "checkForAsserts");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_ZeroCrossingsEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_ZeroCrossings");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_updateRelations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "checkForDiscreteChanges");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_initSample");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_G");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_A");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_B");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_C");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_D");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianG");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianA");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianB");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianC");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianD");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacG_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacA_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacB_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacC_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacD_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "pickUpBoundsForInputsInOptimization");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "};\n",
                                    "\n"
                                }, true));
        txt = functionInitializeDataStruc(txt, i_modelInfo, i_fileNamePrefix, a_guid, i_allEquations, i_jacobianMatrixes, i_delayedExps, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif\n",
                                    "\n",
                                    "static int rml_execution_failed()\n",
                                    "{\n",
                                    "  fflush(NULL);\n",
                                    "  fprintf(stderr, \"Execution failed!\\n\");\n",
                                    "  fflush(NULL);\n",
                                    "  return 1;\n",
                                    "}\n",
                                    "\n",
                                    "#if defined(threadData)\n",
                                    "#undef threadData\n",
                                    "#endif\n",
                                    "/* call the simulation runtime main from our main! */\n",
                                    "int main(int argc, char**argv)\n",
                                    "{\n",
                                    "  int res;\n",
                                    "  DATA simulation_data;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_mainInit);
        txt = Tpl.softNewLine(txt);
        (txt, l_mainBody) = mainTop(txt, l_mainBody, "https://trac.openmodelica.org/OpenModelica/newticket");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_12 = Flags.isSet(Flags.HPCOM);
        txt = fun_91(txt, ret_12);
        txt = Tpl.softNewLine(txt);
        ret_13 = Flags.isSet(Flags.PARMODAUTO);
        txt = fun_92(txt, ret_13);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fflush(NULL);\n",
                                    "EXIT(res);\n",
                                    "return res;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end simulationFile;

public function mainTop
  input Tpl.Text txt;
  input Tpl.Text a_mainBody;
  input String a_url;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_mainBody;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "{\n",
                                   "  MMC_TRY_TOP()\n",
                                   "\n",
                                   "  MMC_TRY_STACK()\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, a_mainBody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "MMC_ELSE()\n",
                                       "rml_execution_failed();\n",
                                       "fprintf(stderr, \"Stack overflow detected and was not caught.\\nSend us a bug report at "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_url);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\\n    Include the following trace:\\n\");\n",
                                       "printStacktraceMessages();\n",
                                       "fflush(NULL);\n",
                                       "return 1;\n",
                                       "MMC_CATCH_STACK()\n",
                                       "\n",
                                       "MMC_CATCH_TOP(return rml_execution_failed());\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_mainBody := a_mainBody;
end mainTop;

public function symbolName
  input Tpl.Text txt;
  input String a_modelNamePrefix;
  input String a_symbolName;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeStr(txt, a_modelNamePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeStr(out_txt, a_symbolName);
end symbolName;

protected function fun_96
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"ParModelica/auto/om_pm_interface.hpp\""));
      then txt;
  end match;
end fun_96;

protected function fun_97
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"util/omc_spinlock.h\""));
      then txt;
  end match;
end fun_97;

protected function fun_98
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define HPCOM"));
      then txt;
  end match;
end fun_98;

public function simulationFileHeader
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      Absyn.Path i_modelInfo_name;
      Boolean ret_4;
      Boolean ret_3;
      String ret_2;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), extObjInfo = SimCode.EXTOBJINFO(vars = _), fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Simulation code for "));
        txt = CodegenUtil.dotPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" generated by the OpenModelica Compiler "));
        ret_0 = Settings.getVersionNr();
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ". */\n",
                                    "\n",
                                    "#include \"openmodelica.h\"\n",
                                    "#include \"openmodelica_func.h\"\n",
                                    "#include \"simulation_data.h\"\n",
                                    "#include \"simulation/simulation_info_xml.h\"\n",
                                    "#include \"simulation/simulation_runtime.h\"\n",
                                    "#include \"util/omc_error.h\"\n",
                                    "#include \"simulation/solver/model_help.h\"\n",
                                    "#include \"simulation/solver/delay.h\"\n",
                                    "#include \"simulation/solver/linearSystem.h\"\n",
                                    "#include \"simulation/solver/nonlinearSystem.h\"\n",
                                    "#include \"simulation/solver/mixedSystem.h\"\n",
                                    "\n",
                                    "#include <assert.h>\n",
                                    "#include <string.h>\n",
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_model.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_literals.h\"\n",
                                    "\n"
                                }, true));
        ret_1 = Flags.isSet(Flags.PARMODAUTO);
        txt = fun_96(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_2 = Flags.getConfigString(Flags.HPCOM_CODE);
        ret_3 = stringEq(ret_2, "pthreads_spin");
        txt = fun_97(txt, ret_3);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_4 = Flags.isSet(Flags.HPCOM);
        txt = fun_98(txt, ret_4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(HPCOM) && !defined(_OPENMP)\n",
                                    "  #error \"HPCOM requires OpenMP or the results are wrong\"\n",
                                    "#endif\n",
                                    "#if defined(_OPENMP)\n",
                                    "  #include <omp.h>\n",
                                    "#else\n",
                                    "  /* dummy omp defines */\n",
                                    "  #define omp_get_max_threads() 1\n",
                                    "#endif\n",
                                    "\n",
                                    "#define threadData data->threadData\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFileHeader;

protected function fun_100
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_delayed)
    local
      Tpl.Text txt;
      Integer i_maxDelayedIndex;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(maxDelayedIndex = i_maxDelayedIndex) )
      equation
        txt = Tpl.writeStr(txt, intString(i_maxDelayedIndex));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_100;

protected function fun_101
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_fileNamePrefix;
  input String in_a_guid;
  input SimCode.DelayedExpression in_a_delayed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_fileNamePrefix, in_a_guid, in_a_delayed)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      String a_guid;
      SimCode.DelayedExpression a_delayed;
      Integer i_varInfo_numJacobians;
      Integer i_varInfo_numStateSets;
      Integer i_varInfo_numNonLinearSystems;
      Integer i_varInfo_numLinearSystems;
      Integer i_varInfo_numMixedSystems;
      Integer i_varInfo_numEquations;
      list<SimCode.Function> i_functions;
      Integer i_varInfo_numExternalObjects;
      Integer i_varInfo_numInitialResiduals;
      Integer i_varInfo_numInitialAlgorithms;
      Integer i_varInfo_numInitialEquations;
      Integer i_varInfo_numMathEventFunctions;
      Integer i_varInfo_numRelations;
      Integer i_varInfo_numTimeEvents;
      Integer i_varInfo_numZeroCrossings;
      Integer i_varInfo_numStringAliasVars;
      Integer i_varInfo_numBoolAliasVars;
      Integer i_varInfo_numIntAliasVars;
      Integer i_varInfo_numAlgAliasVars;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStringParamVars;
      Integer i_varInfo_numBoolParams;
      Integer i_varInfo_numIntParams;
      Integer i_varInfo_numParams;
      Integer i_varInfo_numStringAlgVars;
      Integer i_varInfo_numBoolAlgVars;
      Integer i_varInfo_numIntAlgVars;
      Integer i_varInfo_numOptimizeConstraints;
      Integer i_varInfo_numDiscreteReal;
      Integer i_varInfo_numAlgVars;
      Integer i_varInfo_numStateVars;
      String i_directory;
      Absyn.Path i_name;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numAlgVars = i_varInfo_numAlgVars, numDiscreteReal = i_varInfo_numDiscreteReal, numOptimizeConstraints = i_varInfo_numOptimizeConstraints, numIntAlgVars = i_varInfo_numIntAlgVars, numBoolAlgVars = i_varInfo_numBoolAlgVars, numStringAlgVars = i_varInfo_numStringAlgVars, numParams = i_varInfo_numParams, numIntParams = i_varInfo_numIntParams, numBoolParams = i_varInfo_numBoolParams, numStringParamVars = i_varInfo_numStringParamVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars, numAlgAliasVars = i_varInfo_numAlgAliasVars, numIntAliasVars = i_varInfo_numIntAliasVars, numBoolAliasVars = i_varInfo_numBoolAliasVars, numStringAliasVars = i_varInfo_numStringAliasVars, numZeroCrossings = i_varInfo_numZeroCrossings, numTimeEvents = i_varInfo_numTimeEvents, numRelations = i_varInfo_numRelations, numMathEventFunctions = i_varInfo_numMathEventFunctions, numInitialEquations = i_varInfo_numInitialEquations, numInitialAlgorithms = i_varInfo_numInitialAlgorithms, numInitialResiduals = i_varInfo_numInitialResiduals, numExternalObjects = i_varInfo_numExternalObjects, numEquations = i_varInfo_numEquations, numMixedSystems = i_varInfo_numMixedSystems, numLinearSystems = i_varInfo_numLinearSystems, numNonLinearSystems = i_varInfo_numNonLinearSystems, numStateSets = i_varInfo_numStateSets, numJacobians = i_varInfo_numJacobians), name = i_name, directory = i_directory, functions = i_functions),
           a_fileNamePrefix,
           a_guid,
           a_delayed )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData.modelName = \""));
        txt = CodegenUtil.dotPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData.modelFilePrefix = \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData.modelDir = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData.modelGUID = \"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\";\n",
                                    "#ifdef OPENMODELICA_XML_FROM_FILE_AT_RUNTIME\n",
                                    "data->modelData.initXMLData = NULL;\n",
                                    "data->modelData.modelDataXml.infoXMLData = NULL;\n",
                                    "#else\n",
                                    "data->modelData.initXMLData =\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init.c\"\n",
                                    ";\n",
                                    "data->modelData.modelDataXml.infoXMLData =\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.c\"\n",
                                    ";\n",
                                    "#endif\n",
                                    "\n",
                                    "data->modelData.nStates = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nVariablesReal = 2*"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numDiscreteReal));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOptimizeConstraints));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nDiscreteReal = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numDiscreteReal));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nVariablesInteger = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nVariablesBoolean = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nVariablesString = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nParametersReal = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nParametersInteger = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nParametersBoolean = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nParametersString = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringParamVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nInputVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nOutputVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData.nAliasReal = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nAliasInteger = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nAliasBoolean = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nAliasString = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData.nZeroCrossings = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numZeroCrossings));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nSamples = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numTimeEvents));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nRelations = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numRelations));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nMathEvents = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMathEventFunctions));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nInitEquations = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInitialEquations));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nInitAlgorithms = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInitialAlgorithms));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nInitResiduals = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInitialResiduals));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";    /* data->modelData.nInitEquations + data->modelData.nInitAlgorithms */\n",
                                    "data->modelData.nExtObjs = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numExternalObjects));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.modelDataXml.fileName = \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.xml\";\n",
                                    "data->modelData.modelDataXml.modelInfoXmlLength = 0;\n",
                                    "data->modelData.modelDataXml.nFunctions = "
                                }, false));
        ret_0 = listLength(i_functions);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.modelDataXml.nProfileBlocks = 0;\n",
                                    "data->modelData.modelDataXml.nEquations = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numEquations));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nMixedSystems = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMixedSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nLinearSystems = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nNonLinearSystems = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numNonLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nStateSets = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateSets));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nJacobians = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numJacobians));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.nOptimizeConstraints = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOptimizeConstraints));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData.nDelayExpressions = "
                                }, false));
        txt = fun_100(txt, a_delayed);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_101;

public function populateModelInfo
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input String a_fileNamePrefix;
  input String a_guid;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_symJacs;
  input SimCode.DelayedExpression a_delayed;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_101(txt, a_modelInfo, a_fileNamePrefix, a_guid, a_delayed);
end populateModelInfo;

public function functionInitializeDataStruc
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input String a_fileNamePrefix;
  input String a_guid;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_symJacs;
  input SimCode.DelayedExpression a_delayed;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "setupDataStruc");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n",
                                       "  assertStreamPrint(threadData,0!=data, \"Error while initialize Data\");\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("data->callback = &"));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "callback");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(";\n"));
  out_txt := populateModelInfo(out_txt, a_modelInfo, a_fileNamePrefix, a_guid, a_allEquations, a_symJacs, a_delayed);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitializeDataStruc;

public function functionSimProfDef
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_value;
  input Tpl.Text in_a_reverseProf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
algorithm
  (out_txt, out_a_reverseProf) :=
  match(in_txt, in_a_eq, in_a_value, in_a_reverseProf)
    local
      Tpl.Text txt;
      Integer a_value;
      Tpl.Text a_reverseProf;
      Integer i_index;

    case ( txt,
           SimCode.SES_MIXED(index = i_index),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData.equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           SimCode.SES_LINEAR(index = i_index),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData.equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           SimCode.SES_NONLINEAR(index = i_index),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData.equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           _,
           _,
           a_reverseProf )
      then (txt, a_reverseProf);
  end match;
end functionSimProfDef;

protected function lm_105
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_105(txt, rest);
      then txt;
  end match;
end lm_105;

protected function lm_106
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_numStateVars;
      SimCode.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numStateVars )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars", a_numStateVars);
        txt = Tpl.nextIter(txt);
        txt = lm_106(txt, rest, a_numStateVars);
      then txt;
  end match;
end lm_106;

protected function lm_107
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_numStateVars;
      SimCode.SimVar i_var;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        txt = globalDataVarDefine(txt, i_var, "realVars", ret_0);
        txt = Tpl.nextIter(txt);
        txt = lm_107(txt, rest, a_numStateVars);
      then txt;
  end match;
end lm_107;

protected function lm_108
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_numAlgVars;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numAlgVars, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_numAlgVars;
      Integer a_numStateVars;
      SimCode.SimVar i_var;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numAlgVars,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        ret_1 = intAdd(ret_0, a_numAlgVars);
        txt = globalDataVarDefine(txt, i_var, "realVars", ret_1);
        txt = Tpl.nextIter(txt);
        txt = lm_108(txt, rest, a_numAlgVars, a_numStateVars);
      then txt;
  end match;
end lm_108;

protected function lm_109
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_numDiscreteReal;
  input Integer in_a_numAlgVars;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numDiscreteReal, in_a_numAlgVars, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_numDiscreteReal;
      Integer a_numAlgVars;
      Integer a_numStateVars;
      SimCode.SimVar i_var;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numDiscreteReal,
           a_numAlgVars,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        ret_1 = intAdd(ret_0, a_numAlgVars);
        ret_2 = intAdd(ret_1, a_numDiscreteReal);
        txt = globalDataVarDefine(txt, i_var, "realVars", ret_2);
        txt = Tpl.nextIter(txt);
        txt = lm_109(txt, rest, a_numDiscreteReal, a_numAlgVars, a_numStateVars);
      then txt;
  end match;
end lm_109;

protected function lm_110
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_110(txt, rest);
      then txt;
  end match;
end lm_110;

protected function lm_111
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "extObjs");
        txt = Tpl.nextIter(txt);
        txt = lm_111(txt, rest);
      then txt;
  end match;
end lm_111;

protected function lm_112
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "integerVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_112(txt, rest);
      then txt;
  end match;
end lm_112;

protected function lm_113
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_113(txt, rest);
      then txt;
  end match;
end lm_113;

protected function lm_114
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "booleanVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_114(txt, rest);
      then txt;
  end match;
end lm_114;

protected function lm_115
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_115(txt, rest);
      then txt;
  end match;
end lm_115;

protected function lm_116
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "stringVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_116(txt, rest);
      then txt;
  end match;
end lm_116;

protected function lm_117
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_117(txt, rest);
      then txt;
  end match;
end lm_117;

protected function fun_118
  input Tpl.Text in_txt;
  input BackendDAE.TimeEvent in_a_timeEvent;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_timeEvent)
    local
      Tpl.Text txt;
      Integer i_index;
      Integer ret_0;

    case ( txt,
           BackendDAE.SAMPLE_TIME_EVENT(index = i_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define $P$sample"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo.samples["));
        ret_0 = intSub(i_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_118;

protected function lm_119
  input Tpl.Text in_txt;
  input list<BackendDAE.TimeEvent> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> rest;
      BackendDAE.TimeEvent i_timeEvent;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_timeEvent :: rest )
      equation
        txt = fun_118(txt, i_timeEvent);
        txt = Tpl.nextIter(txt);
        txt = lm_119(txt, rest);
      then txt;
  end match;
end lm_119;

protected function lm_120
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> rest;
      Integer x_i0;
      SimCode.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = functionName(txt, i_fn, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_index "));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_120(txt, rest);
      then txt;
  end match;
end lm_120;

protected function fun_121
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input list<BackendDAE.TimeEvent> in_a_timeEvents;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_timeEvents)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> a_timeEvents;
      list<SimCode.Function> i_functions;
      list<SimCode.SimVar> i_vars_stringParamVars;
      list<SimCode.SimVar> i_vars_stringAlgVars;
      list<SimCode.SimVar> i_vars_boolParamVars;
      list<SimCode.SimVar> i_vars_boolAlgVars;
      list<SimCode.SimVar> i_vars_intParamVars;
      list<SimCode.SimVar> i_vars_intAlgVars;
      list<SimCode.SimVar> i_vars_extObjVars;
      list<SimCode.SimVar> i_vars_paramVars;
      Integer i_numDiscreteReal;
      list<SimCode.SimVar> i_vars_realOptimizeConstraintsVars;
      Integer i_numAlgVars;
      list<SimCode.SimVar> i_vars_discreteAlgVars;
      list<SimCode.SimVar> i_vars_algVars;
      Integer i_numStateVars;
      list<SimCode.SimVar> i_vars_derivativeVars;
      list<SimCode.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_numStateVars, numAlgVars = i_numAlgVars, numDiscreteReal = i_numDiscreteReal), vars = SimCode.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, realOptimizeConstraintsVars = i_vars_realOptimizeConstraintsVars, paramVars = i_vars_paramVars, extObjVars = i_vars_extObjVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars), functions = i_functions),
           a_timeEvents )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#define time data->localData[0]->timeValue\n",
                                    "\n",
                                    "/* States */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_105(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* StatesDerivatives */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_106(txt, i_vars_derivativeVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Non Discrete Real Algebraic Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_107(txt, i_vars_algVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Discrete Real Algebraic Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_108(txt, i_vars_discreteAlgVars, i_numAlgVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Nonlinear Constraints For Optimization */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_109(txt, i_vars_realOptimizeConstraintsVars, i_numDiscreteReal, i_numAlgVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Parameter */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_110(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* External Objects */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_111(txt, i_vars_extObjVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Integer Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_112(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Integer Parameter */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_113(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Boolean Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_114(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Boolean Parameters */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_115(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic String Variables */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_116(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic String Parameter */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_117(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* sample */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_119(txt, a_timeEvents);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_120(txt, i_functions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_121;

public function variableDefinitions
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input list<BackendDAE.TimeEvent> a_timeEvents;

  output Tpl.Text out_txt;
algorithm
  System.tmpTickReset(1000);
  out_txt := fun_121(txt, a_modelInfo, a_timeEvents);
end variableDefinitions;

protected function lm_123
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> rest;
      SimCode.Function i_fn;
      Absyn.Info ret_1;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        ret_0 = System.tmpTick();
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = functionName(txt, i_fn, true);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",{"));
        ret_1 = SimCodeUtil.functionInfo(i_fn);
        txt = infoArgs(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}}"));
        txt = Tpl.nextIter(txt);
        txt = lm_123(txt, rest);
      then txt;
  end match;
end lm_123;

protected function fun_124
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_a_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> i_items;
      Integer ret_0;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const struct FUNCTION_INFO funcInfo[1] = {{-1,\"\",omc_dummyFileInfo}};"));
      then txt;

    case ( txt,
           i_items )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const struct FUNCTION_INFO funcInfo["));
        ret_0 = listLength(i_items);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_123(txt, i_items);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_124;

public function globalDataFunctionInfoArray
  input Tpl.Text txt;
  input String a_name;
  input list<SimCode.Function> a_items;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_124(txt, a_items);
end globalDataFunctionInfoArray;

public function globalDataParDefine
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      DAE.ComponentRef i_name;
      Integer i_index;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCode.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCode.NOALIAS(), index = i_index, name = i_name),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n",
                                    "/* "
                                }, false));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].attribute\n",
                                    "#define $P$ATTRIBUTE$P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define _"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) "));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].info\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           SimCode.SIMVAR(aliasvar = SimCode.NOALIAS(), name = i_name, index = i_index),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define _"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) "));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].attribute\n",
                                    "#define $P$ATTRIBUTE$P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].info\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end globalDataParDefine;

public function globalDataVarDefine
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input String in_a_arrayName;
  input Integer in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_arrayName, in_a_offset)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer a_offset;
      DAE.ComponentRef i_name;
      Integer i_index;
      DAE.ComponentRef i_c;
      Integer ret_14;
      Integer ret_13;
      Integer ret_12;
      Integer ret_11;
      Integer ret_10;
      Integer ret_9;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_tmp;

    case ( txt,
           SimCode.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCode.NOALIAS(), index = i_index, name = i_name),
           a_arrayName,
           a_offset )
      equation
        ret_1 = System.tmpTick();
        l_tmp = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define _"
                                }, false));
        txt = cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->localData[i]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_2 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define $P$PRE"
                                }, false));
        txt = cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Pre["));
        ret_3 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n",
                                    "/* "
                                }, false));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define _"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->localData[i]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_4 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define $P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Pre["));
        ret_5 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        ret_6 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].attribute\n",
                                    "#define $P$ATTRIBUTE$P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        ret_7 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_7));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].info\n",
                                    "#define $P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        ret_8 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].info\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           SimCode.SIMVAR(aliasvar = SimCode.NOALIAS(), name = i_name, index = i_index),
           a_arrayName,
           a_offset )
      equation
        ret_9 = System.tmpTick();
        l_tmp = Tpl.writeStr(Tpl.emptyTxt, intString(ret_9));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define _"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->localData[i]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_10 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_10));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define $P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Pre["));
        ret_11 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_11));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        ret_12 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_12));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].attribute\n",
                                    "#define $P$ATTRIBUTE$P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        ret_13 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_13));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].info\n",
                                    "#define $P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo data->modelData."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        ret_14 = intAdd(a_offset, i_index);
        txt = Tpl.writeStr(txt, intString(ret_14));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].info\n",
                                    "#define _$P$PRE"
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) $P$PRE"));
        txt = cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end globalDataVarDefine;

protected function lm_128
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer i_index;
      SimCode.AliasVariable i_aliasvar;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SIMVAR(aliasvar = i_aliasvar, index = i_index) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = aliasVarNameType(txt, i_aliasvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        txt = lm_128(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_128(txt, rest);
      then txt;
  end match;
end lm_128;

protected function fun_129
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_a_items;
  input String in_a_0__type;
  input String in_a_0__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_items, in_a_0__type, in_a_0__name)
    local
      Tpl.Text txt;
      String a_0__type;
      String a_0__name;
      list<SimCode.SimVar> i_items;
      Integer ret_0;

    case ( txt,
           {},
           a_0__type,
           a_0__name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_0__type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_0__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("[1] = {{0,0,-1}};"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           i_items,
           a_0__type,
           a_0__name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_0__type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_0__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_0 = listLength(i_items);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_128(txt, i_items);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_129;

public function globalDataAliasVarArray
  input Tpl.Text txt;
  input String a_0__type;
  input String a_0__name;
  input list<SimCode.SimVar> a_items;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_129(txt, a_items, a_0__type, a_0__name);
end globalDataAliasVarArray;

protected function fun_131
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer i_index;
      DAE.ComponentRef i_name;
      Integer ret_1;
      Tpl.Text l_tmp;

    case ( txt,
           SimCode.SIMVAR(name = i_name, index = i_index),
           a_arrayName )
      equation
        ret_1 = System.tmpTick();
        l_tmp = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_131;

public function variableDefinitionsOptimizationsConstraints
  input Tpl.Text txt;
  input SimCode.SimVar a_simVar;
  input String a_arrayName;
  input Integer a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_131(txt, a_simVar, a_arrayName);
end variableDefinitionsOptimizationsConstraints;

protected function lm_133
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      list<SimCode.SimVar> i_diffedVars;
      list<SimCode.SimVar> i_diffVars;
      String i_name;
      list<SimCode.SimVar> i_seedVars;
      list<SimCode.JacobianColumn> i_jacColumn;
      Integer i_indexJacobian;
      Tpl.Text l_sparseDef;
      Tpl.Text l_varsDef;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_jacColumn, i_seedVars, i_name, (_, (i_diffVars, i_diffedVars)), _, _, i_indexJacobian) :: rest,
           a_modelNamePrefix )
      equation
        l_varsDef = variableDefinitionsJacobians2(Tpl.emptyTxt, i_indexJacobian, i_jacColumn, i_seedVars, i_name);
        l_sparseDef = defineSparseIndexes(Tpl.emptyTxt, i_diffVars, i_diffedVars, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = symbolName(txt, a_modelNamePrefix, "INDEX_JAC_");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(i_indexJacobian));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_column(void* data);\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(void* data);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varsDef);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseDef);
        txt = Tpl.nextIter(txt);
        txt = lm_133(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_133;

public function variableDefinitionsJacobians
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_analyticVars;
algorithm
  l_analyticVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_analyticVars := lm_133(l_analyticVars, a_JacobianMatrixes, a_modelNamePrefix);
  l_analyticVars := Tpl.popIter(l_analyticVars);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* Jacobian Variables */\n"));
  out_txt := Tpl.writeText(out_txt, l_analyticVars);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end variableDefinitionsJacobians;

protected function lm_135
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input String in_a_name;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name, in_a_indexJacobian)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      String a_name;
      Integer a_indexJacobian;
      Integer x_index0;
      SimCode.SimVar i_var;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_name,
           a_indexJacobian )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = jacobianVarDefine(txt, i_var, "jacobianVarsSeed", a_indexJacobian, x_index0, a_name);
        txt = Tpl.nextIter(txt);
        txt = lm_135(txt, rest, a_name, a_indexJacobian);
      then txt;
  end match;
end lm_135;

protected function lm_136
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input String in_a_name;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name, in_a_indexJacobian)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      String a_name;
      Integer a_indexJacobian;
      Integer x_index0;
      SimCode.SimVar i_var;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_name,
           a_indexJacobian )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = jacobianVarDefine(txt, i_var, "jacobianVars", a_indexJacobian, x_index0, a_name);
        txt = Tpl.nextIter(txt);
        txt = lm_136(txt, rest, a_name, a_indexJacobian);
      then txt;
  end match;
end lm_136;

protected function lm_137
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input String in_a_name;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name, in_a_indexJacobian)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String a_name;
      Integer a_indexJacobian;
      list<SimCode.SimVar> i_vars;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           (_, i_vars, _) :: rest,
           a_name,
           a_indexJacobian )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_136(txt, i_vars, a_name, a_indexJacobian);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_137(txt, rest, a_name, a_indexJacobian);
      then txt;
  end match;
end lm_137;

public function variableDefinitionsJacobians2
  input Tpl.Text txt;
  input Integer a_indexJacobian;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCode.SimVar> a_seedVars;
  input String a_name;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_columnVarsResult;
  Tpl.Text l_seedVarsResult;
algorithm
  l_seedVarsResult := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_seedVarsResult := lm_135(l_seedVarsResult, a_seedVars, a_name, a_indexJacobian);
  l_seedVarsResult := Tpl.popIter(l_seedVarsResult);
  l_columnVarsResult := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                        "\n",
                                                                                        "\n"
                                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_columnVarsResult := lm_137(l_columnVarsResult, a_jacobianColumn, a_name, a_indexJacobian);
  l_columnVarsResult := Tpl.popIter(l_columnVarsResult);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(" */\n"));
  out_txt := Tpl.writeText(out_txt, l_seedVarsResult);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_columnVarsResult);
end variableDefinitionsJacobians2;

protected function fun_139
  input Tpl.Text in_txt;
  input Integer in_a_index;
  input Integer in_a_index0;
  input Integer in_a_indexJac;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_index, in_a_index0, in_a_indexJac, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index0;
      Integer a_indexJac;
      DAE.ComponentRef a_name;
      Integer i_index;

    case ( txt,
           -1,
           a_index0,
           a_indexJac,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define _"));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->simulationInfo.analyticJacobians["));
        txt = Tpl.writeStr(txt, intString(a_indexJac));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].tmpVars["));
        txt = Tpl.writeStr(txt, intString(a_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define "
                                }, false));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__varInfo dummyVAR_INFO\n",
                                    "#define $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" dummyREAL_ATTRIBUTE"));
      then txt;

    case ( txt,
           i_index,
           _,
           a_indexJac,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define _"));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->simulationInfo.analyticJacobians["));
        txt = Tpl.writeStr(txt, intString(a_indexJac));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].resultVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define "
                                }, false));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__varInfo dummyVAR_INFO\n",
                                    "#define $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" dummyREAL_ATTRIBUTE"));
      then txt;
  end match;
end fun_139;

protected function fun_140
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input Integer in_a_index0;
  input Integer in_a_indexJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_index0, in_a_indexJac)
    local
      Tpl.Text txt;
      Integer a_index0;
      Integer a_indexJac;
      DAE.ComponentRef i_name;
      Integer i_index;

    case ( txt,
           SimCode.SIMVAR(aliasvar = SimCode.NOALIAS(), name = i_name, index = i_index),
           a_index0,
           a_indexJac )
      equation
        txt = fun_139(txt, i_index, a_index0, a_indexJac, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_140;

protected function fun_141
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input Integer in_a_index0;
  input Integer in_a_indexJac;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_index0, in_a_indexJac, in_a_matrixName)
    local
      Tpl.Text txt;
      Integer a_index0;
      Integer a_indexJac;
      String a_matrixName;
      DAE.ComponentRef i_name;
      Integer ret_1;
      Tpl.Text l_tmp;

    case ( txt,
           SimCode.SIMVAR(aliasvar = SimCode.NOALIAS(), name = i_name),
           a_index0,
           a_indexJac,
           a_matrixName )
      equation
        ret_1 = System.tmpTick();
        l_tmp = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo.analyticJacobians["));
        txt = Tpl.writeStr(txt, intString(a_indexJac));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].seedVars["));
        txt = Tpl.writeStr(txt, intString(a_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo dummyVAR_INFO"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_141;

protected function fun_142
  input Tpl.Text in_txt;
  input String in_a_array;
  input SimCode.SimVar in_a_simVar;
  input Integer in_a_indexJac;
  input Integer in_a_index0;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_array, in_a_simVar, in_a_indexJac, in_a_index0, in_a_matrixName)
    local
      Tpl.Text txt;
      SimCode.SimVar a_simVar;
      Integer a_indexJac;
      Integer a_index0;
      String a_matrixName;

    case ( txt,
           "jacobianVars",
           a_simVar,
           a_indexJac,
           a_index0,
           _ )
      equation
        txt = fun_140(txt, a_simVar, a_index0, a_indexJac);
      then txt;

    case ( txt,
           "jacobianVarsSeed",
           a_simVar,
           a_indexJac,
           a_index0,
           a_matrixName )
      equation
        txt = fun_141(txt, a_simVar, a_index0, a_indexJac, a_matrixName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_142;

public function jacobianVarDefine
  input Tpl.Text txt;
  input SimCode.SimVar a_simVar;
  input String a_array;
  input Integer a_indexJac;
  input Integer a_index0;
  input String a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_142(txt, a_array, a_simVar, a_indexJac, a_index0, a_matrixName);
end jacobianVarDefine;

protected function lm_144
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixName)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      String a_matrixName;
      Integer x_index0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest,
           a_matrixName )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$indexdiff "));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.nextIter(txt);
        txt = lm_144(txt, rest, a_matrixName);
      then txt;

    case ( txt,
           _ :: rest,
           a_matrixName )
      equation
        txt = lm_144(txt, rest, a_matrixName);
      then txt;
  end match;
end lm_144;

protected function lm_145
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixName)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      String a_matrixName;
      Integer x_index0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest,
           a_matrixName )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$indexdiffed "));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.nextIter(txt);
        txt = lm_145(txt, rest, a_matrixName);
      then txt;

    case ( txt,
           _ :: rest,
           a_matrixName )
      equation
        txt = lm_145(txt, rest, a_matrixName);
      then txt;
  end match;
end lm_145;

public function defineSparseIndexes
  input Tpl.Text txt;
  input list<SimCode.SimVar> a_diffVars;
  input list<SimCode.SimVar> a_diffedVars;
  input String a_matrixName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_diffedVarsResult;
  Tpl.Text l_diffVarsResult;
algorithm
  l_diffVarsResult := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_diffVarsResult := lm_144(l_diffVarsResult, a_diffVars, a_matrixName);
  l_diffVarsResult := Tpl.popIter(l_diffVarsResult);
  l_diffedVarsResult := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_diffedVarsResult := lm_145(l_diffedVarsResult, a_diffedVars, a_matrixName);
  l_diffedVarsResult := Tpl.popIter(l_diffedVarsResult);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(" sparse indexes */\n"));
  out_txt := Tpl.writeText(out_txt, l_diffVarsResult);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_diffedVarsResult);
end defineSparseIndexes;

public function aliasVarNameType
  input Tpl.Text in_txt;
  input SimCode.AliasVariable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_varName;

    case ( txt,
           SimCode.NOALIAS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0,0"));
      then txt;

    case ( txt,
           SimCode.ALIAS(varName = i_varName) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = cref(txt, i_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",0"));
      then txt;

    case ( txt,
           SimCode.NEGATEDALIAS(varName = i_varName) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = cref(txt, i_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end aliasVarNameType;

protected function lm_148
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.ComponentRef i_var_name;
      DAE.Exp i_exp;
      Tpl.Text l_arg;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           SimCode.SIMVAR(initialValue = SOME(i_exp), name = i_var_name) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_arg, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextOther, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = cref(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_arg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_148(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_148(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_148;

protected function lm_149
  input Tpl.Text in_txt;
  input list<SimCode.ExtAlias> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.ExtAlias> rest;
      DAE.ComponentRef i_var2;
      DAE.ComponentRef i_var1;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var1, i_var2) :: rest )
      equation
        txt = cref(txt, i_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = cref(txt, i_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_149(txt, rest);
      then txt;
  end match;
end lm_149;

public function functionCallExternalObjectConstructors
  input Tpl.Text in_txt;
  input SimCode.ExtObjInfo in_a_extObjInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extObjInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCode.ExtAlias> i_aliases;
      list<SimCode.SimVar> i_vars;
      Tpl.Text l_ctorCalls;
      Tpl.Text l_varDecls;
      Tpl.Text l_auxFunction;

    case ( txt,
           SimCode.EXTOBJINFO(vars = i_vars, aliases = i_aliases),
           a_modelNamePrefix )
      equation
        l_auxFunction = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_ctorCalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_ctorCalls, l_auxFunction, l_varDecls) = lm_148(l_ctorCalls, i_vars, l_auxFunction, l_varDecls);
        l_ctorCalls = Tpl.popIter(l_ctorCalls);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Has to be performed after _init.xml file has been read */\n",
                                    "void "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefix, "callExternalObjectConstructors");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* data->simulationInfo.extObjs = NULL; */\n",
                                    "infoStreamPrint(LOG_DEBUG, 0, \"call external Object Constructors\");\n"
                                }, true));
        txt = Tpl.writeText(txt, l_ctorCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_149(txt, i_aliases);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("infoStreamPrint(LOG_DEBUG, 0, \"call external Object Constructors finished\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionCallExternalObjectConstructors;

protected function lm_151
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      DAE.ComponentRef i_var_name;
      Absyn.Path i_ext_fullClassName;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SIMVAR(varKind = BackendDAE.EXTOBJ(fullClassName = i_ext_fullClassName), name = i_var_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = CodegenUtil.underscorePath(txt, i_ext_fullClassName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_destructor(threadData,"));
        txt = cref(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_151(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_151(txt, rest);
      then txt;
  end match;
end lm_151;

public function functionCallExternalObjectDestructors
  input Tpl.Text in_txt;
  input SimCode.ExtObjInfo in_a_extObjInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extObjInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCode.SimVar> i_extObjInfo_vars;

    case ( txt,
           SimCode.EXTOBJINFO(vars = i_extObjInfo_vars),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = symbolName(txt, a_modelNamePrefix, "callExternalObjectDestructors");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n",
                                    "  if(data->simulationInfo.extObjs)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_151(txt, i_extObjInfo_vars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "free(data->simulationInfo.extObjs);\n",
                                    "data->simulationInfo.extObjs = 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionCallExternalObjectDestructors;

protected function lm_153
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo.inputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_153(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_153(txt, rest);
      then txt;
  end match;
end lm_153;

protected function lm_154
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = data->simulationInfo.inputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_154(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_154(txt, rest);
      then txt;
  end match;
end lm_154;

public function functionInput
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCode.SimVar> i_vars_inputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCode.SIMVARS(inputVars = i_vars_inputVars)),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "input_function");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_153(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefix, "input_function_init");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_154(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionInput;

protected function lm_156
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.outputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_156(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_156(txt, rest);
      then txt;
  end match;
end lm_156;

public function functionOutput
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCode.SimVar> i_vars_outputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCode.SIMVARS(outputVars = i_vars_outputVars)),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "output_function");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_156(txt, i_vars_outputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionOutput;

protected function fun_158
  input Tpl.Text in_txt;
  input BackendDAE.TimeEvent in_a_timeEvent;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_timeEvent, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer i_index;
      DAE.Exp i_intervalExp;
      DAE.Exp i_startExp;
      Tpl.Text l_e2;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           BackendDAE.SAMPLE_TIME_EVENT(startExp = i_startExp, intervalExp = i_intervalExp, index = i_index),
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_startExp, SimCode.contextOther, l_preExp, a_varDecls, a_auxFunction);
        (l_e2, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_intervalExp, SimCode.contextOther, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* $P$sample"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "data->modelData.samplesInfo[i].index = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.samplesInfo[i].start = "
                                }, false));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData.samplesInfo[i].interval = "
                                }, false));
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "assertStreamPrint(threadData,data->modelData.samplesInfo[i].interval > 0.0, \"sample-interval <= 0.0\");\n",
                                    "i++;"
                                }, false));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_158;

protected function lm_159
  input Tpl.Text in_txt;
  input list<BackendDAE.TimeEvent> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      BackendDAE.TimeEvent i_timeEvent;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_timeEvent :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_158(txt, i_timeEvent, a_auxFunction, a_varDecls);
        (txt, a_auxFunction, a_varDecls) = lm_159(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_159;

public function functionInitSample
  input Tpl.Text txt;
  input list<BackendDAE.TimeEvent> a_timeEvents;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_res;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_res := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING_LIST({
                                          "/* Initializes the raw time events of the simulation using the now\n",
                                          "   calcualted parameters. */\n",
                                          "void "
                                      }, false));
  l_res := symbolName(l_res, a_modelNamePrefix, "function_initSample");
  l_res := Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                   "(DATA *data)\n",
                                   "{\n",
                                   "  long i=0;\n"
                               }, true));
  l_res := Tpl.pushBlock(l_res, Tpl.BT_INDENT(2));
  l_res := Tpl.writeText(l_res, l_varDecls);
  l_res := Tpl.softNewLine(l_res);
  l_res := Tpl.writeTok(l_res, Tpl.ST_NEW_LINE());
  (l_res, l_auxFunction, l_varDecls) := lm_159(l_res, a_timeEvents, l_auxFunction, l_varDecls);
  l_res := Tpl.softNewLine(l_res);
  l_res := Tpl.popBlock(l_res);
  l_res := Tpl.writeTok(l_res, Tpl.ST_STRING("}"));
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_res);
end functionInitSample;

protected function lm_161
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      list<SimCode.SimEqSystem> i_jacobianEquations;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           ({(i_jacobianEquations, _, _)}, _, _, _, _, _, _) :: rest )
      equation
        txt = functionInitialMixedSystemsTemp(txt, i_jacobianEquations);
        txt = Tpl.nextIter(txt);
        txt = lm_161(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_161(txt, rest);
      then txt;
  end match;
end lm_161;

public function functionInitialMixedSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_body;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody;
algorithm
  l_initbody := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_initialEquations);
  l_parambody := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_parameterEquations);
  l_body := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_allEquations);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                    "\n",
                                                                                    "\n"
                                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacobianbody := lm_161(l_jacobianbody, a_jacobianMatrixes);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* funtion initialize mixed systems */\n",
                                   "void "
                               }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "initialMixedSystem");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nMixedSystems, MIXED_SYSTEM_DATA* mixedSystemData)\n",
                                       "{\n",
                                       "  /* initial mixed systems */\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* parameter mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* model mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* jacobians mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialMixedSystems;

protected function fun_163
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn)
    local
      Tpl.Text txt;
      Integer i_index;
      Integer i_indexMixedSystem;
      list<SimCode.SimVar> i_discVars;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_MIXED(discVars = i_discVars, indexMixedSystem = i_indexMixedSystem, index = i_index) )
      equation
        ret_1 = listLength(i_discVars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nMixedSystems > "));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nMixedSystems mismatch!\");\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solveContinuousPart = updateContinuousPart"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].updateIterationExps = updateIterationExpMixedSystem"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_163;

protected function lm_164
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_eqn :: rest )
      equation
        txt = fun_163(txt, i_eqn);
        txt = Tpl.nextIter(txt);
        txt = lm_164(txt, rest);
      then txt;
  end match;
end lm_164;

public function functionInitialMixedSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_164(out_txt, a_allEquations);
  out_txt := Tpl.popIter(out_txt);
end functionInitialMixedSystemsTemp;

protected function lm_166
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      list<SimCode.SimEqSystem> i_jacobianEquations;

    case ( txt,
           {},
           _,
           a_header )
      then (txt, a_header);

    case ( txt,
           ({(i_jacobianEquations, _, _)}, _, _, _, _, _, _) :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = functionSetupMixedSystemsTemp(txt, i_jacobianEquations, a_header, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        (txt, a_header) = lm_166(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = lm_166(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);
  end match;
end lm_166;

public function functionSetupMixedSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input Tpl.Text a_header;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_body;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody;
algorithm
  (l_initbody, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_initialEquations, a_header, a_modelNamePrefixStr);
  (l_parambody, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_parameterEquations, out_a_header, a_modelNamePrefixStr);
  (l_body, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_allEquations, out_a_header, a_modelNamePrefixStr);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                    "\n",
                                                                                    "\n"
                                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_jacobianbody, out_a_header) := lm_166(l_jacobianbody, a_jacobianMatrixes, a_modelNamePrefixStr, out_a_header);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* initial mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* parameter mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* model mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* jacobians mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
end functionSetupMixedSystems;

protected function fun_168
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_cont;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cont)
    local
      Tpl.Text txt;
      Integer i_indexNonLinearSystem;
      Integer i_indexLinearSystem;

    case ( txt,
           SimCode.SES_LINEAR(indexLinearSystem = i_indexLinearSystem) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.linearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solved"));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(indexNonLinearSystem = i_indexNonLinearSystem) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solved"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_168;

protected function lm_169
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preDisc;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preDisc;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preDisc) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preDisc)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preDisc;
      DAE.ComponentRef i_cref;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preDisc )
      then (txt, a_auxFunction, a_varDecls, a_preDisc);

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(exp = i_exp, cref = i_cref) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preDisc )
      equation
        (l_expPart, a_preDisc, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextSimulationDiscrete, a_preDisc, a_varDecls, a_auxFunction);
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preDisc) = lm_169(txt, rest, a_auxFunction, a_varDecls, a_preDisc);
      then (txt, a_auxFunction, a_varDecls, a_preDisc);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preDisc )
      equation
        (txt, a_auxFunction, a_varDecls, a_preDisc) = lm_169(txt, rest, a_auxFunction, a_varDecls, a_preDisc);
      then (txt, a_auxFunction, a_varDecls, a_preDisc);
  end match;
end lm_169;

protected function fun_170
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      Integer i_indexMixedSystem;
      Integer i_index;
      list<SimCode.SimEqSystem> i_discEqs;
      SimCode.SimEqSystem i_cont;
      Tpl.Text l_discExp;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;
      Tpl.Text l_preDisc;
      Tpl.Text l_solvedContinuous;
      Tpl.Text l_contEqsIndex;

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont, discEqs = i_discEqs, index = i_index, indexMixedSystem = i_indexMixedSystem),
           a_modelNamePrefixStr,
           a_header )
      equation
        l_contEqsIndex = CodegenUtil.equationIndex(Tpl.emptyTxt, i_cont);
        l_solvedContinuous = fun_168(Tpl.emptyTxt, i_cont);
        l_preDisc = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_discExp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_discExp, l_auxFunction, l_varDecls, l_preDisc) = lm_169(l_discExp, i_discEqs, l_auxFunction, l_varDecls, l_preDisc);
        l_discExp = Tpl.popIter(l_discExp);
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("void updateContinuousPart"));
        a_header = Tpl.writeStr(a_header, intString(i_index));
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("(void *);"));
        a_header = Tpl.writeTok(a_header, Tpl.ST_NEW_LINE());
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("void updateIterationExpMixedSystem"));
        a_header = Tpl.writeStr(a_header, intString(i_index));
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("(void *);"));
        a_header = Tpl.writeTok(a_header, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void updateContinuousPart"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_contEqsIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data);\n",
                                    "data->simulationInfo.mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].continuous_solution = "));
        txt = Tpl.writeText(txt, l_solvedContinuous);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void updateIterationExpMixedSystem"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preDisc);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_discExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_header);

    case ( txt,
           _,
           _,
           a_header )
      then (txt, a_header);
  end match;
end fun_170;

protected function lm_171
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           a_header )
      then (txt, a_header);

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = fun_170(txt, i_eqn, a_modelNamePrefixStr, a_header);
        txt = Tpl.nextIter(txt);
        (txt, a_header) = lm_171(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);
  end match;
end lm_171;

public function functionSetupMixedSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input Tpl.Text a_header;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_header) := lm_171(out_txt, a_allEquations, a_modelNamePrefixStr, a_header);
  out_txt := Tpl.popIter(out_txt);
end functionSetupMixedSystemsTemp;

protected function lm_173
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> i_jacobianEquations;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           ({(i_jacobianEquations, _, _)}, _, _, _, _, _, _) :: rest,
           a_modelNamePrefix )
      equation
        txt = functionInitialLinearSystemsTemp(txt, i_jacobianEquations, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_173(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_173(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_173;

public function functionInitialLinearSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_body;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody;
algorithm
  l_initbody := functionInitialLinearSystemsTemp(Tpl.emptyTxt, a_initialEquations, a_modelNamePrefix);
  l_parambody := functionInitialLinearSystemsTemp(Tpl.emptyTxt, a_parameterEquations, a_modelNamePrefix);
  l_body := functionInitialLinearSystemsTemp(Tpl.emptyTxt, a_allEquations, a_modelNamePrefix);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                    "\n",
                                                                                    "\n"
                                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacobianbody := lm_173(l_jacobianbody, a_jacobianMatrixes, a_modelNamePrefix);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* funtion initialize linear systems */\n",
                                   "void "
                               }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "initialLinearSystem");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nLinearSystems, LINEAR_SYSTEM_DATA* linearSystemData)\n",
                                       "{\n",
                                       "  /* initial linear systems */\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* parameter linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* model linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* jacobians linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialLinearSystems;

protected function fun_175
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME((_, _, i_name, _, _, _, _)),
           a_modelNamePrefix )
      equation
        txt = symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_175;

protected function fun_176
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME((_, _, i_name, _, _, _, _)),
           a_modelNamePrefix )
      equation
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_176;

protected function fun_177
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SOME((_, _, _, _, _, _, i_jacindex)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
      then txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_177;

protected function fun_178
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_jacobianMatrix;
  input String in_a_modelNamePrefix;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;
  input Integer in_a_eq_index;
  input Integer in_a_eq_indexLinearSystem;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_eq_simJac;
  input list<SimCode.SimVar> in_a_eq_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_modelNamePrefix, in_a_eq_jacobianMatrix, in_a_eq_index, in_a_eq_indexLinearSystem, in_a_eq_simJac, in_a_eq_vars)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Option<SimCode.JacobianMatrix> a_eq_jacobianMatrix;
      Integer a_eq_index;
      Integer a_eq_indexLinearSystem;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_eq_simJac;
      list<SimCode.SimVar> a_eq_vars;
      Tpl.Text txt_9;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Tpl.Text l_nnz;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           NONE(),
           _,
           _,
           a_eq_index,
           a_eq_indexLinearSystem,
           a_eq_simJac,
           a_eq_vars )
      equation
        ret_1 = listLength(a_eq_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = listLength(a_eq_simJac);
        l_nnz = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nLinearSystems mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 0;\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           SOME(_),
           a_modelNamePrefix,
           a_eq_jacobianMatrix,
           a_eq_index,
           a_eq_indexLinearSystem,
           a_eq_simJac,
           a_eq_vars )
      equation
        ret_4 = listLength(a_eq_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_4));
        ret_5 = listLength(a_eq_simJac);
        l_nnz = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_generatedJac = fun_175(Tpl.emptyTxt, a_eq_jacobianMatrix, a_modelNamePrefix);
        l_initialJac = fun_176(Tpl.emptyTxt, a_eq_jacobianMatrix, a_modelNamePrefix);
        l_jacIndex = fun_177(Tpl.emptyTxt, a_eq_jacobianMatrix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: indexlinearSystem mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 1;\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFunc = residualFunc"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = NULL;//setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = NULL; //setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_eq_index,
           _,
           _,
           _ )
      equation
        txt_9 = Tpl.pushBlock(Tpl.emptyTxt, Tpl.BT_INDENT(1));
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("No jacobian create for linear system "));
        txt_9 = Tpl.writeStr(txt_9, intString(a_eq_index));
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("."));
        txt_9 = Tpl.popBlock(txt_9);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 1555, 14), Tpl.textString(txt_9));
      then txt;
  end match;
end fun_178;

protected function fun_179
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Option<SimCode.JacobianMatrix> i_eq_jacobianMatrix;
      Integer i_eq_index;
      Integer i_eq_indexLinearSystem;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_eq_simJac;
      list<SimCode.SimVar> i_eq_vars;
      Option<SimCode.JacobianMatrix> i_jacobianMatrix;
      SimCode.SimEqSystem i_eq_cont;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_modelNamePrefix )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        txt = functionInitialLinearSystemsTemp(txt, ret_0, a_modelNamePrefix);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(jacobianMatrix = (i_eq_jacobianMatrix as i_jacobianMatrix), vars = i_eq_vars, simJac = i_eq_simJac, indexLinearSystem = i_eq_indexLinearSystem, index = i_eq_index),
           a_modelNamePrefix )
      equation
        txt = fun_178(txt, i_jacobianMatrix, a_modelNamePrefix, i_eq_jacobianMatrix, i_eq_index, i_eq_indexLinearSystem, i_eq_simJac, i_eq_vars);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_179;

protected function lm_180
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefix )
      equation
        txt = fun_179(txt, i_eqn, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_180(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_180;

public function functionInitialLinearSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_180(out_txt, a_allEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
end functionInitialLinearSystemsTemp;

protected function lm_182
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> i_jacobianEquations;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           ({(i_jacobianEquations, _, _)}, _, _, _, _, _, _) :: rest,
           a_modelNamePrefix )
      equation
        txt = functionSetupLinearSystemsTemp(txt, i_jacobianEquations, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_182(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_182(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_182;

public function functionSetupLinearSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_body;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody;
algorithm
  l_initbody := functionSetupLinearSystemsTemp(Tpl.emptyTxt, a_initialEquations, a_modelNamePrefix);
  l_parambody := functionSetupLinearSystemsTemp(Tpl.emptyTxt, a_parameterEquations, a_modelNamePrefix);
  l_body := functionSetupLinearSystemsTemp(Tpl.emptyTxt, a_allEquations, a_modelNamePrefix);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                    "\n",
                                                                                    "\n"
                                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacobianbody := lm_182(l_jacobianbody, a_jacobianMatrixes, a_modelNamePrefix);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* initial linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* parameter linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* model linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* jacobians linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
end functionSetupLinearSystems;

protected function lm_184
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeUtil.varName(i_var);
        txt = cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = xloc["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_184(txt, rest);
      then txt;
  end match;
end lm_184;

protected function lm_185
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDeclsRes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDeclsRes;
algorithm
  (out_txt, out_a_tmp, out_a_varDeclsRes) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDeclsRes)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDeclsRes;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDeclsRes )
      then (txt, a_tmp, a_varDeclsRes);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDeclsRes )
      equation
        (txt, a_varDeclsRes, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_varDeclsRes, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDeclsRes) = lm_185(txt, rest, a_modelNamePrefix, a_tmp, a_varDeclsRes);
      then (txt, a_tmp, a_varDeclsRes);
  end match;
end lm_185;

protected function fun_186
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_186;

protected function fun_187
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_187;

protected function lm_188
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsRes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsRes) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsRes)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsRes;
      Integer x_i0;
      Integer i_eq2_index;
      DAE.Exp i_eq2_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsRes )
      then (txt, a_auxFunction, a_varDeclsRes);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp, index = i_eq2_index) :: rest,
           a_auxFunction,
           a_varDeclsRes )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDeclsRes, a_auxFunction) = daeExp(Tpl.emptyTxt, i_eq2_exp, SimCode.contextSimulationDiscrete, l_preExp, a_varDeclsRes, a_auxFunction);
        ret_2 = Config.profileAll();
        txt = fun_186(txt, ret_2, i_eq2_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_187(txt, ret_3, i_eq2_index);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsRes) = lm_188(txt, rest, a_auxFunction, a_varDeclsRes);
      then (txt, a_auxFunction, a_varDeclsRes);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDeclsRes )
      equation
        (txt, a_auxFunction, a_varDeclsRes) = lm_188(txt, rest, a_auxFunction, a_varDeclsRes);
      then (txt, a_auxFunction, a_varDeclsRes);
  end match;
end lm_188;

protected function fun_189
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq_index)
    local
      Tpl.Text txt;
      Integer a_eq_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_189;

protected function fun_190
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq_index)
    local
      Tpl.Text txt;
      Integer a_eq_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ADD_NCALL_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,1);"));
      then txt;
  end match;
end fun_190;

protected function fun_191
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq_index)
    local
      Tpl.Text txt;
      Integer a_eq_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_191;

protected function lm_192
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      Integer i_col;
      Integer i_row;
      DAE.Exp i_eq_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_row, i_col, SimCode.SES_RESIDUAL(exp = i_eq_exp)) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_eq_exp, SimCode.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setAElement("));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_192(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_192(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_192;

protected function lm_193
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls2;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls2) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls2)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls2;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls2 )
      then (txt, a_auxFunction, a_varDecls2);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls2 )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls2, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextSimulationDiscrete, l_preExp, a_varDecls2, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->b["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] =  "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls2) = lm_193(txt, rest, a_auxFunction, a_varDecls2);
      then (txt, a_auxFunction, a_varDecls2);
  end match;
end lm_193;

protected function fun_194
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_jacobianMatrix;
  input list<DAE.Exp> in_a_eq_beqs;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_eq_simJac;
  input Integer in_a_eq_index;
  input String in_a_modelNamePrefix;
  input list<SimCode.SimEqSystem> in_a_eq_residual;
  input list<SimCode.SimVar> in_a_eq_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_eq_beqs, in_a_eq_simJac, in_a_eq_index, in_a_modelNamePrefix, in_a_eq_residual, in_a_eq_vars)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_eq_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_eq_simJac;
      Integer a_eq_index;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> a_eq_residual;
      list<SimCode.SimVar> a_eq_vars;
      Tpl.Text l_vectorb;
      Tpl.Text l_varDecls2;
      Tpl.Text l_MatrixA;
      Tpl.Text l_varDecls;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_xlocs;
      Tpl.Text l_tmp;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDeclsRes;

    case ( txt,
           SOME(_),
           _,
           _,
           a_eq_index,
           a_modelNamePrefix,
           a_eq_residual,
           a_eq_vars )
      equation
        l_varDeclsRes = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_tmp = Tpl.emptyTxt;
        l_xlocs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_xlocs = lm_184(l_xlocs, a_eq_vars);
        l_xlocs = Tpl.popIter(l_xlocs);
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, l_tmp, l_varDeclsRes) = lm_185(l_prebody, a_eq_residual, a_modelNamePrefix, l_tmp, l_varDeclsRes);
        l_prebody = Tpl.popIter(l_prebody);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, l_auxFunction, l_varDeclsRes) = lm_188(l_body, a_eq_residual, l_auxFunction, l_varDeclsRes);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void residualFunc"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* dataIn, const double* xloc, double* res, const int* iflag)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) dataIn;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, l_varDeclsRes);
        txt = Tpl.softNewLine(txt);
        ret_6 = Config.profileAll();
        txt = fun_189(txt, ret_6, a_eq_index);
        txt = Tpl.softNewLine(txt);
        ret_7 = Config.profileSome();
        txt = fun_190(txt, ret_7, a_eq_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_xlocs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        ret_8 = Config.profileAll();
        txt = fun_191(txt, ret_8, a_eq_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_eq_beqs,
           a_eq_simJac,
           a_eq_index,
           _,
           _,
           _ )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_MatrixA = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_MatrixA, l_auxFunction, l_varDecls) = lm_192(l_MatrixA, a_eq_simJac, l_auxFunction, l_varDecls);
        l_MatrixA = Tpl.popIter(l_MatrixA);
        l_varDecls2 = Tpl.emptyTxt;
        l_vectorb = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_vectorb, l_auxFunction, l_varDecls2) = lm_193(l_vectorb, a_eq_beqs, l_auxFunction, l_varDecls2);
        l_vectorb = Tpl.popIter(l_vectorb);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_MatrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void setLinearVectorb"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varDecls2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorb);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_194;

protected function fun_195
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<DAE.Exp> i_eq_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_eq_simJac;
      Integer i_eq_index;
      list<SimCode.SimEqSystem> i_eq_residual;
      list<SimCode.SimVar> i_eq_vars;
      Option<SimCode.JacobianMatrix> i_jacobianMatrix;
      SimCode.SimEqSystem i_eq_cont;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_modelNamePrefix )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        txt = functionSetupLinearSystemsTemp(txt, ret_0, a_modelNamePrefix);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(jacobianMatrix = i_jacobianMatrix, vars = i_eq_vars, residual = i_eq_residual, index = i_eq_index, simJac = i_eq_simJac, beqs = i_eq_beqs),
           a_modelNamePrefix )
      equation
        txt = fun_194(txt, i_jacobianMatrix, i_eq_beqs, i_eq_simJac, i_eq_index, a_modelNamePrefix, i_eq_residual, i_eq_vars);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_195;

protected function lm_196
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefix )
      equation
        txt = fun_195(txt, i_eqn, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_196(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_196;

public function functionSetupLinearSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_196(out_txt, a_allEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
end functionSetupLinearSystemsTemp;

protected function lm_198
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> i_jacobianEquations;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           ({(i_jacobianEquations, _, _)}, _, _, _, _, _, _) :: rest,
           a_modelNamePrefix )
      equation
        txt = functionInitialNonLinearSystemsTemp(txt, i_jacobianEquations, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_198(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_198(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_198;

public function functionInitialNonLinearSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_equationbody;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody;
algorithm
  l_initbody := functionInitialNonLinearSystemsTemp(Tpl.emptyTxt, a_initialEquations, a_modelNamePrefix);
  l_parambody := functionInitialNonLinearSystemsTemp(Tpl.emptyTxt, a_parameterEquations, a_modelNamePrefix);
  l_equationbody := functionInitialNonLinearSystemsTemp(Tpl.emptyTxt, a_allEquations, a_modelNamePrefix);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                    "\n",
                                                                                    "\n"
                                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacobianbody := lm_198(l_jacobianbody, a_jacobianMatrixes, a_modelNamePrefix);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* funtion initialize non-linear systems */\n",
                                   "void "
                               }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "initialNonLinearSystem");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nNonLinearSystems, NONLINEAR_SYSTEM_DATA* nonLinearSystemData)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_equationbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialNonLinearSystems;

protected function fun_200
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_jacobianMatrix, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      String a_modelPrefixName;
      String i_name;

    case ( txt,
           SOME((_, _, i_name, _, _, _, _)),
           a_modelPrefixName )
      equation
        txt = symbolName(txt, a_modelPrefixName, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_200;

protected function fun_201
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_jacobianMatrix, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      String a_modelPrefixName;
      String i_name;

    case ( txt,
           SOME((_, _, i_name, _, _, _, _)),
           a_modelPrefixName )
      equation
        txt = symbolName(txt, a_modelPrefixName, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_201;

protected function fun_202
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_eq_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SOME((_, _, _, _, _, _, i_jacindex)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
      then txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_202;

protected function fun_203
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      String a_modelPrefixName;
      Integer i_eq_index;
      Integer i_eq_indexNonLinearSystem;
      list<SimCode.SimEqSystem> i_eq_eqs;
      Option<SimCode.JacobianMatrix> i_eq_jacobianMatrix;
      list<DAE.ComponentRef> i_eq_crefs;
      SimCode.SimEqSystem i_eq_cont;
      Tpl.Text l_innerEqs;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;
      Integer ret_2;
      Tpl.Text l_size;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_modelPrefixName )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        txt = functionInitialNonLinearSystemsTemp(txt, ret_0, a_modelPrefixName);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(crefs = i_eq_crefs, jacobianMatrix = i_eq_jacobianMatrix, eqs = i_eq_eqs, indexNonLinearSystem = i_eq_indexNonLinearSystem, index = i_eq_index),
           a_modelPrefixName )
      equation
        ret_2 = listLength(i_eq_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_generatedJac = fun_200(Tpl.emptyTxt, i_eq_jacobianMatrix, a_modelPrefixName);
        l_initialJac = fun_201(Tpl.emptyTxt, i_eq_jacobianMatrix, a_modelPrefixName);
        l_jacIndex = fun_202(Tpl.emptyTxt, i_eq_jacobianMatrix);
        l_innerEqs = functionInitialNonLinearSystemsTemp(Tpl.emptyTxt, i_eq_eqs, a_modelPrefixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nNonLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(", \"Internal Error: nNonLinearSystems mismatch!\");\n"));
        txt = Tpl.writeText(txt, l_innerEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nonLinearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(i_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 0;\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFunc = residualFunc"));
        txt = Tpl.writeStr(txt, intString(i_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_eq_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticNLSData = initializeStaticNLSData"));
        txt = Tpl.writeStr(txt, intString(i_eq_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_203;

protected function lm_204
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelPrefixName;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_modelPrefixName )
      equation
        txt = fun_203(txt, i_eqn, a_modelPrefixName);
        txt = Tpl.nextIter(txt);
        txt = lm_204(txt, rest, a_modelPrefixName);
      then txt;
  end match;
end lm_204;

public function functionInitialNonLinearSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input String a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_204(out_txt, a_allEquations, a_modelPrefixName);
  out_txt := Tpl.popIter(out_txt);
end functionInitialNonLinearSystemsTemp;

public function functionExtraResidualsPreBody
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_varDecls, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_eqs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_eqs;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_varDecls,
           a_eqs,
           _ )
      then (txt, a_varDecls, a_eqs);

    case ( txt,
           i_eq,
           a_varDecls,
           a_eqs,
           a_modelNamePrefixStr )
      equation
        (txt, a_varDecls, a_eqs) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_eqs, a_modelNamePrefixStr);
      then (txt, a_varDecls, a_eqs);
  end match;
end functionExtraResidualsPreBody;

public function equationNamesExtraResidualsPreBody
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefixStr )
      equation
        txt = equationNames_(txt, i_eq, SimCode.contextSimulationDiscrete, a_modelNamePrefixStr);
      then txt;
  end match;
end equationNamesExtraResidualsPreBody;

protected function lm_208
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = xloc["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_208(txt, rest);
      then txt;
  end match;
end lm_208;

protected function lm_209
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static nls data for "));
        txt = cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "nlsData->nominal[i] = $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "nlsData->min[i]     = $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "nlsData->max[i++]   = $P$ATTRIBUTE"
                                }, false));
        txt = cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_209(txt, rest);
      then txt;
  end match;
end lm_209;

protected function lm_210
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_210(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_210;

protected function fun_211
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_211;

protected function fun_212
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_212;

protected function lm_213
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      Integer x_i0;
      Integer i_eq2_index;
      DAE.Exp i_eq2_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp, index = i_eq2_index) :: rest,
           a_tmp,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_tmp) = daeExp(Tpl.emptyTxt, i_eq2_exp, SimCode.contextSimulationDiscrete, l_preExp, a_varDecls, a_tmp);
        ret_2 = Config.profileAll();
        txt = fun_211(txt, ret_2, i_eq2_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_212(txt, ret_3, i_eq2_index);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_213(txt, rest, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_tmp, a_varDecls) = lm_213(txt, rest, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_213;

protected function fun_214
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_214;

protected function fun_215
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ADD_NCALL_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,1);"));
      then txt;
  end match;
end fun_215;

protected function fun_216
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_216;

protected function fun_217
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Integer i_index;
      list<SimCode.SimEqSystem> i_eq_eqs;
      list<DAE.ComponentRef> i_crefs;
      list<SimCode.SimEqSystem> i_eqs;
      SimCode.SimEqSystem i_eq_cont;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_body__initializeStaticNLSData;
      Tpl.Text l_xlocs;
      Tpl.Text l_innerEqs;
      Tpl.Text l_tmp;
      Tpl.Text l_varDecls;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_modelNamePrefix )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        txt = functionNonLinearResiduals(txt, ret_0, a_modelNamePrefix);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(eqs = (i_eq_eqs as i_eqs), crefs = i_crefs, index = i_index),
           a_modelNamePrefix )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_tmp = Tpl.emptyTxt;
        l_innerEqs = functionNonLinearResiduals(Tpl.emptyTxt, i_eqs, a_modelNamePrefix);
        l_xlocs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_xlocs = lm_208(l_xlocs, i_crefs);
        l_xlocs = Tpl.popIter(l_xlocs);
        l_body__initializeStaticNLSData = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticNLSData = lm_209(l_body__initializeStaticNLSData, i_crefs);
        l_body__initializeStaticNLSData = Tpl.popIter(l_body__initializeStaticNLSData);
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, l_tmp, l_varDecls) = lm_210(l_prebody, i_eq_eqs, a_modelNamePrefix, l_tmp, l_varDecls);
        l_prebody = Tpl.popIter(l_prebody);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, l_tmp, l_varDecls) = lm_213(l_body, i_eq_eqs, l_tmp, l_varDecls);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeText(txt, l_innerEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void initializeStaticNLSData"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *inNlsData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  NONLINEAR_SYSTEM_DATA* nlsData = (NONLINEAR_SYSTEM_DATA*) inNlsData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticNLSData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void residualFunc"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* dataIn, const double* xloc, double* res, const int* iflag)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) dataIn;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        ret_8 = Config.profileAll();
        txt = fun_214(txt, ret_8, i_index);
        txt = Tpl.softNewLine(txt);
        ret_9 = Config.profileSome();
        txt = fun_215(txt, ret_9, i_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_xlocs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        ret_10 = Config.profileAll();
        txt = fun_216(txt, ret_10, i_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_217;

protected function lm_218
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefix )
      equation
        txt = fun_217(txt, i_eqn, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_218(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_218;

public function functionNonLinearResiduals
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_218(out_txt, a_allEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
end functionNonLinearResiduals;

protected function fun_220
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           (_, _, i_name, _, _, _, _),
           a_modelNamePrefix )
      equation
        txt = symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;
  end match;
end fun_220;

protected function fun_221
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           (_, _, i_name, _, _, _, _),
           a_modelNamePrefix )
      equation
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;
  end match;
end fun_221;

protected function fun_222
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           (_, _, _, _, _, _, i_jacindex) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
      then txt;
  end match;
end fun_222;

protected function lm_223
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_i1)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_i1;
      Integer x_i2;
      DAE.ComponentRef i_s;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_s :: rest,
           a_i1 )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].states["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        txt = cref(txt, i_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo;"));
        txt = Tpl.nextIter(txt);
        txt = lm_223(txt, rest, a_i1);
      then txt;
  end match;
end lm_223;

protected function lm_224
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_i1)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_i1;
      Integer x_i2;
      DAE.ComponentRef i_cstate;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_cstate :: rest,
           a_i1 )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].statescandidates["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        txt = cref(txt, i_cstate);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo;"));
        txt = Tpl.nextIter(txt);
        txt = lm_224(txt, rest, a_i1);
      then txt;
  end match;
end lm_224;

protected function fun_225
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Integer a_i1;
      String a_modelNamePrefix;
      DAE.ComponentRef i_crA;
      Integer i_nStates;
      Integer i_nCandidates;
      list<DAE.ComponentRef> i_statescandidates;
      list<DAE.ComponentRef> i_states;
      SimCode.JacobianMatrix i_jacobianMatrix;
      Tpl.Text l_statescandidatesvars;
      Tpl.Text l_statesvars;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;

    case ( txt,
           SimCode.SES_STATESET(jacobianMatrix = i_jacobianMatrix, states = i_states, statescandidates = i_statescandidates, nCandidates = i_nCandidates, nStates = i_nStates, crA = i_crA),
           a_i1,
           a_modelNamePrefix )
      equation
        l_generatedJac = fun_220(Tpl.emptyTxt, i_jacobianMatrix, a_modelNamePrefix);
        l_initialJac = fun_221(Tpl.emptyTxt, i_jacobianMatrix, a_modelNamePrefix);
        l_jacIndex = fun_222(Tpl.emptyTxt, i_jacobianMatrix);
        l_statesvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_statesvars = lm_223(l_statesvars, i_states, a_i1);
        l_statesvars = Tpl.popIter(l_statesvars);
        l_statescandidatesvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_statescandidatesvars = lm_224(l_statescandidatesvars, i_statescandidates, a_i1);
        l_statescandidatesvars = Tpl.popIter(l_statescandidatesvars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nStateSets > "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nStateSets mismatch!\");\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nCandidates = "));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nStates = "));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nDummyStates = "));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].states = (VAR_INFO**) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",sizeof(VAR_INFO));\n"));
        txt = Tpl.writeText(txt, l_statesvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].statescandidates = (VAR_INFO**) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",sizeof(VAR_INFO));\n"));
        txt = Tpl.writeText(txt, l_statescandidatesvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].A = &"));
        txt = cref(txt, i_crA);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__varInfo;\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].rowPivot = (modelica_integer*) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_integer));\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].colPivot = (modelica_integer*) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_integer));\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].J = (modelica_real*) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "),sizeof(modelica_real));\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_225;

protected function lm_226
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      String a_modelNamePrefix;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_set :: rest,
           a_modelNamePrefix )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_225(txt, i_set, x_i1, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_226(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_226;

public function functionInitialStateSets
  input Tpl.Text txt;
  input list<SimCode.StateSet> a_stateSets;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
algorithm
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                            "\n",
                                                                            "\n"
                                                                        }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_body := lm_226(l_body, a_stateSets, a_modelNamePrefix);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* funtion initialize state sets */\n",
                                   "void "
                               }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "initializeStateSets");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nStateSets, STATE_SET_DATA* statesetData, DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialStateSets;

protected function lm_228
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextOther, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_228(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_tmp, a_varDecls) = lm_228(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_228;

protected function lm_229
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextOther, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_229(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_tmp, a_varDecls) = lm_229(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_229;

protected function lm_230
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextOther, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_230(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_tmp, a_varDecls) = lm_230(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_230;

protected function lm_231
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextOther, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_231(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_tmp, a_varDecls) = lm_231(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_231;

protected function lm_232
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min = "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT, 0, \"%s(min="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo.name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") $P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min);"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_232(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_232(txt, rest);
      then txt;
  end match;
end lm_232;

protected function lm_233
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max = "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT, 0, \"%s(max="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo.name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") $P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max);"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_233(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_233(txt, rest);
      then txt;
  end match;
end lm_233;

protected function lm_234
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".nominal = "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT, 0, \"%s(nominal="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo.name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") $P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".nominal);"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_234(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_234(txt, rest);
      then txt;
  end match;
end lm_234;

protected function lm_235
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT, 0, \"%s(start="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo.name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")  $P$ATTRIBUTE"));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start);"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_235(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_235(txt, rest);
      then txt;
  end match;
end lm_235;

public function functionUpdateBoundVariableAttributes
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_startValueEquations;
  input list<SimCode.SimEqSystem> a_nominalValueEquations;
  input list<SimCode.SimEqSystem> a_minValueEquations;
  input list<SimCode.SimEqSystem> a_maxValueEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_maxEqPart;
  Tpl.Text l_minEqPart;
  Tpl.Text l_nominalEqPart;
  Tpl.Text l_startEqPart;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_startEqPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_startEqPart, l_tmp, l_varDecls) := lm_228(l_startEqPart, a_startValueEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_startEqPart := Tpl.popIter(l_startEqPart);
  l_nominalEqPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_nominalEqPart, l_tmp, l_varDecls) := lm_229(l_nominalEqPart, a_nominalValueEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_nominalEqPart := Tpl.popIter(l_nominalEqPart);
  l_minEqPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_minEqPart, l_tmp, l_varDecls) := lm_230(l_minEqPart, a_minValueEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_minEqPart := Tpl.popIter(l_minEqPart);
  l_maxEqPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_maxEqPart, l_tmp, l_varDecls) := lm_231(l_maxEqPart, a_maxValueEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_maxEqPart := Tpl.popIter(l_maxEqPart);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "updateBoundVariableAttributes");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* min ******************************************************** */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_minEqPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating min-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_232(out_txt, a_minValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "/* max ******************************************************** */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_maxEqPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating max-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_233(out_txt, a_maxValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "/* nominal **************************************************** */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_nominalEqPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating nominal-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_234(out_txt, a_nominalValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "/* start ****************************************************** */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_startEqPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating start-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_235(out_txt, a_startValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionUpdateBoundVariableAttributes;

protected function lm_237
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_237(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_237;

public function functionUpdateBoundParameters
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  System.tmpTickReset(0);
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, l_tmp, l_varDecls) := lm_237(l_body, a_parameterEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "updateBoundParameters");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionUpdateBoundParameters;

protected function fun_239
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_e_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e_index)
    local
      Tpl.Text txt;
      Integer a_e_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_e_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_239;

protected function fun_240
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_e_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e_index)
    local
      Tpl.Text txt;
      Integer a_e_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_e_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_240;

protected function fun_241
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input String in_a_modelNamePrefix;
  input Integer in_a_e_index;
  input Tpl.Text in_a_eqs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqs, out_a_varDecls) :=
  match(in_txt, in_a_exp, in_a_modelNamePrefix, in_a_e_index, in_a_eqs, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Integer a_e_index;
      Tpl.Text a_eqs;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.SCONST(string = _),
           _,
           _,
           a_eqs,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialResiduals[i++] = 0;"));
      then (txt, a_eqs, a_varDecls);

    case ( txt,
           i_exp,
           a_modelNamePrefix,
           a_e_index,
           a_eqs,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_eqs) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextOther, l_preExp, a_varDecls, a_eqs);
        ret_2 = Config.profileAll();
        txt = fun_239(txt, ret_2, a_e_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialResiduals[i++] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_240(txt, ret_3, a_e_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_RES_INIT, 0, \"[%d]: %s = %g\", i, "));
        txt = symbolName(txt, a_modelNamePrefix, "initialResidualDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i-1), initialResiduals[i-1]);"));
      then (txt, a_eqs, a_varDecls);
  end match;
end fun_241;

public function functionInitialResidualBody
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_varDecls, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_eqs, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_eqs;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Integer i_e_index;
      DAE.Exp i_exp;

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_exp, index = i_e_index),
           a_varDecls,
           a_eqs,
           a_modelNamePrefix )
      equation
        (txt, a_eqs, a_varDecls) = fun_241(txt, i_exp, a_modelNamePrefix, i_e_index, a_eqs, a_varDecls);
      then (txt, a_varDecls, a_eqs);

    case ( txt,
           i_eq,
           a_varDecls,
           a_eqs,
           a_modelNamePrefix )
      equation
        (txt, a_varDecls, a_eqs) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_eqs, a_modelNamePrefix);
      then (txt, a_varDecls, a_eqs);
  end match;
end functionInitialResidualBody;

protected function fun_243
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      String ret_0;

    case ( txt,
           DAE.SCONST(string = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"0\", "));
      then txt;

    case ( txt,
           i_exp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = ExpressionDump.printExpStr(i_exp);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_243;

protected function lm_244
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_exp) :: rest )
      equation
        txt = fun_243(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_244(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_244(txt, rest);
      then txt;
  end match;
end lm_244;

protected function lm_245
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = functionInitialResidualBody(txt, i_eq2, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_245(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_245;

protected function fun_246
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_residualEquations;
  input Tpl.Text in_a_resDesc;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_residualEquations, in_a_resDesc, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_resDesc;
      String a_modelNamePrefix;

    case ( txt,
           {},
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "initialResidualDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i)\n",
                                    "{\n",
                                    "  return \"empty\";\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_resDesc,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "initialResidualDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *res[] = {"));
        txt = Tpl.writeText(txt, a_resDesc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "return res[i];\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_246;

public function functionInitialResidual
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_residualEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_desc;
  Tpl.Text l_body;
  Tpl.Text l_resDesc;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_resDesc := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_resDesc := lm_244(l_resDesc, a_residualEquations);
  l_resDesc := Tpl.popIter(l_resDesc);
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, l_tmp, l_varDecls) := lm_245(l_body, a_residualEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_body := Tpl.popIter(l_body);
  l_desc := fun_246(Tpl.emptyTxt, a_residualEquations, l_resDesc, a_modelNamePrefix);
  out_txt := Tpl.writeText(txt, l_desc);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "initial_residual");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, double *initialResiduals)\n",
                                       "{\n",
                                       "  const int *equationIndexes = NULL;\n",
                                       "  int i = 0;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_RES_INIT, 1, \"updating initial residuals\");\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_RES_INIT)) messageClose(LOG_RES_INIT);\n",
                                       "\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialResidual;

protected function lm_248
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqfuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_eqfuncs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_eqfuncs,
           a_varDecls )
      then (txt, a_eqfuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_eqfuncs,
           a_varDecls )
      equation
        (txt, a_varDecls, a_eqfuncs) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_eqfuncs, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_eqfuncs, a_varDecls) = lm_248(txt, rest, a_modelNamePrefix, a_eqfuncs, a_varDecls);
      then (txt, a_eqfuncs, a_varDecls);
  end match;
end lm_248;

protected function lm_249
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_eqArray;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqfuncs, out_a_eqArray, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_eqfuncs, in_a_eqArray, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_eqArray;
      Tpl.Text a_varDecls;
      Integer x_i0;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_eqfuncs,
           a_eqArray,
           a_varDecls )
      then (txt, a_eqfuncs, a_eqArray, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_eqfuncs,
           a_eqArray,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_eqArray, a_eqfuncs) = equation_arrayFormat(txt, i_eq, "InitialEquations", SimCode.contextSimulationDiscrete, x_i0, a_varDecls, a_eqArray, a_eqfuncs, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_eqfuncs, a_eqArray, a_varDecls) = lm_249(txt, rest, a_modelNamePrefix, a_eqfuncs, a_eqArray, a_varDecls);
      then (txt, a_eqfuncs, a_eqArray, a_varDecls);
  end match;
end lm_249;

protected function fun_250
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_eqArray;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_varDecls;
  input list<SimCode.SimEqSystem> in_a_initalEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqArray, out_a_eqfuncs, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_eqArray, in_a_modelNamePrefix, in_a_eqfuncs, in_a_varDecls, in_a_initalEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_eqArray;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_varDecls;
      list<SimCode.SimEqSystem> a_initalEquations;

    case ( txt,
           false,
           a_eqArray,
           a_modelNamePrefix,
           a_eqfuncs,
           a_varDecls,
           a_initalEquations )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_eqfuncs, a_varDecls) = lm_248(txt, a_initalEquations, a_modelNamePrefix, a_eqfuncs, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_eqArray, a_eqfuncs, a_varDecls);

    case ( txt,
           _,
           a_eqArray,
           a_modelNamePrefix,
           a_eqfuncs,
           a_varDecls,
           a_initalEquations )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_eqfuncs, a_eqArray, a_varDecls) = lm_249(txt, a_initalEquations, a_modelNamePrefix, a_eqfuncs, a_eqArray, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_eqArray, a_eqfuncs, a_varDecls);
  end match;
end fun_250;

protected function fun_251
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_eqArray;
  input list<SimCode.SimEqSystem> in_a_initalEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eqArray, in_a_initalEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_eqArray;
      list<SimCode.SimEqSystem> a_initalEquations;
      Integer ret_0;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_eqArray,
           a_initalEquations )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void (*functionInitialEquations_systems["));
        ret_0 = listLength(a_initalEquations);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_eqArray);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_251;

protected function fun_252
  input Tpl.Text in_txt;
  input Boolean in_a_useSymbolicInitialization;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useSymbolicInitialization)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("errorStreamPrint(LOG_INIT, 0, \"The symbolic initialization was not generated.\");"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_252;

protected function fun_253
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input Tpl.Text in_a_fncalls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_fncalls)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      Tpl.Text a_fncalls;

    case ( txt,
           false,
           _,
           a_fncalls )
      equation
        txt = Tpl.writeText(txt, a_fncalls);
      then txt;

    case ( txt,
           _,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PM_functionInitialEquations("));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data, functionInitialEquations_systems);"));
      then txt;
  end match;
end fun_253;

public function functionInitialEquations
  input Tpl.Text txt;
  input Boolean a_useSymbolicInitialization;
  input list<SimCode.SimEqSystem> a_initalEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_10;
  Tpl.Text l_errorMsg;
  Boolean ret_8;
  Tpl.Text l_eqArrayDecl;
  Boolean ret_6;
  Tpl.Text l_fncalls;
  Tpl.Text l_eqArray;
  Tpl.Text l_eqfuncs;
  Integer ret_2;
  Tpl.Text l_nrfuncs;
  Tpl.Text l_varDecls;
algorithm
  System.tmpTickReset(0);
  l_varDecls := Tpl.emptyTxt;
  ret_2 := listLength(a_initalEquations);
  l_nrfuncs := Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
  l_eqfuncs := Tpl.emptyTxt;
  l_eqArray := Tpl.emptyTxt;
  ret_6 := Flags.isSet(Flags.PARMODAUTO);
  (l_fncalls, l_eqArray, l_eqfuncs, l_varDecls) := fun_250(Tpl.emptyTxt, ret_6, l_eqArray, a_modelNamePrefix, l_eqfuncs, l_varDecls, a_initalEquations);
  ret_8 := Flags.isSet(Flags.PARMODAUTO);
  l_eqArrayDecl := fun_251(Tpl.emptyTxt, ret_8, l_eqArray, a_initalEquations);
  l_errorMsg := fun_252(Tpl.emptyTxt, a_useSymbolicInitialization);
  out_txt := Tpl.writeText(txt, l_eqfuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_eqArrayDecl);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "functionInitialEquations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_errorMsg);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("data->simulationInfo.discreteCall = 1;\n"));
  ret_10 := Flags.isSet(Flags.PARMODAUTO);
  out_txt := fun_253(out_txt, ret_10, l_nrfuncs, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "data->simulationInfo.discreteCall = 0;\n",
                                       "\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialEquations;

protected function fun_255
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_e_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e_index)
    local
      Tpl.Text txt;
      Integer a_e_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_e_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_255;

protected function fun_256
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_e_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e_index)
    local
      Tpl.Text txt;
      Integer a_e_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_e_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_256;

protected function fun_257
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Integer in_a_e_index;
  input Tpl.Text in_a_eqs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqs, out_a_varDecls) :=
  match(in_txt, in_a_exp, in_a_e_index, in_a_eqs, in_a_varDecls)
    local
      Tpl.Text txt;
      Integer a_e_index;
      Tpl.Text a_eqs;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      String ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.SCONST(string = _),
           _,
           a_eqs,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res = 0;"));
      then (txt, a_eqs, a_varDecls);

    case ( txt,
           i_exp,
           a_e_index,
           a_eqs,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_eqs) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextOther, l_preExp, a_varDecls, a_eqs);
        ret_2 = Config.profileAll();
        txt = fun_255(txt, ret_2, a_e_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_256(txt, ret_3, a_e_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(fabs(res) > 1e-5)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("errorStreamPrint(LOG_INIT, 0, \"The initialization problem is inconsistent due to the following equation: 0 != %g = "));
        ret_4 = ExpressionDump.printExpStr(i_exp);
        txt = Tpl.writeStr(txt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", res);\n",
                                    "return 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_eqs, a_varDecls);
  end match;
end fun_257;

public function functionRemovedInitialEquationsBody
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_varDecls, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_eqs, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_eqs;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Integer i_e_index;
      DAE.Exp i_exp;

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_exp, index = i_e_index),
           a_varDecls,
           a_eqs,
           _ )
      equation
        (txt, a_eqs, a_varDecls) = fun_257(txt, i_exp, i_e_index, a_eqs, a_varDecls);
      then (txt, a_varDecls, a_eqs);

    case ( txt,
           i_eq,
           a_varDecls,
           a_eqs,
           a_modelNamePrefix )
      equation
        (txt, a_varDecls, a_eqs) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_eqs, a_modelNamePrefix);
      then (txt, a_varDecls, a_eqs);
  end match;
end functionRemovedInitialEquationsBody;

protected function lm_259
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = functionRemovedInitialEquationsBody(txt, i_eq2, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_259(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_259;

public function functionRemovedInitialEquations
  input Tpl.Text txt;
  input Boolean a_useSymbolicInitialization;
  input list<SimCode.SimEqSystem> a_removedInitalEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, l_tmp, l_varDecls) := lm_259(l_body, a_removedInitalEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "functionRemovedInitialEquations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n",
                                       "  const int *equationIndexes = NULL;\n",
                                       "  double res = 0.0;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionRemovedInitialEquations;

protected function lm_261
  input Tpl.Text in_txt;
  input list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer i_id;
      DAE.Exp i_delayMax;
      DAE.Exp i_d;
      DAE.Exp i_e;
      Tpl.Text l_delayExpMax;
      Tpl.Text l_delayExp;
      Tpl.Text l_eRes;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_id, (i_e, i_d, i_delayMax)) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_eRes, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, SimCode.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_auxFunction);
        (l_delayExp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_d, SimCode.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_auxFunction);
        (l_delayExpMax, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_delayMax, SimCode.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("storeDelayedExpression(data, "));
        txt = Tpl.writeStr(txt, intString(i_id));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_eRes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", time, "));
        txt = Tpl.writeText(txt, l_delayExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_delayExpMax);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_auxFunction, a_varDecls) = lm_261(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_261;

protected function fun_262
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_delayed, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> i_delayedExps;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(delayedExps = i_delayedExps),
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_261(txt, i_delayedExps, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_262;

public function functionStoreDelayed
  input Tpl.Text txt;
  input SimCode.DelayedExpression a_delayed;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_storePart;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_storePart, l_auxFunction, l_varDecls) := fun_262(Tpl.emptyTxt, a_delayed, l_auxFunction, l_varDecls);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "function_storeDelayed");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_storePart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("return 0;\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionStoreDelayed;

protected function lm_264
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_264(txt, rest);
      then txt;
  end match;
end lm_264;

protected function fun_265
  input Tpl.Text in_txt;
  input Boolean in_a_initialCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input list<BackendDAE.WhenOperator> in_a_reinits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_initialCall, in_a_auxFunction, in_a_varDecls, in_a_reinits)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      list<BackendDAE.WhenOperator> a_reinits;

    case ( txt,
           true,
           a_auxFunction,
           a_varDecls,
           a_reinits )
      equation
        (txt, a_varDecls, a_auxFunction) = functionWhenReinitStatementThen(txt, true, a_reinits, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* nothing to do */"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_265;

protected function fun_266
  input Tpl.Text in_txt;
  input list<BackendDAE.WhenOperator> in_a_reinits;
  input Tpl.Text in_a_ifthen;
  input Tpl.Text in_a_helpIf;
  input Tpl.Text in_a_initial__assign;
  input Integer in_a_int;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_reinits, in_a_ifthen, in_a_helpIf, in_a_initial__assign, in_a_int)
    local
      Tpl.Text txt;
      Tpl.Text a_ifthen;
      Tpl.Text a_helpIf;
      Tpl.Text a_initial__assign;
      Integer a_int;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ifthen,
           a_helpIf,
           a_initial__assign,
           a_int )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* for whenclause index "));
        txt = Tpl.writeStr(txt, intString(a_int));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "if(initial())\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_initial__assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else if(0"
                                }, false));
        txt = Tpl.writeText(txt, a_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ifthen);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_266;

public function genreinits
  input Tpl.Text in_txt;
  input SimCode.SimWhenClause in_a_whenClauses;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;
  input Integer in_a_int;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_whenClauses, in_a_varDecls, in_a_auxFunction, in_a_int)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer a_int;
      Boolean i_initialCall;
      list<BackendDAE.WhenOperator> i_reinits;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_initial__assign;
      Tpl.Text l_ifthen;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SIM_WHEN_CLAUSE(conditions = i_conditions, reinits = i_reinits, initialCall = i_initialCall),
           a_varDecls,
           a_auxFunction,
           a_int )
      equation
        l_helpIf = lm_264(Tpl.emptyTxt, i_conditions);
        (l_ifthen, a_varDecls, a_auxFunction) = functionWhenReinitStatementThen(Tpl.emptyTxt, false, i_reinits, a_varDecls, a_auxFunction);
        (l_initial__assign, a_auxFunction, a_varDecls) = fun_265(Tpl.emptyTxt, i_initialCall, a_auxFunction, a_varDecls, i_reinits);
        txt = fun_266(txt, i_reinits, l_ifthen, l_helpIf, l_initial__assign, a_int);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction,
           _ )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end genreinits;

protected function fun_268
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.ComponentRef in_a_stateVar;
  input Tpl.Text in_a_val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stateVar, in_a_val)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_stateVar;
      Tpl.Text a_val;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_stateVar,
           a_val )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_real_array_data_mem("));
        txt = Tpl.writeText(txt, a_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_stateVar,
           a_val )
      equation
        txt = cref(txt, a_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_268;

protected function fun_269
  input Tpl.Text in_txt;
  input Boolean in_a_initialCall;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialCall)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.needToIterate = 1;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_269;

protected function fun_270
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expPart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expPart)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;

    case ( txt,
           false,
           a_expPart )
      equation
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_270;

protected function fun_271
  input Tpl.Text in_txt;
  input BackendDAE.WhenOperator in_a_reinit;
  input Boolean in_a_initialCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_reinit, in_a_initialCall, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Boolean a_initialCall;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Absyn.Info i_info;
      DAE.Exp i_level;
      DAE.Exp i_condition;
      DAE.ElementSource i_source;
      DAE.Exp i_message;
      DAE.ComponentRef i_stateVar;
      DAE.Exp i_value;
      Boolean ret_9;
      Tpl.Text l_expPart;
      list<DAE.Exp> ret_7;
      Absyn.Info ret_6;
      Tpl.Text l_msgVar;
      Tpl.Text l_needToIterate;
      DAE.Type ret_3;
      Tpl.Text l_lhs;
      Tpl.Text l_val;
      Tpl.Text l_preExp;

    case ( txt,
           BackendDAE.REINIT(value = i_value, stateVar = i_stateVar),
           a_initialCall,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_val, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_value, SimCode.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        ret_3 = ComponentReference.crefLastType(i_stateVar);
        l_lhs = fun_268(Tpl.emptyTxt, ret_3, i_stateVar, l_val);
        l_needToIterate = fun_269(Tpl.emptyTxt, a_initialCall);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_EVENTS, 0, \"reinit "));
        txt = cref(txt, i_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  = %f\", "));
        txt = Tpl.writeText(txt, l_val);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_needToIterate);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.TERMINATE(message = i_message, source = i_source),
           _,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_msgVar, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_message, SimCode.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        ret_6 = DAEUtil.getElementSourceFileInfo(i_source);
        txt = infoArgs(txt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_terminate(info, "
                                }, false));
        txt = Tpl.writeText(txt, l_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ASSERT(source = DAE.SOURCE(info = i_info), condition = i_condition, message = i_message, level = i_level),
           _,
           a_auxFunction,
           a_varDecls )
      equation
        ret_7 = List.fill(i_message, 1);
        (txt, a_varDecls, a_auxFunction) = assertCommon(txt, i_condition, ret_7, i_level, SimCode.contextSimulationDiscrete, a_varDecls, a_auxFunction, i_info);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.NORETCALL(exp = i_exp),
           _,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        ret_9 = Util.isCIdentifier(Tpl.textString(l_expPart));
        txt = fun_270(txt, ret_9, l_expPart);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_271;

protected function lm_272
  input Tpl.Text in_txt;
  input list<BackendDAE.WhenOperator> in_items;
  input Boolean in_a_initialCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_initialCall, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.WhenOperator> rest;
      Boolean a_initialCall;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      BackendDAE.WhenOperator i_reinit;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_reinit :: rest,
           a_initialCall,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_271(txt, i_reinit, a_initialCall, a_auxFunction, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_272(txt, rest, a_initialCall, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_272;

public function functionWhenReinitStatementThen
  input Tpl.Text txt;
  input Boolean a_initialCall;
  input list<BackendDAE.WhenOperator> a_reinits;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_body;
algorithm
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, out_a_auxFunction, out_a_varDecls) := lm_272(l_body, a_reinits, a_initialCall, a_auxFunction, a_varDecls);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_body);
end functionWhenReinitStatementThen;

protected function lm_274
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_modelNamePrefixStr;
  input Option<HpcOmSimCode.Schedule> in_a_hpcOmScheduleOpt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_hpcOmScheduleOpt, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_modelNamePrefixStr;
      Option<HpcOmSimCode.Schedule> a_hpcOmScheduleOpt;
      String a_name;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eq;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_hpcOmScheduleOpt,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system_HPCOM(txt, i_eq, a_name, x_i0, a_hpcOmScheduleOpt, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_274(txt, rest, a_modelNamePrefixStr, a_hpcOmScheduleOpt, a_name);
      then txt;
  end match;
end lm_274;

protected function lm_275
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_275(txt, rest, a_name);
      then txt;
  end match;
end lm_275;

protected function fun_276
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dynamic"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static"));
      then txt;
  end match;
end fun_276;

protected function fun_277
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input Integer in_a_nFuncs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_nFuncs)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_nFuncs;
      Integer ret_0;

    case ( txt,
           false,
           a_name,
           a_nFuncs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for(id=0; id<"));
        txt = Tpl.writeStr(txt, intString(a_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("; id++) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_systems[id](data);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_name,
           a_nFuncs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#pragma omp parallel for private(id) schedule("));
        ret_0 = Config.noProc();
        txt = fun_276(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "for(id=0; id<"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("; id++) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_systems[id](data);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_277;

protected function fun_278
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_varDecls;
  input list<list<SimCode.SimEqSystem>> in_a_eqs;
  input Tpl.Text in_a_funcs;
  input String in_a_name;
  input Tpl.Text in_a_loop;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_loop;
algorithm
  (out_txt, out_a_varDecls, out_a_loop) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_eqs, in_a_funcs, in_a_name, in_a_loop)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<list<SimCode.SimEqSystem>> a_eqs;
      Tpl.Text a_funcs;
      String a_name;
      Tpl.Text a_loop;
      Integer i_nFuncs;
      Boolean ret_1;
      Tpl.Text l_funcNames;

    case ( txt,
           0,
           a_varDecls,
           _,
           _,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("/* no "));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING(" systems */"));
      then (txt, a_varDecls, a_loop);

    case ( txt,
           1,
           a_varDecls,
           _,
           a_funcs,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("_system0(data);"));
        txt = Tpl.writeText(txt, a_funcs);
      then (txt, a_varDecls, a_loop);

    case ( txt,
           i_nFuncs,
           a_varDecls,
           a_eqs,
           a_funcs,
           a_name,
           a_loop )
      equation
        l_funcNames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_funcNames = lm_275(l_funcNames, a_eqs, a_name);
        l_funcNames = Tpl.popIter(l_funcNames);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("int id;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        ret_1 = Flags.isSet(Flags.PARMODAUTO);
        a_loop = fun_277(a_loop, ret_1, a_name, i_nFuncs);
        txt = Tpl.writeText(txt, a_funcs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void (*function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(i_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_funcNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_varDecls, a_loop);
  end match;
end fun_278;

public function functionXXX_systems_HPCOM
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqs;
  input String a_name;
  input Tpl.Text a_loop;
  input Tpl.Text a_varDecls;
  input Option<HpcOmSimCode.Schedule> a_hpcOmScheduleOpt;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_loop;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_funcs;
algorithm
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_funcs := lm_274(l_funcs, a_eqs, a_modelNamePrefixStr, a_hpcOmScheduleOpt, a_name);
  l_funcs := Tpl.popIter(l_funcs);
  ret_1 := listLength(a_eqs);
  (out_txt, out_a_varDecls, out_a_loop) := fun_278(txt, ret_1, a_varDecls, a_eqs, l_funcs, a_name, a_loop);
end functionXXX_systems_HPCOM;

protected function lm_280
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.TaskList> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_type, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.TaskList> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.TaskList i_tasks;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_tasks :: rest,
           a_modelNamePrefixStr,
           a_type,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Level(txt, a_derivativEquations, a_name, i_tasks, Tpl.textString(a_type), a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_280(txt, rest, a_modelNamePrefixStr, a_type, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_280;

protected function lm_281
  input Tpl.Text in_txt;
  input list<String> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<String> rest;
      Tpl.Text a_type;
      String i_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_idx :: rest,
           a_type )
      equation
        txt = function_HPCOM_createLock(txt, i_idx, "lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_281(txt, rest, a_type);
      then txt;
  end match;
end lm_281;

protected function lm_282
  input Tpl.Text in_txt;
  input list<String> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<String> rest;
      Tpl.Text a_type;
      String i_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_idx :: rest,
           a_type )
      equation
        txt = function_HPCOM_initializeLock(txt, i_idx, "lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_282(txt, rest, a_type);
      then txt;
  end match;
end lm_282;

protected function lm_283
  input Tpl.Text in_txt;
  input list<String> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<String> rest;
      Tpl.Text a_type;
      String i_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_idx :: rest,
           a_type )
      equation
        txt = function_HPCOM_assignLock(txt, i_idx, "lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_283(txt, rest, a_type);
      then txt;
  end match;
end lm_283;

protected function lm_284
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_decl(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_284(txt, rest);
      then txt;
  end match;
end lm_284;

protected function lm_285
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input array<list<HpcOmSimCode.Task>> in_a_hpcOmSchedule_threadTasks;
  input Integer in_a_n;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_type, in_a_hpcOmSchedule_threadTasks, in_a_n, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      array<list<HpcOmSimCode.Task>> a_hpcOmSchedule_threadTasks;
      Integer a_n;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_func(txt, a_derivativEquations, a_name, a_n, a_hpcOmSchedule_threadTasks, Tpl.textString(a_type), x_i0, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_285(txt, rest, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_285;

protected function lm_286
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Integer in_a_n;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_n, in_a_name)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer a_n;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_n,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_call(txt, a_name, a_n, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_286(txt, rest, a_n, a_name);
      then txt;
  end match;
end lm_286;

protected function lm_287
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_start(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_287(txt, rest);
      then txt;
  end match;
end lm_287;

protected function lm_288
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLock(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_288(txt, rest, a_type);
      then txt;
  end match;
end lm_288;

protected function lm_289
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLock(txt, intString(x_i0), "th_lock1", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_289(txt, rest, a_type);
      then txt;
  end match;
end lm_289;

protected function lm_290
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLock(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_290(txt, rest, a_type);
      then txt;
  end match;
end lm_290;

protected function lm_291
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLock(txt, intString(x_i0), "th_lock1", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_291(txt, rest, a_type);
      then txt;
  end match;
end lm_291;

protected function lm_292
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLock(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_292(txt, rest, a_type);
      then txt;
  end match;
end lm_292;

protected function lm_293
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLock(txt, intString(x_i0), "th_lock1", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_293(txt, rest, a_type);
      then txt;
  end match;
end lm_293;

protected function lm_294
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_releaseLock(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_294(txt, rest, a_type);
      then txt;
  end match;
end lm_294;

protected function lm_295
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_decl(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_295(txt, rest);
      then txt;
  end match;
end lm_295;

protected function lm_296
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input array<list<HpcOmSimCode.Task>> in_a_hpcOmSchedule_threadTasks;
  input Integer in_a_n;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_type, in_a_hpcOmSchedule_threadTasks, in_a_n, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      array<list<HpcOmSimCode.Task>> a_hpcOmSchedule_threadTasks;
      Integer a_n;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_func(txt, a_derivativEquations, a_name, a_n, a_hpcOmSchedule_threadTasks, Tpl.textString(a_type), x_i0, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_296(txt, rest, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_296;

protected function lm_297
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Integer in_a_n;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_n, in_a_name)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer a_n;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_n,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_call(txt, a_name, a_n, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_297(txt, rest, a_n, a_name);
      then txt;
  end match;
end lm_297;

protected function lm_298
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_start(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_298(txt, rest);
      then txt;
  end match;
end lm_298;

protected function lm_299
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLock(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_299(txt, rest);
      then txt;
  end match;
end lm_299;

protected function lm_300
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLock(txt, intString(x_i0), "th_lock1", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_300(txt, rest);
      then txt;
  end match;
end lm_300;

protected function lm_301
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLock(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_301(txt, rest);
      then txt;
  end match;
end lm_301;

protected function lm_302
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLock(txt, intString(x_i0), "th_lock1", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_302(txt, rest);
      then txt;
  end match;
end lm_302;

protected function lm_303
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLock(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_303(txt, rest);
      then txt;
  end match;
end lm_303;

protected function lm_304
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLock(txt, intString(x_i0), "th_lock1", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_304(txt, rest);
      then txt;
  end match;
end lm_304;

protected function lm_305
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_releaseLock(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_305(txt, rest);
      then txt;
  end match;
end lm_305;

protected function fun_306
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_assignLocks;
  input Tpl.Text in_a_initlocks;
  input Tpl.Text in_a_locks;
  input Integer in_a_n;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input array<list<HpcOmSimCode.Task>> in_a_hpcOmSchedule_threadTasks;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_assignLocks, in_a_initlocks, in_a_locks, in_a_n, in_a_modelNamePrefixStr, in_a_type, in_a_hpcOmSchedule_threadTasks, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_assignLocks;
      Tpl.Text a_initlocks;
      Tpl.Text a_locks;
      Integer a_n;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      array<list<HpcOmSimCode.Task>> a_hpcOmSchedule_threadTasks;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      list<list<HpcOmSimCode.Task>> ret_34;
      list<list<HpcOmSimCode.Task>> ret_33;
      list<list<HpcOmSimCode.Task>> ret_32;
      list<list<HpcOmSimCode.Task>> ret_31;
      list<list<HpcOmSimCode.Task>> ret_30;
      list<list<HpcOmSimCode.Task>> ret_29;
      list<list<HpcOmSimCode.Task>> ret_28;
      list<list<HpcOmSimCode.Task>> ret_27;
      list<list<HpcOmSimCode.Task>> ret_26;
      list<list<HpcOmSimCode.Task>> ret_25;
      list<list<HpcOmSimCode.Task>> ret_24;
      Integer ret_23;
      list<list<HpcOmSimCode.Task>> ret_22;
      Tpl.Text l_threadReleaseLocks;
      list<list<HpcOmSimCode.Task>> ret_20;
      Tpl.Text l_threadAssignLocks1;
      list<list<HpcOmSimCode.Task>> ret_18;
      Tpl.Text l_threadAssignLocks;
      list<list<HpcOmSimCode.Task>> ret_16;
      Tpl.Text l_threadLocksInit1;
      list<list<HpcOmSimCode.Task>> ret_14;
      Tpl.Text l_threadLocksInit;
      list<list<HpcOmSimCode.Task>> ret_12;
      Tpl.Text l_threadLocks1;
      list<list<HpcOmSimCode.Task>> ret_10;
      Tpl.Text l_threadLocks;
      list<list<HpcOmSimCode.Task>> ret_8;
      Tpl.Text l_threadStart;
      list<list<HpcOmSimCode.Task>> ret_6;
      Tpl.Text l_threadFuncCalls;
      list<list<HpcOmSimCode.Task>> ret_4;
      Tpl.Text l_threadFuncs;
      list<list<HpcOmSimCode.Task>> ret_2;
      Tpl.Text l_threadDecl;
      Tpl.Text l_taskEqs;

    case ( txt,
           "openmp",
           a_assignLocks,
           a_initlocks,
           a_locks,
           a_n,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_name,
           a_derivativEquations )
      equation
        l_taskEqs = functionXXX_system0_HPCOM_Thread(Tpl.emptyTxt, a_derivativEquations, a_name, a_hpcOmSchedule_threadTasks, Tpl.textString(a_type), a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "//using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int initialized = 0;\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n",
                                    "  omp_set_dynamic(0);\n",
                                    "  //create locks\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_locks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(!initialized)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_initlocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//set locks\n"
                                }, true));
        txt = Tpl.writeText(txt, a_assignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "initialized = 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_taskEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads",
           a_assignLocks,
           a_initlocks,
           a_locks,
           a_n,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_name,
           a_derivativEquations )
      equation
        ret_2 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadDecl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadDecl = lm_284(l_threadDecl, ret_2);
        l_threadDecl = Tpl.popIter(l_threadDecl);
        ret_4 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncs = lm_285(l_threadFuncs, ret_4, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
        l_threadFuncs = Tpl.popIter(l_threadFuncs);
        ret_6 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncCalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncCalls = lm_286(l_threadFuncCalls, ret_6, a_n, a_name);
        l_threadFuncCalls = Tpl.popIter(l_threadFuncCalls);
        ret_8 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadStart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadStart = lm_287(l_threadStart, ret_8);
        l_threadStart = Tpl.popIter(l_threadStart);
        ret_10 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks = lm_288(l_threadLocks, ret_10, a_type);
        l_threadLocks = Tpl.popIter(l_threadLocks);
        ret_12 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks1 = lm_289(l_threadLocks1, ret_12, a_type);
        l_threadLocks1 = Tpl.popIter(l_threadLocks1);
        ret_14 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit = lm_290(l_threadLocksInit, ret_14, a_type);
        l_threadLocksInit = Tpl.popIter(l_threadLocksInit);
        ret_16 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit1 = lm_291(l_threadLocksInit1, ret_16, a_type);
        l_threadLocksInit1 = Tpl.popIter(l_threadLocksInit1);
        ret_18 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks = lm_292(l_threadAssignLocks, ret_18, a_type);
        l_threadAssignLocks = Tpl.popIter(l_threadAssignLocks);
        ret_20 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks1 = lm_293(l_threadAssignLocks1, ret_20, a_type);
        l_threadAssignLocks1 = Tpl.popIter(l_threadAssignLocks1);
        ret_22 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadReleaseLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadReleaseLocks = lm_294(l_threadReleaseLocks, ret_22, a_type);
        l_threadReleaseLocks = Tpl.popIter(l_threadReleaseLocks);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// number of threads: "));
        ret_23 = arrayLength(a_hpcOmSchedule_threadTasks);
        txt = Tpl.writeStr(txt, intString(ret_23));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int finished; //set to 1 if the hpcom-threads should be destroyed\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_locks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "  finished = 1;\n",
                                    "\n",
                                    "  //Start the threads one last time\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int initialized = 0;\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n",
                                    "  if(!initialized)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, a_initlocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//set locks\n"
                                }, true));
        txt = Tpl.writeText(txt, a_assignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadAssignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadFuncCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("initialized = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n",
                                    "  //Start the threads\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//\"join\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_assignLocks,
           a_initlocks,
           a_locks,
           a_n,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_name,
           a_derivativEquations )
      equation
        ret_24 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadDecl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadDecl = lm_295(l_threadDecl, ret_24);
        l_threadDecl = Tpl.popIter(l_threadDecl);
        ret_25 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncs = lm_296(l_threadFuncs, ret_25, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
        l_threadFuncs = Tpl.popIter(l_threadFuncs);
        ret_26 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncCalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncCalls = lm_297(l_threadFuncCalls, ret_26, a_n, a_name);
        l_threadFuncCalls = Tpl.popIter(l_threadFuncCalls);
        ret_27 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadStart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadStart = lm_298(l_threadStart, ret_27);
        l_threadStart = Tpl.popIter(l_threadStart);
        ret_28 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks = lm_299(l_threadLocks, ret_28);
        l_threadLocks = Tpl.popIter(l_threadLocks);
        ret_29 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks1 = lm_300(l_threadLocks1, ret_29);
        l_threadLocks1 = Tpl.popIter(l_threadLocks1);
        ret_30 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit = lm_301(l_threadLocksInit, ret_30);
        l_threadLocksInit = Tpl.popIter(l_threadLocksInit);
        ret_31 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit1 = lm_302(l_threadLocksInit1, ret_31);
        l_threadLocksInit1 = Tpl.popIter(l_threadLocksInit1);
        ret_32 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks = lm_303(l_threadAssignLocks, ret_32);
        l_threadAssignLocks = Tpl.popIter(l_threadAssignLocks);
        ret_33 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks1 = lm_304(l_threadAssignLocks1, ret_33);
        l_threadAssignLocks1 = Tpl.popIter(l_threadAssignLocks1);
        ret_34 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadReleaseLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadReleaseLocks = lm_305(l_threadReleaseLocks, ret_34);
        l_threadReleaseLocks = Tpl.popIter(l_threadReleaseLocks);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int finished; //set to 1 if the hpcom-threads should be destroyed\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_locks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "  finished = 1;\n",
                                    "\n",
                                    "  //Start the threads one last time\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int initialized = 0;\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n",
                                    "  if(!initialized)\n",
                                    "  {\n",
                                    "      finished = 0;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, a_initlocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//set locks\n"
                                }, true));
        txt = Tpl.writeText(txt, a_assignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadAssignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadFuncCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("initialized = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n",
                                    "  //Start the threads\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//\"join\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_306;

protected function fun_307
  input Tpl.Text in_txt;
  input Option<HpcOmSimCode.Schedule> in_a_hpcOmScheduleOpt;
  input Tpl.Text in_a_type;
  input String in_a_modelNamePrefixStr;
  input Integer in_a_n;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_hpcOmScheduleOpt, in_a_type, in_a_modelNamePrefixStr, in_a_n, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_type;
      String a_modelNamePrefixStr;
      Integer a_n;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      array<list<HpcOmSimCode.Task>> i_hpcOmSchedule_threadTasks;
      list<String> i_hpcOmSchedule_lockIdc;
      list<HpcOmSimCode.TaskList> i_hpcOmSchedule_tasksOfLevels;
      list<tuple<HpcOmSimCode.Task, list<Integer>>> i_hpcOmSchedule_tasks;
      String str_6;
      Tpl.Text l_assignLocks;
      Tpl.Text l_initlocks;
      Tpl.Text l_locks;
      Integer ret_2;
      Tpl.Text l_odeEqs;
      Tpl.Text l_taskEqs;

    case ( txt,
           SOME(HpcOmSimCode.EMPTYSCHEDULE()),
           _,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = functionXXX_system(txt, a_derivativEquations, a_name, a_n, a_modelNamePrefixStr);
      then txt;

    case ( txt,
           SOME(HpcOmSimCode.TASKDEPSCHEDULE(tasks = i_hpcOmSchedule_tasks)),
           a_type,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        l_taskEqs = functionXXX_system0_HPCOM_TaskDep(Tpl.emptyTxt, i_hpcOmSchedule_tasks, a_derivativEquations, Tpl.textString(a_type), a_name, a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "//using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_taskEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           SOME(HpcOmSimCode.LEVELSCHEDULE(tasksOfLevels = i_hpcOmSchedule_tasksOfLevels)),
           a_type,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_280(l_odeEqs, i_hpcOmSchedule_tasksOfLevels, a_modelNamePrefixStr, a_type, a_name, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "//using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data)\n",
                                    "{\n",
                                    "  omp_set_dynamic(0);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#pragma omp parallel num_threads("));
        ret_2 = Flags.getConfigInt(Flags.NUM_PROC);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           SOME(HpcOmSimCode.THREADSCHEDULE(lockIdc = i_hpcOmSchedule_lockIdc, threadTasks = i_hpcOmSchedule_threadTasks)),
           a_type,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        l_locks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_locks = lm_281(l_locks, i_hpcOmSchedule_lockIdc, a_type);
        l_locks = Tpl.popIter(l_locks);
        l_initlocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_initlocks = lm_282(l_initlocks, i_hpcOmSchedule_lockIdc, a_type);
        l_initlocks = Tpl.popIter(l_initlocks);
        l_assignLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_assignLocks = lm_283(l_assignLocks, i_hpcOmSchedule_lockIdc, a_type);
        l_assignLocks = Tpl.popIter(l_assignLocks);
        str_6 = Tpl.textString(a_type);
        txt = fun_306(txt, str_6, l_assignLocks, l_initlocks, l_locks, a_n, a_modelNamePrefixStr, a_type, i_hpcOmSchedule_threadTasks, a_name, a_derivativEquations);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_307;

public function functionXXX_system_HPCOM
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input Option<HpcOmSimCode.Schedule> a_hpcOmScheduleOpt;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  String ret_1;
  Tpl.Text l_type;
algorithm
  ret_1 := Flags.getConfigString(Flags.HPCOM_CODE);
  l_type := Tpl.writeStr(Tpl.emptyTxt, ret_1);
  out_txt := fun_307(txt, a_hpcOmScheduleOpt, l_type, a_modelNamePrefixStr, a_n, a_name, a_derivativEquations);
end functionXXX_system_HPCOM;

protected function lm_309
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Level0Section(txt, a_derivativEquations, a_name, i_task, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_309(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_309;

protected function lm_310
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Level0(txt, a_derivativEquations, a_name, i_task, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_310(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_310;

protected function fun_311
  input Tpl.Text in_txt;
  input HpcOmSimCode.TaskList in_a_tasksOfLevel;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_name;
  input String in_a_iType;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tasksOfLevel, in_a_derivativEquations, in_a_name, in_a_iType, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_name;
      String a_iType;
      String a_modelNamePrefixStr;
      list<HpcOmSimCode.Task> i_tasks;
      Tpl.Text l_odeEqs;

    case ( txt,
           HpcOmSimCode.PARALLELTASKLIST(tasks = i_tasks),
           a_derivativEquations,
           a_name,
           a_iType,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_309(l_odeEqs, i_tasks, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma omp sections\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "#pragma omp barrier //I\'m not sure if this is required"
                                }, false));
      then txt;

    case ( txt,
           HpcOmSimCode.SERIALTASKLIST(tasks = i_tasks),
           a_derivativEquations,
           a_name,
           a_iType,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_310(l_odeEqs, i_tasks, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma omp master\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "#pragma omp barrier"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_311;

public function functionXXX_system0_HPCOM_Level
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.TaskList a_tasksOfLevel;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_311(txt, a_tasksOfLevel, a_derivativEquations, a_name, a_iType, a_modelNamePrefixStr);
end functionXXX_system0_HPCOM_Level;

public function functionXXX_system0_HPCOM_Level0
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.Task a_iTask;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
  out_txt := function_HPCOM_Task(out_txt, a_derivativEquations, a_name, a_iTask, a_iType, a_modelNamePrefixStr);
  out_txt := Tpl.popBlock(out_txt);
end functionXXX_system0_HPCOM_Level0;

public function functionXXX_system0_HPCOM_Level0Section
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.Task a_iTask;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#pragma omp section\n",
                                   "{\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := function_HPCOM_Task(out_txt, a_derivativEquations, a_name, a_iTask, a_iType, a_modelNamePrefixStr);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionXXX_system0_HPCOM_Level0Section;

protected function lm_315
  input Tpl.Text in_txt;
  input list<tuple<HpcOmSimCode.Task, list<Integer>>> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_name;
  input String in_a_iType;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_name, in_a_iType, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<tuple<HpcOmSimCode.Task, list<Integer>>> rest;
      String a_modelNamePrefixStr;
      String a_name;
      String a_iType;
      list<SimCode.SimEqSystem> a_derivativEquations;
      tuple<HpcOmSimCode.Task, list<Integer>> i_t;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_t :: rest,
           a_modelNamePrefixStr,
           a_name,
           a_iType,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_TaskDep0(txt, i_t, a_derivativEquations, a_iType, a_name, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_315(txt, rest, a_modelNamePrefixStr, a_name, a_iType, a_derivativEquations);
      then txt;
  end match;
end lm_315;

public function functionXXX_system0_HPCOM_TaskDep
  input Tpl.Text txt;
  input list<tuple<HpcOmSimCode.Task, list<Integer>>> a_tasks;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_iType;
  input String a_name;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_odeEqs;
algorithm
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_315(l_odeEqs, a_tasks, a_modelNamePrefixStr, a_name, a_iType, a_derivativEquations);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "\n",
                                   "int t[0];\n",
                                   "#pragma omp parallel\n",
                                   "{\n",
                                   "  #pragma omp master\n",
                                   "  {\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(6));
  out_txt := Tpl.writeText(out_txt, l_odeEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "}"
                                   }, false));
end functionXXX_system0_HPCOM_TaskDep;

protected function lm_317
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_p;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_p :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("t["));
        txt = Tpl.writeStr(txt, intString(i_p));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
        txt = Tpl.nextIter(txt);
        txt = lm_317(txt, rest);
      then txt;
  end match;
end lm_317;

protected function fun_318
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_parentDependencies;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_parentDependencies)
    local
      Tpl.Text txt;
      Tpl.Text a_parentDependencies;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_parentDependencies )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("depend(in:"));
        txt = Tpl.writeText(txt, a_parentDependencies);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_318;

public function functionXXX_system0_HPCOM_TaskDep0
  input Tpl.Text in_txt;
  input tuple<HpcOmSimCode.Task, list<Integer>> in_a_taskIn;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_iType;
  input String in_a_name;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_taskIn, in_a_derivativEquations, in_a_iType, in_a_name, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_iType;
      String a_name;
      String a_modelNamePrefixStr;
      Integer i_task_index;
      list<Integer> i_parents;
      HpcOmSimCode.Task i_task;
      Boolean ret_4;
      Integer ret_3;
      Tpl.Text l_depIn;
      Tpl.Text l_parentDependencies;
      Tpl.Text l_taskEqs;

    case ( txt,
           ((i_task as HpcOmSimCode.CALCTASK(index = i_task_index)), i_parents),
           a_derivativEquations,
           a_iType,
           a_name,
           a_modelNamePrefixStr )
      equation
        l_taskEqs = function_HPCOM_Task(Tpl.emptyTxt, a_derivativEquations, a_name, i_task, a_iType, a_modelNamePrefixStr);
        l_parentDependencies = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_parentDependencies = lm_317(l_parentDependencies, i_parents);
        l_parentDependencies = Tpl.popIter(l_parentDependencies);
        ret_3 = listLength(i_parents);
        ret_4 = intGt(ret_3, 0);
        l_depIn = fun_318(Tpl.emptyTxt, ret_4, l_parentDependencies);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#pragma omp task "));
        txt = Tpl.writeText(txt, l_depIn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" depend(out:t["));
        txt = Tpl.writeStr(txt, intString(i_task_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "])\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_taskEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end functionXXX_system0_HPCOM_TaskDep0;

protected function lm_320
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      list<HpcOmSimCode.Task> i_tt;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_tt :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Thread0(txt, a_derivativEquations, a_name, i_tt, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_320(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_320;

protected function fun_321
  input Tpl.Text in_txt;
  input String in_a_iType;
  input Tpl.Text in_a_odeEqs;
  input array<list<HpcOmSimCode.Task>> in_a_threadTasks;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_odeEqs, in_a_threadTasks)
    local
      Tpl.Text txt;
      Tpl.Text a_odeEqs;
      array<list<HpcOmSimCode.Task>> a_threadTasks;
      Integer ret_0;

    case ( txt,
           "openmp",
           a_odeEqs,
           a_threadTasks )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if (omp_get_dynamic())\n",
                                    "  omp_set_dynamic(0);\n",
                                    "#pragma omp parallel sections num_threads("
                                }, false));
        ret_0 = arrayLength(a_threadTasks);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, a_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//not implemented"));
      then txt;

    case ( txt,
           "pthreads_spin",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//not implemented"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_321;

public function functionXXX_system0_HPCOM_Thread
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input array<list<HpcOmSimCode.Task>> a_threadTasks;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  list<list<HpcOmSimCode.Task>> ret_1;
  Tpl.Text l_odeEqs;
algorithm
  ret_1 := arrayList(a_threadTasks);
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_320(l_odeEqs, ret_1, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  out_txt := fun_321(txt, a_iType, l_odeEqs, a_threadTasks);
end functionXXX_system0_HPCOM_Thread;

protected function lm_323
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.Task i_tt;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_tt :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = function_HPCOM_Task(txt, a_derivativEquations, a_name, i_tt, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_323(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_323;

protected function fun_324
  input Tpl.Text in_txt;
  input String in_a_iType;
  input Tpl.Text in_a_threadTasks;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_threadTasks)
    local
      Tpl.Text txt;
      Tpl.Text a_threadTasks;

    case ( txt,
           "openmp",
           a_threadTasks )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma omp section\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_threadTasks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads",
           a_threadTasks )
      equation
        txt = Tpl.writeText(txt, a_threadTasks);
      then txt;

    case ( txt,
           "pthreads_spin",
           a_threadTasks )
      equation
        txt = Tpl.writeText(txt, a_threadTasks);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_324;

public function functionXXX_system0_HPCOM_Thread0
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input list<HpcOmSimCode.Task> a_threadTaskList;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_threadTasks;
algorithm
  l_threadTasks := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_threadTasks := lm_323(l_threadTasks, a_threadTaskList, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
  l_threadTasks := Tpl.popIter(l_threadTasks);
  out_txt := fun_324(txt, a_iType, l_threadTasks);
end functionXXX_system0_HPCOM_Thread0;

protected function lm_326
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input String in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<Integer> rest;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        txt = equationNamesHPCOM_Thread_(txt, i_eq, a_derivativEquations, SimCode.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_326(txt, rest, a_modelNamePrefixStr, a_derivativEquations);
      then txt;
  end match;
end lm_326;

protected function lm_327
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input String in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<Integer> rest;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        txt = equationNamesHPCOM_Thread_(txt, i_eq, a_derivativEquations, SimCode.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_327(txt, rest, a_modelNamePrefixStr, a_derivativEquations);
      then txt;
  end match;
end lm_327;

protected function fun_328
  input Tpl.Text in_txt;
  input HpcOmSimCode.Task in_a_iTask;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_iType;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iTask, in_a_derivativEquations, in_a_iType, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_iType;
      String a_modelNamePrefixStr;
      String i_task_lockId;
      Integer i_task_index;
      list<Integer> i_task_eqIdc;
      Tpl.Text l_relLck;
      Tpl.Text l_assLck;
      Tpl.Text l_odeEqs;

    case ( txt,
           HpcOmSimCode.CALCTASK(eqIdc = i_task_eqIdc, index = i_task_index),
           a_derivativEquations,
           _,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_326(l_odeEqs, i_task_eqIdc, a_modelNamePrefixStr, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// Task "));
        txt = Tpl.writeStr(txt, intString(i_task_index));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// End Task "));
        txt = Tpl.writeStr(txt, intString(i_task_index));
      then txt;

    case ( txt,
           HpcOmSimCode.CALCTASK_LEVEL(eqIdc = i_task_eqIdc),
           a_derivativEquations,
           _,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_327(l_odeEqs, i_task_eqIdc, a_modelNamePrefixStr, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeText(txt, l_odeEqs);
      then txt;

    case ( txt,
           HpcOmSimCode.ASSIGNLOCKTASK(lockId = i_task_lockId),
           _,
           a_iType,
           _ )
      equation
        l_assLck = function_HPCOM_assignLock(Tpl.emptyTxt, i_task_lockId, "lock", a_iType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//Assign lock "));
        txt = Tpl.writeStr(txt, i_task_lockId);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_assLck);
      then txt;

    case ( txt,
           HpcOmSimCode.RELEASELOCKTASK(lockId = i_task_lockId),
           _,
           a_iType,
           _ )
      equation
        l_relLck = function_HPCOM_releaseLock(Tpl.emptyTxt, i_task_lockId, "lock", a_iType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//Release lock "));
        txt = Tpl.writeStr(txt, i_task_lockId);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_relLck);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_328;

public function function_HPCOM_Task
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.Task a_iTask;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_328(txt, a_iTask, a_derivativEquations, a_iType, a_modelNamePrefixStr);
end function_HPCOM_Task;

protected function fun_330
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockIdx;
  input String in_a_lockPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockIdx, in_a_lockPrefix)
    local
      Tpl.Text txt;
      String a_lockIdx;
      String a_lockPrefix;

    case ( txt,
           "openmp",
           a_lockIdx,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omp_init_lock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockIdx,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_init(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", NULL);"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockIdx,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_spin_init(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 0);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_330;

public function function_HPCOM_initializeLock
  input Tpl.Text txt;
  input String a_lockIdx;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_330(txt, a_iType, a_lockIdx, a_lockPrefix);
end function_HPCOM_initializeLock;

protected function fun_332
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockIdx;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockIdx, in_a_prefix)
    local
      Tpl.Text txt;
      String a_lockIdx;
      String a_prefix;

    case ( txt,
           "openmp",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static omp_lock_t "));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static pthread_mutex_t "));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static pthread_spinlock_t "));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_332;

public function function_HPCOM_createLock
  input Tpl.Text txt;
  input String a_lockIdx;
  input String a_prefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_332(txt, a_iType, a_lockIdx, a_prefix);
end function_HPCOM_createLock;

protected function fun_334
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockIdx;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockIdx, in_a_prefix)
    local
      Tpl.Text txt;
      String a_lockIdx;
      String a_prefix;

    case ( txt,
           "openmp",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omp_set_lock(&"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_lock(&"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_spin_lock(&"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_334;

public function function_HPCOM_assignLock
  input Tpl.Text txt;
  input String a_lockIdx;
  input String a_prefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_334(txt, a_iType, a_lockIdx, a_prefix);
end function_HPCOM_assignLock;

protected function fun_336
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockIdx;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockIdx, in_a_prefix)
    local
      Tpl.Text txt;
      String a_lockIdx;
      String a_prefix;

    case ( txt,
           "openmp",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omp_unset_lock(&"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_unlock(&"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockIdx,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_spin_unlock(&"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_336;

public function function_HPCOM_releaseLock
  input Tpl.Text txt;
  input String a_lockIdx;
  input String a_prefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_336(txt, a_iType, a_lockIdx, a_prefix);
end function_HPCOM_releaseLock;

public function functionXXX_system0_HPCOM_PThread_func
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input array<list<HpcOmSimCode.Task>> a_threadTasks;
  input String a_iType;
  input Integer a_idx;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_relLock;
  Tpl.Text l_assLock;
  list<HpcOmSimCode.Task> ret_2;
  Integer ret_1;
  Tpl.Text l_taskEqs;
algorithm
  ret_1 := intAdd(a_idx, 1);
  ret_2 := arrayGet(a_threadTasks, ret_1);
  l_taskEqs := functionXXX_system0_HPCOM_Thread0(Tpl.emptyTxt, a_derivativEquations, a_name, ret_2, a_iType, a_modelNamePrefixStr);
  l_assLock := function_HPCOM_assignLock(Tpl.emptyTxt, intString(a_idx), "th_lock", "pthreads");
  l_relLock := function_HPCOM_releaseLock(Tpl.emptyTxt, intString(a_idx), "th_lock1", "pthreads");
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void function"));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_system"));
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_thread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n",
                                       "  while(1)\n",
                                       "  {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeText(out_txt, l_assLock);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "if(finished)\n",
                                       "   return;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_taskEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_relLock);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "}"
                                   }, false));
end functionXXX_system0_HPCOM_PThread_func;

public function functionXXX_system0_HPCOM_PThread_call
  input Tpl.Text txt;
  input String a_name;
  input Integer a_n;
  input Integer a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("GC_pthread_create(&odeThread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", NULL, function"));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_system"));
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_thread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", data);"));
end functionXXX_system0_HPCOM_PThread_call;

public function functionXXX_system0_HPCOM_PThread_decl
  input Tpl.Text txt;
  input Integer a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("static pthread_t odeThread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
end functionXXX_system0_HPCOM_PThread_decl;

public function functionXXX_system0_HPCOM_PThread_start
  input Tpl.Text txt;
  input Integer a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_lock(&th_unlock_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(");"));
end functionXXX_system0_HPCOM_PThread_start;

protected function fun_342
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_mArg;
  input String in_a_modelNamePrefixStr;
  input Integer in_a_idx;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_idx, in_a_derivativEquations)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      Integer a_idx;
      list<SimCode.SimEqSystem> a_derivativEquations;
      SimCode.SimEqSystem ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_idx,
           a_derivativEquations )
      equation
        ret_1 = HpcOmSimCodeMain.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, ret_1);
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data);"));
      then txt;
  end match;
end fun_342;

protected function fun_343
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_mArg;
  input String in_a_modelNamePrefixStr;
  input Integer in_a_idx;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_idx, in_a_derivativEquations)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      Integer a_idx;
      list<SimCode.SimEqSystem> a_derivativEquations;
      SimCode.SimEqSystem ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_idx,
           a_derivativEquations )
      equation
        ret_1 = HpcOmSimCodeMain.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, ret_1);
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data);"));
      then txt;
  end match;
end fun_343;

protected function fun_344
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Integer in_a_idx;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_idx, in_a_derivativEquations, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Integer a_idx;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem ret_1;
      SimCode.SimEqSystem ret_0;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = true),
           a_idx,
           a_derivativEquations,
           a_modelNamePrefixStr )
      equation
        ret_0 = HpcOmSimCodeMain.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        txt = fun_342(txt, ret_0, a_modelNamePrefixStr, a_idx, a_derivativEquations);
      then txt;

    case ( txt,
           _,
           a_idx,
           a_derivativEquations,
           a_modelNamePrefixStr )
      equation
        ret_1 = HpcOmSimCodeMain.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        txt = fun_343(txt, ret_1, a_modelNamePrefixStr, a_idx, a_derivativEquations);
      then txt;
  end match;
end fun_344;

public function equationNamesHPCOM_Thread_
  input Tpl.Text txt;
  input Integer a_idx;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input SimCode.Context a_context;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_344(txt, a_context, a_idx, a_derivativEquations, a_modelNamePrefixStr);
end equationNamesHPCOM_Thread_;

protected function lm_346
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equationNames_(txt, i_eq, SimCode.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_346(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_346;

protected function lm_347
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equationForward_(txt, i_eq, SimCode.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_347(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_347;

public function functionXXX_system
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_forwardEqs;
  Tpl.Text l_odeEqs;
algorithm
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_346(l_odeEqs, a_derivativEquations, a_modelNamePrefixStr);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  l_forwardEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_forwardEqs := lm_347(l_forwardEqs, a_derivativEquations, a_modelNamePrefixStr);
  l_forwardEqs := Tpl.popIter(l_forwardEqs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "\n",
                                   "/* forwarded equations */\n"
                               }, true));
  out_txt := Tpl.writeText(out_txt, l_forwardEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "static void function"
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_system"));
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_odeEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionXXX_system;

protected function lm_349
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_modelNamePrefixStr;
      String a_name;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system(txt, i_eq, a_name, x_i0, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_349(txt, rest, a_modelNamePrefixStr, a_name);
      then txt;
  end match;
end lm_349;

protected function lm_350
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_350(txt, rest, a_name);
      then txt;
  end match;
end lm_350;

protected function fun_351
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dynamic"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static"));
      then txt;
  end match;
end fun_351;

protected function fun_352
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer ret_0;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#pragma omp parallel for private(id) schedule("));
        ret_0 = Config.noProc();
        txt = fun_351(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_352;

protected function fun_353
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_varDecls;
  input list<list<SimCode.SimEqSystem>> in_a_eqs;
  input Tpl.Text in_a_funcs;
  input String in_a_name;
  input Tpl.Text in_a_loop;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_loop;
algorithm
  (out_txt, out_a_varDecls, out_a_loop) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_eqs, in_a_funcs, in_a_name, in_a_loop)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<list<SimCode.SimEqSystem>> a_eqs;
      Tpl.Text a_funcs;
      String a_name;
      Tpl.Text a_loop;
      Integer i_nFuncs;
      Boolean ret_2;
      Tpl.Text l_head;
      Tpl.Text l_funcNames;

    case ( txt,
           0,
           a_varDecls,
           _,
           _,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("/* no "));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING(" systems */"));
      then (txt, a_varDecls, a_loop);

    case ( txt,
           1,
           a_varDecls,
           _,
           a_funcs,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("_system0(data);"));
        txt = Tpl.writeText(txt, a_funcs);
      then (txt, a_varDecls, a_loop);

    case ( txt,
           i_nFuncs,
           a_varDecls,
           a_eqs,
           a_funcs,
           a_name,
           a_loop )
      equation
        l_funcNames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_funcNames = lm_350(l_funcNames, a_eqs, a_name);
        l_funcNames = Tpl.popIter(l_funcNames);
        ret_2 = Flags.isSet(Flags.PARMODAUTO);
        l_head = fun_352(Tpl.emptyTxt, ret_2);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("int id;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_loop = Tpl.writeText(a_loop, l_head);
        a_loop = Tpl.softNewLine(a_loop);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("for(id=0; id<"));
        a_loop = Tpl.writeStr(a_loop, intString(i_nFuncs));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("; id++) {\n"));
        a_loop = Tpl.pushBlock(a_loop, Tpl.BT_INDENT(2));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("_systems[id](data);\n"));
        a_loop = Tpl.popBlock(a_loop);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, a_funcs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void (*function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(i_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_funcNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_varDecls, a_loop);
  end match;
end fun_353;

public function functionXXX_systems
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqs;
  input String a_name;
  input Tpl.Text a_loop;
  input Tpl.Text a_varDecls;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_loop;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_funcs;
algorithm
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_funcs := lm_349(l_funcs, a_eqs, a_modelNamePrefixStr, a_name);
  l_funcs := Tpl.popIter(l_funcs);
  ret_1 := listLength(a_eqs);
  (out_txt, out_a_varDecls, out_a_loop) := fun_353(txt, ret_1, a_varDecls, a_eqs, l_funcs, a_name, a_loop);
end functionXXX_systems;

protected function fun_355
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_355;

protected function fun_356
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_356;

protected function fun_357
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_arrayIndex;
  input String in_a_name;
  input Tpl.Text in_a_forwardEqs;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_arrayEqs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_forwardEqs;
  output Tpl.Text out_a_arrayEqs;
algorithm
  (out_txt, out_a_forwardEqs, out_a_arrayEqs) :=
  match(in_txt, in_a_eq, in_a_arrayIndex, in_a_name, in_a_forwardEqs, in_a_modelNamePrefixStr, in_a_arrayEqs)
    local
      Tpl.Text txt;
      Integer a_arrayIndex;
      String a_name;
      Tpl.Text a_forwardEqs;
      String a_modelNamePrefixStr;
      Tpl.Text a_arrayEqs;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           a_forwardEqs,
           _,
           a_arrayEqs )
      then (txt, a_forwardEqs, a_arrayEqs);

    case ( txt,
           i_eq,
           a_arrayIndex,
           a_name,
           a_forwardEqs,
           a_modelNamePrefixStr,
           a_arrayEqs )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        a_arrayEqs = symbolName(a_arrayEqs, a_modelNamePrefixStr, "eqFunction");
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING("_"));
        a_arrayEqs = Tpl.writeText(a_arrayEqs, l_ix);
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING(","));
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_NEW_LINE());
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("extern void "));
        a_forwardEqs = symbolName(a_forwardEqs, a_modelNamePrefixStr, "eqFunction");
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("_"));
        a_forwardEqs = Tpl.writeText(a_forwardEqs, l_ix);
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("(DATA* data);"));
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_NEW_LINE());
        ret_1 = Config.profileAll();
        txt = fun_355(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(a_arrayIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("](data);\n"));
        ret_2 = Config.profileAll();
        txt = fun_356(txt, ret_2, l_ix);
      then (txt, a_forwardEqs, a_arrayEqs);
  end match;
end fun_357;

protected function fun_358
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_358;

protected function fun_359
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_359;

protected function fun_360
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_arrayIndex;
  input String in_a_name;
  input Tpl.Text in_a_forwardEqs;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_arrayEqs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_forwardEqs;
  output Tpl.Text out_a_arrayEqs;
algorithm
  (out_txt, out_a_forwardEqs, out_a_arrayEqs) :=
  match(in_txt, in_a_eq, in_a_arrayIndex, in_a_name, in_a_forwardEqs, in_a_modelNamePrefixStr, in_a_arrayEqs)
    local
      Tpl.Text txt;
      Integer a_arrayIndex;
      String a_name;
      Tpl.Text a_forwardEqs;
      String a_modelNamePrefixStr;
      Tpl.Text a_arrayEqs;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           a_forwardEqs,
           _,
           a_arrayEqs )
      then (txt, a_forwardEqs, a_arrayEqs);

    case ( txt,
           i_eq,
           a_arrayIndex,
           a_name,
           a_forwardEqs,
           a_modelNamePrefixStr,
           a_arrayEqs )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        a_arrayEqs = symbolName(a_arrayEqs, a_modelNamePrefixStr, "eqFunction");
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING("_"));
        a_arrayEqs = Tpl.writeText(a_arrayEqs, l_ix);
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING(","));
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_NEW_LINE());
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("extern void "));
        a_forwardEqs = symbolName(a_forwardEqs, a_modelNamePrefixStr, "eqFunction");
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("_"));
        a_forwardEqs = Tpl.writeText(a_forwardEqs, l_ix);
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("(DATA* data);"));
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_NEW_LINE());
        ret_1 = Config.profileAll();
        txt = fun_358(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// "));
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data);\n",
                                    "function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(a_arrayIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("](data);\n"));
        ret_2 = Config.profileAll();
        txt = fun_359(txt, ret_2, l_ix);
      then (txt, a_forwardEqs, a_arrayEqs);
  end match;
end fun_360;

protected function fun_361
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_name;
  input Integer in_a_arrayIndex;
  input Tpl.Text in_a_arrayEqs;
  input Tpl.Text in_a_forwardEqs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayEqs;
  output Tpl.Text out_a_forwardEqs;
algorithm
  (out_txt, out_a_arrayEqs, out_a_forwardEqs) :=
  match(in_txt, in_a_context, in_a_eq, in_a_name, in_a_arrayIndex, in_a_arrayEqs, in_a_forwardEqs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      String a_name;
      Integer a_arrayIndex;
      Tpl.Text a_arrayEqs;
      Tpl.Text a_forwardEqs;
      String a_modelNamePrefixStr;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = true),
           a_eq,
           a_name,
           a_arrayIndex,
           a_arrayEqs,
           a_forwardEqs,
           a_modelNamePrefixStr )
      equation
        (txt, a_forwardEqs, a_arrayEqs) = fun_357(txt, a_eq, a_arrayIndex, a_name, a_forwardEqs, a_modelNamePrefixStr, a_arrayEqs);
      then (txt, a_arrayEqs, a_forwardEqs);

    case ( txt,
           _,
           a_eq,
           a_name,
           a_arrayIndex,
           a_arrayEqs,
           a_forwardEqs,
           a_modelNamePrefixStr )
      equation
        (txt, a_forwardEqs, a_arrayEqs) = fun_360(txt, a_eq, a_arrayIndex, a_name, a_forwardEqs, a_modelNamePrefixStr, a_arrayEqs);
      then (txt, a_arrayEqs, a_forwardEqs);
  end match;
end fun_361;

public function equationNamesArrayFormat
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input String a_name;
  input Integer a_arrayIndex;
  input Tpl.Text a_arrayEqs;
  input Tpl.Text a_forwardEqs;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayEqs;
  output Tpl.Text out_a_forwardEqs;
algorithm
  (out_txt, out_a_arrayEqs, out_a_forwardEqs) := fun_361(txt, a_context, a_eq, a_name, a_arrayIndex, a_arrayEqs, a_forwardEqs, a_modelNamePrefixStr);
end equationNamesArrayFormat;

protected function lm_363
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_forwardEqs;
  input Tpl.Text in_a_arrayEqs;
  input String in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_forwardEqs;
  output Tpl.Text out_a_arrayEqs;
algorithm
  (out_txt, out_a_forwardEqs, out_a_arrayEqs) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_forwardEqs, in_a_arrayEqs, in_a_name)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_forwardEqs;
      Tpl.Text a_arrayEqs;
      String a_name;
      Integer x_i0;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_forwardEqs,
           a_arrayEqs,
           _ )
      then (txt, a_forwardEqs, a_arrayEqs);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_forwardEqs,
           a_arrayEqs,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_arrayEqs, a_forwardEqs) = equationNamesArrayFormat(txt, i_eq, SimCode.contextSimulationNonDiscrete, a_name, x_i0, a_arrayEqs, a_forwardEqs, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        (txt, a_forwardEqs, a_arrayEqs) = lm_363(txt, rest, a_modelNamePrefixStr, a_forwardEqs, a_arrayEqs, a_name);
      then (txt, a_forwardEqs, a_arrayEqs);
  end match;
end lm_363;

protected function fun_364
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_a_eqlstlst;
  input String in_a_name;
  input Tpl.Text in_a_fncalls;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fncalls;
  output Tpl.Text out_a_nrfuncs;
algorithm
  (out_txt, out_a_fncalls, out_a_nrfuncs) :=
  match(in_txt, in_a_eqlstlst, in_a_name, in_a_fncalls, in_a_nrfuncs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_name;
      Tpl.Text a_fncalls;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> i_eqlst;
      Tpl.Text l_forwardEqs;
      Tpl.Text l_arrayEqs;
      Integer ret_0;

    case ( txt,
           {},
           a_name,
           a_fncalls,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* no "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" systems */"));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           {{}},
           a_name,
           a_fncalls,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* no "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" systems */"));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           {i_eqlst},
           a_name,
           a_fncalls,
           a_nrfuncs,
           a_modelNamePrefixStr )
      equation
        ret_0 = listLength(i_eqlst);
        a_nrfuncs = Tpl.writeStr(a_nrfuncs, intString(ret_0));
        l_arrayEqs = Tpl.emptyTxt;
        l_forwardEqs = Tpl.emptyTxt;
        a_fncalls = Tpl.pushIter(a_fncalls, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_fncalls, l_forwardEqs, l_arrayEqs) = lm_363(a_fncalls, i_eqlst, a_modelNamePrefixStr, l_forwardEqs, l_arrayEqs, a_name);
        a_fncalls = Tpl.popIter(a_fncalls);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* forwarded equations */\n"));
        txt = Tpl.writeText(txt, l_forwardEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "static void (*function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_arrayEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "\n"
                                }, true));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           {_ :: _},
           a_name,
           a_fncalls,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* TODO more than ODE list in "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" systems */"));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           _,
           _,
           a_fncalls,
           a_nrfuncs,
           _ )
      then (txt, a_fncalls, a_nrfuncs);
  end match;
end fun_364;

public function functionXXX_systems_arrayFormat
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqlstlst;
  input String a_name;
  input Tpl.Text a_fncalls;
  input Tpl.Text a_nrfuncs;
  input Tpl.Text a_varDecls;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fncalls;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_fncalls, out_a_nrfuncs) := fun_364(txt, a_eqlstlst, a_name, a_fncalls, a_nrfuncs, a_modelNamePrefixStr);
  out_a_varDecls := a_varDecls;
end functionXXX_systems_arrayFormat;

protected function fun_366
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_fncalls;
  input list<list<SimCode.SimEqSystem>> in_a_derivativEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_fncalls;
algorithm
  (out_txt, out_a_nrfuncs, out_a_varDecls, out_a_fncalls) :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_modelNamePrefix, in_a_varDecls, in_a_fncalls, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_fncalls;
      list<list<SimCode.SimEqSystem>> a_derivativEquations;

    case ( txt,
           false,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        (txt, a_fncalls, a_varDecls) = functionXXX_systems(txt, a_derivativEquations, "ODE", a_fncalls, a_varDecls, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);

    case ( txt,
           _,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        (txt, a_fncalls, a_nrfuncs, a_varDecls) = functionXXX_systems_arrayFormat(txt, a_derivativEquations, "ODE", a_fncalls, a_nrfuncs, a_varDecls, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);
  end match;
end fun_366;

protected function fun_367
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Option<HpcOmSimCode.Schedule> in_a_hpcOmSchedule;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_fncalls;
  input list<list<SimCode.SimEqSystem>> in_a_derivativEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_fncalls;
algorithm
  (out_txt, out_a_nrfuncs, out_a_varDecls, out_a_fncalls) :=
  match(in_txt, in_mArg, in_a_hpcOmSchedule, in_a_nrfuncs, in_a_modelNamePrefix, in_a_varDecls, in_a_fncalls, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Option<HpcOmSimCode.Schedule> a_hpcOmSchedule;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_fncalls;
      list<list<SimCode.SimEqSystem>> a_derivativEquations;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        ret_0 = Flags.isSet(Flags.PARMODAUTO);
        (txt, a_nrfuncs, a_varDecls, a_fncalls) = fun_366(txt, ret_0, a_nrfuncs, a_modelNamePrefix, a_varDecls, a_fncalls, a_derivativEquations);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);

    case ( txt,
           _,
           a_hpcOmSchedule,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        (txt, a_fncalls, a_varDecls) = functionXXX_systems_HPCOM(txt, a_derivativEquations, "ODE", a_fncalls, a_varDecls, a_hpcOmSchedule, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);
  end match;
end fun_367;

protected function fun_368
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rt_tick(SIM_TIMER_FUNCTION_ODE);"));
      then txt;
  end match;
end fun_368;

protected function fun_369
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input Tpl.Text in_a_fncalls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_fncalls)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      Tpl.Text a_fncalls;

    case ( txt,
           false,
           _,
           a_fncalls )
      equation
        txt = Tpl.writeText(txt, a_fncalls);
      then txt;

    case ( txt,
           _,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PM_functionODE("));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data, functionODE_systems);"));
      then txt;
  end match;
end fun_369;

protected function fun_370
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rt_accumulate(SIM_TIMER_FUNCTION_ODE);"));
      then txt;
  end match;
end fun_370;

public function functionODE
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_derivativEquations;
  input Tpl.Text a_method;
  input Option<HpcOmSimCode.Schedule> a_hpcOmSchedule;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
protected
  Boolean ret_9;
  Boolean ret_8;
  Boolean ret_7;
  Tpl.Text l_tmp;
  Boolean ret_5;
  Tpl.Text l_systems;
  Tpl.Text l_fncalls;
  Tpl.Text l_varDecls;
  Tpl.Text l_varDecls2;
  Tpl.Text l_nrfuncs;
algorithm
  System.tmpTickReset(0);
  l_nrfuncs := Tpl.emptyTxt;
  l_varDecls2 := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  l_fncalls := Tpl.emptyTxt;
  ret_5 := Flags.isSet(Flags.HPCOM);
  (l_systems, l_nrfuncs, l_varDecls, l_fncalls) := fun_367(Tpl.emptyTxt, ret_5, a_hpcOmSchedule, l_nrfuncs, a_modelNamePrefix, l_varDecls, l_fncalls, a_derivativEquations);
  l_tmp := Tpl.emptyTxt;
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_systems);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "functionODE");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_7 := Config.profileFunctions();
  out_txt := fun_368(out_txt, ret_7);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "data->simulationInfo.callStatistics.functionODE++;\n",
                                       "\n",
                                       "data->simulationInfo.discreteCall = 0;\n"
                                   }, true));
  ret_8 := Flags.isSet(Flags.PARMODAUTO);
  out_txt := fun_369(out_txt, ret_8, l_nrfuncs, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  ret_9 := Config.profileFunctions();
  out_txt := fun_370(out_txt, ret_9);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_method := a_method;
end functionODE;

protected function fun_372
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_fncalls;
  input list<list<SimCode.SimEqSystem>> in_a_algebraicEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_fncalls;
algorithm
  (out_txt, out_a_nrfuncs, out_a_varDecls, out_a_fncalls) :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_modelNamePrefix, in_a_varDecls, in_a_fncalls, in_a_algebraicEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_fncalls;
      list<list<SimCode.SimEqSystem>> a_algebraicEquations;

    case ( txt,
           false,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_algebraicEquations )
      equation
        (txt, a_fncalls, a_varDecls) = functionXXX_systems(txt, a_algebraicEquations, "Alg", a_fncalls, a_varDecls, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);

    case ( txt,
           _,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_algebraicEquations )
      equation
        (txt, a_fncalls, a_nrfuncs, a_varDecls) = functionXXX_systems_arrayFormat(txt, a_algebraicEquations, "Alg", a_fncalls, a_nrfuncs, a_varDecls, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);
  end match;
end fun_372;

protected function fun_373
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input Tpl.Text in_a_fncalls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_fncalls)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      Tpl.Text a_fncalls;

    case ( txt,
           false,
           _,
           a_fncalls )
      equation
        txt = Tpl.writeText(txt, a_fncalls);
      then txt;

    case ( txt,
           _,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PM_functionAlg("));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data, functionAlg_systems);"));
      then txt;
  end match;
end fun_373;

public function functionAlgebraic
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_algebraicEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_5;
  Boolean ret_4;
  Tpl.Text l_systems;
  Tpl.Text l_fncalls;
  Tpl.Text l_nrfuncs;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_nrfuncs := Tpl.emptyTxt;
  l_fncalls := Tpl.emptyTxt;
  ret_4 := Flags.isSet(Flags.PARMODAUTO);
  (l_systems, l_nrfuncs, l_varDecls, l_fncalls) := fun_372(Tpl.emptyTxt, ret_4, l_nrfuncs, a_modelNamePrefix, l_varDecls, l_fncalls, a_algebraicEquations);
  out_txt := Tpl.writeText(txt, l_systems);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* for continuous time variables */\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "functionAlgebraics");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "\n",
                                       "data->simulationInfo.discreteCall = 0;\n"
                                   }, true));
  ret_5 := Flags.isSet(Flags.PARMODAUTO);
  out_txt := fun_373(out_txt, ret_5, l_nrfuncs, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionAlgebraic;

protected function lm_375
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextSimulationNonDiscrete, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_375(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_375;

public function functionAliasEquation
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_removedEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_removedPart;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_removedPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_removedPart, l_tmp, l_varDecls) := lm_375(l_removedPart, a_removedEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_removedPart := Tpl.popIter(l_removedPart);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* for continuous time variables */\n",
                                       "int functionAliasEquations(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "\n",
                                       "data->simulationInfo.discreteCall = 0;\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_removedPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionAliasEquation;

protected function lm_377
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqfuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_eqfuncs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_eqfuncs,
           a_varDecls )
      then (txt, a_eqfuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_eqfuncs,
           a_varDecls )
      equation
        (txt, a_varDecls, a_eqfuncs) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_eqfuncs, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_eqfuncs, a_varDecls) = lm_377(txt, rest, a_modelNamePrefix, a_eqfuncs, a_varDecls);
      then (txt, a_eqfuncs, a_varDecls);
  end match;
end lm_377;

protected function lm_378
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_eqArray;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqfuncs, out_a_eqArray, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_eqfuncs, in_a_eqArray, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_eqArray;
      Tpl.Text a_varDecls;
      Integer x_i0;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_eqfuncs,
           a_eqArray,
           a_varDecls )
      then (txt, a_eqfuncs, a_eqArray, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_eqfuncs,
           a_eqArray,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_eqArray, a_eqfuncs) = equation_arrayFormat(txt, i_eq, "DAE", SimCode.contextSimulationDiscrete, x_i0, a_varDecls, a_eqArray, a_eqfuncs, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_eqfuncs, a_eqArray, a_varDecls) = lm_378(txt, rest, a_modelNamePrefix, a_eqfuncs, a_eqArray, a_varDecls);
      then (txt, a_eqfuncs, a_eqArray, a_varDecls);
  end match;
end lm_378;

protected function fun_379
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_eqArray;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_varDecls;
  input list<SimCode.SimEqSystem> in_a_allEquationsPlusWhen;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqArray, out_a_eqfuncs, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_eqArray, in_a_modelNamePrefix, in_a_eqfuncs, in_a_varDecls, in_a_allEquationsPlusWhen)
    local
      Tpl.Text txt;
      Tpl.Text a_eqArray;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_varDecls;
      list<SimCode.SimEqSystem> a_allEquationsPlusWhen;

    case ( txt,
           false,
           a_eqArray,
           a_modelNamePrefix,
           a_eqfuncs,
           a_varDecls,
           a_allEquationsPlusWhen )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_eqfuncs, a_varDecls) = lm_377(txt, a_allEquationsPlusWhen, a_modelNamePrefix, a_eqfuncs, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_eqArray, a_eqfuncs, a_varDecls);

    case ( txt,
           _,
           a_eqArray,
           a_modelNamePrefix,
           a_eqfuncs,
           a_varDecls,
           a_allEquationsPlusWhen )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_eqfuncs, a_eqArray, a_varDecls) = lm_378(txt, a_allEquationsPlusWhen, a_modelNamePrefix, a_eqfuncs, a_eqArray, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_eqArray, a_eqfuncs, a_varDecls);
  end match;
end fun_379;

protected function lm_380
  input Tpl.Text in_txt;
  input list<SimCode.SimWhenClause> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimWhenClause> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      SimCode.SimWhenClause i_when;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_when :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_auxFunction) = genreinits(txt, i_when, a_varDecls, a_auxFunction, x_i0);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_380(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_380;

protected function fun_381
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_eqArray;
  input Tpl.Text in_a_nrfuncs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eqArray, in_a_nrfuncs)
    local
      Tpl.Text txt;
      Tpl.Text a_eqArray;
      Tpl.Text a_nrfuncs;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_eqArray,
           a_nrfuncs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void (*functionDAE_systems["));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_eqArray);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_381;

protected function fun_382
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input Tpl.Text in_a_fncalls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_fncalls)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      Tpl.Text a_fncalls;

    case ( txt,
           false,
           _,
           a_fncalls )
      equation
        txt = Tpl.writeText(txt, a_fncalls);
      then txt;

    case ( txt,
           _,
           a_nrfuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PM_functionDAE("));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data, functionDAE_systems);"));
      then txt;
  end match;
end fun_382;

public function functionDAE
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input list<SimCode.SimWhenClause> a_whenClauses;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_11;
  Boolean ret_10;
  Tpl.Text l_eqArrayDecl;
  Tpl.Text l_reinit;
  Boolean ret_7;
  Tpl.Text l_fncalls;
  Tpl.Text l_eqArray;
  Tpl.Text l_eqfuncs;
  Integer ret_3;
  Tpl.Text l_nrfuncs;
  Tpl.Text l_varDecls;
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  ret_3 := listLength(a_allEquationsPlusWhen);
  l_nrfuncs := Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
  l_eqfuncs := Tpl.emptyTxt;
  l_eqArray := Tpl.emptyTxt;
  ret_7 := Flags.isSet(Flags.PARMODAUTO);
  (l_fncalls, l_eqArray, l_eqfuncs, l_varDecls) := fun_379(Tpl.emptyTxt, ret_7, l_eqArray, a_modelNamePrefix, l_eqfuncs, l_varDecls, a_allEquationsPlusWhen);
  l_reinit := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_reinit, l_auxFunction, l_varDecls) := lm_380(l_reinit, a_whenClauses, l_auxFunction, l_varDecls);
  l_reinit := Tpl.popIter(l_reinit);
  ret_10 := Flags.isSet(Flags.PARMODAUTO);
  l_eqArrayDecl := fun_381(Tpl.emptyTxt, ret_10, l_eqArray, l_nrfuncs);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_eqfuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_eqArrayDecl);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "functionDAE");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n",
                                       "  int equationIndexes[1] = {0};\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "\n",
                                       "data->simulationInfo.needToIterate = 0;\n",
                                       "data->simulationInfo.discreteCall = 1;\n"
                                   }, true));
  ret_11 := Flags.isSet(Flags.PARMODAUTO);
  out_txt := fun_382(out_txt, ret_11, l_nrfuncs, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_reinit);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionDAE;

protected function lm_384
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextSimulationNonDiscrete, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_384(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_384;

protected function lm_385
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      DAE.Exp i_relation__;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = ExpressionDump.printExpStr(i_relation__);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_385(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_385(txt, rest);
      then txt;
  end match;
end lm_385;

protected function lm_386
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = lm_386(txt, rest);
      then txt;
  end match;
end lm_386;

protected function lm_387
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Integer x_i0;
      list<Integer> i_occurEquLst;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(occurEquLst = i_occurEquLst) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const int occurEqs"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("[] = {"));
        ret_0 = listLength(i_occurEquLst);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = lm_386(txt, i_occurEquLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
        txt = Tpl.nextIter(txt);
        txt = lm_387(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_387(txt, rest);
      then txt;
  end match;
end lm_387;

protected function lm_388
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = _) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("occurEqs"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_388(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_388(txt, rest);
      then txt;
  end match;
end lm_388;

protected function fun_389
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_a_zeroCrossings;
  input Tpl.Text in_a_resDesc;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_zeroCrossings, in_a_resDesc, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_resDesc;
      String a_modelNamePrefix;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;

    case ( txt,
           {},
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i, int **out_EquationIndexes)\n",
                                    "{\n",
                                    "  *out_EquationIndexes = NULL;\n",
                                    "  return \"empty\";\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_zeroCrossings,
           a_resDesc,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i, int **out_EquationIndexes)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const char *res[] = {"));
        txt = Tpl.writeText(txt, a_resDesc);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_387(txt, i_zeroCrossings);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const int *occurEqs[] = {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_388(txt, i_zeroCrossings);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "*out_EquationIndexes = occurEqs[i];\n",
                                    "return res[i];\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_389;

public function functionZeroCrossing
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input list<SimCode.SimEqSystem> a_equationsForZeroCrossings;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_desc;
  Tpl.Text l_resDesc;
  Tpl.Text l_zeroCrossingsCode;
  Tpl.Text l_varDecls2;
  Tpl.Text l_eqs;
  Tpl.Text l_auxFunction;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_eqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_eqs, l_tmp, l_varDecls) := lm_384(l_eqs, a_equationsForZeroCrossings, a_modelNamePrefix, l_tmp, l_varDecls);
  l_eqs := Tpl.popIter(l_eqs);
  l_varDecls2 := Tpl.emptyTxt;
  (l_zeroCrossingsCode, l_varDecls2, l_auxFunction) := zeroCrossingsTpl(Tpl.emptyTxt, a_zeroCrossings, l_varDecls2, l_auxFunction);
  l_resDesc := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_resDesc := lm_385(l_resDesc, a_zeroCrossings);
  l_resDesc := Tpl.popIter(l_resDesc);
  l_desc := fun_389(Tpl.emptyTxt, a_zeroCrossings, l_resDesc, a_modelNamePrefix);
  out_txt := Tpl.writeText(txt, l_desc);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "function_ZeroCrossingsEquations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "data->simulationInfo.callStatistics.functionZeroCrossingsEquations++;\n",
                                       "\n",
                                       "data->simulationInfo.discreteCall = 0;\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_eqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "function_ZeroCrossings");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, double *gout)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls2);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "data->simulationInfo.callStatistics.functionZeroCrossings++;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_zeroCrossingsCode);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionZeroCrossing;

protected function lm_391
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_auxFunction) = zeroCrossingTpl(txt, x_i0, i_relation__, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_391(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_391(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_391;

public function zeroCrossingsTpl
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_391(out_txt, a_zeroCrossings, a_auxFunction, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end zeroCrossingsTpl;

protected function fun_393
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;
  input Integer in_a_index1;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_relation, in_a_index1, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Integer a_index1;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp2;
      DAE.Exp i_idx;
      DAE.Exp i_exp1;
      DAE.Exp i_exp;
      Tpl.Text txt_4;
      Tpl.Text l_e2;
      Tpl.Text l_indx;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           (i_exp as DAE.RELATION(exp1 = _)),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp1 as DAE.LBINARY(exp1 = _)),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp1 as DAE.LUNARY(operator = _)),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {_, _, _}),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_exp1, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (floor("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != floor(data->simulationInfo.mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "floor"), expLst = {i_exp1, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (floor("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != floor(data->simulationInfo.mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "ceil"), expLst = {i_exp1, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (ceil("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != ceil(data->simulationInfo.mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_exp1, i_exp2, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_e2, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp2, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, SimCode.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (trunc("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != trunc(data->simulationInfo.mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]/data->simulationInfo.mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        txt_4 = Tpl.pushBlock(Tpl.emptyTxt, Tpl.BT_INDENT(1));
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("UNKNOWN ZERO CROSSING for "));
        txt_4 = Tpl.writeStr(txt_4, intString(a_index1));
        txt_4 = Tpl.popBlock(txt_4);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 3173, 11), Tpl.textString(txt_4));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_393;

public function zeroCrossingTpl
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_393(txt, a_relation, a_index1, a_varDecls, a_auxFunction);
end zeroCrossingTpl;

protected function lm_395
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      DAE.Exp i_relation__;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = ExpressionDump.printExpStr(i_relation__);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_395(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_395(txt, rest);
      then txt;
  end match;
end lm_395;

protected function fun_396
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_a_relations;
  input Tpl.Text in_a_resDesc;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_relations, in_a_resDesc, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_resDesc;
      String a_modelNamePrefix;

    case ( txt,
           {},
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i)\n",
                                    "{\n",
                                    "  return \"empty\";\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_resDesc,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *res[] = {"));
        txt = Tpl.writeText(txt, a_resDesc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "return res[i];\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_396;

public function functionRelations
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_relations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_desc;
  Tpl.Text l_resDesc;
  Tpl.Text l_relationsCodeElse;
  Tpl.Text l_relationsCode;
  Tpl.Text l_varDecls;
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  (l_relationsCode, l_varDecls, l_auxFunction) := relationsTpl(Tpl.emptyTxt, a_relations, SimCode.contextZeroCross, l_varDecls, l_auxFunction);
  (l_relationsCodeElse, l_varDecls, l_auxFunction) := relationsTpl(Tpl.emptyTxt, a_relations, SimCode.contextOther, l_varDecls, l_auxFunction);
  l_resDesc := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_resDesc := lm_395(l_resDesc, a_relations);
  l_resDesc := Tpl.popIter(l_resDesc);
  l_desc := fun_396(Tpl.emptyTxt, a_relations, l_resDesc, a_modelNamePrefix);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_desc);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "function_updateRelations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, int evalforZeroCross)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_PUSH\n",
                                       "\n",
                                       "if(evalforZeroCross)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_relationsCode);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "else\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_relationsCodeElse);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionRelations;

protected function lm_398
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_auxFunction) = relationTpl(txt, x_i0, i_relation__, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_398(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_398(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_398;

public function relationsTpl
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_relations;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_398(out_txt, a_relations, a_auxFunction, a_varDecls, a_context);
  out_txt := Tpl.popIter(out_txt);
end relationsTpl;

protected function fun_400
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;
  input Integer in_a_index1;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_relation, in_a_index1, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Integer a_index1;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Tpl.Text l_res;
      Tpl.Text l_preExp;

    case ( txt,
           (i_exp as DAE.RELATION(exp1 = _)),
           a_index1,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_res, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.relations["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_index1,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* UNKNOWN Relation for "));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_400;

public function relationTpl
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_400(txt, a_relation, a_index1, a_context, a_varDecls, a_auxFunction);
end relationTpl;

protected function fun_402
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_var;

    case ( txt,
           (i_var as DAE.CREF_QUAL(ident = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != $P$PRE"));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_EVENTS_V, 0, \"discrete var changed: "));
        txt = CodegenUtil.crefStr(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" from "));
        txt = crefToPrintfArg(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" to "));
        txt = crefToPrintfArg(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", $P$PRE"));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "needToIterate = 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           (i_var as DAE.CREF_IDENT(ident = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != $P$PRE"));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_EVENTS_V, 0, \"discrete var changed: "));
        txt = CodegenUtil.crefStr(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" from "));
        txt = crefToPrintfArg(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" to "));
        txt = crefToPrintfArg(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", $P$PRE"));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = cref(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "needToIterate = 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_402;

protected function lm_403
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = fun_402(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_403(txt, rest);
      then txt;
  end match;
end lm_403;

public function functionCheckForDiscreteChanges
  input Tpl.Text txt;
  input list<DAE.ComponentRef> a_discreteModelVars;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_changediscreteVars;
algorithm
  l_changediscreteVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_changediscreteVars := lm_403(l_changediscreteVars, a_discreteModelVars);
  l_changediscreteVars := Tpl.popIter(l_changediscreteVars);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "checkForDiscreteChanges");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n",
                                       "  int needToIterate = 0;\n",
                                       "\n",
                                       "  TRACE_PUSH\n",
                                       "\n",
                                       "  infoStreamPrint(LOG_EVENTS_V, 1, \"check for discrete changes at time=%.12g\", data->localData[0]->timeValue);\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_changediscreteVars);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_EVENTS_V)) messageClose(LOG_EVENTS_V);\n",
                                       "\n",
                                       "TRACE_POP\n",
                                       "return needToIterate;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionCheckForDiscreteChanges;

protected function fun_405
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text txt_0;

    case ( txt,
           "modelica_real",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%g"));
      then txt;

    case ( txt,
           "modelica_integer",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%ld"));
      then txt;

    case ( txt,
           "modelica_boolean",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%d"));
      then txt;

    case ( txt,
           "modelica_string",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%s"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Do not know what printf argument to give "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_cr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 3297, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_405;

public function crefToPrintfArg
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := crefType(Tpl.emptyTxt, a_cr);
  str_1 := Tpl.textString(txt_0);
  out_txt := fun_405(txt, str_1, a_cr);
end crefToPrintfArg;

public function crefType
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = expTypeModelica(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefType(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefType;

protected function lm_408
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextSimulationDiscrete, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_408(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_408;

public function functionAssertsforCheck
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_algAndEqAssertsEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_algAndEqAssertsPart;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_algAndEqAssertsPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algAndEqAssertsPart, l_tmp, l_varDecls) := lm_408(l_algAndEqAssertsPart, a_algAndEqAssertsEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_algAndEqAssertsPart := Tpl.popIter(l_algAndEqAssertsPart);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* function to check assert after a step is done */\n",
                                       "int "
                                   }, false));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "checkForAsserts");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_algAndEqAssertsPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionAssertsforCheck;

public function defvars
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_item;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_item)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCode.SIMVAR(name = i_name) )
      equation
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end defvars;

public function functionlinearmodel
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCode.SimVar> i_vars_outputVars;
      list<SimCode.SimVar> i_vars_inputVars;
      list<SimCode.SimVar> i_vars_stateVars;
      Absyn.Path i_name;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStateVars;
      Tpl.Text l_vectorY;
      Tpl.Text l_vectorU;
      Tpl.Text l_vectorX;
      Tpl.Text l_matrixD;
      Tpl.Text l_matrixC;
      Tpl.Text l_matrixB;
      Tpl.Text l_matrixA;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars), vars = SimCode.SIMVARS(stateVars = i_vars_stateVars, inputVars = i_vars_inputVars, outputVars = i_vars_outputVars), name = i_name),
           a_modelNamePrefix )
      equation
        l_matrixA = genMatrix(Tpl.emptyTxt, "A", i_varInfo_numStateVars, i_varInfo_numStateVars);
        l_matrixB = genMatrix(Tpl.emptyTxt, "B", i_varInfo_numStateVars, i_varInfo_numInVars);
        l_matrixC = genMatrix(Tpl.emptyTxt, "C", i_varInfo_numOutVars, i_varInfo_numStateVars);
        l_matrixD = genMatrix(Tpl.emptyTxt, "D", i_varInfo_numOutVars, i_varInfo_numInVars);
        l_vectorX = genVector(Tpl.emptyTxt, "x", i_varInfo_numStateVars, 0);
        l_vectorU = genVector(Tpl.emptyTxt, "u", i_varInfo_numInVars, 1);
        l_vectorY = genVector(Tpl.emptyTxt, "y", i_varInfo_numOutVars, 2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = symbolName(txt, a_modelNamePrefix, "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return \"model linear_"));
        txt = CodegenUtil.underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\n  parameter Integer n = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; // states \\n  parameter Integer k = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; // top-level inputs \\n  parameter Integer l = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "; // top-level outputs \\n\"\n",
                                    "\"  parameter Real x0["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = {%s};\\n\"\n",
                                    "\"  parameter Real u0["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = {%s};\\n\"\n"));
        txt = Tpl.writeText(txt, l_matrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixB);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorX);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorU);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorY);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"\\n  "));
        txt = getVarName(txt, i_vars_stateVars, "x", i_varInfo_numStateVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  "));
        txt = getVarName(txt, i_vars_inputVars, "u", i_varInfo_numInVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  "));
        txt = getVarName(txt, i_vars_outputVars, "y", i_varInfo_numOutVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\n\"\n",
                                    "\"equation\\n  der(x) = A * x + B * u;\\n  y = C * x + D * u;\\nend linear_"
                                }, false));
        txt = CodegenUtil.underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\\n\";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionlinearmodel;

protected function fun_412
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_var;
  input Tpl.Text in_a_rest;
  input Tpl.Text in_a_arrindex;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_rest, in_a_arrindex, in_a_arrayName)
    local
      Tpl.Text txt;
      Tpl.Text a_rest;
      Tpl.Text a_arrindex;
      String a_arrayName;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCode.SIMVAR(name = i_name),
           a_rest,
           a_arrindex,
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefM(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, a_arrindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n  "));
        txt = Tpl.writeText(txt, a_rest);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_412;

public function getVarName
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_a_simVars;
  input String in_a_arrayName;
  input Integer in_a_arraySize;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVars, in_a_arrayName, in_a_arraySize)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer a_arraySize;
      SimCode.SimVar i_var;
      list<SimCode.SimVar> i_restVars;
      Integer ret_3;
      Integer ret_2;
      Tpl.Text l_arrindex;
      Tpl.Text l_rest;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: i_restVars,
           a_arrayName,
           a_arraySize )
      equation
        l_rest = getVarName(Tpl.emptyTxt, i_restVars, a_arrayName, a_arraySize);
        ret_2 = listLength(i_restVars);
        ret_3 = SimCodeUtil.decrementInt(a_arraySize, ret_2);
        l_arrindex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        txt = fun_412(txt, i_var, l_rest, l_arrindex, a_arrayName);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end getVarName;

protected function fun_414
  input Tpl.Text in_txt;
  input Integer in_a_col;
  input Integer in_a_row;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_col, in_a_row, in_a_name)
    local
      Tpl.Text txt;
      Integer a_row;
      String a_name;
      Integer i_col;

    case ( txt,
           (i_col as 0),
           a_row,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  parameter Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = zeros("));
        txt = Tpl.writeStr(txt, intString(a_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");%s\\n\""));
      then txt;

    case ( txt,
           i_col,
           a_row,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  parameter Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = [%s];\\n\""));
      then txt;
  end match;
end fun_414;

protected function fun_415
  input Tpl.Text in_txt;
  input Integer in_a_row;
  input String in_a_name;
  input Integer in_a_col;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_row, in_a_name, in_a_col)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_col;
      Integer i_row;

    case ( txt,
           (i_row as 0),
           a_name,
           a_col )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  parameter Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = zeros("));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");%s\\n\""));
      then txt;

    case ( txt,
           i_row,
           a_name,
           a_col )
      equation
        txt = fun_414(txt, a_col, i_row, a_name);
      then txt;
  end match;
end fun_415;

public function genMatrix
  input Tpl.Text txt;
  input String a_name;
  input Integer a_row;
  input Integer a_col;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_415(txt, a_row, a_name, a_col);
end genMatrix;

protected function fun_417
  input Tpl.Text in_txt;
  input Integer in_a_numIn;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numIn, in_a_name)
    local
      Tpl.Text txt;
      String a_name;
      Integer i_numIn;

    case ( txt,
           (i_numIn as 0),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_numIn));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           i_numIn,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_numIn));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("](start="));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0);\\n\""));
      then txt;
  end match;
end fun_417;

protected function fun_418
  input Tpl.Text in_txt;
  input Integer in_a_numIn;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numIn, in_a_name)
    local
      Tpl.Text txt;
      String a_name;
      Integer i_numIn;

    case ( txt,
           (i_numIn as 0),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  input Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_numIn));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           i_numIn,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  input Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_numIn));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("](start= "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0);\\n\""));
      then txt;
  end match;
end fun_418;

protected function fun_419
  input Tpl.Text in_txt;
  input Integer in_a_numIn;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numIn, in_a_name)
    local
      Tpl.Text txt;
      String a_name;
      Integer i_numIn;

    case ( txt,
           (i_numIn as 0),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  output Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_numIn));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           i_numIn,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  output Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_numIn));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;
  end match;
end fun_419;

protected function fun_420
  input Tpl.Text in_txt;
  input Integer in_a_flag;
  input String in_a_name;
  input Integer in_a_numIn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag, in_a_name, in_a_numIn)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_numIn;

    case ( txt,
           0,
           a_name,
           a_numIn )
      equation
        txt = fun_417(txt, a_numIn, a_name);
      then txt;

    case ( txt,
           1,
           a_name,
           a_numIn )
      equation
        txt = fun_418(txt, a_numIn, a_name);
      then txt;

    case ( txt,
           2,
           a_name,
           a_numIn )
      equation
        txt = fun_419(txt, a_numIn, a_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_420;

public function genVector
  input Tpl.Text txt;
  input String a_name;
  input Integer a_numIn;
  input Integer a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_420(txt, a_flag, a_name, a_numIn);
end genVector;

protected function lm_422
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      Integer i_maxColor;
      list<list<DAE.ComponentRef>> i_colorList;
      list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> i_sparsepattern;
      String i_name;
      list<SimCode.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_mat, i_vars, i_name, (i_sparsepattern, (_, _)), i_colorList, i_maxColor, _) :: rest,
           a_modelNamePrefix )
      equation
        txt = initialAnalyticJacobians(txt, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, i_maxColor, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_422(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_422;

protected function lm_423
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      String i_name;
      list<SimCode.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_mat, i_vars, i_name, _, _, _, _) :: rest,
           a_modelNamePrefix )
      equation
        txt = generateMatrix(txt, i_mat, i_vars, i_name, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_423(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_423;

public function functionAnalyticJacobians
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacMats;
  Tpl.Text l_initialjacMats;
algorithm
  l_initialjacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_initialjacMats := lm_422(l_initialjacMats, a_JacobianMatrixes, a_modelNamePrefix);
  l_initialjacMats := Tpl.popIter(l_initialjacMats);
  l_jacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacMats := lm_423(l_jacMats, a_JacobianMatrixes, a_modelNamePrefix);
  l_jacMats := Tpl.popIter(l_jacMats);
  out_txt := Tpl.writeText(txt, l_initialjacMats);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_jacMats);
end functionAnalyticJacobians;

protected function lm_425
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input list<DAE.ComponentRef> in_a_indexes;
  input String in_a_matrixname;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexes, in_a_matrixname, in_a_cref)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      list<DAE.ComponentRef> a_indexes;
      String a_matrixname;
      DAE.ComponentRef a_cref;
      Integer x_index0;
      DAE.ComponentRef i_indexrow;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_indexrow :: rest,
           a_indexes,
           a_matrixname,
           a_cref )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("i = data->simulationInfo.analyticJacobians[index].sparsePattern.leadindex["));
        txt = cref(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$indexdiff] - "));
        ret_0 = listLength(a_indexes);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->simulationInfo.analyticJacobians[index].sparsePattern.index[i+"
                                }, false));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = cref(txt, i_indexrow);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$indexdiffed;"));
        txt = Tpl.nextIter(txt);
        txt = lm_425(txt, rest, a_indexes, a_matrixname, a_cref);
      then txt;
  end match;
end lm_425;

public function mkSparseFunction
  input Tpl.Text in_txt;
  input String in_a_matrixname;
  input String in_a_matrixIndex;
  input DAE.ComponentRef in_a_cref;
  input list<DAE.ComponentRef> in_a_indexes;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrixname, in_a_matrixIndex, in_a_cref, in_a_indexes, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_matrixIndex;
      DAE.ComponentRef a_cref;
      list<DAE.ComponentRef> a_indexes;
      String a_modelNamePrefix;
      String i_matrixname;
      Tpl.Text l_indexrows;

    case ( txt,
           i_matrixname,
           a_matrixIndex,
           a_cref,
           a_indexes,
           a_modelNamePrefix )
      equation
        l_indexrows = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexrows = lm_425(l_indexrows, a_indexes, a_indexes, i_matrixname, a_cref);
        l_indexrows = Tpl.popIter(l_indexrows);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void "));
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_matrixIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, int index)\n",
                                    "{\n",
                                    "  int i;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* write index for cref: "));
        txt = cref(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        txt = Tpl.writeText(txt, l_indexrows);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end mkSparseFunction;

protected function lm_427
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> in_items;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixname)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> rest;
      String a_matrixname;
      list<DAE.ComponentRef> i_indexes;
      DAE.ComponentRef i_cref;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_cref, i_indexes) :: rest,
           a_matrixname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.analyticJacobians[index].sparsePattern.leadindex["));
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$indexdiff] = "));
        ret_0 = listLength(i_indexes);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_427(txt, rest, a_matrixname);
      then txt;
  end match;
end lm_427;

protected function lm_428
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> in_items;
  input String in_a_modelNamePrefix;
  input String in_a_matrixname;
  input Tpl.Text in_a_eachCrefParts;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eachCrefParts;
algorithm
  (out_txt, out_a_eachCrefParts) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_matrixname, in_a_eachCrefParts)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> rest;
      String a_modelNamePrefix;
      String a_matrixname;
      Tpl.Text a_eachCrefParts;
      Integer x_index0;
      list<DAE.ComponentRef> i_indexes;
      DAE.ComponentRef i_cref;

    case ( txt,
           {},
           _,
           _,
           a_eachCrefParts )
      then (txt, a_eachCrefParts);

    case ( txt,
           (i_cref, i_indexes) :: rest,
           a_modelNamePrefix,
           a_matrixname,
           a_eachCrefParts )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        a_eachCrefParts = mkSparseFunction(a_eachCrefParts, a_matrixname, intString(x_index0), i_cref, i_indexes, a_modelNamePrefix);
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data, index);"));
        txt = Tpl.nextIter(txt);
        (txt, a_eachCrefParts) = lm_428(txt, rest, a_modelNamePrefix, a_matrixname, a_eachCrefParts);
      then (txt, a_eachCrefParts);
  end match;
end lm_428;

protected function lm_429
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_index0;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index0, in_a_matrixname)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_index0;
      String a_matrixname;
      DAE.ComponentRef i_i__index;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_i__index :: rest,
           a_index0,
           a_matrixname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.analyticJacobians[index].sparsePattern.colorCols["));
        txt = cref(txt, i_i__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$pDER"));
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$indexdiff] = "));
        ret_0 = intAdd(a_index0, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_429(txt, rest, a_index0, a_matrixname);
      then txt;
  end match;
end lm_429;

protected function lm_430
  input Tpl.Text in_txt;
  input list<list<DAE.ComponentRef>> in_items;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixname)
    local
      Tpl.Text txt;
      list<list<DAE.ComponentRef>> rest;
      String a_matrixname;
      Integer x_index0;
      list<DAE.ComponentRef> i_indexes;
      Tpl.Text l_colorCol;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_indexes :: rest,
           a_matrixname )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        l_colorCol = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_colorCol = lm_429(l_colorCol, i_indexes, x_index0, a_matrixname);
        l_colorCol = Tpl.popIter(l_colorCol);
        txt = Tpl.writeText(txt, l_colorCol);
        txt = Tpl.nextIter(txt);
        txt = lm_430(txt, rest, a_matrixname);
      then txt;
  end match;
end lm_430;

protected function lm_431
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String i_indxColumn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (_, _, i_indxColumn) :: rest )
      equation
        txt = Tpl.writeStr(txt, i_indxColumn);
        txt = Tpl.nextIter(txt);
        txt = lm_431(txt, rest);
      then txt;
  end match;
end lm_431;

protected function lm_432
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      list<SimCode.SimVar> i_vars;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (_, i_vars, _) :: rest )
      equation
        ret_0 = listLength(i_vars);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.nextIter(txt);
        txt = lm_432(txt, rest);
      then txt;
  end match;
end lm_432;

protected function fun_433
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> in_a_sparsepattern;
  input Integer in_a_maxColor;
  input list<SimCode.SimVar> in_a_seedVars;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<list<DAE.ComponentRef>> in_a_colorList;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sparsepattern, in_a_maxColor, in_a_seedVars, in_a_jacobianColumn, in_a_colorList, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Integer a_maxColor;
      list<SimCode.SimVar> a_seedVars;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<list<DAE.ComponentRef>> a_colorList;
      String a_matrixname;
      String a_modelNamePrefix;
      list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> i_sparsepattern;
      Integer ret_12;
      Tpl.Text l_index__;
      Tpl.Text l_tmpvarsSize;
      Tpl.Text l_indexColumn;
      Tpl.Text l_colorArray;
      Tpl.Text l_indexElems;
      Tpl.Text l_leadindex;
      Integer ret_5;
      Tpl.Text l_sizeleadindex;
      Integer ret_3;
      list<list<DAE.ComponentRef>> ret_2;
      Tpl.Text l_sp__size__index;
      Tpl.Text l_eachCrefParts;

    case ( txt,
           {(_, {})},
           _,
           _,
           _,
           _,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* inData)\n",
                                    "{\n",
                                    "  return 1;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_sparsepattern,
           a_maxColor,
           a_seedVars,
           a_jacobianColumn,
           a_colorList,
           a_matrixname,
           a_modelNamePrefix )
      equation
        l_eachCrefParts = Tpl.emptyTxt;
        ret_2 = Util.splitTuple212List(i_sparsepattern);
        ret_3 = List.lengthListElements(ret_2);
        l_sp__size__index = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        ret_5 = listLength(i_sparsepattern);
        l_sizeleadindex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_leadindex = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_leadindex = lm_427(l_leadindex, i_sparsepattern, a_matrixname);
        l_leadindex = Tpl.popIter(l_leadindex);
        l_indexElems = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_indexElems, l_eachCrefParts) = lm_428(l_indexElems, i_sparsepattern, a_modelNamePrefix, a_matrixname, l_eachCrefParts);
        l_indexElems = Tpl.popIter(l_indexElems);
        l_colorArray = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_colorArray = lm_430(l_colorArray, a_colorList, a_matrixname);
        l_colorArray = Tpl.popIter(l_colorArray);
        l_indexColumn = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexColumn = lm_431(l_indexColumn, a_jacobianColumn);
        l_indexColumn = Tpl.popIter(l_indexColumn);
        l_tmpvarsSize = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_tmpvarsSize = lm_432(l_tmpvarsSize, a_jacobianColumn);
        l_tmpvarsSize = Tpl.popIter(l_tmpvarsSize);
        ret_12 = listLength(a_seedVars);
        l_index__ = Tpl.writeStr(Tpl.emptyTxt, intString(ret_12));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_eachCrefParts);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* inData)\n",
                                    "{\n",
                                    "  DATA* data = ((DATA*)inData);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int index = "));
        txt = symbolName(txt, a_modelNamePrefix, "INDEX_JAC_");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "int i;\n",
                                    "\n",
                                    "data->simulationInfo.analyticJacobians[index].sizeCols = "
                                }, false));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->simulationInfo.analyticJacobians[index].sizeRows = "
                                }, false));
        txt = Tpl.writeText(txt, l_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->simulationInfo.analyticJacobians[index].sizeTmpVars = "
                                }, false));
        txt = Tpl.writeText(txt, l_tmpvarsSize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->simulationInfo.analyticJacobians[index].seedVars = (modelica_real*) calloc("
                                }, false));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_real));\n",
                                    "data->simulationInfo.analyticJacobians[index].resultVars = (modelica_real*) calloc("
                                }, false));
        txt = Tpl.writeText(txt, l_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_real));\n",
                                    "data->simulationInfo.analyticJacobians[index].tmpVars = (modelica_real*) calloc("
                                }, false));
        txt = Tpl.writeText(txt, l_tmpvarsSize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_real));\n",
                                    "data->simulationInfo.analyticJacobians[index].sparsePattern.leadindex = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(int));\n",
                                    "data->simulationInfo.analyticJacobians[index].sparsePattern.index = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(int));\n",
                                    "data->simulationInfo.analyticJacobians[index].sparsePattern.colorCols = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(int));\n",
                                    "data->simulationInfo.analyticJacobians[index].sparsePattern.maxColors = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_maxColor));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->simulationInfo.analyticJacobians[index].jacobian = NULL;\n",
                                    "\n",
                                    "/* write column ptr of compressed sparse column*/\n"
                                }, true));
        txt = Tpl.writeText(txt, l_leadindex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for(i=1;i<"));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";++i)\n",
                                    "    data->simulationInfo.analyticJacobians[index].sparsePattern.leadindex[i] += data->simulationInfo.analyticJacobians[index].sparsePattern.leadindex[i-1];\n",
                                    "\n",
                                    "\n",
                                    "/* call functions to write index for each cref */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_indexElems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* write color array */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_colorArray);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_433;

protected function fun_434
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_a_seedVars;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input String in_a_matrixname;
  input list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> in_a_sparsepattern;
  input list<list<DAE.ComponentRef>> in_a_colorList;
  input Integer in_a_maxColor;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_seedVars, in_a_jacobianColumn, in_a_matrixname, in_a_sparsepattern, in_a_colorList, in_a_maxColor, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      String a_matrixname;
      list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> a_sparsepattern;
      list<list<DAE.ComponentRef>> a_colorList;
      Integer a_maxColor;
      String a_modelNamePrefix;
      list<SimCode.SimVar> i_seedVars;

    case ( txt,
           {},
           _,
           a_matrixname,
           _,
           _,
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* inData)\n",
                                    "{\n",
                                    "  return 1;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_seedVars,
           a_jacobianColumn,
           a_matrixname,
           a_sparsepattern,
           a_colorList,
           a_maxColor,
           a_modelNamePrefix )
      equation
        txt = fun_433(txt, a_sparsepattern, a_maxColor, i_seedVars, a_jacobianColumn, a_colorList, a_matrixname, a_modelNamePrefix);
      then txt;
  end match;
end fun_434;

public function initialAnalyticJacobians
  input Tpl.Text txt;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCode.SimVar> a_seedVars;
  input String a_matrixname;
  input list<tuple<DAE.ComponentRef, list<DAE.ComponentRef>>> a_sparsepattern;
  input list<list<DAE.ComponentRef>> a_colorList;
  input Integer a_maxColor;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_434(txt, a_seedVars, a_jacobianColumn, a_matrixname, a_sparsepattern, a_colorList, a_maxColor, a_modelNamePrefix);
end initialAnalyticJacobians;

protected function lm_436
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String i_indxColumn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (_, _, i_indxColumn) :: rest )
      equation
        txt = Tpl.writeStr(txt, i_indxColumn);
        txt = lm_436(txt, rest);
      then txt;
  end match;
end lm_436;

protected function lm_437
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input String in_a_modelNamePrefix;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_matrixname)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String a_modelNamePrefix;
      String a_matrixname;
      String i_indxColumn;
      list<SimCode.SimVar> i_vars;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           (i_eqs, i_vars, i_indxColumn) :: rest,
           a_modelNamePrefix,
           a_matrixname )
      equation
        txt = functionJac(txt, i_eqs, i_vars, i_indxColumn, a_matrixname, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_437(txt, rest, a_modelNamePrefix, a_matrixname);
      then txt;
  end match;
end lm_437;

protected function lm_438
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String i_indxColumn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (_, _, i_indxColumn) :: rest )
      equation
        txt = Tpl.writeStr(txt, i_indxColumn);
        txt = Tpl.nextIter(txt);
        txt = lm_438(txt, rest);
      then txt;
  end match;
end lm_438;

protected function fun_439
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_a_seedVars;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_seedVars, in_a_jacobianColumn, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      String a_matrixname;
      String a_modelNamePrefix;
      Tpl.Text l_indexColumn;
      Tpl.Text l_jacMats;

    case ( txt,
           {},
           _,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_column(void* data)\n",
                                    "{\n",
                                    "  return 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_jacobianColumn,
           a_matrixname,
           a_modelNamePrefix )
      equation
        l_jacMats = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_jacMats = lm_437(l_jacMats, a_jacobianColumn, a_modelNamePrefix, a_matrixname);
        l_jacMats = Tpl.popIter(l_jacMats);
        l_indexColumn = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexColumn = lm_438(l_indexColumn, a_jacobianColumn);
        l_indexColumn = Tpl.popIter(l_indexColumn);
        txt = Tpl.writeText(txt, l_jacMats);
      then txt;
  end match;
end fun_439;

protected function fun_440
  input Tpl.Text in_txt;
  input String in_mArg;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<SimCode.SimVar> in_a_seedVars;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_jacobianColumn, in_a_seedVars, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<SimCode.SimVar> a_seedVars;
      String a_matrixname;
      String a_modelNamePrefix;

    case ( txt,
           "0",
           _,
           _,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_column(void* data)\n",
                                    "{\n",
                                    "  return 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_jacobianColumn,
           a_seedVars,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = fun_439(txt, a_seedVars, a_jacobianColumn, a_matrixname, a_modelNamePrefix);
      then txt;
  end match;
end fun_440;

public function generateMatrix
  input Tpl.Text txt;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCode.SimVar> a_seedVars;
  input String a_matrixname;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  String str_1;
  Tpl.Text l_indxColumn;
algorithm
  l_indxColumn := lm_436(Tpl.emptyTxt, a_jacobianColumn);
  str_1 := Tpl.textString(l_indxColumn);
  out_txt := fun_440(txt, str_1, a_jacobianColumn, a_seedVars, a_matrixname, a_modelNamePrefix);
end generateMatrix;

protected function lm_442
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = equation_(txt, i_eq, SimCode.contextSimulationNonDiscrete, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_442(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_442;

public function functionJac
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_jacEquations;
  input list<SimCode.SimVar> a_tmpVars;
  input String a_columnLength;
  input String a_matrixName;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_eqns__;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_eqns__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_eqns__, l_tmp, l_varDecls) := lm_442(l_eqns__, a_jacEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_eqns__ := Tpl.popIter(l_eqns__);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "functionJac");
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_column(void* inData)\n",
                                       "{\n",
                                       "  DATA* data = ((DATA*)inData);\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int index = "));
  out_txt := symbolName(out_txt, a_modelNamePrefix, "INDEX_JAC_");
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(";\n"));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_eqns__);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("return 0;\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionJac;

protected function lm_444
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_it));
        txt = Tpl.nextIter(txt);
        txt = lm_444(txt, rest);
      then txt;
  end match;
end lm_444;

public function intArr
  input Tpl.Text txt;
  input list<Integer> a_values;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_444(out_txt, a_values);
  out_txt := Tpl.popIter(out_txt);
end intArr;

protected function fun_446
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = true) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_446;

protected function lm_447
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_447(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_447;

protected function fun_448
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_eqfuncs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tempeqns;
  input Tpl.Text in_a_varD;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_tempeqns;
  output Tpl.Text out_a_varD;
algorithm
  (out_txt, out_a_eqfuncs, out_a_tempeqns, out_a_varD) :=
  match(in_txt, in_a_eq, in_a_eqfuncs, in_a_modelNamePrefix, in_a_tempeqns, in_a_varD, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_eqfuncs;
      String a_modelNamePrefix;
      Tpl.Text a_tempeqns;
      Tpl.Text a_varD;
      SimCode.Context a_context;
      list<SimCode.SimEqSystem> i_e_eqs;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationSimpleAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ARRAY_CALL_ASSIGN(index = _)),
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationArrayCallAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_IFEQUATION(index = _)),
           a_eqfuncs,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationIfEquationAssign(txt, i_e, a_context, a_varD, a_tempeqns, a_modelNamePrefix);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ALGORITHM(index = _)),
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationAlgorithm(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_LINEAR(index = _)),
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD) = equationLinear(txt, i_e, a_context, a_varD);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(eqs = i_e_eqs)),
           a_eqfuncs,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        a_tempeqns = Tpl.pushIter(a_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns = lm_447(a_tempeqns, i_e_eqs, a_modelNamePrefix);
        a_tempeqns = Tpl.popIter(a_tempeqns);
        (txt, a_varD) = equationNonlinear(txt, i_e, a_context, a_varD, a_modelNamePrefix);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_WHEN(index = _)),
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationWhen(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION SES_RESIDUAL"));
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_MIXED(index = _)),
           a_eqfuncs,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_eqfuncs) = equationMixed(txt, i_e, a_context, a_varD, a_eqfuncs, a_modelNamePrefix);
      then (txt, a_eqfuncs, a_tempeqns, a_varD);

    case ( txt,
           _,
           a_eqfuncs,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION equation_"));
      then (txt, a_eqfuncs, a_tempeqns, a_varD);
  end match;
end fun_448;

protected function fun_449
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_name;
  input SimCode.Context in_a_context;
  input Integer in_a_arrayIndex;
  input Tpl.Text in_a_eqArray;
  input Tpl.Text in_a_eqfuncs;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_eqfuncs;
algorithm
  (out_txt, out_a_eqArray, out_a_eqfuncs) :=
  match(in_txt, in_a_eq, in_a_name, in_a_context, in_a_arrayIndex, in_a_eqArray, in_a_eqfuncs, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_name;
      SimCode.Context a_context;
      Integer a_arrayIndex;
      Tpl.Text a_eqArray;
      Tpl.Text a_eqfuncs;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      list<SimCode.SimEqSystem> ret_6;
      Tpl.Text l_x;
      Tpl.Text l_disc;
      Tpl.Text l_tempeqns;
      Tpl.Text l_varD;
      Tpl.Text l_tmp;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _,
           a_eqArray,
           a_eqfuncs,
           _ )
      then (txt, a_eqArray, a_eqfuncs);

    case ( txt,
           i_eq,
           a_name,
           a_context,
           a_arrayIndex,
           a_eqArray,
           a_eqfuncs,
           a_modelNamePrefix )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        l_tmp = Tpl.emptyTxt;
        l_varD = Tpl.emptyTxt;
        l_tempeqns = Tpl.emptyTxt;
        System.tmpTickResetIndex(0, 1);
        l_disc = fun_446(Tpl.emptyTxt, a_context);
        (l_x, a_eqfuncs, l_tempeqns, l_varD) = fun_448(Tpl.emptyTxt, i_eq, a_eqfuncs, a_modelNamePrefix, l_tempeqns, l_varD, a_context);
        a_eqArray = symbolName(a_eqArray, a_modelNamePrefix, "eqFunction");
        a_eqArray = Tpl.writeTok(a_eqArray, Tpl.ST_STRING("_"));
        a_eqArray = Tpl.writeText(a_eqArray, l_ix);
        a_eqArray = Tpl.writeTok(a_eqArray, Tpl.ST_STRING(", "));
        a_eqArray = Tpl.writeTok(a_eqArray, Tpl.ST_NEW_LINE());
        l_varD = addRootsTempArray(l_varD);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_NEW_LINE());
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_tempeqns);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("/*\n"));
        a_eqfuncs = Tpl.pushBlock(a_eqfuncs, Tpl.BT_INDENT(1));
        ret_6 = List.fill(i_eq, 1);
        a_eqfuncs = CodegenUtil.dumpEqs(a_eqfuncs, ret_6);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("*/\n"));
        a_eqfuncs = Tpl.popBlock(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("void "));
        a_eqfuncs = symbolName(a_eqfuncs, a_modelNamePrefix, "eqFunction");
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("_"));
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_ix);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING_LIST({
                                                "(DATA *data)\n",
                                                "{\n"
                                            }, true));
        a_eqfuncs = Tpl.pushBlock(a_eqfuncs, Tpl.BT_INDENT(2));
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_ix);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING_LIST({
                                                "};\n",
                                                "TRACE_PUSH\n"
                                            }, true));
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_varD);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_x);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("TRACE_POP\n"));
        a_eqfuncs = Tpl.popBlock(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// "));
        txt = symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data);\n",
                                    "function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(a_arrayIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("](data);"));
      then (txt, a_eqArray, a_eqfuncs);
  end match;
end fun_449;

public function equation_arrayFormat
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input String a_name;
  input SimCode.Context a_context;
  input Integer a_arrayIndex;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_eqArray;
  input Tpl.Text a_eqfuncs;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_eqfuncs;
algorithm
  (out_txt, out_a_eqArray, out_a_eqfuncs) := fun_449(txt, a_eq, a_name, a_context, a_arrayIndex, a_eqArray, a_eqfuncs, a_modelNamePrefix);
  out_a_varDecls := a_varDecls;
end equation_arrayFormat;

protected function fun_451
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = true) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_451;

protected function lm_452
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_452(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_452;

protected function fun_453
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tempeqns;
  input Tpl.Text in_a_varD;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
  output Tpl.Text out_a_tempeqns;
  output Tpl.Text out_a_varD;
algorithm
  (out_txt, out_a_eqs, out_a_tempeqns, out_a_varD) :=
  match(in_txt, in_a_eq, in_a_eqs, in_a_modelNamePrefix, in_a_tempeqns, in_a_varD, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_eqs;
      String a_modelNamePrefix;
      Tpl.Text a_tempeqns;
      Tpl.Text a_varD;
      SimCode.Context a_context;
      list<SimCode.SimEqSystem> i_e_eqs;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationSimpleAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ARRAY_CALL_ASSIGN(index = _)),
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationArrayCallAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_IFEQUATION(index = _)),
           a_eqs,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationIfEquationAssign(txt, i_e, a_context, a_varD, a_tempeqns, a_modelNamePrefix);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ALGORITHM(index = _)),
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationAlgorithm(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_LINEAR(index = _)),
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD) = equationLinear(txt, i_e, a_context, a_varD);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(eqs = i_e_eqs)),
           a_eqs,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        a_tempeqns = Tpl.pushIter(a_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns = lm_452(a_tempeqns, i_e_eqs, a_modelNamePrefix);
        a_tempeqns = Tpl.popIter(a_tempeqns);
        (txt, a_varD) = equationNonlinear(txt, i_e, a_context, a_varD, a_modelNamePrefix);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_WHEN(index = _)),
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationWhen(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION SES_RESIDUAL"));
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_MIXED(index = _)),
           a_eqs,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_eqs) = equationMixed(txt, i_e, a_context, a_varD, a_eqs, a_modelNamePrefix);
      then (txt, a_eqs, a_tempeqns, a_varD);

    case ( txt,
           _,
           a_eqs,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION equation_"));
      then (txt, a_eqs, a_tempeqns, a_varD);
  end match;
end fun_453;

protected function fun_454
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_454;

protected function fun_455
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_455;

protected function fun_456
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_context, in_a_eqs, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_eqs;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Boolean ret_8;
      Boolean ret_7;
      list<SimCode.SimEqSystem> ret_6;
      Tpl.Text l_x;
      Tpl.Text l_disc;
      Tpl.Text l_tempeqns;
      Tpl.Text l_varD;
      Tpl.Text l_tmp;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           a_eqs,
           _ )
      then (txt, a_eqs);

    case ( txt,
           i_eq,
           a_context,
           a_eqs,
           a_modelNamePrefix )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        l_tmp = Tpl.emptyTxt;
        l_varD = Tpl.emptyTxt;
        l_tempeqns = Tpl.emptyTxt;
        System.tmpTickResetIndex(0, 1);
        l_disc = fun_451(Tpl.emptyTxt, a_context);
        (l_x, a_eqs, l_tempeqns, l_varD) = fun_453(Tpl.emptyTxt, i_eq, a_eqs, a_modelNamePrefix, l_tempeqns, l_varD, a_context);
        l_varD = addRootsTempArray(l_varD);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_NEW_LINE());
        a_eqs = Tpl.writeText(a_eqs, l_tempeqns);
        a_eqs = Tpl.softNewLine(a_eqs);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_LINE("/*\n"));
        a_eqs = Tpl.pushBlock(a_eqs, Tpl.BT_INDENT(1));
        ret_6 = List.fill(i_eq, 1);
        a_eqs = CodegenUtil.dumpEqs(a_eqs, ret_6);
        a_eqs = Tpl.softNewLine(a_eqs);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_LINE("*/\n"));
        a_eqs = Tpl.popBlock(a_eqs);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_STRING("void "));
        a_eqs = symbolName(a_eqs, a_modelNamePrefix, "eqFunction");
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_STRING("_"));
        a_eqs = Tpl.writeText(a_eqs, l_ix);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_STRING_LIST({
                                        "(DATA *data)\n",
                                        "{\n"
                                    }, true));
        a_eqs = Tpl.pushBlock(a_eqs, Tpl.BT_INDENT(2));
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        a_eqs = Tpl.writeText(a_eqs, l_ix);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_STRING_LIST({
                                        "};\n",
                                        "TRACE_PUSH\n"
                                    }, true));
        a_eqs = Tpl.writeText(a_eqs, l_varD);
        a_eqs = Tpl.softNewLine(a_eqs);
        a_eqs = Tpl.writeText(a_eqs, l_x);
        a_eqs = Tpl.softNewLine(a_eqs);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_LINE("TRACE_POP\n"));
        a_eqs = Tpl.popBlock(a_eqs);
        a_eqs = Tpl.writeTok(a_eqs, Tpl.ST_STRING("}"));
        ret_7 = Config.profileAll();
        txt = fun_454(txt, ret_7, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(data);\n"));
        ret_8 = Config.profileAll();
        txt = fun_455(txt, ret_8, l_ix);
      then (txt, a_eqs);
  end match;
end fun_456;

public function equation_
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_eqs;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_eqs) := fun_456(txt, a_eq, a_context, a_eqs, a_modelNamePrefix);
  out_a_varDecls := a_varDecls;
end equation_;

protected function fun_458
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefixStr )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA* data);"));
      then txt;
  end match;
end fun_458;

protected function fun_459
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefixStr )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA* data);"));
      then txt;
  end match;
end fun_459;

protected function fun_460
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      String a_modelNamePrefixStr;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = true),
           a_eq,
           a_modelNamePrefixStr )
      equation
        txt = fun_458(txt, a_eq, a_modelNamePrefixStr);
      then txt;

    case ( txt,
           _,
           a_eq,
           a_modelNamePrefixStr )
      equation
        txt = fun_459(txt, a_eq, a_modelNamePrefixStr);
      then txt;
  end match;
end fun_460;

public function equationForward_
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_460(txt, a_context, a_eq, a_modelNamePrefixStr);
end equationForward_;

protected function fun_462
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_462;

protected function fun_463
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_463;

protected function fun_464
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefixStr )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        ret_1 = Config.profileAll();
        txt = fun_462(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(data);\n"));
        ret_2 = Config.profileAll();
        txt = fun_463(txt, ret_2, l_ix);
      then txt;
  end match;
end fun_464;

protected function fun_465
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_465;

protected function fun_466
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_466;

protected function fun_467
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefixStr )
      equation
        l_ix = CodegenUtil.equationIndex(Tpl.emptyTxt, i_eq);
        ret_1 = Config.profileAll();
        txt = fun_465(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(data);\n"));
        ret_2 = Config.profileAll();
        txt = fun_466(txt, ret_2, l_ix);
      then txt;
  end match;
end fun_467;

protected function fun_468
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      String a_modelNamePrefixStr;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = true),
           a_eq,
           a_modelNamePrefixStr )
      equation
        txt = fun_464(txt, a_eq, a_modelNamePrefixStr);
      then txt;

    case ( txt,
           _,
           a_eq,
           a_modelNamePrefixStr )
      equation
        txt = fun_467(txt, a_eq, a_modelNamePrefixStr);
      then txt;
  end match;
end fun_468;

public function equationNames_
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_468(txt, a_context, a_eq, a_modelNamePrefixStr);
end equationNames_;

public function equationSimpleAssign
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_cref;
      SimCode.SimEqSystem i_eq;
      DAE.Exp i_exp;
      Absyn.Info ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(exp = i_exp, cref = i_cref)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_2 = SimCodeUtil.eqInfo(i_eq);
        txt = modelicaLine(txt, ret_2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = endModelicaLine(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationSimpleAssign;

protected function fun_471
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_eqn_exp;
  input DAE.ComponentRef in_a_eqn_componentRef;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_eqn_exp, in_a_eqn_componentRef, in_a_expPart, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Exp a_eqn_exp;
      DAE.ComponentRef a_eqn_componentRef;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text l_tvar;

    case ( txt,
           "boolean",
           _,
           a_eqn_componentRef,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_boolean_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_eqn_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           "integer",
           _,
           a_eqn_componentRef,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "integer_array", a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_integer_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_eqn_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           "real",
           _,
           a_eqn_componentRef,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_real_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_eqn_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           "string",
           _,
           a_eqn_componentRef,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_string_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_eqn_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_eqn_exp,
           _,
           _,
           _,
           a_varDecls )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("No runtime support for this sort of array call: "));
        ret_1 = ExpressionDump.printExpStr(a_eqn_exp);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 3871, 14), Tpl.textString(txt_1));
      then (txt, a_varDecls);
  end match;
end fun_471;

protected function fun_472
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_eqn_componentRef;
      DAE.Exp i_eqn_exp;
      DAE.Exp i_exp;
      String str_3;
      Tpl.Text txt_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(exp = (i_eqn_exp as i_exp), componentRef = i_eqn_componentRef),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt_2 = expTypeFromExpShort(Tpl.emptyTxt, i_eqn_exp);
        str_3 = Tpl.textString(txt_2);
        (txt, a_varDecls) = fun_471(txt, str_3, i_eqn_exp, i_eqn_componentRef, l_expPart, l_preExp, a_varDecls);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_472;

public function equationArrayCallAssign
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Absyn.Info ret_0;
algorithm
  ret_0 := SimCodeUtil.eqInfo(a_eq);
  out_txt := modelicaLine(txt, ret_0);
  out_txt := Tpl.softNewLine(out_txt);
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_472(out_txt, a_eq, a_context, a_varDecls, a_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := endModelicaLine(out_txt);
end equationArrayCallAssign;

protected function lm_474
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_474(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_474;

public function equationAlgorithm
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_statements;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = i_statements),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_474(txt, i_statements, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationAlgorithm;

protected function fun_476
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_476;

protected function lm_477
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_indexLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexLinearSystem)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_indexLinearSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest,
           a_indexLinearSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo.linearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].x["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_477(txt, rest, a_indexLinearSystem);
      then txt;

    case ( txt,
           _ :: rest,
           a_indexLinearSystem )
      equation
        txt = lm_477(txt, rest, a_indexLinearSystem);
      then txt;
  end match;
end lm_477;

protected function fun_478
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_478;

protected function fun_479
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> i_vars;
      Integer i_indexLinearSystem;
      Integer i_index;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCode.SES_LINEAR(index = i_index, indexLinearSystem = i_indexLinearSystem, vars = i_vars) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Linear equation system */\n"));
        ret_0 = Config.profileSome();
        txt = fun_476(txt, ret_0, i_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("solve_linear_system(data, "));
        txt = Tpl.writeStr(txt, intString(i_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_477(txt, i_vars, i_indexLinearSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_1 = Config.profileSome();
        txt = fun_478(txt, ret_1, i_index);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_479;

public function equationLinear
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_479(txt, a_eq);
  out_a_varDecls := a_varDecls;
end equationLinear;

protected function fun_481
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_481;

protected function lm_482
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_eqn_indexMixedSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_eqn_indexMixedSystem)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_eqn_indexMixedSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest,
           a_eqn_indexMixedSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.mixedSystemData["));
        txt = Tpl.writeStr(txt, intString(a_eqn_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].iterationVarsPtr["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (modelica_boolean*)&"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_482(txt, rest, a_eqn_indexMixedSystem);
      then txt;

    case ( txt,
           _ :: rest,
           a_eqn_indexMixedSystem )
      equation
        txt = lm_482(txt, rest, a_eqn_indexMixedSystem);
      then txt;
  end match;
end lm_482;

protected function lm_483
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_eqn_indexMixedSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_eqn_indexMixedSystem)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_eqn_indexMixedSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest,
           a_eqn_indexMixedSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.mixedSystemData["));
        txt = Tpl.writeStr(txt, intString(a_eqn_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].iterationPreVarsPtr["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (modelica_boolean*)&$P$PRE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_483(txt, rest, a_eqn_indexMixedSystem);
      then txt;

    case ( txt,
           _ :: rest,
           a_eqn_indexMixedSystem )
      equation
        txt = lm_483(txt, rest, a_eqn_indexMixedSystem);
      then txt;
  end match;
end lm_483;

protected function fun_484
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_484;

public function equationMixed
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_tmp;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_varDecls, out_a_tmp) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_tmp, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_tmp;
      String a_modelNamePrefixStr;
      Integer i_indexMixedSystem;
      Integer i_eqn_indexMixedSystem;
      Integer i_index;
      list<SimCode.SimVar> i_discVars;
      SimCode.SimEqSystem i_cont;
      Boolean ret_4;
      Boolean ret_3;
      Integer ret_2;
      Tpl.Text l_numDiscVarsStr;
      Tpl.Text l_contEqs;

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont, discVars = i_discVars, index = i_index, indexMixedSystem = (i_indexMixedSystem as i_eqn_indexMixedSystem)),
           a_context,
           a_varDecls,
           a_tmp,
           a_modelNamePrefixStr )
      equation
        (l_contEqs, a_varDecls, a_tmp) = equation_(Tpl.emptyTxt, i_cont, a_context, a_varDecls, a_tmp, a_modelNamePrefixStr);
        ret_2 = listLength(i_discVars);
        l_numDiscVarsStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Continuous equation part in "));
        txt = Tpl.writeText(txt, l_contEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        ret_3 = Config.profileSome();
        txt = fun_481(txt, ret_3, i_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_482(txt, i_discVars, i_eqn_indexMixedSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_483(txt, i_discVars, i_eqn_indexMixedSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "solve_mixed_system(data, "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        ret_4 = Config.profileSome();
        txt = fun_484(txt, ret_4, i_index);
      then (txt, a_varDecls, a_tmp);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_tmp,
           _ )
      then (txt, a_varDecls, a_tmp);
  end match;
end equationMixed;

protected function lm_486
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_486(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_486;

protected function fun_487
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ").profileBlockIndex);\n",
                                    "SIM_PROF_ADD_NCALL_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,-1);"));
      then txt;
  end match;
end fun_487;

protected function lm_488
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_indexNonLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexNonLinearSystem)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_indexNonLinearSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Tpl.Text l_namestr;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_indexNonLinearSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_namestr = cref(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo.nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsx["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->simulationInfo.nonlinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsxOld["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = _"));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(1) /*old*/;\n",
                                    "data->simulationInfo.nonlinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsxExtrapolation["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = extraPolate(data, _"));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(1) /*old*/, _"));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(2) /*old2*/);"));
        txt = Tpl.nextIter(txt);
        txt = lm_488(txt, rest, a_indexNonLinearSystem);
      then txt;
  end match;
end lm_488;

protected function lm_489
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_indexNonLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexNonLinearSystem)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_indexNonLinearSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_indexNonLinearSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo.nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsx["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_489(txt, rest, a_indexNonLinearSystem);
      then txt;
  end match;
end lm_489;

protected function fun_490
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoXmlGetEquation(&data->modelData.modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_490;

protected function fun_491
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String a_modelNamePrefix;
      Integer i_index;
      Integer i_indexNonLinearSystem;
      list<SimCode.SimEqSystem> i_eqs;
      list<DAE.ComponentRef> i_crefs;
      Boolean ret_6;
      Boolean ret_5;
      Tpl.Text l_nonlinindx;
      Tpl.Text l_innerBody;
      Tpl.Text l_tmp;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(crefs = i_crefs, eqs = i_eqs, indexNonLinearSystem = i_indexNonLinearSystem, index = i_index),
           a_varDecls,
           a_modelNamePrefix )
      equation
        ret_1 = listLength(i_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_tmp = Tpl.emptyTxt;
        l_innerBody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_innerBody, l_tmp, a_varDecls) = lm_486(l_innerBody, i_eqs, a_modelNamePrefix, l_tmp, a_varDecls);
        l_innerBody = Tpl.popIter(l_innerBody);
        l_nonlinindx = Tpl.writeStr(Tpl.emptyTxt, intString(i_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("int retValue;\n"));
        ret_5 = Config.profileSome();
        txt = fun_487(txt, ret_5, i_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extrapolate data */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_488(txt, i_crefs, i_indexNonLinearSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("retValue = solve_nonlinear_system(data, "));
        txt = Tpl.writeStr(txt, intString(i_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/* check if solution process was sucessful */\n",
                                    "if (retValue > 0){\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int indexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "throwStreamPrintWithEquationIndexes(threadData, indexes, \"Solving non-linear system failed at time=%.15g.\\nFor more information please use -lv LOG_NLS.\", time);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "/* write solution */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_489(txt, i_crefs, i_indexNonLinearSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* update inner equations */\n"));
        txt = Tpl.writeText(txt, l_innerBody);
        txt = Tpl.softNewLine(txt);
        ret_6 = Config.profileSome();
        txt = fun_490(txt, ret_6, i_index);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           _ )
      then (txt, a_varDecls);
  end match;
end fun_491;

public function equationNonlinear
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) := fun_491(txt, a_eq, a_varDecls, a_modelNamePrefix);
end equationNonlinear;

protected function lm_493
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_493(txt, rest);
      then txt;
  end match;
end lm_493;

protected function fun_494
  input Tpl.Text in_txt;
  input Boolean in_a_initialCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_right;
  input DAE.ComponentRef in_a_left;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_initialCall, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_right, in_a_left)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Exp a_right;
      DAE.ComponentRef a_left;
      DAE.Type ret_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           _,
           _,
           a_left )
      equation
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = $P$PRE"));
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_right,
           a_left )
      equation
        ret_0 = Expression.typeof(a_right);
        (txt, a_varDecls, a_auxFunction) = whenAssign(txt, a_left, ret_0, a_right, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_494;

protected function lm_495
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_495(txt, rest);
      then txt;
  end match;
end lm_495;

protected function fun_496
  input Tpl.Text in_txt;
  input Boolean in_a_initialCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_right;
  input DAE.ComponentRef in_a_left;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_initialCall, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_right, in_a_left)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Exp a_right;
      DAE.ComponentRef a_left;
      DAE.Type ret_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           _,
           _,
           a_left )
      equation
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = $P$PRE"));
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_right,
           a_left )
      equation
        ret_0 = Expression.typeof(a_right);
        (txt, a_varDecls, a_auxFunction) = whenAssign(txt, a_left, ret_0, a_right, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_496;

public function equationWhen
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimEqSystem i_elseWhenEq;
      DAE.Exp i_right;
      DAE.ComponentRef i_left;
      Boolean i_initialCall;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_elseWhen;
      DAE.Type ret_4;
      DAE.Type ret_3;
      Tpl.Text l_assign;
      Tpl.Text l_initial__assign;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(left = i_left, right = i_right, conditions = i_conditions, elseWhen = NONE(), initialCall = i_initialCall),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_helpIf = lm_493(Tpl.emptyTxt, i_conditions);
        (l_initial__assign, a_auxFunction, a_varDecls) = fun_494(Tpl.emptyTxt, i_initialCall, a_auxFunction, a_varDecls, a_context, i_right, i_left);
        ret_3 = Expression.typeof(i_right);
        (l_assign, a_varDecls, a_auxFunction) = whenAssign(Tpl.emptyTxt, i_left, ret_3, i_right, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(initial())\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_initial__assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else if(0"
                                }, false));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = cref(txt, i_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = $P$PRE"));
        txt = cref(txt, i_left);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_WHEN(left = i_left, right = i_right, conditions = i_conditions, elseWhen = SOME(i_elseWhenEq), initialCall = i_initialCall),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_helpIf = lm_495(Tpl.emptyTxt, i_conditions);
        (l_initial__assign, a_auxFunction, a_varDecls) = fun_496(Tpl.emptyTxt, i_initialCall, a_auxFunction, a_varDecls, a_context, i_right, i_left);
        ret_4 = Expression.typeof(i_right);
        (l_assign, a_varDecls, a_auxFunction) = whenAssign(Tpl.emptyTxt, i_left, ret_4, i_right, a_context, a_varDecls, a_auxFunction);
        (l_elseWhen, a_varDecls, a_auxFunction) = equationElseWhen(Tpl.emptyTxt, i_elseWhenEq, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(initial())\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_initial__assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else if(0"
                                }, false));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_elseWhen);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = cref(txt, i_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = $P$PRE"));
        txt = cref(txt, i_left);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationWhen;

protected function lm_498
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_498(txt, rest);
      then txt;
  end match;
end lm_498;

protected function lm_499
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_499(txt, rest);
      then txt;
  end match;
end lm_499;

public function equationElseWhen
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimEqSystem i_elseWhenEq;
      DAE.Exp i_right;
      DAE.ComponentRef i_left;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_elseWhen;
      DAE.Type ret_3;
      DAE.Type ret_2;
      Tpl.Text l_assign;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(left = i_left, right = i_right, conditions = i_conditions, elseWhen = NONE()),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_helpIf = lm_498(Tpl.emptyTxt, i_conditions);
        ret_2 = Expression.typeof(i_right);
        (l_assign, a_varDecls, a_auxFunction) = whenAssign(Tpl.emptyTxt, i_left, ret_2, i_right, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if(0"));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_WHEN(left = i_left, right = i_right, conditions = i_conditions, elseWhen = SOME(i_elseWhenEq)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_helpIf = lm_499(Tpl.emptyTxt, i_conditions);
        ret_3 = Expression.typeof(i_right);
        (l_assign, a_varDecls, a_auxFunction) = whenAssign(Tpl.emptyTxt, i_left, ret_3, i_right, a_context, a_varDecls, a_auxFunction);
        (l_elseWhen, a_varDecls, a_auxFunction) = equationElseWhen(Tpl.emptyTxt, i_elseWhenEq, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if(0"));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_elseWhen);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationElseWhen;

protected function fun_501
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_right;
  input DAE.ComponentRef in_a_left;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_right, in_a_left, in_a_expPart, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Exp a_right;
      DAE.ComponentRef a_left;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text l_tvar;

    case ( txt,
           "boolean",
           _,
           a_left,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_boolean_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           "integer",
           _,
           a_left,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "integer_array", a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_integer_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           "real",
           _,
           a_left,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_real_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           "string",
           _,
           a_left,
           a_expPart,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_string_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_right,
           a_left,
           _,
           _,
           a_varDecls )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("No runtime support for this sort of array call: "));
        txt_1 = cref(txt_1, a_left);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(" = "));
        ret_1 = ExpressionDump.printExpStr(a_right);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4076, 13), Tpl.textString(txt_1));
      then (txt, a_varDecls);
  end match;
end fun_501;

protected function fun_502
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_left;
  input DAE.Exp in_a_right;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ty, in_a_left, in_a_right, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_left;
      DAE.Exp a_right;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Tpl.Text l_exp;
      String str_3;
      Tpl.Text txt_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_left,
           a_right,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_right, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt_2 = expTypeFromExpShort(Tpl.emptyTxt, a_right);
        str_3 = Tpl.textString(txt_2);
        (txt, a_varDecls) = fun_501(txt, str_3, a_right, a_left, l_expPart, l_preExp, a_varDecls);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_left,
           a_right,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_exp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_right, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_502;

public function whenAssign
  input Tpl.Text txt;
  input DAE.ComponentRef a_left;
  input DAE.Type a_ty;
  input DAE.Exp a_right;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_502(txt, a_ty, a_left, a_right, a_context, a_varDecls, a_auxFunction);
end whenAssign;

protected function lm_504
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_eqnsDecls;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqnsDecls;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqnsDecls, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_eqnsDecls, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_eqnsDecls;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      SimCode.SimEqSystem i_eqn;
      Tpl.Text l_eqnStr;

    case ( txt,
           {},
           _,
           a_eqnsDecls,
           a_varDecls,
           _ )
      then (txt, a_eqnsDecls, a_varDecls);

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefixStr,
           a_eqnsDecls,
           a_varDecls,
           a_context )
      equation
        (l_eqnStr, a_varDecls, a_eqnsDecls) = equation_(Tpl.emptyTxt, i_eqn, a_context, a_varDecls, a_eqnsDecls, a_modelNamePrefixStr);
        txt = Tpl.writeText(txt, l_eqnStr);
        txt = Tpl.nextIter(txt);
        (txt, a_eqnsDecls, a_varDecls) = lm_504(txt, rest, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, a_context);
      then (txt, a_eqnsDecls, a_varDecls);
  end match;
end lm_504;

protected function fun_505
  input Tpl.Text in_txt;
  input Integer in_a_index0;
  input Tpl.Text in_a_condition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_index0, in_a_condition)
    local
      Tpl.Text txt;
      Tpl.Text a_condition;

    case ( txt,
           0,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if("));
        txt = Tpl.writeText(txt, a_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_505;

protected function lm_506
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_eqnsDecls;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqnsDecls;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_eqnsDecls, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_eqnsDecls, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_eqnsDecls;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_index0;
      list<SimCode.SimEqSystem> i_eqns;
      DAE.Exp i_e;
      Tpl.Text l_conditionline;
      Tpl.Text l_ifequations;
      Tpl.Text l_condition;

    case ( txt,
           {},
           _,
           a_eqnsDecls,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_eqnsDecls, a_varDecls, a_preExp);

    case ( txt,
           (i_e, i_eqns) :: rest,
           a_modelNamePrefixStr,
           a_eqnsDecls,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        (l_condition, a_preExp, a_varDecls, a_eqnsDecls) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_eqnsDecls);
        l_ifequations = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_ifequations, a_eqnsDecls, a_varDecls) = lm_504(l_ifequations, i_eqns, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, a_context);
        l_ifequations = Tpl.popIter(l_ifequations);
        l_conditionline = fun_505(Tpl.emptyTxt, x_index0, l_condition);
        txt = Tpl.writeText(txt, l_conditionline);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_ifequations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_eqnsDecls, a_varDecls, a_preExp) = lm_506(txt, rest, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, a_preExp, a_context);
      then (txt, a_eqnsDecls, a_varDecls, a_preExp);
  end match;
end lm_506;

protected function lm_507
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_eqnsDecls;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqnsDecls;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqnsDecls, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_eqnsDecls, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_eqnsDecls;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      SimCode.SimEqSystem i_eqn;
      Tpl.Text l_eqnStr;

    case ( txt,
           {},
           _,
           a_eqnsDecls,
           a_varDecls,
           _ )
      then (txt, a_eqnsDecls, a_varDecls);

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefixStr,
           a_eqnsDecls,
           a_varDecls,
           a_context )
      equation
        (l_eqnStr, a_varDecls, a_eqnsDecls) = equation_(Tpl.emptyTxt, i_eqn, a_context, a_varDecls, a_eqnsDecls, a_modelNamePrefixStr);
        txt = Tpl.writeText(txt, l_eqnStr);
        txt = Tpl.nextIter(txt);
        (txt, a_eqnsDecls, a_varDecls) = lm_507(txt, rest, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, a_context);
      then (txt, a_eqnsDecls, a_varDecls);
  end match;
end lm_507;

public function equationIfEquationAssign
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_eqnsDecls;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqnsDecls;
algorithm
  (out_txt, out_a_varDecls, out_a_eqnsDecls) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_eqnsDecls, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_eqnsDecls;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> i_elsebranch;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> i_ifbranches;
      Tpl.Text l_elseequations;
      Tpl.Text l_IfEquation;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.SES_IFEQUATION(ifbranches = i_ifbranches, elsebranch = i_elsebranch),
           a_context,
           a_varDecls,
           a_eqnsDecls,
           a_modelNamePrefixStr )
      equation
        l_preExp = Tpl.emptyTxt;
        l_IfEquation = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_IfEquation, a_eqnsDecls, a_varDecls, l_preExp) = lm_506(l_IfEquation, i_ifbranches, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, l_preExp, a_context);
        l_IfEquation = Tpl.popIter(l_IfEquation);
        l_elseequations = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_elseequations, a_eqnsDecls, a_varDecls) = lm_507(l_elseequations, i_elsebranch, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, a_context);
        l_elseequations = Tpl.popIter(l_elseequations);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_IfEquation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_elseequations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_eqnsDecls);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_eqnsDecls,
           _ )
      then (txt, a_varDecls, a_eqnsDecls);
  end match;
end equationIfEquationAssign;

protected function fun_509
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_literal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_literal)
    local
      Tpl.Text txt;
      DAE.Exp a_literal;
      String ret_1;
      String ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_literal )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        ret_0 = ExpressionDump.printExpStr(a_literal);
        ret_1 = Util.escapeModelicaStringToCString(ret_0);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_509;

protected function lm_510
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_preLit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preLit;
algorithm
  (out_txt, out_a_preLit) :=
  match(in_txt, in_items, in_a_preLit)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_preLit;
      Integer x_i0;
      DAE.Exp i_literal;
      Boolean ret_0;

    case ( txt,
           {},
           a_preLit )
      then (txt, a_preLit);

    case ( txt,
           i_literal :: rest,
           a_preLit )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = Config.typeinfo();
        txt = fun_509(txt, ret_0, i_literal);
        (txt, a_preLit) = literalExpConst(txt, i_literal, x_i0, a_preLit);
        txt = Tpl.nextIter(txt);
        (txt, a_preLit) = lm_510(txt, rest, a_preLit);
      then (txt, a_preLit);
  end match;
end lm_510;

public function simulationLiteralsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<DAE.Exp> a_literals;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_res;
  Tpl.Text l_preLit;
algorithm
  l_preLit := Tpl.emptyTxt;
  l_res := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_res, l_preLit) := lm_510(l_res, a_literals, l_preLit);
  l_res := Tpl.popIter(l_res);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#ifdef __cplusplus\n",
                                   "extern \"C\" {\n",
                                   "#endif\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.writeText(out_txt, l_preLit);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_res);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end simulationLiteralsFile;

public function simulationFunctionsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCode.Function> a_functions;
  input list<String> a_includes;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_functions.h\"\n",
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n",
                                       "\n",
                                       "#include \""
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("_literals.h\"\n"));
  out_txt := externalFunctionIncludes(out_txt, a_includes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := functionBodies(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end simulationFunctionsFile;

public function simulationParModelicaKernelsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  System.tmpTickResetIndex(0, 20);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include <ParModelica/explicit/openclrt/OCLRuntimeUtil.cl>\n",
                                   "\n",
                                   "// ParModelica Parallel Function headers.\n"
                               }, true));
  out_txt := functionHeadersParModelica(out_txt, a_filePrefix, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "// Headers finish here.\n",
                                       "\n"
                                   }, true));
  out_txt := functionBodiesParModelica(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "\n"
                                   }, true));
end simulationParModelicaKernelsFile;

protected function fun_514
  input Tpl.Text in_txt;
  input Option<SimCode.Function> in_a_mainFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction)
    local
      Tpl.Text txt;
      SimCode.Function i_fn;

    case ( txt,
           SOME(i_fn) )
      equation
        txt = functionBodyParModelica(txt, i_fn, true);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_514;

public function functionsParModelicaKernelsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input Option<SimCode.Function> a_mainFunction;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  System.tmpTickResetIndex(0, 20);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include <ParModelica/explicit/openclrt/OCLRuntimeUtil.cl>\n",
                                   "\n",
                                   "// ParModelica Parallel Function headers.\n"
                               }, true));
  out_txt := functionHeadersParModelica(out_txt, a_filePrefix, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "// Headers finish here.\n",
                                       "\n"
                                   }, true));
  out_txt := fun_514(out_txt, a_mainFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := functionBodiesParModelica(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "\n"
                                   }, true));
end functionsParModelicaKernelsFile;

protected function lm_516
  input Tpl.Text in_txt;
  input list<SimCode.RecordDeclaration> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.RecordDeclaration> rest;
      SimCode.RecordDeclaration i_rd;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rd :: rest )
      equation
        txt = recordDeclaration(txt, i_rd);
        txt = Tpl.nextIter(txt);
        txt = lm_516(txt, rest);
      then txt;
  end match;
end lm_516;

public function recordsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCode.RecordDeclaration> a_recordDecls;

  output Tpl.Text out_txt;
protected
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("/* Additional record code for "));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" generated by the OpenModelica Compiler "));
  ret_0 := Settings.getVersionNr();
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ". */\n",
                                       "#include \"meta/meta_modelica.h\"\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                        "\n",
                                                                        "\n"
                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_516(out_txt, a_recordDecls);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end recordsFile;

protected function lm_518
  input Tpl.Text in_txt;
  input list<SimCode.RecordDeclaration> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.RecordDeclaration> rest;
      SimCode.RecordDeclaration i_rd;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rd :: rest )
      equation
        txt = recordDeclarationHeader(txt, i_rd);
        txt = Tpl.nextIter(txt);
        txt = lm_518(txt, rest);
      then txt;
  end match;
end lm_518;

public function simulationFunctionsHeaderFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCode.Function> a_functions;
  input list<SimCode.RecordDeclaration> a_recordDecls;

  output Tpl.Text out_txt;
protected
  String ret_1;
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
  ret_0 := System.stringReplace(a_filePrefix, ".", "_");
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "#define "
                                   }, false));
  ret_1 := System.stringReplace(a_filePrefix, ".", "_");
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__H\n"));
  out_txt := commonHeader(out_txt, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#include \"simulation/simulation_runtime.h\"\n",
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n"
                                   }, true));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                        "\n",
                                                                        "\n"
                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_518(out_txt, a_recordDecls);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := functionHeaders(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end simulationFunctionsHeaderFile;

public function functionHeadersParModelica
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
protected
  String ret_1;
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
  ret_0 := System.stringReplace(a_filePrefix, ".", "_");
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "#define "
                                   }, false));
  ret_1 := System.stringReplace(a_filePrefix, ".", "_");
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "//#include \"helper.cl\"\n",
                                       "\n"
                                   }, true));
  out_txt := parallelFunctionHeadersImpl(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end functionHeadersParModelica;

protected function fun_521
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_521;

protected function lm_522
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_522(txt, rest);
      then txt;
  end match;
end lm_522;

protected function fun_523
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_523;

protected function fun_524
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_524;

protected function fun_525
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMOCLRuntime.lib OpenCL.lib"));
      then txt;
  end match;
end fun_525;

protected function fun_526
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_526;

protected function fun_527
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_526(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_527;

protected function fun_528
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/openmp"));
      then txt;
  end match;
end fun_528;

protected function fun_529
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      String i_makefileParams_omhome;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_7;
      Tpl.Text l_extraCflags;
      Boolean ret_5;
      Tpl.Text l_ParModelicaExpLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCode.MAKEFILE_PARAMS(libs = i_makefileParams_libs, omhome = i_makefileParams_omhome), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix) )
      equation
        l_dirExtra = fun_521(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_522(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_523(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_524(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        ret_5 = Config.acceptParModelicaGrammar();
        l_ParModelicaExpLibs = fun_525(Tpl.emptyTxt, ret_5);
        l_extraCflags = fun_527(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "\n",
                                    "# Simulations use -O0 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CC=cl\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "CFLAGS=/Od /ZI /EHa /fp:except /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" /I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/msvc/\" /I. /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY /DOPENMODELICA_XML_FROM_FILE_AT_RUNTIME "));
        ret_7 = Flags.isSet(Flags.HPCOM);
        txt = fun_528(txt, ret_7);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "# /ZI enable Edit and Continue debug info\n",
                                    "CDFLAGS = /ZI\n",
                                    "\n",
                                    "# /MD - link with MSVCRT.LIB\n",
                                    "# /link - [linker options and libraries]\n",
                                    "# /LIBPATH: - Directories where libs can be found\n",
                                    "LDFLAGS=/MD /link /NODEFAULTLIB:libcmt /STACK:0x2000000 /pdb:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".pdb\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/msvc/\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/msvc/release/\" "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " f2c.lib initialization.lib libexpat.lib math-support.lib meta.lib results.lib simulation.lib solver.lib sundials_kinsol.lib sundials_nvecserial.lib util.lib lapack_win32_MT.lib lis.lib  gc-lib.lib user32.lib pthreadVC2.lib\n",
                                    "\n",
                                    "# /MDd link with MSVCRTD.LIB debug lib\n",
                                    "# lib names should not be appended with a d just switch to lib/omc/msvc/debug\n",
                                    "\n",
                                    "\n",
                                    "FILEPREFIX="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MAINFILE=$(FILEPREFIX).c\n",
                                    "MAINOBJ=$(FILEPREFIX).obj\n",
                                    "CFILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_01exo.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_02nls.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_03lsy.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_04set.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_05evt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_06inz.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_07dly.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_08bnd.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_09alg.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_10asr.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_11mix.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_12jac.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_13opt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_14lnz.c\n",
                                    "OFILES=$(CFILES:.c=.obj)\n",
                                    "GENERATEDFILES=$(MAINFILE) $(FILEPREFIX)_functions.h $(FILEPREFIX).makefile $(CFILES)\n",
                                    "\n",
                                    ".PHONY: $(FILEPREFIX)$(EXEEXT)\n",
                                    "\n",
                                    "# This is to make sure that "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_*.c are always compiled.\n",
                                    ".PHONY: $(CFILES)\n",
                                    "\n",
                                    "$(FILEPREFIX)$(EXEEXT): $(MAINFILE) $(FILEPREFIX)_functions.h $(CFILES)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(CXX) /Fe$(FILEPREFIX)$(EXEEXT) $(MAINFILE) $(CFILES) $(CFLAGS) $(LDFLAGS)\n",
                                    "\n",
                                    "clean:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f *.obj *.lib *.exp *.c *.h *.xml *.libs *.log *.makefile *.pdb *.idb *.exe"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_529;

protected function fun_530
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_530;

protected function lm_531
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_531(txt, rest);
      then txt;
  end match;
end lm_531;

protected function fun_532
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_532;

protected function fun_533
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_533;

protected function fun_534
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lOMOCLRuntime -lOpenCL"));
      then txt;
  end match;
end fun_534;

protected function fun_535
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lom_pm_autort -L. -ltbb"));
      then txt;
  end match;
end fun_535;

protected function fun_536
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_536;

protected function fun_537
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_536(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_537;

protected function fun_538
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-O0 -g"));
      then txt;
  end match;
end fun_538;

protected function fun_539
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_ccompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_ccompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_ccompiler;

    case ( txt,
           false,
           a_makefileParams_ccompiler )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_ccompiler);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("g++"));
      then txt;
  end match;
end fun_539;

protected function fun_540
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_cflags;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(cflags = i_s_cflags)) )
      equation
        txt = Tpl.writeStr(txt, i_s_cflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_540;

protected function fun_541
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_EMCC_PRE_JS="));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/emcc/pre.js"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_541;

protected function lm_542
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_542(txt, rest);
      then txt;
  end match;
end lm_542;

protected function fun_543
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_EMCC"));
      then txt;
  end match;
end fun_543;

protected function fun_544
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("--stack,0x2000000,"));
      then txt;
  end match;
end fun_544;

protected function fun_545
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_runtimelibs;
  input String in_a_makefileParams_ldflags;
  input Tpl.Text in_a_ParModelicaAutoLibs;
  input Tpl.Text in_a_ParModelicaExpLibs;
  input String in_a_makefileParams_platform;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_runtimelibs, in_a_makefileParams_ldflags, in_a_ParModelicaAutoLibs, in_a_ParModelicaExpLibs, in_a_makefileParams_platform, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_runtimelibs;
      String a_makefileParams_ldflags;
      Tpl.Text a_ParModelicaAutoLibs;
      Tpl.Text a_ParModelicaExpLibs;
      String a_makefileParams_platform;
      String a_makefileParams_omhome;
      Boolean ret_0;

    case ( txt,
           false,
           a_makefileParams_runtimelibs,
           a_makefileParams_ldflags,
           a_ParModelicaAutoLibs,
           a_ParModelicaExpLibs,
           a_makefileParams_platform,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc\" -L\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib\" -Wl,"));
        ret_0 = stringEq(a_makefileParams_platform, "win32");
        txt = fun_544(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-rpath,\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc\" -Wl,-rpath,\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib\" "));
        txt = Tpl.writeText(txt, a_ParModelicaExpLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_ParModelicaAutoLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_makefileParams_ldflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_makefileParams_runtimelibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\'"));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/emcc\' -lblas -llapack -lexpat -lSimulationRuntimeC -lf2c -s TOTAL_MEMORY=805306368 -s OUTLINING_LIMIT=20000 --pre-js $(OMC_EMCC_PRE_JS)"));
      then txt;
  end match;
end fun_545;

protected function fun_546
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
      then txt;
  end match;
end fun_546;

protected function fun_547
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ln -s "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_node.js "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
      then txt;
  end match;
end fun_547;

protected function fun_548
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("chmod +x "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_node.js"));
      then txt;
  end match;
end fun_548;

protected function fun_549
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      String i_makefileParams_runtimelibs;
      String i_makefileParams_ldflags;
      String i_makefileParams_platform;
      list<String> i_makefileParams_includes;
      String i_makefileParams_omhome;
      String i_makefileParams_cflags;
      String i_makefileParams_dllext;
      String i_makefileParams_exeext;
      String i_makefileParams_linker;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_24;
      String ret_23;
      Boolean ret_22;
      String ret_21;
      Boolean ret_20;
      String ret_19;
      Boolean ret_18;
      String ret_17;
      Boolean ret_16;
      String ret_15;
      Boolean ret_14;
      String ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Tpl.Text l_extraCflags;
      Boolean ret_7;
      Tpl.Text l_ParModelicaAutoLibs;
      Boolean ret_5;
      Tpl.Text l_ParModelicaExpLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCode.MAKEFILE_PARAMS(libs = i_makefileParams_libs, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, linker = i_makefileParams_linker, exeext = i_makefileParams_exeext, dllext = i_makefileParams_dllext, cflags = i_makefileParams_cflags, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes, platform = i_makefileParams_platform, ldflags = i_makefileParams_ldflags, runtimelibs = i_makefileParams_runtimelibs), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix) )
      equation
        l_dirExtra = fun_530(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_531(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_532(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_533(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        ret_5 = Config.acceptParModelicaGrammar();
        l_ParModelicaExpLibs = fun_534(Tpl.emptyTxt, ret_5);
        ret_7 = Flags.isSet(Flags.PARMODAUTO);
        l_ParModelicaAutoLibs = fun_535(Tpl.emptyTxt, ret_7);
        l_extraCflags = fun_537(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "\n",
                                    "# Simulations use -O3 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL="
                                }, false));
        ret_9 = Config.acceptMetaModelicaGrammar();
        ret_10 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_11 = boolOr(ret_9, ret_10);
        txt = fun_538(txt, ret_11);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CC="));
        ret_12 = Config.acceptParModelicaGrammar();
        txt = fun_539(txt, ret_12, i_makefileParams_ccompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CXX="));
        txt = Tpl.writeStr(txt, i_makefileParams_cxxcompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LINK="));
        txt = Tpl.writeStr(txt, i_makefileParams_linker);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("EXEEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_exeext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS_BASED_ON_INIT_FILE="));
        txt = Tpl.writeText(txt, l_extraCflags);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS=$(CFLAGS_BASED_ON_INIT_FILE) "));
        txt = Tpl.writeStr(txt, i_makefileParams_cflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_540(txt, i_sopt);
        txt = Tpl.softNewLine(txt);
        ret_13 = Config.simCodeTarget();
        ret_14 = stringEq(ret_13, "JavaScript");
        txt = fun_541(txt, ret_14, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CPPFLAGS="));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_542(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" -I. -DOPENMODELICA_XML_FROM_FILE_AT_RUNTIME"));
        ret_15 = Config.simCodeTarget();
        ret_16 = stringEq(ret_15, "JavaScript");
        txt = fun_543(txt, ret_16);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LDFLAGS="));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        ret_17 = Config.simCodeTarget();
        ret_18 = stringEq(ret_17, "JavaScript");
        txt = fun_545(txt, ret_18, i_makefileParams_runtimelibs, i_makefileParams_ldflags, l_ParModelicaAutoLibs, l_ParModelicaExpLibs, i_makefileParams_platform, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MAINFILE="));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".c\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".o\n",
                                    "CFILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_01exo.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_02nls.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_03lsy.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_04set.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_05evt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_06inz.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_07dly.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_08bnd.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_09alg.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_10asr.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_11mix.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_12jac.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_13opt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_14lnz.c\n",
                                    "OFILES=$(CFILES:.c=.o)\n",
                                    "GENERATEDFILES=$(MAINFILE) "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".makefile "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_literals.h "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h $(CFILES)\n",
                                    "\n",
                                    ".PHONY: omc_main_target clean bundle\n",
                                    "\n",
                                    "# This is to make sure that "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_*.c are always compiled.\n",
                                    ".PHONY: $(CFILES)\n",
                                    "\n",
                                    "omc_main_target: $(MAINOBJ) "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_literals.h $(OFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CC) -I. -o "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(EXEEXT) $(MAINOBJ) $(OFILES) $(CPPFLAGS) "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" $(CFLAGS) $(LDFLAGS)\n"));
        ret_19 = Config.simCodeTarget();
        ret_20 = stringEq(ret_19, "JavaScript");
        txt = fun_546(txt, ret_20, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        ret_21 = Config.simCodeTarget();
        ret_22 = stringEq(ret_21, "JavaScript");
        txt = fun_547(txt, ret_22, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        ret_23 = Config.simCodeTarget();
        ret_24 = stringEq(ret_23, "JavaScript");
        txt = fun_548(txt, ret_24, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("clean:\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@rm -f "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_records.o $(MAINOBJ)\n",
                                    "\n",
                                    "bundle:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@tar -cvf "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_Files.tar $(GENERATEDFILES)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_549;

public function simulationMakefile
  input Tpl.Text in_txt;
  input String in_a_target;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_target, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String i_target;
      Tpl.Text txt_0;

    case ( txt,
           "msvc",
           a_simCode )
      equation
        txt = fun_529(txt, a_simCode);
      then txt;

    case ( txt,
           "gcc",
           a_simCode )
      equation
        txt = fun_549(txt, a_simCode);
      then txt;

    case ( txt,
           i_target,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Target "));
        txt_0 = Tpl.writeStr(txt_0, i_target);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(" is not handled!"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4393, 9), Tpl.textString(txt_0));
      then txt;
  end match;
end simulationMakefile;

public function xsdateTime
  input Tpl.Text in_txt;
  input Util.DateTime in_a_dt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dt)
    local
      Tpl.Text txt;
      Integer i_sec;
      Integer i_min;
      Integer i_hour;
      Integer i_mday;
      Integer i_mon;
      Integer i_year;
      String ret_4;
      String ret_3;
      String ret_2;
      String ret_1;
      String ret_0;

    case ( txt,
           Util.DATETIME(year = i_year, mon = i_mon, mday = i_mday, hour = i_hour, min = i_min, sec = i_sec) )
      equation
        txt = Tpl.writeStr(txt, intString(i_year));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        ret_0 = SimCodeUtil.twodigit(i_mon);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        ret_1 = SimCodeUtil.twodigit(i_mday);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("T"));
        ret_2 = SimCodeUtil.twodigit(i_hour);
        txt = Tpl.writeStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        ret_3 = SimCodeUtil.twodigit(i_min);
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        ret_4 = SimCodeUtil.twodigit(i_sec);
        txt = Tpl.writeStr(txt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Z"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end xsdateTime;

public function simulationInitFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      SimCode.ModelInfo i_modelInfo;
      String i_s_variableFilter;
      String i_s_outputFormat;
      String i_s_method;
      Real i_s_tolerance;
      Real i_s_stepSize;
      Real i_s_stopTime;
      Real i_s_startTime;
      Integer i_vi_numBoolParams;
      Integer i_vi_numBoolAliasVars;
      Integer i_vi_numBoolAlgVars;
      Integer i_vi_numStringParamVars;
      Integer i_vi_numStringAliasVars;
      Integer i_vi_numStringAlgVars;
      Integer i_vi_numIntParams;
      Integer i_vi_numIntAliasVars;
      Integer i_vi_numIntAlgVars;
      Integer i_vi_numParams;
      Integer i_vi_numAlgAliasVars;
      Integer i_vi_numOptimizeConstraints;
      Integer i_vi_numDiscreteReal;
      Integer i_vi_numAlgVars;
      Integer i_vi_numStateVars;
      list<SimCode.Function> i_functions;
      Integer i_vi_numExternalObjects;
      Integer i_vi_numInitialResiduals;
      Integer i_vi_numOutVars;
      Integer i_vi_numInVars;
      Integer i_vi_numTimeEvents;
      Integer i_vi_numZeroCrossings;
      String i_modelInfo_description;
      String i_makefileParams_omhome;
      Absyn.Path i_modelInfo_name;
      Integer ret_9;
      Integer ret_8;
      Integer ret_7;
      Util.DateTime ret_6;
      String ret_5;
      String ret_4;
      String ret_3;
      Tpl.Text txt_2;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(functions = i_functions, varInfo = SimCode.VARINFO(numZeroCrossings = i_vi_numZeroCrossings, numTimeEvents = i_vi_numTimeEvents, numInVars = i_vi_numInVars, numOutVars = i_vi_numOutVars, numInitialResiduals = i_vi_numInitialResiduals, numExternalObjects = i_vi_numExternalObjects, numStateVars = i_vi_numStateVars, numAlgVars = i_vi_numAlgVars, numDiscreteReal = i_vi_numDiscreteReal, numOptimizeConstraints = i_vi_numOptimizeConstraints, numAlgAliasVars = i_vi_numAlgAliasVars, numParams = i_vi_numParams, numIntAlgVars = i_vi_numIntAlgVars, numIntAliasVars = i_vi_numIntAliasVars, numIntParams = i_vi_numIntParams, numStringAlgVars = i_vi_numStringAlgVars, numStringAliasVars = i_vi_numStringAliasVars, numStringParamVars = i_vi_numStringParamVars, numBoolAlgVars = i_vi_numBoolAlgVars, numBoolAliasVars = i_vi_numBoolAliasVars, numBoolParams = i_vi_numBoolParams), vars = SimCode.SIMVARS(stateVars = _), name = i_modelInfo_name, description = i_modelInfo_description)), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_s_startTime, stopTime = i_s_stopTime, stepSize = i_s_stepSize, tolerance = i_s_tolerance, method = i_s_method, outputFormat = i_s_outputFormat, variableFilter = i_s_variableFilter)), makefileParams = SimCode.MAKEFILE_PARAMS(omhome = i_makefileParams_omhome)),
           a_guid )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<?xml version = \"1.0\" encoding=\"UTF-8\"?>\n",
                                    "\n",
                                    "<!-- description of the model interface using an extention of the FMI standard -->\n",
                                    "<fmiModelDescription\n",
                                    "  fmiVersion                          = \"1.0\"\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelName                           = \""));
        txt_0 = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        ret_1 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "modelIdentifier                     = \""
                                }, false));
        txt_2 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_modelInfo_name);
        ret_3 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_2));
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "\n",
                                    "OPENMODELICAHOME                    = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "\n",
                                    "guid                                = \"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\"\n",
                                    "\n",
                                    "description                         = \""
                                }, false));
        ret_4 = Util.escapeModelicaStringToXmlString(i_modelInfo_description);
        txt = Tpl.writeStr(txt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationTool                      = \"OpenModelica Compiler "
                                }, false));
        ret_5 = Settings.getVersionNr();
        txt = Tpl.writeStr(txt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationDateAndTime               = \""
                                }, false));
        ret_6 = Util.getCurrentDateTime();
        txt = xsdateTime(txt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "\n",
                                    "variableNamingConvention            = \"structured\"\n",
                                    "\n",
                                    "numberOfEventIndicators             = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numZeroCrossings));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfEventIndicators             = \"NG:       number of zero crossings,                           FMI\"\n",
                                    "numberOfTimeEvents                  = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numTimeEvents));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfTimeEvents                  = \"NG_SAM:   number of zero crossings that are samples,          OMC\"\n",
                                    "\n",
                                    "numberOfInputVariables              = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfInputVariables              = \"NI:       number of inputvar on topmodel,                     OMC\"\n",
                                    "numberOfOutputVariables             = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfOutputVariables             = \"NO:       number of outputvar on topmodel,                    OMC\"\n",
                                    "\n",
                                    "numberOfResidualsForInitialization  = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numInitialResiduals));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfResidualsForInitialization  = \"NR:       number of residuals for initialialization function, OMC\"\n",
                                    "numberOfExternalObjects             = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numExternalObjects));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfExternalObjects             = \"NEXT:     number of external objects,                         OMC\"\n",
                                    "numberOfFunctions                   = \""
                                }, false));
        ret_7 = listLength(i_functions);
        txt = Tpl.writeStr(txt, intString(ret_7));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfFunctions                   = \"NFUNC:    number of functions used by the simulation,         OMC\"\n",
                                    "\n",
                                    "numberOfContinuousStates            = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfContinuousStates            = \"NX:       number of states,                                   FMI\"\n",
                                    "numberOfRealAlgebraicVariables      = \""
                                }, false));
        ret_8 = intAdd(i_vi_numDiscreteReal, i_vi_numOptimizeConstraints);
        ret_9 = intAdd(i_vi_numAlgVars, ret_8);
        txt = Tpl.writeStr(txt, intString(ret_9));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfRealAlgebraicVariables      = \"NY:       number of real variables,                           OMC\"\n",
                                    "numberOfRealAlgebraicAliasVariables = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numAlgAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfRealAlgebraicAliasVariables = \"NA:       number of alias variables,                          OMC\"\n",
                                    "numberOfRealParameters              = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfRealParameters              = \"NP:       number of parameters,                               OMC\"\n",
                                    "\n",
                                    "numberOfIntegerAlgebraicVariables   = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numIntAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfIntegerAlgebraicVariables   = \"NYINT:    number of alg. int variables,                       OMC\"\n",
                                    "numberOfIntegerAliasVariables       = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numIntAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfIntegerAliasVariables       = \"NAINT:    number of alias int variables,                      OMC\"\n",
                                    "numberOfIntegerParameters           = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numIntParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfIntegerParameters           = \"NPINT:    number of int parameters,                           OMC\"\n",
                                    "\n",
                                    "numberOfStringAlgebraicVariables    = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numStringAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfStringAlgebraicVariables    = \"NYSTR:    number of alg. string variables,                    OMC\"\n",
                                    "numberOfStringAliasVariables        = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numStringAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfStringAliasVariables        = \"NASTR:    number of alias string variables,                   OMC\"\n",
                                    "numberOfStringParameters            = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numStringParamVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfStringParameters            = \"NPSTR:    number of string parameters,                        OMC\"\n",
                                    "\n",
                                    "numberOfBooleanAlgebraicVariables   = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numBoolAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfBooleanAlgebraicVariables   = \"NYBOOL:   number of alg. bool variables,                      OMC\"\n",
                                    "numberOfBooleanAliasVariables       = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numBoolAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfBooleanAliasVariables       = \"NABOOL:   number of alias bool variables,                     OMC\"\n",
                                    "numberOfBooleanParameters           = \""
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numBoolParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  cmt_numberOfBooleanParameters           = \"NPBOOL:   number of bool parameters,                          OMC\" >\n",
                                    "\n",
                                    "\n",
                                    "<!-- startTime, stopTime, tolerance are FMI specific, all others are OMC specific -->\n",
                                    "<DefaultExperiment\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("startTime      = \""));
        txt = Tpl.writeStr(txt, realString(i_s_startTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "stopTime       = \""
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_s_stopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "stepSize       = \""
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_s_stepSize));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "tolerance      = \""
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_s_tolerance));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "solver         = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_s_method);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "outputFormat   = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_s_outputFormat);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "variableFilter = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_s_variableFilter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\" />\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<!-- variables in the model -->\n"));
        txt = ModelVariables(txt, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "</fmiModelDescription>\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end simulationInitFile;

protected function fun_553
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define __OPENMODELICA__METAMODELICA"));
      then txt;
  end match;
end fun_553;

protected function fun_554
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"meta/meta_modelica.h\""));
      then txt;
  end match;
end fun_554;

protected function fun_555
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_filePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_filePrefix)
    local
      Tpl.Text txt;
      String a_filePrefix;
      Integer ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_filePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include <ParModelica/explicit/openclrt/omc_ocl_interface.h>\n",
                                    "/* the OpenCL Kernels file name needed in libOMOCLRuntime.a */\n",
                                    "const char* omc_ocl_kernels_source = \""
                                }, false));
        txt = Tpl.writeStr(txt, a_filePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_kernels.cl\";\n",
                                    "/* the OpenCL program. Made global to avoid repeated builds */\n",
                                    "extern cl_program omc_ocl_program;\n",
                                    "/* The default OpenCL device. If not set (=0) show the selection option.*/\n",
                                    "unsigned int default_ocl_device = "
                                }, false));
        ret_0 = Config.getDefaultOpenCLDevice();
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_555;

public function commonHeader
  input Tpl.Text txt;
  input String a_filePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Config.acceptMetaModelicaGrammar();
  out_txt := fun_553(txt, ret_0);
  out_txt := Tpl.softNewLine(out_txt);
  ret_1 := Config.acceptMetaModelicaGrammar();
  out_txt := fun_554(out_txt, ret_1);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#include \"util/modelica.h\"\n",
                                       "#include <stdio.h>\n",
                                       "#include <stdlib.h>\n",
                                       "#include <errno.h>\n"
                                   }, true));
  ret_2 := Config.acceptParModelicaGrammar();
  out_txt := fun_555(out_txt, ret_2, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end commonHeader;

protected function lm_557
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_preLit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preLit;
algorithm
  (out_txt, out_a_preLit) :=
  match(in_txt, in_items, in_a_preLit)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_preLit;
      Integer x_i0;
      DAE.Exp i_literal;

    case ( txt,
           {},
           a_preLit )
      then (txt, a_preLit);

    case ( txt,
           i_literal :: rest,
           a_preLit )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_preLit) = literalExpConst(txt, i_literal, x_i0, a_preLit);
        txt = Tpl.nextIter(txt);
        (txt, a_preLit) = lm_557(txt, rest, a_preLit);
      then (txt, a_preLit);
  end match;
end lm_557;

protected function fun_558
  input Tpl.Text in_txt;
  input Option<SimCode.Function> in_a_mainFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction)
    local
      Tpl.Text txt;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void (*omc_assert)(threadData_t*,FILE_INFO info,const char *msg,...) __attribute__ ((noreturn)) = omc_assert_function;\n",
                                    "void (*omc_assert_warning)(FILE_INFO info,const char *msg,...) = omc_assert_warning_function;\n",
                                    "void (*omc_terminate)(FILE_INFO info,const char *msg,...) = omc_terminate_function;\n",
                                    "void (*omc_throw)(threadData_t*) __attribute__ ((noreturn)) = omc_throw_function;"
                                }, false));
      then txt;
  end match;
end fun_558;

protected function fun_559
  input Tpl.Text in_txt;
  input Option<SimCode.Function> in_a_mainFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction)
    local
      Tpl.Text txt;
      SimCode.Function i_fn;

    case ( txt,
           SOME(i_fn) )
      equation
        txt = functionBody(txt, i_fn, true);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_559;

public function functionsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input Option<SimCode.Function> a_mainFunction;
  input list<SimCode.Function> a_functions;
  input list<DAE.Exp> a_literals;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_literalsRes;
  Tpl.Text l_preLit;
algorithm
  l_preLit := Tpl.emptyTxt;
  l_literalsRes := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_literalsRes, l_preLit) := lm_557(l_literalsRes, a_literals, l_preLit);
  l_literalsRes := Tpl.popIter(l_literalsRes);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(".h\"\n"));
  out_txt := Tpl.writeText(out_txt, l_preLit);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_literalsRes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#include \"util/modelica.h\"\n"));
  out_txt := fun_558(out_txt, a_mainFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := fun_559(out_txt, a_mainFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := functionBodies(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end functionsFile;

protected function lm_561
  input Tpl.Text in_txt;
  input list<SimCode.RecordDeclaration> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.RecordDeclaration> rest;
      SimCode.RecordDeclaration i_rd;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rd :: rest )
      equation
        txt = recordDeclarationHeader(txt, i_rd);
        txt = Tpl.nextIter(txt);
        txt = lm_561(txt, rest);
      then txt;
  end match;
end lm_561;

protected function fun_562
  input Tpl.Text in_txt;
  input Option<SimCode.Function> in_a_mainFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction)
    local
      Tpl.Text txt;
      SimCode.Function i_fn;

    case ( txt,
           SOME(i_fn) )
      equation
        txt = functionHeader(txt, i_fn, true);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_562;

public function functionsHeaderFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input Option<SimCode.Function> a_mainFunction;
  input list<SimCode.Function> a_functions;
  input list<SimCode.RecordDeclaration> a_extraRecordDecls;
  input list<String> a_includes;

  output Tpl.Text out_txt;
protected
  String ret_1;
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
  ret_0 := System.stringReplace(a_filePrefix, ".", "_");
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "#define "
                                   }, false));
  ret_1 := System.stringReplace(a_filePrefix, ".", "_");
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__H\n"));
  out_txt := commonHeader(out_txt, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_561(out_txt, a_extraRecordDecls);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := fun_562(out_txt, a_mainFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := functionHeaders(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* start - annotation(Include=...) if we have any */\n"
                                   }, true));
  out_txt := externalFunctionIncludes(out_txt, a_includes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* end - annotation(Include=...) */\n",
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end functionsHeaderFile;

protected function lm_564
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_564(txt, rest);
      then txt;
  end match;
end lm_564;

protected function fun_565
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lOMOCLRuntime -lOpenCL"));
      then txt;
  end match;
end fun_565;

protected function fun_566
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -g"));
      then txt;
  end match;
end fun_566;

protected function fun_567
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_ccompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_ccompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_ccompiler;

    case ( txt,
           false,
           a_makefileParams_ccompiler )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_ccompiler);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("g++"));
      then txt;
  end match;
end fun_567;

protected function lm_568
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_568(txt, rest);
      then txt;
  end match;
end lm_568;

public function functionsMakefile
  input Tpl.Text in_txt;
  input SimCode.FunctionCode in_a_fnCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fnCode)
    local
      Tpl.Text txt;
      String i_name;
      String i_makefileParams_runtimelibs;
      String i_makefileParams_ldflags;
      String i_makefileParams_cflags;
      list<String> i_makefileParams_includes;
      String i_makefileParams_omhome;
      String i_makefileParams_dllext;
      String i_makefileParams_exeext;
      String i_makefileParams_linker;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      list<String> i_makefileParams_libs;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_ParModelicaExpLibs;
      Tpl.Text l_libsStr;

    case ( txt,
           SimCode.FUNCTIONCODE(makefileParams = SimCode.MAKEFILE_PARAMS(libs = i_makefileParams_libs, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, linker = i_makefileParams_linker, exeext = i_makefileParams_exeext, dllext = i_makefileParams_dllext, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes, cflags = i_makefileParams_cflags, ldflags = i_makefileParams_ldflags, runtimelibs = i_makefileParams_runtimelibs), name = i_name) )
      equation
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_564(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        ret_2 = Config.acceptParModelicaGrammar();
        l_ParModelicaExpLibs = fun_565(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "\n",
                                    "# Dynamic loading uses -O0 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=-O0"
                                }, false));
        ret_3 = Config.acceptMetaModelicaGrammar();
        ret_4 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_5 = boolOr(ret_3, ret_4);
        txt = fun_566(txt, ret_5);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CC="));
        ret_6 = Config.acceptParModelicaGrammar();
        txt = fun_567(txt, ret_6, i_makefileParams_ccompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CXX="));
        txt = Tpl.writeStr(txt, i_makefileParams_cxxcompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LINK="));
        txt = Tpl.writeStr(txt, i_makefileParams_linker);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("EXEEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_exeext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS= -I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_568(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_makefileParams_cflags);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LDFLAGS= -L\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc\" -Wl,-rpath,\'"));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc\' "));
        txt = Tpl.writeText(txt, l_ParModelicaExpLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_makefileParams_ldflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_makefileParams_runtimelibs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "PERL=perl\n",
                                    "MAINFILE="
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".c\n",
                                    "\n",
                                    ".PHONY: "
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": $(MAINFILE) "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".h "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(CC) $(CFLAGS) -c -o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".o $(MAINFILE)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(CC) $(CFLAGS) -c -o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_records.o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(LINK) -o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_records.o "));
        txt = Tpl.writeText(txt, l_libsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(CFLAGS) $(LDFLAGS) -lm"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end functionsMakefile;

protected function lm_570
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeDimensionExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_570(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_570(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_570;

protected function fun_571
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      DAE.ComponentRef i_cr;
      ClassInf.State i_record__state;
      String ret_12;
      Tpl.Text txt_11;
      list<DAE.Subscript> ret_10;
      Tpl.Text l_dimsValuesStr;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_5;
      Tpl.Text l_recPtr;
      Absyn.Path ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(identType = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), ident = i_ident, componentRef = i_componentRef)),
           a_auxFunction,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        ret_3 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_3);
        txt_5 = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("*"));
        (l_recPtr, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), l_varDecls);
        ret_7 = ComponentReference.crefSubs(i_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = ComponentReference.crefSubs(i_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, l_varDecls, l_preExp) = lm_570(l_dimsValuesStr, ret_10, a_auxFunction, l_varDecls, l_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_element_addr(&_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))->"));
        (txt, a_auxFunction) = contextCref(txt, i_componentRef, a_context, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           i_cr,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt_11 = CodegenUtil.crefStr(Tpl.emptyTxt, i_cr);
        ret_12 = System.unquoteIdentifier(Tpl.textString(txt_11));
        txt = Tpl.writeStr(txt, ret_12);
      then (txt, a_auxFunction);
  end match;
end fun_571;

protected function lm_572
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeDimensionExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_572(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_572(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_572;

protected function fun_573
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      DAE.ComponentRef i_cr;
      ClassInf.State i_record__state;
      String ret_12;
      Tpl.Text txt_11;
      list<DAE.Subscript> ret_10;
      Tpl.Text l_dimsValuesStr;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_5;
      Tpl.Text l_recPtr;
      Absyn.Path ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(identType = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), ident = i_ident, componentRef = i_componentRef)),
           a_auxFunction,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        ret_3 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_3);
        txt_5 = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("*"));
        (l_recPtr, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), l_varDecls);
        ret_7 = ComponentReference.crefSubs(i_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = ComponentReference.crefSubs(i_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, l_varDecls, l_preExp) = lm_572(l_dimsValuesStr, ret_10, a_auxFunction, l_varDecls, l_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_element_addr(&_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))->"));
        (txt, a_auxFunction) = contextCref(txt, i_componentRef, a_context, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           i_cr,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt_11 = CodegenUtil.crefStr(Tpl.emptyTxt, i_cr);
        ret_12 = System.unquoteIdentifier(Tpl.textString(txt_11));
        txt = Tpl.writeStr(txt, ret_12);
      then (txt, a_auxFunction);
  end match;
end fun_573;

protected function fun_574
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_cr, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text a_auxFunction;
      SimCode.Context i_context;

    case ( txt,
           (i_context as SimCode.FUNCTION_CONTEXT()),
           a_cr,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_571(txt, a_cr, a_auxFunction, i_context);
      then (txt, a_auxFunction);

    case ( txt,
           (i_context as SimCode.PARALLEL_FUNCTION_CONTEXT()),
           a_cr,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_573(txt, a_cr, a_auxFunction, i_context);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_cr,
           a_auxFunction )
      equation
        txt = cref(txt, a_cr);
      then (txt, a_auxFunction);
  end match;
end fun_574;

public function contextCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCode.Context a_context;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_574(txt, a_context, a_cr, a_auxFunction);
end contextCref;

protected function fun_576
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Absyn.Ident in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Ident a_name;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_576;

public function contextIteratorName
  input Tpl.Text txt;
  input Absyn.Ident a_name;
  input SimCode.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_576(txt, a_context, a_name);
end contextIteratorName;

public function cref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")) )
      equation
        txt = CodegenUtil.crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("time"));
      then txt;

    case ( txt,
           DAE.WILD() )
      then txt;

    case ( txt,
           i_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = crefToCStr(txt, i_cr);
      then txt;
  end match;
end cref;

public function crefToCStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident, subscriptLst = i_subscriptLst) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
        txt = subscriptsToCStr(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = subscriptsToCStr(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = crefToCStr(txt, i_componentRef);
      then txt;

    case ( txt,
           DAE.WILD() )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefToCStr;

protected function lm_580
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToCStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_580(txt, rest);
      then txt;
  end match;
end lm_580;

public function subscriptsToCStr
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$lB"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("$c")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_580(txt, i_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$rB"));
      then txt;
  end match;
end subscriptsToCStr;

protected function fun_582
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;
      Tpl.Text l_index;
      Tpl.Text l_auxFunction;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;

    case ( txt,
           DAE.ICONST(integer = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           i_exp )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_index, l_preExp, l_varDecls, l_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextOther, l_preExp, l_varDecls, l_auxFunction);
        txt = Tpl.writeText(txt, l_index);
      then txt;
  end match;
end fun_582;

public function subscriptToCStr
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_subscript;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;

    case ( txt,
           DAE.SLICE(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.WHOLEDIM() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLEDIM"));
      then txt;

    case ( txt,
           DAE.INDEX(exp = i_exp) )
      equation
        txt = fun_582(txt, i_exp);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKNOWN_SUBSCRIPT"));
      then txt;
  end match;
end subscriptToCStr;

public function crefM
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")) )
      equation
        txt = CodegenUtil.crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("time"));
      then txt;

    case ( txt,
           i_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("P"));
        txt = crefToMStr(txt, i_cr);
      then txt;
  end match;
end crefM;

public function crefToMStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident, subscriptLst = i_subscriptLst) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
        txt = subscriptsToMStr(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = subscriptsToMStr(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("P"));
        txt = crefToMStr(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefToMStr;

protected function lm_586
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToMStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_586(txt, rest);
      then txt;
  end match;
end lm_586;

public function subscriptsToMStr
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lB"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("c")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_586(txt, i_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rB"));
      then txt;
  end match;
end subscriptsToMStr;

protected function fun_588
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;
      Tpl.Text l_index;
      Tpl.Text l_auxFunction;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;

    case ( txt,
           DAE.ICONST(integer = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           i_exp )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_index, l_preExp, l_varDecls, l_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextOther, l_preExp, l_varDecls, l_auxFunction);
        txt = Tpl.writeText(txt, l_index);
      then txt;
  end match;
end fun_588;

public function subscriptToMStr
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_subscript;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;

    case ( txt,
           DAE.SLICE(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.WHOLEDIM() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLEDIM"));
      then txt;

    case ( txt,
           DAE.INDEX(exp = i_exp) )
      equation
        txt = fun_588(txt, i_exp);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKNOWN_SUBSCRIPT"));
      then txt;
  end match;
end subscriptToMStr;

protected function fun_590
  input Tpl.Text in_txt;
  input Tpl.Text in_a_lhs;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lhs, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;
      Tpl.Text i_lhs;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_e )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Got empty statement from writeLhsCref("));
        ret_0 = ExpressionDump.printExpStr(a_e);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4745, 62), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           i_lhs,
           _ )
      equation
        txt = Tpl.writeText(txt, i_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_590;

protected function fun_591
  input Tpl.Text in_txt;
  input Tpl.Text in_a_lhs;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lhs, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;
      Tpl.Text i_lhs;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_e )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Got empty statement from writeLhsCref("));
        ret_0 = ExpressionDump.printExpStr(a_e);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4753, 62), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           i_lhs,
           _ )
      equation
        txt = Tpl.writeText(txt, i_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_591;

protected function fun_592
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;
  input DAE.Exp in_a_e;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varCopy;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varCopy, out_a_auxFunction) :=
  match(in_txt, in_a_ty, in_a_cr, in_a_e, in_a_context, in_a_varDecls, in_a_varCopy, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      DAE.Exp a_e;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_varCopy;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      Tpl.Text txt_3;
      Tpl.Text l_lhs;
      Tpl.Text l_var;
      Tpl.Text l_varCopyAfter;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           a_e,
           a_context,
           a_varDecls,
           a_varCopy,
           a_auxFunction )
      equation
        l_varCopyAfter = Tpl.emptyTxt;
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "base_array_t", a_varDecls);
        (l_lhs, l_varCopyAfter, a_varDecls, a_auxFunction) = writeLhsCref(Tpl.emptyTxt, a_e, Tpl.textString(l_var), a_context, l_varCopyAfter, a_varDecls, a_auxFunction);
        a_varCopy = fun_590(a_varCopy, l_lhs, a_e);
        a_varCopy = Tpl.writeText(a_varCopy, l_varCopyAfter);
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_varDecls, a_varCopy, a_auxFunction);

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))),
           _,
           a_e,
           a_context,
           a_varDecls,
           a_varCopy,
           a_auxFunction )
      equation
        l_varCopyAfter = Tpl.emptyTxt;
        txt_3 = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        (l_lhs, l_varCopyAfter, a_varDecls, a_auxFunction) = writeLhsCref(Tpl.emptyTxt, a_e, Tpl.textString(l_var), a_context, l_varCopyAfter, a_varDecls, a_auxFunction);
        a_varCopy = fun_591(a_varCopy, l_lhs, a_e);
        a_varCopy = Tpl.writeText(a_varCopy, l_varCopyAfter);
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_varDecls, a_varCopy, a_auxFunction);

    case ( txt,
           _,
           a_cr,
           _,
           a_context,
           a_varDecls,
           a_varCopy,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_cr, a_context, a_auxFunction);
      then (txt, a_varDecls, a_varCopy, a_auxFunction);
  end match;
end fun_592;

public function contextArrayReferenceCrefAndCopy
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input DAE.Exp a_e;
  input DAE.Type a_ty;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varCopy;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varCopy, out_a_auxFunction) := fun_592(txt, a_ty, a_cr, a_e, a_context, a_varDecls, a_varCopy, a_auxFunction);
end contextArrayReferenceCrefAndCopy;

protected function fun_594
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = arrayCrefStr(txt, a_cr);
      then txt;

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = arrayCrefStr(txt, a_cr);
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = arrayCrefCStr(txt, a_cr);
      then txt;
  end match;
end fun_594;

public function contextArrayCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCode.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_594(txt, a_context, a_cr);
end contextArrayCref;

public function arrayCrefCStr
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
  out_txt := arrayCrefCStr2(out_txt, a_cr);
end arrayCrefCStr;

public function arrayCrefCStr2
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = subscriptsToCStr(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = arrayCrefCStr2(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayCrefCStr2;

public function arrayCrefStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = arrayCrefStr(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayCrefStr;

public function expCref
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ecr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_arg_componentRef;
      DAE.ComponentRef i_componentRef;

    case ( txt,
           DAE.CREF(componentRef = i_componentRef) )
      equation
        txt = cref(txt, i_componentRef);
      then txt;

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "der"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$DER"));
        txt = cref(txt, i_arg_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR_NOT_A_CREF"));
      then txt;
  end match;
end expCref;

public function crefFunctionName
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      String ret_3;
      String ret_2;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        ret_1 = System.stringReplace(ret_0, "_", "__");
        txt = Tpl.writeStr(txt, ret_1);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef) )
      equation
        ret_2 = System.unquoteIdentifier(i_ident);
        ret_3 = System.stringReplace(ret_2, "_", "__");
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefFunctionName(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end crefFunctionName;

protected function lm_601
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_601(txt, rest);
      then txt;
  end match;
end lm_601;

public function externalFunctionIncludes
  input Tpl.Text in_txt;
  input list<String> in_a_includes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_includes)
    local
      Tpl.Text txt;
      list<String> i_includes;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_includes )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_601(txt, i_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end externalFunctionIncludes;

protected function lm_603
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> rest;
      SimCode.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = functionHeader(txt, i_fn, false);
        txt = Tpl.nextIter(txt);
        txt = lm_603(txt, rest);
      then txt;
  end match;
end lm_603;

public function functionHeaders
  input Tpl.Text txt;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_603(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end functionHeaders;

protected function lm_605
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> rest;
      SimCode.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = parallelFunctionHeader(txt, i_fn, false);
        txt = Tpl.nextIter(txt);
        txt = lm_605(txt, rest);
      then txt;
  end match;
end lm_605;

public function parallelFunctionHeadersImpl
  input Tpl.Text txt;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_605(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end parallelFunctionHeadersImpl;

protected function lm_607
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      DAE.ComponentRef i_name;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_name)) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = lm_607(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_607(txt, rest);
      then txt;
  end match;
end lm_607;

public function functionHeader
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      list<SimCode.Variable> i_funArgs;
      SimCode.Function i_fn;
      list<SimCode.Variable> i_outVars;
      list<SimCode.Variable> i_functionArguments;
      Absyn.Path i_name;
      Tpl.Text l_funArgsStr;
      Tpl.Text l_fname;
      Boolean ret_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Boolean ret_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_fn as SimCode.FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars)),
           a_inFunc )
      equation
        txt_0 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderNormal(txt, Tpl.textString(txt_0), i_functionArguments, i_outVars, a_inFunc, false);
        txt = Tpl.softNewLine(txt);
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        ret_2 = SimCodeUtil.isBoxedFunction(i_fn);
        txt = functionHeaderBoxed(txt, Tpl.textString(txt_1), i_functionArguments, i_outVars, ret_2, false);
      then txt;

    case ( txt,
           SimCode.KERNEL_FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars),
           _ )
      equation
        txt_3 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderKernelFunctionInterface(txt, Tpl.textString(txt_3), i_functionArguments, i_outVars);
      then txt;

    case ( txt,
           (i_fn as SimCode.EXTERNAL_FUNCTION(dynamicLoad = true, name = i_name, funArgs = i_funArgs, outVars = i_outVars)),
           a_inFunc )
      equation
        txt_4 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderNormal(txt, Tpl.textString(txt_4), i_funArgs, i_outVars, a_inFunc, true);
        txt = Tpl.softNewLine(txt);
        txt_5 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        ret_6 = SimCodeUtil.isBoxedFunction(i_fn);
        txt = functionHeaderBoxed(txt, Tpl.textString(txt_5), i_funArgs, i_outVars, ret_6, true);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = extFunDefDynamic(txt, i_fn);
      then txt;

    case ( txt,
           (i_fn as SimCode.EXTERNAL_FUNCTION(name = i_name, funArgs = i_funArgs, outVars = i_outVars)),
           a_inFunc )
      equation
        txt_7 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderNormal(txt, Tpl.textString(txt_7), i_funArgs, i_outVars, a_inFunc, false);
        txt = Tpl.softNewLine(txt);
        txt_8 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        ret_9 = SimCodeUtil.isBoxedFunction(i_fn);
        txt = functionHeaderBoxed(txt, Tpl.textString(txt_8), i_funArgs, i_outVars, ret_9, false);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = extFunDef(txt, i_fn);
      then txt;

    case ( txt,
           SimCode.RECORD_CONSTRUCTOR(name = i_name, funArgs = i_funArgs),
           _ )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_funArgsStr = lm_607(Tpl.emptyTxt, i_funArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("DLLExport\n"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = Tpl.writeText(txt, l_funArgsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "); /* record head */\n",
                                    "\n"
                                }, true));
        txt = functionHeaderBoxed(txt, Tpl.textString(l_fname), i_funArgs, SimCode.boxedRecordOutVars, false, false);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionHeader;

public function parallelFunctionHeader
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      list<SimCode.Variable> i_outVars;
      list<SimCode.Variable> i_functionArguments;
      Absyn.Path i_name;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.PARALLEL_FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars),
           a_inFunc )
      equation
        txt_0 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderParallelImpl(txt, Tpl.textString(txt_0), i_functionArguments, i_outVars, a_inFunc, false);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end parallelFunctionHeader;

protected function lm_610
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinition(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_610(txt, rest);
      then txt;
  end match;
end lm_610;

protected function lm_611
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input String in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fname)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      String a_fname;
      Integer x_i1;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_fname )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype_"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.nextIter(txt);
        txt = lm_611(txt, rest, a_fname);
      then txt;
  end match;
end lm_611;

protected function lm_612
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_612(txt, rest);
      then txt;
  end match;
end lm_612;

protected function fun_613
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Dimensions i_dims;

    case ( txt,
           DAE.T_ARRAY(dims = i_dims) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_612(txt, i_dims);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_613;

protected function fun_614
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_var)
    local
      Tpl.Text txt;
      SimCode.Variable a_var;

    case ( txt,
           false,
           a_var )
      equation
        txt = varType(txt, a_var);
      then txt;

    case ( txt,
           _,
           a_var )
      equation
        txt = varTypeBoxed(txt, a_var);
      then txt;
  end match;
end fun_614;

protected function fun_615
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Integer in_a_i1;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_i1, in_a_boxed)
    local
      Tpl.Text txt;
      Integer a_i1;
      Boolean a_boxed;
      String i_name_1;
      DAE.ComponentRef i_name;
      SimCode.Variable i_var;
      DAE.Type i_ty;
      Tpl.Text l_typeStr;
      Tpl.Text l_dimStr;

    case ( txt,
           (i_var as SimCode.VARIABLE(ty = i_ty, name = i_name)),
           a_i1,
           a_boxed )
      equation
        l_dimStr = fun_613(Tpl.emptyTxt, i_ty);
        l_typeStr = fun_614(Tpl.emptyTxt, a_boxed, i_var);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" c"));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* "));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeText(txt, l_dimStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_i1,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr c"));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* "));
        txt = Tpl.writeStr(txt, i_name_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_615;

protected function lm_616
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_boxed)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Boolean a_boxed;
      Integer x_i1;
      SimCode.Variable i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_boxed )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_615(txt, i_var, x_i1, a_boxed);
        txt = Tpl.nextIter(txt);
        txt = lm_616(txt, rest, a_boxed);
      then txt;
  end match;
end lm_616;

protected function fun_617
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_fargsStr;
  input Boolean in_a_boxed;
  input String in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fargsStr, in_a_boxed, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStr;
      Boolean a_boxed;
      String a_fname;
      list<SimCode.Variable> i_outVars;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_outVars,
           a_fargsStr,
           a_boxed,
           a_fname )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_611(txt, i_outVars, a_fname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef struct "));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_rettype_s\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_616(txt, i_outVars, a_boxed);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} "));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_rettype;\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n"
                                }, true));
      then txt;
  end match;
end fun_617;

public function functionHeaderParallelImpl
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCode.Variable> a_fargs;
  input list<SimCode.Variable> a_outVars;
  input Boolean a_inFunc;
  input Boolean a_boxed;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fargsStr;
algorithm
  l_fargsStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_fargsStr := lm_610(l_fargsStr, a_fargs);
  l_fargsStr := Tpl.popIter(l_fargsStr);
  out_txt := fun_617(txt, a_outVars, l_fargsStr, a_boxed, a_fname);
end functionHeaderParallelImpl;

protected function lm_619
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.VARIABLE(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"_"));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_619(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_619(txt, rest);
      then txt;
  end match;
end lm_619;

protected function lm_620
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_name :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_620(txt, rest);
      then txt;
  end match;
end lm_620;

public function recordDeclaration
  input Tpl.Text in_txt;
  input SimCode.RecordDeclaration in_a_recDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recDecl)
    local
      Tpl.Text txt;
      list<String> i_fieldNames;
      Absyn.Path i_path;
      list<SimCode.Variable> i_variables;
      Absyn.Path i_defPath;
      Integer ret_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Integer ret_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.RECORD_DECL_FULL(defPath = i_defPath, variables = i_variables) )
      equation
        txt_0 = CodegenUtil.dotPath(Tpl.emptyTxt, i_defPath);
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_defPath);
        txt_2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_2 = lm_619(txt_2, i_variables);
        txt_2 = Tpl.popIter(txt_2);
        ret_3 = listLength(i_variables);
        txt = recordDefinition(txt, Tpl.textString(txt_0), Tpl.textString(txt_1), Tpl.textString(txt_2), ret_3);
      then txt;

    case ( txt,
           SimCode.RECORD_DECL_DEF(path = i_path, fieldNames = i_fieldNames) )
      equation
        txt_4 = CodegenUtil.dotPath(Tpl.emptyTxt, i_path);
        txt_5 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt_6 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_6 = lm_620(txt_6, i_fieldNames);
        txt_6 = Tpl.popIter(txt_6);
        ret_7 = listLength(i_fieldNames);
        txt = recordDefinition(txt, Tpl.textString(txt_4), Tpl.textString(txt_5), Tpl.textString(txt_6), ret_7);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end recordDeclaration;

protected function lm_622
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      DAE.ComponentRef i_var_name;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_var_name)) :: rest )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = CodegenUtil.crefStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_622(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_622(txt, rest);
      then txt;
  end match;
end lm_622;

protected function fun_623
  input Tpl.Text in_txt;
  input Option<String> in_a_aliasName;
  input list<SimCode.Variable> in_a_r_variables;
  input String in_a_r_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasName, in_a_r_variables, in_a_r_name)
    local
      Tpl.Text txt;
      list<SimCode.Variable> a_r_variables;
      String a_r_name;
      String i_str;

    case ( txt,
           SOME(i_str),
           _,
           a_r_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = Tpl.writeStr(txt, i_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_r_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_r_variables,
           a_r_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef struct "));
        txt = Tpl.writeStr(txt, a_r_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_s {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_622(txt, a_r_variables);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} "));
        txt = Tpl.writeStr(txt, a_r_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_623;

public function recordDeclarationHeader
  input Tpl.Text in_txt;
  input SimCode.RecordDeclaration in_a_recDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recDecl)
    local
      Tpl.Text txt;
      list<String> i_fieldNames;
      Absyn.Path i_path;
      list<SimCode.Variable> i_variables;
      Absyn.Path i_defPath;
      String i_name;
      list<SimCode.Variable> i_r_variables;
      String i_r_name;
      Option<String> i_aliasName;
      Integer ret_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Integer ret_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.RECORD_DECL_FULL(aliasName = i_aliasName, name = (i_name as i_r_name), variables = (i_variables as i_r_variables), defPath = i_defPath) )
      equation
        txt = fun_623(txt, i_aliasName, i_r_variables, i_r_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef base_array_t "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_array;\n"));
        txt_0 = CodegenUtil.dotPath(Tpl.emptyTxt, i_defPath);
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_defPath);
        ret_2 = listLength(i_variables);
        txt = recordDefinitionHeader(txt, Tpl.textString(txt_0), Tpl.textString(txt_1), ret_2);
      then txt;

    case ( txt,
           SimCode.RECORD_DECL_DEF(path = i_path, fieldNames = i_fieldNames) )
      equation
        txt_3 = CodegenUtil.dotPath(Tpl.emptyTxt, i_path);
        txt_4 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        ret_5 = listLength(i_fieldNames);
        txt = recordDefinitionHeader(txt, Tpl.textString(txt_3), Tpl.textString(txt_4), ret_5);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end recordDeclarationHeader;

protected function fun_625
  input Tpl.Text in_txt;
  input Integer in_a_numFields;
  input String in_a_fieldNames;
  input String in_a_encName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numFields, in_a_fieldNames, in_a_encName)
    local
      Tpl.Text txt;
      String a_fieldNames;
      String a_encName;
      Integer i_numFields;

    case ( txt,
           0,
           _,
           a_encName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char* "));
        txt = Tpl.writeStr(txt, a_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc__fields[1] = {\"no fields\"};"));
      then txt;

    case ( txt,
           i_numFields,
           a_fieldNames,
           a_encName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char* "));
        txt = Tpl.writeStr(txt, a_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc__fields["));
        txt = Tpl.writeStr(txt, intString(i_numFields));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = {"));
        txt = Tpl.writeStr(txt, a_fieldNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_625;

public function recordDefinition
  input Tpl.Text txt;
  input String a_origName;
  input String a_encName;
  input String a_fieldNames;
  input Integer a_numFields;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fieldsDescription;
algorithm
  l_fieldsDescription := fun_625(Tpl.emptyTxt, a_numFields, a_fieldNames, a_encName);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
  out_txt := Tpl.writeStr(out_txt, a_encName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__desc_added 1\n"));
  out_txt := Tpl.writeText(out_txt, l_fieldsDescription);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("struct record_description "));
  out_txt := Tpl.writeStr(out_txt, a_encName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__desc = {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
  out_txt := Tpl.writeStr(out_txt, a_encName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\", /* package_record__X */\n",
                                       "\""
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_origName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("\", /* package.record_X */\n"));
  out_txt := Tpl.writeStr(out_txt, a_encName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__desc__fields\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("};"));
end recordDefinition;

public function recordDefinitionHeader
  input Tpl.Text txt;
  input String a_origName;
  input String a_encName;
  input Integer a_numFields;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("extern struct record_description "));
  out_txt := Tpl.writeStr(out_txt, a_encName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("__desc;"));
end recordDefinitionHeader;

public function functionHeaderNormal
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCode.Variable> a_fargs;
  input list<SimCode.Variable> a_outVars;
  input Boolean a_inFunc;
  input Boolean a_dynamicLoad;

  output Tpl.Text out_txt;
algorithm
  out_txt := functionHeaderImpl(txt, a_fname, a_fargs, a_outVars, a_inFunc, false, a_dynamicLoad);
end functionHeaderNormal;

protected function fun_629
  input Tpl.Text in_txt;
  input Boolean in_a_isBoxed;
  input String in_a_fname;
  input list<SimCode.Variable> in_a_fargs;
  input list<SimCode.Variable> in_a_outVars;
  input Boolean in_a_dynamicLoad;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isBoxed, in_a_fname, in_a_fargs, in_a_outVars, in_a_dynamicLoad)
    local
      Tpl.Text txt;
      String a_fname;
      list<SimCode.Variable> a_fargs;
      list<SimCode.Variable> a_outVars;
      Boolean a_dynamicLoad;

    case ( txt,
           false,
           a_fname,
           a_fargs,
           a_outVars,
           a_dynamicLoad )
      equation
        txt = functionHeaderImpl(txt, a_fname, a_fargs, a_outVars, false, true, a_dynamicLoad);
      then txt;

    case ( txt,
           _,
           a_fname,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define boxptr_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_629;

public function functionHeaderBoxed
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCode.Variable> a_fargs;
  input list<SimCode.Variable> a_outVars;
  input Boolean a_isBoxed;
  input Boolean a_dynamicLoad;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_629(txt, a_isBoxed, a_fname, a_fargs, a_outVars, a_dynamicLoad);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT(boxvar_lit_"));
  out_txt := Tpl.writeStr(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(",2,0) {boxptr_"));
  out_txt := Tpl.writeStr(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ",0}};\n",
                                       "#define boxvar_"
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT(boxvar_lit_"));
  out_txt := Tpl.writeStr(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(")"));
end functionHeaderBoxed;

protected function fun_631
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fname)
    local
      Tpl.Text txt;
      String a_fname;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "DLLExport\n",
                                    "int in_"
                                }, false));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(type_description * inArgs, type_description * outVar);"));
      then txt;
  end match;
end fun_631;

protected function fun_632
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input Tpl.Text in_a_prototype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_prototype)
    local
      Tpl.Text txt;
      Tpl.Text a_prototype;

    case ( txt,
           false,
           a_prototype )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLExport"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_prototype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_632;

public function functionHeaderImpl
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCode.Variable> a_fargs;
  input list<SimCode.Variable> a_outVars;
  input Boolean a_inFunc;
  input Boolean a_boxed;
  input Boolean a_dynamicLoad;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Tpl.Text l_inFnStr;
  Tpl.Text l_prototype;
algorithm
  l_prototype := functionPrototype(Tpl.emptyTxt, a_fname, a_fargs, a_outVars, a_boxed);
  ret_2 := boolAnd(a_boxed, a_inFunc);
  l_inFnStr := fun_631(Tpl.emptyTxt, ret_2, a_fname);
  out_txt := Tpl.writeText(txt, l_inFnStr);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_632(out_txt, a_dynamicLoad, l_prototype);
end functionHeaderImpl;

protected function lm_634
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgDefinition(txt, i_var);
        txt = lm_634(txt, rest);
      then txt;
  end match;
end lm_634;

protected function lm_635
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgBoxedDefinition(txt, i_var);
        txt = lm_635(txt, rest);
      then txt;
  end match;
end lm_635;

protected function fun_636
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input list<SimCode.Variable> in_a_fargs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_fargs)
    local
      Tpl.Text txt;
      list<SimCode.Variable> a_fargs;

    case ( txt,
           false,
           a_fargs )
      equation
        txt = lm_634(txt, a_fargs);
      then txt;

    case ( txt,
           _,
           a_fargs )
      equation
        txt = lm_635(txt, a_fargs);
      then txt;
  end match;
end fun_636;

protected function fun_637
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_var)
    local
      Tpl.Text txt;
      SimCode.Variable a_var;

    case ( txt,
           false,
           a_var )
      equation
        txt = varType(txt, a_var);
      then txt;

    case ( txt,
           _,
           a_var )
      equation
        txt = varTypeBoxed(txt, a_var);
      then txt;
  end match;
end fun_637;

protected function fun_638
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_boxed)
    local
      Tpl.Text txt;
      Boolean a_boxed;
      SimCode.Variable i_var;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = _)),
           a_boxed )
      equation
        txt = fun_637(txt, a_boxed, i_var);
      then txt;

    case ( txt,
           SimCode.FUNCTION_PTR(name = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_638;

protected function fun_639
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_boxed)
    local
      Tpl.Text txt;
      Boolean a_boxed;
      SimCode.Variable i_var;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           i_var :: _,
           a_boxed )
      equation
        txt = fun_638(txt, i_var, a_boxed);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_639;

protected function fun_640
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxptr"));
      then txt;
  end match;
end fun_640;

protected function fun_641
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_var)
    local
      Tpl.Text txt;
      SimCode.Variable a_var;

    case ( txt,
           false,
           a_var )
      equation
        txt = varType(txt, a_var);
      then txt;

    case ( txt,
           _,
           a_var )
      equation
        txt = varTypeBoxed(txt, a_var);
      then txt;
  end match;
end fun_641;

protected function fun_642
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_boxed)
    local
      Tpl.Text txt;
      Boolean a_boxed;
      SimCode.Variable i_var;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = _)),
           a_boxed )
      equation
        txt = fun_641(txt, a_boxed, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" *out"));
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           (i_var as SimCode.FUNCTION_PTR(name = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr *out"));
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_642;

protected function lm_643
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_boxed)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Boolean a_boxed;
      SimCode.Variable i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_boxed )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = fun_642(txt, i_var, a_boxed);
        txt = lm_643(txt, rest, a_boxed);
      then txt;
  end match;
end lm_643;

protected function fun_644
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_outarg;
  input Boolean in_a_boxed;
  input Tpl.Text in_a_fargsStr;
  input String in_a_fname;
  input Tpl.Text in_a_boxPtrStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_outarg, in_a_boxed, in_a_fargsStr, in_a_fname, in_a_boxPtrStr)
    local
      Tpl.Text txt;
      Tpl.Text a_outarg;
      Boolean a_boxed;
      Tpl.Text a_fargsStr;
      String a_fname;
      Tpl.Text a_boxPtrStr;
      list<SimCode.Variable> i_outVars;
      list<SimCode.Variable> ret_1;
      Tpl.Text l_outargs;

    case ( txt,
           {},
           _,
           _,
           a_fargsStr,
           a_fname,
           a_boxPtrStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_boxPtrStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_outVars,
           a_outarg,
           a_boxed,
           a_fargsStr,
           a_fname,
           a_boxPtrStr )
      equation
        ret_1 = List.rest(i_outVars);
        l_outargs = lm_643(Tpl.emptyTxt, ret_1, a_boxed);
        txt = Tpl.writeText(txt, a_outarg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_boxPtrStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeText(txt, l_outargs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_644;

public function functionPrototype
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCode.Variable> a_fargs;
  input list<SimCode.Variable> a_outVars;
  input Boolean a_boxed;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_boxPtrStr;
  Tpl.Text l_outarg;
  Tpl.Text l_fargsStr;
algorithm
  l_fargsStr := fun_636(Tpl.emptyTxt, a_boxed, a_fargs);
  l_outarg := fun_639(Tpl.emptyTxt, a_outVars, a_boxed);
  l_boxPtrStr := fun_640(Tpl.emptyTxt, a_boxed);
  out_txt := fun_644(txt, a_outVars, l_outarg, a_boxed, l_fargsStr, a_fname, l_boxPtrStr);
end functionPrototype;

protected function lm_646
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinitionKernelFunctionInterface(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_646(txt, rest);
      then txt;
  end match;
end lm_646;

protected function lm_647
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_647(txt, rest);
      then txt;
  end match;
end lm_647;

protected function fun_648
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Dimensions i_dims;

    case ( txt,
           DAE.T_ARRAY(dims = i_dims) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_647(txt, i_dims);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_648;

protected function fun_649
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_i1)
    local
      Tpl.Text txt;
      Integer a_i1;
      String i_name_1;
      DAE.ComponentRef i_name;
      SimCode.Variable i_var;
      DAE.Type i_ty;
      Tpl.Text l_typeStr;
      Tpl.Text l_dimStr;

    case ( txt,
           (i_var as SimCode.VARIABLE(ty = i_ty, name = i_name)),
           a_i1 )
      equation
        l_dimStr = fun_648(Tpl.emptyTxt, i_ty);
        l_typeStr = varType(Tpl.emptyTxt, i_var);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" c"));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* "));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeText(txt, l_dimStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr c"));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* "));
        txt = Tpl.writeStr(txt, i_name_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_649;

protected function lm_650
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Integer x_i1;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_649(txt, i_var, x_i1);
        txt = Tpl.nextIter(txt);
        txt = lm_650(txt, rest);
      then txt;
  end match;
end lm_650;

protected function fun_651
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_fargsStr;
  input String in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fargsStr, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStr;
      String a_fname;
      list<SimCode.Variable> i_outVars;

    case ( txt,
           {},
           a_fargsStr,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void _"
                                }, false));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData, "));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           i_outVars,
           a_fargsStr,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef struct "));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_rettype_s {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_650(txt, i_outVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} "));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_rettype;\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData, "));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_651;

public function functionHeaderKernelFunctionInterface
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCode.Variable> a_fargs;
  input list<SimCode.Variable> a_outVars;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fargsStr;
algorithm
  l_fargsStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_fargsStr := lm_646(l_fargsStr, a_fargs);
  l_fargsStr := Tpl.popIter(l_fargsStr);
  out_txt := fun_651(txt, a_outVars, l_fargsStr, a_fname);
end functionHeaderKernelFunctionInterface;

protected function fun_653
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCode.VARIABLE(name = i_name),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_653;

public function funArgName
  input Tpl.Text txt;
  input SimCode.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_653(txt, a_var, l_auxFunction);
end funArgName;

protected function fun_655
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;
      SimCode.Variable i_var;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_name)),
           a_auxFunction )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr _"));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_655;

public function funArgDefinition
  input Tpl.Text txt;
  input SimCode.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_655(txt, a_var, l_auxFunction);
end funArgDefinition;

protected function fun_657
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_name;
      SimCode.Variable i_var;

    case ( txt,
           (i_var as SimCode.VARIABLE(ty = DAE.T_ARRAY(ty = _), parallelism = DAE.PARGLOBAL(), name = i_name)),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_"));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(ty = DAE.T_ARRAY(ty = _), parallelism = DAE.PARLOCAL(), name = i_name)),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_local_"));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_name)),
           a_auxFunction )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Invalid function argument to Kernel function Interface."));
      then (txt, a_auxFunction);
  end match;
end fun_657;

public function funArgDefinitionKernelFunctionInterface
  input Tpl.Text txt;
  input SimCode.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_657(txt, a_var, l_auxFunction);
end funArgDefinitionKernelFunctionInterface;

protected function fun_659
  input Tpl.Text in_txt;
  input DAE.VarParallelism in_a_parallelism;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_parallelism, in_a_varName, in_a_var_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;

    case ( txt,
           DAE.PARGLOBAL(),
           a_varName,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           DAE.PARLOCAL(),
           a_varName,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_659;

protected function fun_660
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input DAE.VarParallelism in_a_parallelism;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_parallelism, in_a_varName, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.VarParallelism a_parallelism;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           _,
           a_varName,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           a_parallelism,
           a_varName,
           a_var_ty )
      equation
        txt = fun_659(txt, a_parallelism, a_varName, a_var_ty);
      then txt;
  end match;
end fun_660;

protected function fun_661
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.VarParallelism i_parallelism;
      list<DAE.Exp> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCode.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARGLOBAL(), name = i_var_name),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __global modelica_integer* info_"));
        txt = Tpl.writeText(txt, l_varName);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL(), name = i_var_name),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__local modelica_"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __local modelica_integer* info_"));
        txt = Tpl.writeText(txt, l_varName);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty, parallelism = i_parallelism),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        txt = fun_660(txt, i_instDims, i_parallelism, l_varName, i_var_ty);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#error Unknown variable type in as function argument funArgDefinitionKernelFunctionBody"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction);
  end match;
end fun_661;

public function funArgDefinitionKernelFunctionBody
  input Tpl.Text txt;
  input SimCode.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_661(txt, a_var, l_auxFunction);
end funArgDefinitionKernelFunctionBody;

protected function fun_663
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_parArgList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parArgList;
algorithm
  (out_txt, out_a_parArgList) :=
  match(in_txt, in_a_instDims, in_a_varName, in_a_var_ty, in_a_parArgList)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_parArgList;

    case ( txt,
           {},
           a_varName,
           a_var_ty,
           a_parArgList )
      equation
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    modelica_"));
        a_parArgList = expTypeShort(a_parArgList, a_var_ty);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(" "));
        a_parArgList = Tpl.writeText(a_parArgList, a_varName);
      then (txt, a_parArgList);

    case ( txt,
           _,
           a_varName,
           a_var_ty,
           a_parArgList )
      equation
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_"));
        a_parArgList = expTypeShort(a_parArgList, a_var_ty);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("* data_"));
        a_parArgList = Tpl.writeText(a_parArgList, a_varName);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_integer* info_"));
        a_parArgList = Tpl.writeText(a_parArgList, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_parArgList);
  end match;
end fun_663;

protected function fun_664
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_parArgList;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parArgList;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_parArgList, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_parArgList, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_parArgList;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCode.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), name = i_var_name),
           a_parArgList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_"));
        a_parArgList = expTypeShort(a_parArgList, i_var_ty);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("* data_"));
        a_parArgList = Tpl.writeText(a_parArgList, l_varName);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_integer* info_"));
        a_parArgList = Tpl.writeText(a_parArgList, l_varName);
      then (txt, a_parArgList, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty),
           a_parArgList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        (txt, a_parArgList) = fun_663(txt, i_instDims, l_varName, i_var_ty, a_parArgList);
      then (txt, a_parArgList, a_auxFunction);

    case ( txt,
           _,
           a_parArgList,
           a_auxFunction )
      equation
        a_parArgList = Tpl.pushBlock(a_parArgList, Tpl.BT_INDENT(4));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("#error Unknown variable type in as function argument funArgDefinitionKernelFunctionBody2"));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.popBlock(a_parArgList);
      then (txt, a_parArgList, a_auxFunction);
  end match;
end fun_664;

public function funArgDefinitionKernelFunctionBody2
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input Tpl.Text a_parArgList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parArgList;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_parArgList, l_auxFunction) := fun_664(txt, a_var, a_parArgList, l_auxFunction);
end funArgDefinitionKernelFunctionBody2;

protected function fun_666
  input Tpl.Text in_txt;
  input DAE.Type in_a_cref_identType;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref_identType, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_integer* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _)),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_real* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Template error in parFunArgDefinitionFromLooptupleVar"));
      then txt;
  end match;
end fun_666;

protected function fun_667
  input Tpl.Text in_txt;
  input DAE.Type in_a_cref_identType;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref_identType, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer "));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_real "));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Tempalte error in parFunArgDefinitionFromLooptupleVar"));
      then txt;
  end match;
end fun_667;

public function parFunArgDefinitionFromLooptupleVar
  input Tpl.Text in_txt;
  input tuple<DAE.ComponentRef, Absyn.Info> in_a_tupleVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tupleVar)
    local
      Tpl.Text txt;
      DAE.Type i_cref_identType;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varName;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = (i_cref_identType as DAE.T_ARRAY(ty = _)))), _) )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, SimCode.contextParallelFunction);
        txt = fun_666(txt, i_cref_identType, l_varName);
      then txt;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = i_cref_identType)), _) )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, SimCode.contextParallelFunction);
        txt = fun_667(txt, i_cref_identType, l_varName);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end parFunArgDefinitionFromLooptupleVar;

protected function fun_669
  input Tpl.Text in_txt;
  input DAE.Type in_a_cref_identType;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
algorithm
  (out_txt, out_a_reconstructedArrs) :=
  match(in_txt, in_a_cref_identType, in_a_varName, in_a_reconstructedArrs)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_reconstructedArrs;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)),
           a_varName,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("integer_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs);

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _)),
           a_varName,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("real_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs);

    case ( txt,
           _,
           _,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("#wiered variable in kerenl reconstruction of arrays"));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs);
  end match;
end fun_669;

public function reconstructKernelArraysFromLooptupleVars
  input Tpl.Text in_txt;
  input tuple<DAE.ComponentRef, Absyn.Info> in_a_tupleVar;
  input Tpl.Text in_a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
algorithm
  (out_txt, out_a_reconstructedArrs) :=
  match(in_txt, in_a_tupleVar, in_a_reconstructedArrs)
    local
      Tpl.Text txt;
      Tpl.Text a_reconstructedArrs;
      DAE.Type i_cref_identType;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varName;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = (i_cref_identType as DAE.T_ARRAY(ty = _)))), _),
           a_reconstructedArrs )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, SimCode.contextParallelFunction);
        (txt, a_reconstructedArrs) = fun_669(txt, i_cref_identType, l_varName, a_reconstructedArrs);
      then (txt, a_reconstructedArrs);

    case ( txt,
           _,
           a_reconstructedArrs )
      then (txt, a_reconstructedArrs);
  end match;
end reconstructKernelArraysFromLooptupleVars;

protected function fun_671
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
algorithm
  (out_txt, out_a_reconstructedArrs) :=
  match(in_txt, in_a_instDims, in_a_varName, in_a_var_ty, in_a_reconstructedArrs)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_reconstructedArrs;

    case ( txt,
           {},
           _,
           _,
           a_reconstructedArrs )
      then (txt, a_reconstructedArrs);

    case ( txt,
           _,
           a_varName,
           a_var_ty,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = expTypeShort(a_reconstructedArrs, a_var_ty);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_reconstructedArrs);
  end match;
end fun_671;

protected function fun_672
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_reconstructedArrs;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_reconstructedArrs, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_reconstructedArrs, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_reconstructedArrs;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCode.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARGLOBAL(), name = i_var_name),
           a_reconstructedArrs,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        a_reconstructedArrs = expTypeShort(a_reconstructedArrs, i_var_ty);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL(), name = i_var_name),
           a_reconstructedArrs,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("local_"));
        a_reconstructedArrs = expTypeShort(a_reconstructedArrs, i_var_ty);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty),
           a_reconstructedArrs,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextParallelFunction, a_auxFunction);
        (txt, a_reconstructedArrs) = fun_671(txt, i_instDims, l_varName, i_var_ty, a_reconstructedArrs);
      then (txt, a_reconstructedArrs, a_auxFunction);

    case ( txt,
           _,
           a_reconstructedArrs,
           a_auxFunction )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("#wiered variable in kerenl reconstruction of arrays"));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs, a_auxFunction);
  end match;
end fun_672;

public function reconstructKernelArrays
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input Tpl.Text a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_reconstructedArrs, l_auxFunction) := fun_672(txt, a_var, a_reconstructedArrs, l_auxFunction);
end reconstructKernelArrays;

protected function fun_674
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCode.VARIABLE(name = i_name),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype "));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr _"));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_674;

public function funArgBoxedDefinition
  input Tpl.Text txt;
  input SimCode.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_674(txt, a_var, l_auxFunction);
end funArgBoxedDefinition;

protected function lm_676
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeStr(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_676(txt, rest);
      then txt;
  end match;
end lm_676;

protected function fun_677
  input Tpl.Text in_txt;
  input list<String> in_a_includes;
  input Tpl.Text in_a_fargsStrEscaped;
  input Tpl.Text in_a_fargsStr;
  input Tpl.Text in_a_fn__name;
  input SimCode.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_includes, in_a_fargsStrEscaped, in_a_fargsStr, in_a_fn__name, in_a_extReturn)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStrEscaped;
      Tpl.Text a_fargsStr;
      Tpl.Text a_fn__name;
      SimCode.SimExtArg a_extReturn;

    case ( txt,
           {},
           _,
           a_fargsStr,
           a_fn__name,
           a_extReturn )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern "));
        txt = extReturnType(txt, a_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_fargsStrEscaped,
           _,
           a_fn__name,
           a_extReturn )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*\n",
                                    " * The function has annotation(Include=...>)\n",
                                    " * the external function definition should be present\n",
                                    " * in one of these files and have this prototype:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* extern "));
        txt = extReturnType(txt, a_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStrEscaped);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "*/"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_677;

public function extFunDef
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      SimCode.SimExtArg i_extReturn;
      list<String> i_includes;
      list<SimCode.SimExtArg> i_extArgs;
      String i_language;
      String i_extName;
      Tpl.Text l_includesStr;
      Tpl.Text l_fargsStrEscaped;
      Tpl.Text l_fargsStr;
      Tpl.Text l_fn__name;

    case ( txt,
           SimCode.EXTERNAL_FUNCTION(extName = i_extName, language = i_language, extArgs = i_extArgs, includes = i_includes, extReturn = i_extReturn) )
      equation
        l_fn__name = extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        l_fargsStr = extFunDefArgs(Tpl.emptyTxt, i_extArgs, i_language);
        l_fargsStrEscaped = CodegenUtil.escapeCComments(Tpl.emptyTxt, Tpl.textString(l_fargsStr));
        l_includesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_includesStr = lm_676(l_includesStr, i_includes);
        l_includesStr = Tpl.popIter(l_includesStr);
        txt = fun_677(txt, i_includes, l_fargsStrEscaped, l_fargsStr, l_fn__name, i_extReturn);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end extFunDef;

public function extFunDefDynamic
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      SimCode.SimExtArg i_extReturn;
      list<SimCode.SimExtArg> i_extArgs;
      String i_language;
      String i_extName;
      Tpl.Text l_fargsStr;
      Tpl.Text l_fn__name;

    case ( txt,
           SimCode.EXTERNAL_FUNCTION(extName = i_extName, language = i_language, extArgs = i_extArgs, extReturn = i_extReturn) )
      equation
        l_fn__name = extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        l_fargsStr = extFunDefArgs(Tpl.emptyTxt, i_extArgs, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = extReturnType(txt, i_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (*ptrT_"));
        txt = Tpl.writeText(txt, l_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")("));
        txt = Tpl.writeText(txt, l_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "extern ptrT_"
                                }, false));
        txt = Tpl.writeText(txt, l_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ptr_"));
        txt = Tpl.writeText(txt, l_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end extFunDefDynamic;

protected function fun_680
  input Tpl.Text in_txt;
  input String in_a_language;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_name)
    local
      Tpl.Text txt;
      String a_name;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "C",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;

    case ( txt,
           "FORTRAN 77",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           i_language,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupport external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5282, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_680;

public function extFunctionName
  input Tpl.Text txt;
  input String a_name;
  input String a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_680(txt, a_language, a_name);
end extFunctionName;

protected function lm_682
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = extFunDefArg(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_682(txt, rest);
      then txt;
  end match;
end lm_682;

protected function lm_683
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = extFunDefArgF77(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_683(txt, rest);
      then txt;
  end match;
end lm_683;

protected function fun_684
  input Tpl.Text in_txt;
  input String in_a_language;
  input list<SimCode.SimExtArg> in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_args)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> a_args;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "C",
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_682(txt, a_args);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           "FORTRAN 77",
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_683(txt, a_args);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           i_language,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupport external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5290, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_684;

public function extFunDefArgs
  input Tpl.Text txt;
  input list<SimCode.SimExtArg> a_args;
  input String a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_684(txt, a_language, a_args);
end extFunDefArgs;

public function extReturnType
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extArg)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      DAE.Type i_type__;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           SimCode.SIMEXTARG(type_ = i_type__) )
      equation
        txt = extType(txt, i_type__, true, false);
      then txt;

    case ( txt,
           SimCode.SIMNOEXTARG() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           SimCode.SIMEXTARGEXP(exp = i_exp) )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Expression types are unsupported as return arguments "));
        ret_0 = ExpressionDump.printExpStr(i_exp);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5299, 36), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5300, 14), "Unsupported return argument");
      then txt;
  end match;
end extReturnType;

protected function fun_687
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isInput;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isInput)
    local
      Tpl.Text txt;
      Boolean a_isInput;
      DAE.Type i_type;
      Absyn.Path i_rname;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char*"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty),
           a_isInput )
      equation
        txt = extType(txt, i_ty, a_isInput, true);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void *"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)),
           _ )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           i_type,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown external C type "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5323, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_687;

protected function fun_688
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "const char*" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const "));
      then txt;
  end match;
end fun_688;

protected function fun_689
  input Tpl.Text in_txt;
  input Boolean in_a_isArray;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArray, in_a_s)
    local
      Tpl.Text txt;
      Tpl.Text a_s;
      String str_0;

    case ( txt,
           false,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_s )
      equation
        str_0 = Tpl.textString(a_s);
        txt = fun_688(txt, str_0);
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_689;

protected function fun_690
  input Tpl.Text in_txt;
  input Boolean in_a_isInput;
  input Boolean in_a_isArray;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInput, in_a_isArray, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isArray;
      Tpl.Text a_s;

    case ( txt,
           false,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           _,
           a_isArray,
           a_s )
      equation
        txt = fun_689(txt, a_isArray, a_s);
      then txt;
  end match;
end fun_690;

protected function fun_691
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isArray;
  input Boolean in_a_isInput;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isArray, in_a_isInput, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isArray;
      Boolean a_isInput;
      Tpl.Text a_s;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isArray,
           a_isInput,
           a_s )
      equation
        txt = fun_690(txt, a_isInput, a_isArray, a_s);
      then txt;
  end match;
end fun_691;

public function extType
  input Tpl.Text txt;
  input DAE.Type a_type;
  input Boolean a_isInput;
  input Boolean a_isArray;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_s;
algorithm
  l_s := fun_687(Tpl.emptyTxt, a_type, a_isInput);
  out_txt := fun_691(txt, a_type, a_isArray, a_isInput, l_s);
end extType;

protected function fun_693
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      Absyn.Path i_rname;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("char"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = extTypeF77(txt, i_ty, true);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown external F77 type "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5342, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_693;

protected function fun_694
  input Tpl.Text in_txt;
  input Boolean in_a_isReference;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReference, in_a_s)
    local
      Tpl.Text txt;
      Tpl.Text a_s;

    case ( txt,
           false,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_694;

protected function fun_695
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isReference;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isReference, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isReference;
      Tpl.Text a_s;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isReference,
           a_s )
      equation
        txt = fun_694(txt, a_isReference, a_s);
      then txt;
  end match;
end fun_695;

public function extTypeF77
  input Tpl.Text txt;
  input DAE.Type a_type;
  input Boolean a_isReference;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_s;
algorithm
  l_s := fun_693(Tpl.emptyTxt, a_type);
  out_txt := fun_695(txt, a_type, a_isReference, l_s);
end extTypeF77;

protected function fun_697
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extArg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Type i_type__;
      Boolean i_ia;
      Boolean i_ii;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_typeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, isInput = i_ii, isArray = i_ia, type_ = i_t),
           a_auxFunction )
      equation
        (l_name, a_auxFunction) = contextCref(Tpl.emptyTxt, i_c, SimCode.contextFunction, a_auxFunction);
        l_typeStr = extType(Tpl.emptyTxt, i_t, i_ii, i_ia);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*"));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGEXP(type_ = i_type__),
           a_auxFunction )
      equation
        l_typeStr = extType(Tpl.emptyTxt, i_type__, true, false);
        txt = Tpl.writeText(txt, l_typeStr);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGSIZE(cref = _),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_t"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_697;

public function extFunDefArg
  input Tpl.Text txt;
  input SimCode.SimExtArg a_extArg;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_697(txt, a_extArg, l_auxFunction);
end extFunDefArg;

protected function fun_699
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extArg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Type i_type__;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_typeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, isInput = _, type_ = i_t),
           a_auxFunction )
      equation
        (l_name, a_auxFunction) = contextCref(Tpl.emptyTxt, i_c, SimCode.contextFunction, a_auxFunction);
        l_typeStr = extTypeF77(Tpl.emptyTxt, i_t, true);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*"));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGEXP(type_ = i_type__),
           a_auxFunction )
      equation
        txt = extTypeF77(txt, i_type__, true);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGSIZE(cref = _),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int *"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_699;

public function extFunDefArgF77
  input Tpl.Text txt;
  input SimCode.SimExtArg a_extArg;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_699(txt, a_extArg, l_auxFunction);
end extFunDefArgF77;

protected function fun_701
  input Tpl.Text in_txt;
  input Boolean in_a_dotPath;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dotPath, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = CodegenUtil.dotPath(txt, a_name);
      then txt;
  end match;
end fun_701;

protected function fun_702
  input Tpl.Text in_txt;
  input Boolean in_a_dotPath;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dotPath, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = CodegenUtil.dotPath(txt, a_name);
      then txt;
  end match;
end fun_702;

protected function fun_703
  input Tpl.Text in_txt;
  input Boolean in_a_dotPath;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dotPath, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = CodegenUtil.dotPath(txt, a_name);
      then txt;
  end match;
end fun_703;

public function functionName
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_dotPath;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_dotPath)
    local
      Tpl.Text txt;
      Boolean a_dotPath;
      Absyn.Path i_name;

    case ( txt,
           SimCode.FUNCTION(name = i_name),
           a_dotPath )
      equation
        txt = fun_701(txt, a_dotPath, i_name);
      then txt;

    case ( txt,
           SimCode.EXTERNAL_FUNCTION(name = i_name),
           a_dotPath )
      equation
        txt = fun_702(txt, a_dotPath, i_name);
      then txt;

    case ( txt,
           SimCode.RECORD_CONSTRUCTOR(name = i_name),
           a_dotPath )
      equation
        txt = fun_703(txt, a_dotPath, i_name);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionName;

protected function lm_705
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> rest;
      SimCode.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = functionBody(txt, i_fn, false);
        txt = Tpl.nextIter(txt);
        txt = lm_705(txt, rest);
      then txt;
  end match;
end lm_705;

public function functionBodies
  input Tpl.Text txt;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_705(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end functionBodies;

protected function lm_707
  input Tpl.Text in_txt;
  input list<SimCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Function> rest;
      SimCode.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = functionBodyParModelica(txt, i_fn, false);
        txt = Tpl.nextIter(txt);
        txt = lm_707(txt, rest);
      then txt;
  end match;
end lm_707;

public function functionBodiesParModelica
  input Tpl.Text txt;
  input list<SimCode.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_707(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end functionBodiesParModelica;

public function functionBody
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      SimCode.Function i_fn;

    case ( txt,
           (i_fn as SimCode.FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyRegularFunction(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCode.KERNEL_FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyKernelFunctionInterface(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCode.EXTERNAL_FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyExternalFunction(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCode.RECORD_CONSTRUCTOR(name = _)),
           _ )
      equation
        txt = functionBodyRecordConstructor(txt, i_fn);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionBody;

public function functionBodyParModelica
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      SimCode.Function i_fn;

    case ( txt,
           (i_fn as SimCode.FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = extractParforBodies(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCode.KERNEL_FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyKernelFunction(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCode.PARALLEL_FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyParallelFunction(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionBodyParModelica;

protected function lm_711
  input Tpl.Text in_txt;
  input list<SimCode.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extractParFors(txt, i_stmt, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_711(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_711;

protected function fun_712
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCode.Statement> i_body;
      Tpl.Text l_bodyPart;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCode.FUNCTION(body = i_body) )
      equation
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_bodyPart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bodyPart, l_auxFunction, l_varDecls) = lm_711(l_bodyPart, i_body, l_auxFunction, l_varDecls);
        l_bodyPart = Tpl.popIter(l_bodyPart);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyPart);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_712;

public function extractParforBodies
  input Tpl.Text txt;
  input SimCode.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_712(txt, a_fn);
end extractParforBodies;

protected function lm_714
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_714(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_714;

protected function lm_715
  input Tpl.Text in_txt;
  input list<SimCode.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = funStatement(txt, i_stmt, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_715(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_715;

protected function lm_716
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_outVarAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outVarAssign;
algorithm
  (out_txt, out_a_outVarAssign) :=
  match(in_txt, in_items, in_a_outVarAssign)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_outVarAssign;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_outVarAssign )
      then (txt, a_outVarAssign);

    case ( txt,
           i_var :: rest,
           a_outVarAssign )
      equation
        (txt, a_outVarAssign) = varOutput(txt, i_var, a_outVarAssign);
        (txt, a_outVarAssign) = lm_716(txt, rest, a_outVarAssign);
      then (txt, a_outVarAssign);
  end match;
end lm_716;

protected function lm_717
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_var_name;
      Absyn.Path i_path__ext;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(ty = DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = i_path__ext)), name = i_var_name) :: rest,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = CodegenUtil.underscorePath(txt, i_path__ext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_destructor(threadData,"));
        (txt, a_auxFunction) = contextCref(txt, i_var_name, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_717(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _ :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = lm_717(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_717;

protected function fun_718
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varFrees;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varFrees)
    local
      Tpl.Text txt;
      Tpl.Text a_varFrees;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_varFrees )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Free GPU/OpenCL CPU memory */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_varFrees);
      then txt;
  end match;
end fun_718;

protected function fun_719
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCode.Variable i_v;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;

    case ( txt,
           i_v :: _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_719;

protected function fun_720
  input Tpl.Text in_txt;
  input Boolean in_a_inFunc;
  input list<SimCode.Variable> in_a_outVars;
  input list<SimCode.Variable> in_a_functionArguments;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fname;
algorithm
  (out_txt, out_a_fname) :=
  match(in_txt, in_a_inFunc, in_a_outVars, in_a_functionArguments, in_a_fname)
    local
      Tpl.Text txt;
      list<SimCode.Variable> a_outVars;
      list<SimCode.Variable> a_functionArguments;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           a_fname )
      then (txt, a_fname);

    case ( txt,
           _,
           a_outVars,
           a_functionArguments,
           a_fname )
      equation
        (txt, a_fname) = generateInFunc(txt, a_fname, a_functionArguments, a_outVars);
      then (txt, a_fname);
  end match;
end fun_720;

public function functionBodyRegularFunction
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      list<SimCode.Variable> i_functionArguments;
      SimCode.Function i_fn;
      list<SimCode.Variable> i_outVars;
      list<SimCode.Statement> i_body;
      list<SimCode.Variable> i_variableDeclarations;
      Absyn.Path i_name;
      Boolean ret_15;
      Tpl.Text l_boxedFn;
      Tpl.Text l_freeConstructedExternalObjects;
      list<SimCode.Variable> ret_12;
      Tpl.Text l_0___1;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_outVarCopy;
      Tpl.Text l_outVarInits;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0__;
      Tpl.Text l_auxFunction_1;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_fname;
      Tpl.Text l_auxFunction;

    case ( txt,
           (i_fn as SimCode.FUNCTION(name = i_name, variableDeclarations = i_variableDeclarations, body = i_body, outVars = i_outVars, functionArguments = i_functionArguments)),
           a_inFunc )
      equation
        l_auxFunction = Tpl.emptyTxt;
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction_1 = Tpl.emptyTxt;
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction_1, l_varFrees, l_varInits, l_varDecls) = lm_714(l_0__, i_variableDeclarations, l_auxFunction_1, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        l_bodyPart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bodyPart, l_auxFunction_1, l_varDecls) = lm_715(l_bodyPart, i_body, l_auxFunction_1, l_varDecls);
        l_bodyPart = Tpl.popIter(l_bodyPart);
        l_outVarInits = Tpl.emptyTxt;
        l_outVarCopy = Tpl.emptyTxt;
        l_outVarAssign = Tpl.emptyTxt;
        ret_12 = List.restOrEmpty(i_outVars);
        (l_0___1, l_outVarAssign) = lm_716(Tpl.emptyTxt, ret_12, l_outVarAssign);
        l_freeConstructedExternalObjects = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_freeConstructedExternalObjects, l_auxFunction_1) = lm_717(l_freeConstructedExternalObjects, i_variableDeclarations, l_auxFunction_1);
        l_freeConstructedExternalObjects = Tpl.popIter(l_freeConstructedExternalObjects);
        l_varDecls = addRootsTempArray(l_varDecls);
        l_boxedFn = functionBodyBoxed(Tpl.emptyTxt, i_fn);
        txt = Tpl.writeText(txt, l_auxFunction_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("DLLExport\n"));
        txt = functionPrototype(txt, Tpl.textString(l_fname), i_functionArguments, i_outVars, false);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_tailrecursive: OMC_LABEL_UNUSED\n",
                                    "TRACE_PUSH\n"
                                }, true));
        txt = Tpl.writeText(txt, l_outVarInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_return: OMC_LABEL_UNUSED\n"));
        txt = Tpl.writeText(txt, l_outVarCopy);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.softNewLine(txt);
        ret_15 = Config.acceptParModelicaGrammar();
        txt = fun_718(txt, ret_15, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_freeConstructedExternalObjects);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = fun_719(txt, i_outVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, l_fname) = fun_720(txt, a_inFunc, i_outVars, i_functionArguments, l_fname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_boxedFn);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionBodyRegularFunction;

protected function fun_722
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!mmc_GC_state) mmc_GC_init();"));
      then txt;
  end match;
end fun_722;

protected function lm_723
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinition(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_723(txt, rest);
      then txt;
  end match;
end lm_723;

protected function lm_724
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinition(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_724(txt, rest);
      then txt;
  end match;
end lm_724;

protected function lm_725
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = readInVar(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_725(txt, rest);
      then txt;
  end match;
end lm_725;

protected function fun_726
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCode.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_726;

protected function lm_727
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgName(txt, i_var);
        txt = lm_727(txt, rest);
      then txt;
  end match;
end lm_727;

protected function lm_728
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = funArgName(txt, i_var);
        txt = lm_728(txt, rest);
      then txt;
  end match;
end lm_728;

protected function fun_729
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCode.Variable i_first;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_noretcall(outVar);"));
      then txt;

    case ( txt,
           i_first :: _ )
      equation
        txt = writeOutVar(txt, i_first);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_729;

protected function lm_730
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = writeOutVar(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_730(txt, rest);
      then txt;
  end match;
end lm_730;

protected function fun_731
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("terminateHpcOmThreads();"));
      then txt;
  end match;
end fun_731;

public function generateInFunc
  input Tpl.Text txt;
  input Tpl.Text a_fname;
  input list<SimCode.Variable> a_functionArguments;
  input list<SimCode.Variable> a_outVars;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fname;
protected
  Boolean ret_4;
  Tpl.Text txt_3;
  list<SimCode.Variable> ret_2;
  list<SimCode.Variable> ret_1;
  Boolean ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "DLLExport\n",
                                   "int in_"
                               }, false));
  out_txt := Tpl.writeText(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(type_description * inArgs, type_description * outVar)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_0 := Config.acceptMetaModelicaGrammar();
  out_txt := fun_722(out_txt, ret_0);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_723(out_txt, a_functionArguments);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_724(out_txt, a_outVars);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_725(out_txt, a_functionArguments);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "MMC_INIT();\n",
                                       "MMC_TRY_TOP()\n"
                                   }, true));
  out_txt := fun_726(out_txt, a_outVars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("omc_"));
  out_txt := Tpl.writeText(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(threadData"));
  out_txt := lm_727(out_txt, a_functionArguments);
  ret_1 := List.restOrEmpty(a_outVars);
  out_txt := lm_728(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ");\n",
                                       "MMC_CATCH_TOP(return 1)\n"
                                   }, true));
  out_txt := fun_729(out_txt, a_outVars);
  out_txt := Tpl.softNewLine(out_txt);
  ret_2 := List.restOrEmpty(a_outVars);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_730(out_txt, ret_2);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "fflush(NULL);\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "#ifdef GENERATE_MAIN_EXECUTABLE\n",
                                       "static int rml_execution_failed()\n",
                                       "{\n",
                                       "  fflush(NULL);\n",
                                       "  fprintf(stderr, \"Execution failed!\\n\");\n",
                                       "  fflush(NULL);\n",
                                       "  return 1;\n",
                                       "}\n",
                                       "\n",
                                       "int main(int argc, char **argv) {\n",
                                       "  MMC_INIT();\n",
                                       "  {\n",
                                       "  void *lst = mmc_mk_nil();\n",
                                       "  int i = 0;\n",
                                       "\n",
                                       "  for (i=argc-1; i>0; i--) {\n",
                                       "    lst = mmc_mk_cons(mmc_mk_scon(argv[i]), lst);\n",
                                       "  }\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  txt_3 := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("omc_"));
  txt_3 := Tpl.writeText(txt_3, a_fname);
  txt_3 := Tpl.writeTok(txt_3, Tpl.ST_STRING("(threadData, lst);"));
  (out_txt, txt_3) := mainTop(out_txt, txt_3, "https://trac.openmodelica.org/OpenModelica/newticket");
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n"
                                   }, true));
  ret_4 := Flags.isSet(Flags.HPCOM);
  out_txt := fun_731(out_txt, ret_4);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "fflush(NULL);\n",
                                       "EXIT(0);\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "#endif"
                                   }, false));
  out_a_fname := a_fname;
end generateInFunc;

protected function lm_733
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_733(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_733;

protected function lm_734
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinitionKernelFunctionBody(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_734(txt, rest);
      then txt;
  end match;
end lm_734;

protected function lm_735
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_argStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_argStr;
algorithm
  (out_txt, out_a_argStr) :=
  match(in_txt, in_items, in_a_argStr)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_argStr;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_argStr )
      then (txt, a_argStr);

    case ( txt,
           i_var :: rest,
           a_argStr )
      equation
        (txt, a_argStr) = funArgDefinitionKernelFunctionBody2(txt, i_var, a_argStr);
        txt = Tpl.nextIter(txt);
        (txt, a_argStr) = lm_735(txt, rest, a_argStr);
      then (txt, a_argStr);
  end match;
end lm_735;

protected function lm_736
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_reconstrucedArrays;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstrucedArrays;
algorithm
  (out_txt, out_a_reconstrucedArrays) :=
  match(in_txt, in_items, in_a_reconstrucedArrays)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_reconstrucedArrays;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_reconstrucedArrays )
      then (txt, a_reconstrucedArrays);

    case ( txt,
           i_var :: rest,
           a_reconstrucedArrays )
      equation
        (txt, a_reconstrucedArrays) = reconstructKernelArrays(txt, i_var, a_reconstrucedArrays);
        (txt, a_reconstrucedArrays) = lm_736(txt, rest, a_reconstrucedArrays);
      then (txt, a_reconstrucedArrays);
  end match;
end lm_736;

protected function lm_737
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_reconstrucedArrays;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstrucedArrays;
algorithm
  (out_txt, out_a_reconstrucedArrays) :=
  match(in_txt, in_items, in_a_reconstrucedArrays)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_reconstrucedArrays;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_reconstrucedArrays )
      then (txt, a_reconstrucedArrays);

    case ( txt,
           i_var :: rest,
           a_reconstrucedArrays )
      equation
        (txt, a_reconstrucedArrays) = reconstructKernelArrays(txt, i_var, a_reconstrucedArrays);
        (txt, a_reconstrucedArrays) = lm_737(txt, rest, a_reconstrucedArrays);
      then (txt, a_reconstrucedArrays);
  end match;
end lm_737;

protected function lm_738
  input Tpl.Text in_txt;
  input list<SimCode.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = parModelicafunStatement(txt, i_stmt, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_738(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_738;

protected function fun_739
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCode.Statement> i_body;
      list<SimCode.Variable> i_outVars;
      list<SimCode.Variable> i_functionArguments;
      list<SimCode.Variable> i_variableDeclarations;
      Absyn.Path i_name;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0___3;
      Tpl.Text l_0___2;
      Tpl.Text l_reconstrucedArrays;
      Tpl.Text l_0___1;
      Tpl.Text l_argStr;
      Tpl.Text l_0__;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_fname;

    case ( txt,
           SimCode.KERNEL_FUNCTION(name = i_name, variableDeclarations = i_variableDeclarations, functionArguments = i_functionArguments, outVars = i_outVars, body = i_body) )
      equation
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_varInits, l_varDecls) = lm_733(l_0__, i_variableDeclarations, l_auxFunction, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                   ", \n",
                                                                                   "    "
                                                                               }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_argStr = lm_734(l_argStr, i_functionArguments);
        l_argStr = Tpl.popIter(l_argStr);
        l_0___1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0___1, l_argStr) = lm_735(l_0___1, i_outVars, l_argStr);
        l_0___1 = Tpl.popIter(l_0___1);
        l_reconstrucedArrays = Tpl.emptyTxt;
        (l_0___2, l_reconstrucedArrays) = lm_736(Tpl.emptyTxt, i_functionArguments, l_reconstrucedArrays);
        (l_0___3, l_reconstrucedArrays) = lm_737(Tpl.emptyTxt, i_outVars, l_reconstrucedArrays);
        l_bodyPart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bodyPart, l_auxFunction, l_varDecls) = lm_738(l_bodyPart, i_body, l_auxFunction, l_varDecls);
        l_bodyPart = Tpl.popIter(l_bodyPart);
        l_varDecls = addRootsTempArray(l_varDecls);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "__kernel void omc_"
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "  /* functionBodyKernelFunction: Reconstruct Arrays */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_reconstrucedArrays);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* functionBodyKernelFunction: locals */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* functionBodyKernelFunction: var inits */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* functionBodyKernelFunction: body */\n"));
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Free GPU/OpenCL CPU memory */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_739;

public function functionBodyKernelFunction
  input Tpl.Text txt;
  input SimCode.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_739(txt, a_fn);
end functionBodyKernelFunction;

protected function fun_741
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype"));
      then txt;
  end match;
end fun_741;

protected function fun_742
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_retType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_outVars, in_a_varDecls, in_a_retType)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_retType;

    case ( txt,
           {},
           a_varDecls,
           _ )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           a_retType )
      equation
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(a_retType), a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_742;

protected function lm_743
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Integer x_i1;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInitParallel(txt, i_var, "", x_i1, a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_743(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_743;

protected function lm_744
  input Tpl.Text in_txt;
  input list<SimCode.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = parModelicafunStatement(txt, i_stmt, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_744(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_744;

protected function lm_745
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDecls, in_a_retVar)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDecls;
      Tpl.Text a_retVar;
      Integer x_i1;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           a_retVar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_auxFunction) = varOutputParallel(txt, i_var, Tpl.textString(a_retVar), x_i1, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls) = lm_745(txt, rest, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls, a_retVar);
      then (txt, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);
  end match;
end lm_745;

protected function lm_746
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinition(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_746(txt, rest);
      then txt;
  end match;
end lm_746;

protected function fun_747
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text a_retVar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retVar )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, a_retVar);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_747;

protected function fun_748
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCode.Variable> i_functionArguments;
      list<SimCode.Statement> i_body;
      list<SimCode.Variable> i_variableDeclarations;
      list<SimCode.Variable> i_outVars;
      Absyn.Path i_name;
      Tpl.Text l_0__1;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_outVarCopy;
      Tpl.Text l_outVarInits;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0__;
      Tpl.Text l_retVar;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           SimCode.PARALLEL_FUNCTION(name = i_name, outVars = i_outVars, variableDeclarations = i_variableDeclarations, body = i_body, functionArguments = i_functionArguments) )
      equation
        System.tmpTickReset(1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = fun_741(Tpl.emptyTxt, i_outVars, l_fname);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_retVar, l_varDecls) = fun_742(Tpl.emptyTxt, i_outVars, l_varDecls, l_retType);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_varInits, l_varDecls) = lm_743(l_0__, i_variableDeclarations, l_auxFunction, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        l_bodyPart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bodyPart, l_auxFunction, l_varDecls) = lm_744(l_bodyPart, i_body, l_auxFunction, l_varDecls);
        l_bodyPart = Tpl.popIter(l_bodyPart);
        l_outVarInits = Tpl.emptyTxt;
        l_outVarCopy = Tpl.emptyTxt;
        l_outVarAssign = Tpl.emptyTxt;
        l_0__1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__1, l_auxFunction, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDecls) = lm_745(l_0__1, i_outVars, l_auxFunction, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDecls, l_retVar);
        l_0__1 = Tpl.popIter(l_0__1);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_746(txt, i_functionArguments);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outVarInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_outVarCopy);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/*mahge: Free unwanted meomory allocated*/\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return"
                                }, false));
        txt = fun_747(txt, i_outVars, l_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_748;

public function functionBodyParallelFunction
  input Tpl.Text txt;
  input SimCode.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_748(txt, a_fn);
end functionBodyParallelFunction;

protected function fun_750
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype"));
      then txt;
  end match;
end fun_750;

protected function fun_751
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_retType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_outVars, in_a_varDecls, in_a_retType)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_retType;

    case ( txt,
           {},
           a_varDecls,
           _ )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           a_retType )
      equation
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(a_retType), a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_751;

protected function lm_752
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDecls, in_a_retVar)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDecls;
      Tpl.Text a_retVar;
      Integer x_i1;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           a_retVar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_auxFunction) = varOutputKernelInterface(txt, i_var, Tpl.textString(a_retVar), x_i1, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls) = lm_752(txt, rest, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls, a_retVar);
      then (txt, a_auxFunction, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);
  end match;
end lm_752;

protected function lm_753
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_kernelArgSets;
  input Tpl.Text in_a_kernel__arg__number;
  input Tpl.Text in_a_cl__kernelVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_kernelArgSets;
  output Tpl.Text out_a_kernel__arg__number;
  output Tpl.Text out_a_cl__kernelVar;
algorithm
  (out_txt, out_a_kernelArgSets, out_a_kernel__arg__number, out_a_cl__kernelVar) :=
  match(in_txt, in_items, in_a_kernelArgSets, in_a_kernel__arg__number, in_a_cl__kernelVar)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_kernelArgSets;
      Tpl.Text a_kernel__arg__number;
      Tpl.Text a_cl__kernelVar;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);

    case ( txt,
           i_var :: rest,
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      equation
        (txt, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets) = setKernelArg_ith(txt, i_var, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets);
        (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar) = lm_753(txt, rest, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
  end match;
end lm_753;

protected function lm_754
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_kernelArgSets;
  input Tpl.Text in_a_kernel__arg__number;
  input Tpl.Text in_a_cl__kernelVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_kernelArgSets;
  output Tpl.Text out_a_kernel__arg__number;
  output Tpl.Text out_a_cl__kernelVar;
algorithm
  (out_txt, out_a_kernelArgSets, out_a_kernel__arg__number, out_a_cl__kernelVar) :=
  match(in_txt, in_items, in_a_kernelArgSets, in_a_kernel__arg__number, in_a_cl__kernelVar)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_kernelArgSets;
      Tpl.Text a_kernel__arg__number;
      Tpl.Text a_cl__kernelVar;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);

    case ( txt,
           i_var :: rest,
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      equation
        (txt, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets) = setKernelArg_ith(txt, i_var, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets);
        (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar) = lm_754(txt, rest, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
  end match;
end lm_754;

protected function lm_755
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinitionKernelFunctionInterface(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_755(txt, rest);
      then txt;
  end match;
end lm_755;

protected function fun_756
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text a_retVar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retVar )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, a_retVar);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_756;

protected function fun_757
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCode.Variable> i_functionArguments;
      list<SimCode.Variable> i_outVars;
      Absyn.Path i_name;
      Tpl.Text l_0___1;
      Tpl.Text l_0__;
      Tpl.Text l_kernelArgSets;
      Tpl.Text l_kernel__arg__number;
      Tpl.Text l_cl__kernelVar;
      Tpl.Text l_0__1;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_outVarCopy;
      Tpl.Text l_outVarInits;
      Tpl.Text l_retVar;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           SimCode.KERNEL_FUNCTION(name = i_name, outVars = i_outVars, functionArguments = i_functionArguments) )
      equation
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = fun_750(Tpl.emptyTxt, i_outVars, l_fname);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_retVar, l_varDecls) = fun_751(Tpl.emptyTxt, i_outVars, l_varDecls, l_retType);
        l_outVarInits = Tpl.emptyTxt;
        l_outVarCopy = Tpl.emptyTxt;
        l_outVarAssign = Tpl.emptyTxt;
        l_0__1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__1, l_auxFunction, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDecls) = lm_752(l_0__1, i_outVars, l_auxFunction, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDecls, l_retVar);
        l_0__1 = Tpl.popIter(l_0__1);
        (l_cl__kernelVar, l_varDecls) = tempDecl(Tpl.emptyTxt, "cl_kernel", l_varDecls);
        l_kernel__arg__number = Tpl.writeText(Tpl.emptyTxt, l_fname);
        l_kernel__arg__number = Tpl.writeTok(l_kernel__arg__number, Tpl.ST_STRING("_arg_nr"));
        l_kernelArgSets = Tpl.emptyTxt;
        (l_0__, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar) = lm_753(Tpl.emptyTxt, i_functionArguments, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar);
        (l_0___1, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar) = lm_754(Tpl.emptyTxt, i_outVars, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Interface function to "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" defined in parallelFunctions.cl file. */\n"));
        txt = Tpl.writeText(txt, l_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData, "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_755(txt, i_functionArguments);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outVarInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* functionBodyKernelFunctionInterface : "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " Kernel creation and execution */\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_kernel__arg__number);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ocl_create_kernel(omc_ocl_program, \"omc_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\");\n"));
        txt = Tpl.writeText(txt, l_kernelArgSets);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ocl_execute_kernel("));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "clReleaseKernel("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/*functionBodyKernelFunctionInterface : "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " kernel execution ends here.*/\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_outVarCopy);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/*mahge: Free unwanted meomory allocated*/\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return"
                                }, false));
        txt = fun_756(txt, i_outVars, l_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_757;

public function functionBodyKernelFunctionInterface
  input Tpl.Text txt;
  input SimCode.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_757(txt, a_fn);
end functionBodyKernelFunctionInterface;

protected function fun_759
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_argNr;
  input Tpl.Text in_a_KernelName;
  input Tpl.Text in_a_parVarList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parVarList;
algorithm
  (out_txt, out_a_parVarList) :=
  match(in_txt, in_a_instDims, in_a_varName, in_a_argNr, in_a_KernelName, in_a_parVarList)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_argNr;
      Tpl.Text a_KernelName;
      Tpl.Text a_parVarList;

    case ( txt,
           {},
           a_varName,
           a_argNr,
           a_KernelName,
           a_parVarList )
      equation
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);

    case ( txt,
           _,
           a_varName,
           a_argNr,
           a_KernelName,
           a_parVarList )
      equation
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".data); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info_dev); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);
  end match;
end fun_759;

protected function fun_760
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_argNr;
  input Tpl.Text in_a_KernelName;
  input Tpl.Text in_a_parVarList;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parVarList;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_parVarList, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_argNr, in_a_KernelName, in_a_parVarList, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_argNr;
      Tpl.Text a_KernelName;
      Tpl.Text a_parVarList;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCode.VARIABLE(ty = DAE.T_ARRAY(ty = _), parallelism = DAE.PARGLOBAL(), name = i_var_name),
           a_argNr,
           a_KernelName,
           a_parVarList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".data); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info_dev); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL(), name = i_var_name),
           a_argNr,
           a_KernelName,
           a_parVarList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_local_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", sizeof(modelica_"));
        a_parVarList = expTypeShort(a_parVarList, i_var_ty);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(") * device_array_nr_of_elements(&"));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(")); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_local_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", sizeof(modelica_integer) * ("));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info[0]+1)*sizeof(modelica_integer)); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(name = i_var_name, instDims = i_instDims),
           a_argNr,
           a_KernelName,
           a_parVarList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        (txt, a_parVarList) = fun_759(txt, i_instDims, l_varName, a_argNr, a_KernelName, a_parVarList);
      then (txt, a_parVarList, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_parVarList,
           a_auxFunction )
      then (txt, a_parVarList, a_auxFunction);
  end match;
end fun_760;

public function setKernelArg_ith
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input Tpl.Text a_KernelName;
  input Tpl.Text a_argNr;
  input Tpl.Text a_parVarList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_KernelName;
  output Tpl.Text out_a_argNr;
  output Tpl.Text out_a_parVarList;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_parVarList, l_auxFunction) := fun_760(txt, a_var, a_argNr, a_KernelName, a_parVarList, l_auxFunction);
  out_a_KernelName := a_KernelName;
  out_a_argNr := a_argNr;
end setKernelArg_ith;

protected function fun_762
  input Tpl.Text in_txt;
  input tuple<DAE.ComponentRef, Absyn.Info> in_a_tupleVar;
  input Tpl.Text in_a_KernelName;
  input Tpl.Text in_a_argNr;
  input Tpl.Text in_a_parVarList;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parVarList;
algorithm
  (out_txt, out_a_parVarList) :=
  match(in_txt, in_a_tupleVar, in_a_KernelName, in_a_argNr, in_a_parVarList, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_KernelName;
      Tpl.Text a_argNr;
      Tpl.Text a_parVarList;
      SimCode.Context a_context;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varName;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = DAE.T_ARRAY(ty = _))), _),
           a_KernelName,
           a_argNr,
           a_parVarList,
           a_context )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, a_context);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".data); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info_dev); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(ident = _)), _),
           a_KernelName,
           a_argNr,
           a_parVarList,
           a_context )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, a_context);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);

    case ( txt,
           _,
           _,
           _,
           a_parVarList,
           _ )
      then (txt, a_parVarList);
  end match;
end fun_762;

public function setKernelArgFormTupleLoopVars_ith
  input Tpl.Text txt;
  input tuple<DAE.ComponentRef, Absyn.Info> a_tupleVar;
  input Tpl.Text a_KernelName;
  input Tpl.Text a_argNr;
  input Tpl.Text a_parVarList;
  input SimCode.Context a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_KernelName;
  output Tpl.Text out_a_argNr;
  output Tpl.Text out_a_parVarList;
algorithm
  (out_txt, out_a_parVarList) := fun_762(txt, a_tupleVar, a_KernelName, a_argNr, a_parVarList, a_context);
  out_a_KernelName := a_KernelName;
  out_a_argNr := a_argNr;
end setKernelArgFormTupleLoopVars_ith;

protected function fun_764
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype"));
      then txt;
  end match;
end fun_764;

protected function lm_765
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_outputAlloc;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_outputAlloc;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_outputAlloc, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_outputAlloc, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_outputAlloc;
      Tpl.Text a_varDecls;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_outputAlloc,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_outputAlloc,
           a_varDecls )
      equation
        (txt, a_varDecls, a_outputAlloc, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_outputAlloc, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls) = lm_765(txt, rest, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls);
  end match;
end lm_765;

protected function lm_766
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_outVarAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outVarAssign;
algorithm
  (out_txt, out_a_outVarAssign) :=
  match(in_txt, in_items, in_a_outVarAssign)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_outVarAssign;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_outVarAssign )
      then (txt, a_outVarAssign);

    case ( txt,
           i_var :: rest,
           a_outVarAssign )
      equation
        (txt, a_outVarAssign) = varOutput(txt, i_var, a_outVarAssign);
        (txt, a_outVarAssign) = lm_766(txt, rest, a_outVarAssign);
      then (txt, a_outVarAssign);
  end match;
end lm_766;

protected function fun_767
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCode.Variable i_v;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;

    case ( txt,
           i_v :: _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_767;

protected function fun_768
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ptrT_"));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ptr_"));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=NULL;"));
      then txt;
  end match;
end fun_768;

protected function fun_769
  input Tpl.Text in_txt;
  input Boolean in_a_inFunc;
  input list<SimCode.Variable> in_a_outVars;
  input list<SimCode.Variable> in_a_funArgs;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fname;
algorithm
  (out_txt, out_a_fname) :=
  match(in_txt, in_a_inFunc, in_a_outVars, in_a_funArgs, in_a_fname)
    local
      Tpl.Text txt;
      list<SimCode.Variable> a_outVars;
      list<SimCode.Variable> a_funArgs;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           a_fname )
      then (txt, a_fname);

    case ( txt,
           _,
           a_outVars,
           a_funArgs,
           a_fname )
      equation
        (txt, a_fname) = generateInFunc(txt, a_fname, a_funArgs, a_outVars);
      then (txt, a_fname);
  end match;
end fun_769;

public function functionBodyExternalFunction
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      String i_language;
      String i_extName;
      Boolean i_dynamicLoad;
      list<SimCode.Variable> i_funArgs;
      SimCode.Function i_efn;
      list<SimCode.Variable> i_outVars;
      Absyn.Path i_name;
      Tpl.Text l_fnBody;
      Tpl.Text l_boxedFn;
      list<SimCode.Variable> ret_11;
      Tpl.Text l_0___1;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_0__;
      Tpl.Text l_callPart;
      Tpl.Text l_auxFunction;
      Tpl.Text l_outputAlloc;
      Tpl.Text l_varFrees;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           (i_efn as SimCode.EXTERNAL_FUNCTION(name = i_name, outVars = i_outVars, funArgs = i_funArgs, dynamicLoad = i_dynamicLoad, extName = i_extName, language = i_language)),
           a_inFunc )
      equation
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = fun_764(Tpl.emptyTxt, i_outVars, l_fname);
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_outputAlloc = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_callPart, l_preExp, l_varDecls, l_auxFunction) = extFunCall(Tpl.emptyTxt, i_efn, l_preExp, l_varDecls, l_auxFunction);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_outputAlloc, l_varDecls) = lm_765(l_0__, i_outVars, l_auxFunction, l_varFrees, l_outputAlloc, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        l_outVarAssign = Tpl.emptyTxt;
        ret_11 = List.restOrEmpty(i_outVars);
        (l_0___1, l_outVarAssign) = lm_766(Tpl.emptyTxt, ret_11, l_outVarAssign);
        l_varDecls = addRootsTempArray(l_varDecls);
        l_boxedFn = functionBodyBoxed(Tpl.emptyTxt, i_efn);
        l_fnBody = Tpl.writeText(Tpl.emptyTxt, l_auxFunction);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = functionPrototype(l_fnBody, Tpl.textString(l_fname), i_funArgs, i_outVars, false);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("{\n"));
        l_fnBody = Tpl.pushBlock(l_fnBody, Tpl.BT_INDENT(2));
        l_fnBody = Tpl.writeText(l_fnBody, l_varDecls);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_preExp);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_outputAlloc);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_callPart);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_outVarAssign);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = fun_767(l_fnBody, i_outVars);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.popBlock(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_STRING("}"));
        txt = fun_768(txt, i_dynamicLoad, i_language, i_extName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_fnBody);
        txt = Tpl.softNewLine(txt);
        (txt, l_fname) = fun_769(txt, a_inFunc, i_outVars, i_funArgs, l_fname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_boxedFn);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionBodyExternalFunction;

protected function lm_771
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_structVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varInits, in_a_varDecls, in_a_structVar)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Tpl.Text a_structVar;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varInits,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varInits,
           a_varDecls,
           a_structVar )
      equation
        (txt, a_varDecls, a_varInits, a_auxFunction) = varInitRecord(txt, i_var, Tpl.textString(a_structVar), a_varDecls, a_varInits, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varInits, a_varDecls) = lm_771(txt, rest, a_auxFunction, a_varInits, a_varDecls, a_structVar);
      then (txt, a_auxFunction, a_varInits, a_varDecls);
  end match;
end lm_771;

protected function lm_772
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      DAE.ComponentRef i_name;
      DAE.Type i_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.VARIABLE(ty = i_ty, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = lm_772(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_772(txt, rest);
      then txt;
  end match;
end lm_772;

protected function lm_773
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_structVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_structVar)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_structVar;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.VARIABLE(name = i_name) :: rest,
           a_structVar )
      equation
        txt = Tpl.writeText(txt, a_structVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_773(txt, rest, a_structVar);
      then txt;

    case ( txt,
           _ :: rest,
           a_structVar )
      equation
        txt = lm_773(txt, rest, a_structVar);
      then txt;
  end match;
end lm_773;

public function functionBodyRecordConstructor
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCode.Variable> i_funArgs;
      SimCode.Function i_fn;
      list<SimCode.Variable> i_locals;
      Absyn.Path i_name;
      Tpl.Text l_boxedFn;
      Tpl.Text l_0__;
      Tpl.Text l_structVar;
      Tpl.Text l_structType;
      Tpl.Text l_fname;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;

    case ( txt,
           (i_fn as SimCode.RECORD_CONSTRUCTOR(name = i_name, locals = i_locals, funArgs = i_funArgs)) )
      equation
        System.tmpTickReset(1);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_structType = Tpl.writeText(Tpl.emptyTxt, l_fname);
        (l_structVar, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_structType), l_varDecls);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varInits, l_varDecls) = lm_771(l_0__, i_locals, l_auxFunction, l_varInits, l_varDecls, l_structVar);
        l_0__ = Tpl.popIter(l_0__);
        l_boxedFn = functionBodyBoxed(Tpl.emptyTxt, i_fn);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = lm_772(txt, i_funArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_773(txt, i_funArgs, l_structVar);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, l_structVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_boxedFn);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end functionBodyRecordConstructor;

protected function lm_775
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_775(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_775;

protected function fun_776
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_var_value, in_a_auxFunction, in_a_varDecls, in_a_varInits, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varName;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_varName )
      equation
        l_defaultValue = Tpl.writeText(Tpl.emptyTxt, a_varName);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_776;

protected function fun_777
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varName;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_var, in_a_instDimsInit, in_a_var_ty, in_a_auxFunction, in_a_varDecls, in_a_varInits, in_a_varName, in_a_var_value)
    local
      Tpl.Text txt;
      SimCode.Variable a_var;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varName;
      Option<DAE.Exp> a_var_value;
      list<DAE.Exp> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_varName,
           a_var_value )
      equation
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_776(txt, a_var_value, a_auxFunction, a_varDecls, a_varInits, a_varName);
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_instDims,
           a_var,
           a_instDimsInit,
           a_var_ty,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_varName,
           _ )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_varDecls, a_varInits, a_auxFunction) = varDefaultValue(Tpl.emptyTxt, a_var, "", Tpl.textString(a_varName), a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_777;

public function varInitRecord
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_prefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_prefix, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_prefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_var_value;
      list<DAE.Exp> i_instDims;
      SimCode.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCode.VARIABLE(parallelism = DAE.NON_PARALLEL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_prefix,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        l_varName = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_varName = Tpl.writeTok(l_varName, Tpl.ST_STRING("._"));
        l_varName = crefToCStr(l_varName, i_var_name);
        (a_varInits, a_auxFunction) = initRecordMembers(a_varInits, i_var, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_775(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_777(txt, i_instDims, i_var, l_instDimsInit, i_var_ty, a_auxFunction, a_varDecls, a_varInits, l_varName, i_var_value);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = _),
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5896, 12), "Unknown local variable type in record");
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end varInitRecord;

protected function fun_779
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Absyn.Path i_name;

    case ( txt,
           SimCode.FUNCTION(name = i_name) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_name);
      then txt;

    case ( txt,
           SimCode.EXTERNAL_FUNCTION(name = i_name) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_name);
      then txt;

    case ( txt,
           SimCode.RECORD_CONSTRUCTOR(name = i_name) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_779;

protected function fun_780
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCode.Variable> in_a_outVars;
  input list<SimCode.Variable> in_a_functionArguments;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outVars, in_a_functionArguments, in_a_name)
    local
      Tpl.Text txt;
      list<SimCode.Variable> a_outVars;
      list<SimCode.Variable> a_functionArguments;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_outVars,
           a_functionArguments,
           a_name )
      equation
        txt = functionBodyBoxedImpl(txt, a_name, a_functionArguments, a_outVars);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_780;

protected function fun_781
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCode.Variable> in_a_outVars;
  input list<SimCode.Variable> in_a_funArgs;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outVars, in_a_funArgs, in_a_name)
    local
      Tpl.Text txt;
      list<SimCode.Variable> a_outVars;
      list<SimCode.Variable> a_funArgs;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_outVars,
           a_funArgs,
           a_name )
      equation
        txt = functionBodyBoxedImpl(txt, a_name, a_funArgs, a_outVars);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_781;

protected function fun_782
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCode.Variable> i_funArgs;
      list<SimCode.Variable> i_outVars;
      list<SimCode.Variable> i_functionArguments;
      Absyn.Path i_name;
      SimCode.Function i_fn;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_fn as SimCode.FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars)) )
      equation
        ret_0 = SimCodeUtil.isBoxedFunction(i_fn);
        txt = fun_780(txt, ret_0, i_outVars, i_functionArguments, i_name);
      then txt;

    case ( txt,
           (i_fn as SimCode.EXTERNAL_FUNCTION(name = i_name, funArgs = i_funArgs, outVars = i_outVars)) )
      equation
        ret_1 = SimCodeUtil.isBoxedFunction(i_fn);
        txt = fun_781(txt, ret_1, i_outVars, i_funArgs, i_name);
      then txt;

    case ( txt,
           (i_fn as SimCode.RECORD_CONSTRUCTOR(name = _)) )
      equation
        txt = boxRecordConstructor(txt, i_fn);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_782;

public function functionBodyBoxed
  input Tpl.Text txt;
  input SimCode.Function a_fn;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fname;
algorithm
  l_fname := fun_779(Tpl.emptyTxt, a_fn);
  out_txt := fun_782(txt, a_fn);
end functionBodyBoxed;

protected function fun_784
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outvars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outvars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_784;

protected function lm_785
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varBox;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varBox;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varBox, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varBox, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varBox;
      Tpl.Text a_varDecls;
      SimCode.Variable i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varBox,
           a_varDecls )
      then (txt, a_auxFunction, a_varBox, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varBox,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_varDecls, a_varBox, a_auxFunction) = funArgUnbox(txt, i_arg, a_varDecls, a_varBox, a_auxFunction);
        (txt, a_auxFunction, a_varBox, a_varDecls) = lm_785(txt, rest, a_auxFunction, a_varBox, a_varDecls);
      then (txt, a_auxFunction, a_varBox, a_varDecls);
  end match;
end lm_785;

protected function fun_786
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      SimCode.Variable a_var;
      Tpl.Text l_0__;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, a_var);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           _,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls,
           a_var )
      equation
        (l_0__, a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore) = varInit(Tpl.emptyTxt, a_var, "", a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = funArgName(txt, a_var);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end fun_786;

protected function fun_787
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_a_var, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      SimCode.Variable i_var;
      SimCode.Variable i_v;
      list<DAE.Exp> i_v_instDims;
      DAE.Type i_v_ty;
      Tpl.Text txt_1;
      DAE.Type ret_0;

    case ( txt,
           (i_v as SimCode.VARIABLE(ty = i_v_ty, instDims = i_v_instDims)),
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        ret_0 = Types.liftArrayListExp(i_v_ty, i_v_instDims);
        txt_1 = mmcConstructorType(Tpl.emptyTxt, ret_0);
        (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls) = fun_786(txt, txt_1, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls, i_v);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           (i_var as SimCode.FUNCTION_PTR(name = _)),
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, i_var);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           _,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end fun_787;

protected function lm_788
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls) = fun_787(txt, i_var, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls) = lm_788(txt, rest, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end lm_788;

protected function fun_789
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input Tpl.Text in_a_out;
  input Tpl.Text in_a_varDecls;
  input SimCode.Variable in_a_v;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_out, in_a_varDecls, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_out;
      Tpl.Text a_varDecls;
      SimCode.Variable a_v;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_varDecls,
           a_v )
      equation
        txt = funArgName(txt, a_v);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_out,
           a_varDecls,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("modelica_metatype "));
        a_varDecls = Tpl.writeText(a_varDecls, a_out);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_out);
      then (txt, a_varDecls);
  end match;
end fun_789;

protected function fun_790
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outvars;
  input Tpl.Text in_a_varUnbox;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varUnbox;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varUnbox, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_a_outvars, in_a_varUnbox, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varUnbox;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      list<DAE.Exp> i_v_instDims;
      DAE.Type i_v_ty;
      SimCode.Variable i_v;
      Tpl.Text txt_6;
      DAE.Type ret_5;
      DAE.Type ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_0___1;
      Tpl.Text l_out;
      Tpl.Text l_0__;

    case ( txt,
           {},
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           (i_v as SimCode.VARIABLE(ty = i_v_ty, instDims = i_v_instDims)) :: _,
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        (l_0__, a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore) = varInit(Tpl.emptyTxt, i_v, "", a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore);
        l_out = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
        l_out = funArgName(l_out, i_v);
        txt_3 = funArgName(Tpl.emptyTxt, i_v);
        ret_4 = Types.liftArrayListExp(i_v_ty, i_v_instDims);
        (l_0___1, a_varUnbox, a_varDecls) = funArgBox(Tpl.emptyTxt, Tpl.textString(l_out), Tpl.textString(txt_3), "", ret_4, a_varUnbox, a_varDecls);
        ret_5 = Types.liftArrayListExp(i_v_ty, i_v_instDims);
        txt_6 = mmcConstructorType(Tpl.emptyTxt, ret_5);
        (txt, a_varDecls) = fun_789(txt, txt_6, l_out, a_varDecls, i_v);
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           i_v :: _,
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        (l_0__, a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore) = varInit(Tpl.emptyTxt, i_v, "", a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore);
        txt = funArgName(txt, i_v);
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           _,
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end fun_790;

protected function lm_791
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varUnbox;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varUnbox;
algorithm
  (out_txt, out_a_varDecls, out_a_varUnbox) :=
  match(in_txt, in_items, in_a_varDecls, in_a_varUnbox)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_varDecls;
      Tpl.Text a_varUnbox;
      list<DAE.Exp> i_var_instDims;
      DAE.Type i_var_ty;
      SimCode.Variable i_var;
      DAE.Type ret_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text l_arg;

    case ( txt,
           {},
           a_varDecls,
           a_varUnbox )
      then (txt, a_varDecls, a_varUnbox);

    case ( txt,
           (i_var as SimCode.VARIABLE(ty = i_var_ty, instDims = i_var_instDims)) :: rest,
           a_varDecls,
           a_varUnbox )
      equation
        l_arg = funArgName(Tpl.emptyTxt, i_var);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("*out"));
        txt_1 = Tpl.writeText(txt_1, l_arg);
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
        txt_2 = Tpl.writeText(txt_2, l_arg);
        ret_3 = Types.liftArrayListExp(i_var_ty, i_var_instDims);
        (txt, a_varUnbox, a_varDecls) = funArgBox(txt, Tpl.textString(txt_1), Tpl.textString(l_arg), Tpl.textString(txt_2), ret_3, a_varUnbox, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls, a_varUnbox) = lm_791(txt, rest, a_varDecls, a_varUnbox);
      then (txt, a_varDecls, a_varUnbox);

    case ( txt,
           _ :: rest,
           a_varDecls,
           a_varUnbox )
      equation
        (txt, a_varDecls, a_varUnbox) = lm_791(txt, rest, a_varDecls, a_varUnbox);
      then (txt, a_varDecls, a_varUnbox);
  end match;
end lm_791;

protected function fun_792
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outvars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outvars)
    local
      Tpl.Text txt;
      SimCode.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_792;

protected function fun_793
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_a_outvars;
  input Tpl.Text in_a_retvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outvars, in_a_retvar)
    local
      Tpl.Text txt;
      Tpl.Text a_retvar;

    case ( txt,
           _ :: _,
           a_retvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, a_retvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_793;

public function functionBodyBoxedImpl
  input Tpl.Text txt;
  input Absyn.Path a_name;
  input list<SimCode.Variable> a_funargs;
  input list<SimCode.Variable> a_outvars;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_prototype;
  list<SimCode.Variable> ret_15;
  Tpl.Text l_0__;
  Tpl.Text l_retvar;
  list<SimCode.Variable> ret_12;
  Tpl.Text l_outputs;
  Tpl.Text l_auxFunctionIgnore;
  Tpl.Text l_varFreesIgnore;
  Tpl.Text l_outputAllocIgnore;
  Tpl.Text l_varBoxIgnore;
  Tpl.Text l_args;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varUnbox;
  Tpl.Text l_varBox;
  Tpl.Text l_varDecls;
  Tpl.Text l_retTypeBoxed;
  Tpl.Text l_fname;
algorithm
  System.tmpTickReset(1);
  System.tmpTickResetIndex(0, 1);
  l_fname := CodegenUtil.underscorePath(Tpl.emptyTxt, a_name);
  l_retTypeBoxed := fun_784(Tpl.emptyTxt, a_outvars);
  l_varDecls := Tpl.emptyTxt;
  l_varBox := Tpl.emptyTxt;
  l_varUnbox := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_args, l_auxFunction, l_varBox, l_varDecls) := lm_785(Tpl.emptyTxt, a_funargs, l_auxFunction, l_varBox, l_varDecls);
  l_varBoxIgnore := Tpl.emptyTxt;
  l_outputAllocIgnore := Tpl.emptyTxt;
  l_varFreesIgnore := Tpl.emptyTxt;
  l_auxFunctionIgnore := Tpl.emptyTxt;
  ret_12 := List.restOrEmpty(a_outvars);
  l_outputs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_outputs, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls) := lm_788(l_outputs, ret_12, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls);
  l_outputs := Tpl.popIter(l_outputs);
  (l_retvar, l_varUnbox, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls) := fun_790(Tpl.emptyTxt, a_outvars, l_varUnbox, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls);
  ret_15 := List.restOrEmpty(a_outvars);
  l_0__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_0__, l_varDecls, l_varUnbox) := lm_791(l_0__, ret_15, l_varDecls, l_varUnbox);
  l_0__ := Tpl.popIter(l_0__);
  l_prototype := functionPrototype(Tpl.emptyTxt, Tpl.textString(l_fname), a_funargs, a_outvars, true);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_prototype);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("{\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := addRootsTempArray(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_varBox);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_792(out_txt, a_outvars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("omc_"));
  out_txt := Tpl.writeText(out_txt, l_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(threadData"));
  out_txt := Tpl.writeText(out_txt, l_args);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(");\n"));
  out_txt := Tpl.writeText(out_txt, l_varUnbox);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_793(out_txt, a_outvars, l_retvar);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionBodyBoxedImpl;

protected function fun_795
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCode.VARIABLE(name = i_name),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5990, 17), "boxRecordConstructor:Unknown variable");
      then (txt, a_auxFunction);
  end match;
end fun_795;

protected function lm_796
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           i_var :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_795(txt, i_var, a_auxFunction);
        (txt, a_auxFunction) = lm_796(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_796;

protected function lm_797
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      SimCode.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgBoxedDefinition(txt, i_var);
        txt = lm_797(txt, rest);
      then txt;
  end match;
end lm_797;

protected function fun_798
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fn;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_fn, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      list<SimCode.Variable> i_funArgs;
      Absyn.Path i_name;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_start;
      Tpl.Text l_funArgsStr;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           SimCode.RECORD_CONSTRUCTOR(name = i_name, funArgs = i_funArgs),
           a_auxFunction )
      equation
        System.tmpTickReset(1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = Tpl.writeText(Tpl.emptyTxt, l_fname);
        l_retType = Tpl.writeTok(l_retType, Tpl.ST_STRING("_rettypeboxed"));
        (l_funArgsStr, a_auxFunction) = lm_796(Tpl.emptyTxt, i_funArgs, a_auxFunction);
        ret_4 = listLength(i_funArgs);
        ret_5 = SimCodeUtil.incrementInt(ret_4, 1);
        l_start = daeExpMetaHelperBoxStart(Tpl.emptyTxt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype boxptr_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = lm_797(txt, i_funArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return mmc_mk_box"));
        txt = Tpl.writeText(txt, l_start);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("3, &"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = Tpl.writeText(txt, l_funArgsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_798;

public function boxRecordConstructor
  input Tpl.Text txt;
  input SimCode.Function a_fn;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_798(txt, a_fn, l_auxFunction);
end boxRecordConstructor;

public function funArgUnbox
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varBox;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varBox;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varBox, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_varDecls, in_a_varBox, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varBox;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.Type i_ty;
      DAE.ComponentRef i_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCode.VARIABLE(name = i_name, ty = i_ty),
           a_varDecls,
           a_varBox,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_name, SimCode.contextFunction, a_auxFunction);
        (txt, a_varBox, a_varDecls) = unboxVariable(txt, Tpl.textString(l_varName), i_ty, a_varBox, a_varDecls);
      then (txt, a_varDecls, a_varBox, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name_1),
           a_varDecls,
           a_varBox,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_varDecls, a_varBox, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_varBox,
           a_auxFunction )
      then (txt, a_varDecls, a_varBox, a_auxFunction);
  end match;
end funArgUnbox;

protected function fun_801
  input Tpl.Text in_txt;
  input DAE.Type in_a_varType;
  input String in_a_varName;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_varType, in_a_varName, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_varName;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type i_varType;
      Tpl.Text l_tmpVar;
      Tpl.Text l_ty;
      Tpl.Text l_shortType;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METATYPE(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METARECORD(utPath = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METALIST(listType = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAARRAY(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAPOLYMORPHIC(name = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAOPTION(optionType = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METATUPLE(types = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METABOXED(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           (i_varType as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls) = unboxRecord(txt, a_varName, i_varType, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*((base_array_t*)"));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           i_varType,
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        l_shortType = mmcTypeShort(Tpl.emptyTxt, i_varType);
        l_ty = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("modelica_"));
        l_ty = Tpl.writeText(l_ty, l_shortType);
        (l_tmpVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmpVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_unbox_"));
        a_preExp = Tpl.writeText(a_preExp, l_shortType);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeStr(a_preExp, a_varName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_801;

public function unboxVariable
  input Tpl.Text txt;
  input String a_varName;
  input DAE.Type a_varType;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) := fun_801(txt, a_varType, a_varName, a_preExp, a_varDecls);
end unboxVariable;

protected function lm_803
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmpVar;
  input String in_a_recordVar;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_tmpVar, in_a_recordVar, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmpVar;
      String a_recordVar;
      Tpl.Text a_varDecls;
      Integer x_offset;
      DAE.Ident i_compname;
      DAE.Type i_ty;
      Tpl.Text l_unboxStr;
      Tpl.Text l_unboxBuf;
      Tpl.Text l_untagTmp;
      Tpl.Text l_varType;

    case ( txt,
           {},
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           DAE.TYPES_VAR(name = i_compname, ty = i_ty) :: rest,
           a_tmpVar,
           a_recordVar,
           a_varDecls )
      equation
        x_offset = Tpl.getIteri_i0(txt);
        l_varType = mmcTypeShort(Tpl.emptyTxt, i_ty);
        (l_untagTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        l_unboxBuf = Tpl.emptyTxt;
        (l_unboxStr, l_unboxBuf, a_varDecls) = unboxVariable(Tpl.emptyTxt, Tpl.textString(l_untagTmp), i_ty, l_unboxBuf, a_varDecls);
        txt = Tpl.writeText(txt, l_untagTmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeStr(txt, a_recordVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeStr(txt, intString(x_offset));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")));\n"));
        txt = Tpl.writeText(txt, l_unboxBuf);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_tmpVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_compname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_unboxStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_803(txt, rest, a_tmpVar, a_recordVar, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _ :: rest,
           a_tmpVar,
           a_recordVar,
           a_varDecls )
      equation
        (txt, a_varDecls) = lm_803(txt, rest, a_tmpVar, a_recordVar, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_803;

protected function fun_804
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_recordVar;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_recordVar, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_recordVar;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      list<DAE.Var> i_vars;
      Absyn.Path i_path;
      Tpl.Text txt_1;
      Tpl.Text l_tmpVar;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_path), varLst = i_vars),
           a_recordVar,
           a_preExp,
           a_varDecls )
      equation
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        (l_tmpVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_preExp = Tpl.pushIter(a_preExp, Tpl.ITER_OPTIONS(2, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_preExp, a_varDecls) = lm_803(a_preExp, i_vars, l_tmpVar, a_recordVar, a_varDecls);
        a_preExp = Tpl.popIter(a_preExp);
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_804;

public function unboxRecord
  input Tpl.Text txt;
  input String a_recordVar;
  input DAE.Type a_ty;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) := fun_804(txt, a_ty, a_recordVar, a_preExp, a_varDecls);
end unboxRecord;

protected function fun_806
  input Tpl.Text in_txt;
  input String in_a_condition;
  input Tpl.Text in_a_constructor;
  input String in_a_outName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_condition, in_a_constructor, in_a_outName)
    local
      Tpl.Text txt;
      Tpl.Text a_constructor;
      String a_outName;
      String i_condition;

    case ( txt,
           "",
           a_constructor,
           a_outName )
      equation
        txt = Tpl.writeStr(txt, a_outName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_constructor);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_condition,
           a_constructor,
           a_outName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, i_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { "));
        txt = Tpl.writeStr(txt, a_outName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_constructor);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_806;

protected function fun_807
  input Tpl.Text in_txt;
  input Tpl.Text in_a_constructorType;
  input String in_a_outName;
  input String in_a_condition;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input String in_a_varName;
  input Tpl.Text in_a_varUnbox;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varUnbox;
algorithm
  (out_txt, out_a_varDecls, out_a_varUnbox) :=
  match(in_txt, in_a_constructorType, in_a_outName, in_a_condition, in_a_varDecls, in_a_ty, in_a_varName, in_a_varUnbox)
    local
      Tpl.Text txt;
      String a_outName;
      String a_condition;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      String a_varName;
      Tpl.Text a_varUnbox;
      Tpl.Text l_constructor;
      String ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           a_varDecls,
           a_ty,
           a_varName,
           a_varUnbox )
      equation
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_STRING("/* skip box "));
        a_varUnbox = Tpl.writeStr(a_varUnbox, a_varName);
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_STRING("; "));
        ret_0 = Types.unparseType(a_ty);
        a_varUnbox = Tpl.writeStr(a_varUnbox, ret_0);
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_STRING(" */"));
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_varDecls, a_varUnbox);

    case ( txt,
           _,
           a_outName,
           a_condition,
           a_varDecls,
           a_ty,
           a_varName,
           a_varUnbox )
      equation
        (l_constructor, a_varUnbox, a_varDecls) = mmcConstructor(Tpl.emptyTxt, a_ty, a_varName, a_varUnbox, a_varDecls);
        a_varUnbox = fun_806(a_varUnbox, a_condition, l_constructor, a_outName);
        txt = Tpl.writeStr(txt, a_outName);
      then (txt, a_varDecls, a_varUnbox);
  end match;
end fun_807;

public function funArgBox
  input Tpl.Text txt;
  input String a_outName;
  input String a_varName;
  input String a_condition;
  input DAE.Type a_ty;
  input Tpl.Text a_varUnbox;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varUnbox;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_constructorType;
algorithm
  l_constructorType := mmcConstructorType(Tpl.emptyTxt, a_ty);
  (out_txt, out_a_varDecls, out_a_varUnbox) := fun_807(txt, l_constructorType, a_outName, a_condition, a_varDecls, a_ty, a_varName, a_varUnbox);
end funArgBox;

public function mmcConstructorType
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end mmcConstructorType;

protected function lm_810
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_preExp;
  input String in_a_varName;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_preExp, in_a_varName, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_preExp;
      String a_varName;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;
      DAE.Ident i_name;
      Tpl.Text l_varname;
      Tpl.Text l_tmp;

    case ( txt,
           {},
           a_preExp,
           _,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.TYPES_VAR(name = i_name, ty = i_ty) :: rest,
           a_preExp,
           a_varName,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        l_varname = Tpl.writeStr(Tpl.emptyTxt, a_varName);
        l_varname = Tpl.writeTok(l_varname, Tpl.ST_STRING("._"));
        l_varname = Tpl.writeStr(l_varname, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls) = funArgBox(txt, Tpl.textString(l_tmp), Tpl.textString(l_varname), "", i_ty, a_preExp, a_varDecls);
        (txt, a_preExp, a_varDecls) = lm_810(txt, rest, a_preExp, a_varName, a_varDecls);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_preExp,
           a_varName,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls) = lm_810(txt, rest, a_preExp, a_varName, a_varDecls);
      then (txt, a_preExp, a_varDecls);
  end match;
end lm_810;

public function mmcConstructor
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_varName;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_type, in_a_varName, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_varName;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Absyn.Path i_path;
      list<DAE.Var> i_vars;
      Tpl.Text l_varsStr;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_varCount;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_rcon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_string("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_modelica_array("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_path), varLst = i_vars),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        ret_1 = listLength(i_vars);
        ret_2 = SimCodeUtil.incrementInt(ret_1, 1);
        l_varCount = daeExpMetaHelperBoxStart(Tpl.emptyTxt, ret_2);
        (l_varsStr, a_preExp, a_varDecls) = lm_810(Tpl.emptyTxt, i_vars, a_preExp, a_varName, a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box"));
        txt = Tpl.writeText(txt, l_varCount);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("3, &"));
        txt = CodegenUtil.underscorePath(txt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = Tpl.writeText(txt, l_varsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);
  end match;
end mmcConstructor;

protected function fun_812
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char**)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_812;

protected function fun_813
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_name;
      DAE.ComponentRef i_cr;
      DAE.Type i_ty;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.VARIABLE(name = i_cr, ty = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_modelica_record(&inArgs, "));
        (txt_0, a_auxFunction) = contextCref(Tpl.emptyTxt, i_cr, SimCode.contextFunction, a_auxFunction);
        txt = readInVarRecordMembers(txt, i_ty, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(name = i_name, ty = (i_ty as DAE.T_STRING(varLst = _))),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_"));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&inArgs, "));
        ret_1 = Config.acceptMetaModelicaGrammar();
        txt = fun_812(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" &"));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(ty = i_ty, name = i_name),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_"));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&inArgs, &"));
        (txt, a_auxFunction) = contextCref(txt, i_name, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_813;

public function readInVar
  input Tpl.Text txt;
  input SimCode.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_813(txt, a_var, l_auxFunction);
end readInVar;

protected function fun_815
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.Ident in_a_subvar_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_subvar_name, in_a_prefix)
    local
      Tpl.Text txt;
      DAE.Ident a_subvar_name;
      String a_prefix;
      DAE.Type i_ty;
      Tpl.Text l_newPrefix;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_subvar_name,
           a_prefix )
      equation
        l_newPrefix = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newPrefix = Tpl.writeTok(l_newPrefix, Tpl.ST_STRING("._"));
        l_newPrefix = Tpl.writeStr(l_newPrefix, a_subvar_name);
        txt = readInVarRecordMembers(txt, i_ty, Tpl.textString(l_newPrefix));
      then txt;

    case ( txt,
           _,
           a_subvar_name,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&("));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_subvar_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_815;

protected function lm_816
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_prefix;
      DAE.Ident i_subvar_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(ty = i_ty, name = i_subvar_name) :: rest,
           a_prefix )
      equation
        txt = fun_815(txt, i_ty, i_subvar_name, a_prefix);
        txt = Tpl.nextIter(txt);
        txt = lm_816(txt, rest, a_prefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_prefix )
      equation
        txt = lm_816(txt, rest, a_prefix);
      then txt;
  end match;
end lm_816;

public function readInVarRecordMembers
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_prefix)
    local
      Tpl.Text txt;
      String a_prefix;
      list<DAE.Var> i_vl;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl),
           a_prefix )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_816(txt, i_vl, a_prefix);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end readInVarRecordMembers;

public function writeOutVar
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      SimCode.Variable i_var;
      DAE.Type i_ty;
      Tpl.Text txt_0;

    case ( txt,
           (i_var as SimCode.VARIABLE(ty = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_record(outVar, "));
        txt_0 = funArgName(Tpl.emptyTxt, i_var);
        txt = writeOutVarRecordMembers(txt, i_ty, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_"));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(outVar, &"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end writeOutVar;

protected function fun_819
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.Ident in_a_subvar_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_subvar_name, in_a_prefix)
    local
      Tpl.Text txt;
      DAE.Ident a_subvar_name;
      String a_prefix;
      DAE.Type i_ty;
      Tpl.Text l_newPrefix;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_subvar_name,
           a_prefix )
      equation
        l_newPrefix = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newPrefix = Tpl.writeTok(l_newPrefix, Tpl.ST_STRING("._"));
        l_newPrefix = Tpl.writeStr(l_newPrefix, a_subvar_name);
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = writeOutVarRecordMembers(txt, i_ty, Tpl.textString(l_newPrefix));
      then txt;

    case ( txt,
           i_ty,
           a_subvar_name,
           a_prefix )
      equation
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &("));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_subvar_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_819;

protected function lm_820
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_prefix;
      DAE.Ident i_subvar_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(ty = i_ty, name = i_subvar_name) :: rest,
           a_prefix )
      equation
        txt = fun_819(txt, i_ty, i_subvar_name, a_prefix);
        txt = Tpl.nextIter(txt);
        txt = lm_820(txt, rest, a_prefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_prefix )
      equation
        txt = lm_820(txt, rest, a_prefix);
      then txt;
  end match;
end lm_820;

protected function fun_821
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args)
    local
      Tpl.Text txt;
      Tpl.Text i_args;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_args )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, i_args);
      then txt;
  end match;
end fun_821;

public function writeOutVarRecordMembers
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_prefix)
    local
      Tpl.Text txt;
      String a_prefix;
      list<DAE.Var> i_vl;
      ClassInf.State i_n;
      Tpl.Text l_args;
      Absyn.Path ret_1;
      Tpl.Text l_basename;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl, complexClassType = i_n),
           a_prefix )
      equation
        ret_1 = ClassInf.getStateName(i_n);
        l_basename = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args = lm_820(l_args, i_vl, a_prefix);
        l_args = Tpl.popIter(l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_basename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = fun_821(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", TYPE_DESC_NONE"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end writeOutVarRecordMembers;

protected function fun_823
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "modelica_metatype" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = NULL"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_823;

protected function fun_824
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Tpl.Text in_a_initVar;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_typ;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outStruct, in_a_initVar, in_a_varName, in_a_typ)
    local
      Tpl.Text txt;
      Tpl.Text a_initVar;
      Tpl.Text a_varName;
      Tpl.Text a_typ;

    case ( txt,
           "",
           a_initVar,
           a_varName,
           a_typ )
      equation
        txt = Tpl.writeText(txt, a_typ);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeText(txt, a_initVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_824;

protected function lm_825
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_825(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_825;

protected function fun_826
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var_value, in_a_varDecls, in_a_varInits, in_a_auxFunction, in_a_var_name)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varDecls,
           a_varInits,
           a_auxFunction,
           a_var_name )
      equation
        (l_defaultValue, a_auxFunction) = contextCref(Tpl.emptyTxt, a_var_name, SimCode.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           _ )
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_826;

protected function fun_827
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varName;
  input String in_a_outStruct;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_a_var_value, in_a_auxFunction, in_a_varInits, in_a_varDecls, in_a_varName, in_a_outStruct, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Tpl.Text a_varName;
      String a_outStruct;
      SimCode.Variable a_var;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(_),
           a_auxFunction,
           a_varInits,
           a_varDecls,
           a_varName,
           a_outStruct,
           a_var )
      equation
        (l_defaultValue, a_varDecls, a_varInits, a_auxFunction) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_auxFunction, a_varInits, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varInits,
           a_varDecls,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varInits, a_varDecls);
  end match;
end fun_827;

protected function fun_828
  input Tpl.Text in_txt;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input String in_a_outStruct;
  input SimCode.Variable in_a_var;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_instDimsInit;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_var_ty, in_a_auxFunction, in_a_varDecls, in_a_outStruct, in_a_var, in_a_var_value, in_a_instDimsInit, in_a_instDims, in_a_varName, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      String a_outStruct;
      SimCode.Variable a_var;
      Option<DAE.Exp> a_var_value;
      Tpl.Text a_instDimsInit;
      list<DAE.Exp> a_instDims;
      Tpl.Text a_varName;
      Tpl.Text a_varInits;
      DAE.Type i_var_ty;
      Tpl.Text l_defaultValue;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           (i_var_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_auxFunction,
           a_varDecls,
           a_outStruct,
           a_var,
           a_var_value,
           a_instDimsInit,
           a_instDims,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_generic_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", sizeof("));
        a_varInits = expTypeShort(a_varInits, i_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("), "));
        ret_0 = listLength(a_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (txt, a_auxFunction, a_varInits, a_varDecls) = fun_827(txt, a_var_value, a_auxFunction, a_varInits, a_varDecls, a_varName, a_outStruct, a_var);
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_var_ty,
           a_auxFunction,
           a_varDecls,
           a_outStruct,
           a_var,
           _,
           a_instDimsInit,
           a_instDims,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, i_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_1 = listLength(a_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_1));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_varDecls, a_varInits, a_auxFunction) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_828;

protected function fun_829
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input String in_a_outStruct;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_instDims, in_a_outStruct, in_a_var, in_a_instDimsInit, in_a_varName, in_a_var_ty, in_a_varDecls, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_var_value)
    local
      Tpl.Text txt;
      String a_outStruct;
      SimCode.Variable a_var;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      list<DAE.Exp> i_instDims;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_var_value )
      equation
        (txt, a_varDecls, a_varInits, a_auxFunction) = fun_826(txt, a_var_value, a_varDecls, a_varInits, a_auxFunction, a_var_name);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           i_instDims,
           a_outStruct,
           a_var,
           a_instDimsInit,
           a_varName,
           a_var_ty,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           _,
           a_var_value )
      equation
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_828(txt, a_var_ty, a_auxFunction, a_varDecls, a_outStruct, a_var, a_var_value, a_instDimsInit, i_instDims, a_varName, a_varInits);
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_829;

public function varInit
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_outStruct;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varFrees, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_varDecls, in_a_varInits, in_a_varFrees, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varFrees;
      Tpl.Text a_auxFunction;
      String i_name;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_var_value;
      list<DAE.Exp> i_instDims;
      SimCode.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName_1;
      String str_3;
      Tpl.Text l_initVar;
      Tpl.Text l_typ;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCode.VARIABLE(parallelism = DAE.NON_PARALLEL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        l_typ = varType(Tpl.emptyTxt, i_var);
        str_3 = Tpl.textString(l_typ);
        l_initVar = fun_823(Tpl.emptyTxt, str_3);
        a_varDecls = fun_824(a_varDecls, a_outStruct, l_initVar, l_varName, l_typ);
        (l_varName_1, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        (a_varInits, a_auxFunction) = initRecordMembers(a_varInits, i_var, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_825(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varDecls, a_varInits, a_auxFunction) = fun_829(txt, i_instDims, a_outStruct, i_var, l_instDimsInit, l_varName_1, i_var_ty, a_varDecls, a_varInits, a_auxFunction, i_var_name, i_var_value);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(name = _)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = parVarInit(txt, i_var, a_outStruct, a_varDecls, a_varInits, a_varFrees, a_auxFunction);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_name),
           _,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("modelica_fnptr _"));
        a_varDecls = Tpl.writeStr(a_varDecls, i_name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6218, 12), "Unknown local variable type");
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);
  end match;
end varInit;

protected function lm_831
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_831(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_831;

protected function fun_832
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_var_value, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCode.Variable a_var;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction) = contextCref(Tpl.emptyTxt, a_var_name, SimCode.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_832;

protected function fun_833
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_varFrees;
  input String in_a_outStruct;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varFrees, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_instDims, in_a_varFrees, in_a_outStruct, in_a_instDimsInit, in_a_var_ty, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls, in_a_var_value)
    local
      Tpl.Text txt;
      Tpl.Text a_varFrees;
      String a_outStruct;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCode.Variable a_var;
      Tpl.Text a_varDecls;
      Option<DAE.Exp> a_var_value;
      list<DAE.Exp> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_0;

    case ( txt,
           {},
           a_varFrees,
           _,
           _,
           _,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls,
           a_var_value )
      equation
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_832(txt, a_var_value, a_varInits, a_auxFunction, a_var_name, a_varName, a_var, a_varDecls);
      then (txt, a_varFrees, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           i_instDims,
           a_varFrees,
           a_outStruct,
           a_instDimsInit,
           a_var_ty,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("device_"));
        a_varDecls = expTypeShort(a_varDecls, a_var_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("_array "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_varDecls, a_varInits, a_auxFunction) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        a_varFrees = Tpl.writeTok(a_varFrees, Tpl.ST_STRING("free_device_array(&"));
        a_varFrees = Tpl.writeText(a_varFrees, a_varName);
        a_varFrees = Tpl.writeTok(a_varFrees, Tpl.ST_STRING(");"));
        a_varFrees = Tpl.writeTok(a_varFrees, Tpl.ST_NEW_LINE());
      then (txt, a_varFrees, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_833;

protected function lm_834
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_834(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_834;

protected function fun_835
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_var_value, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCode.Variable a_var;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction) = contextCref(Tpl.emptyTxt, a_var_name, SimCode.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_835;

protected function fun_836
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input String in_a_outStruct;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_instDims, in_a_outStruct, in_a_instDimsInit, in_a_var_ty, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls, in_a_var_value)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCode.Variable a_var;
      Tpl.Text a_varDecls;
      Option<DAE.Exp> a_var_value;
      list<DAE.Exp> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls,
           a_var_value )
      equation
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_835(txt, a_var_value, a_varInits, a_auxFunction, a_var_name, a_varName, a_var, a_varDecls);
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           i_instDims,
           a_outStruct,
           a_instDimsInit,
           a_var_ty,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("device_local_"));
        a_varDecls = expTypeShort(a_varDecls, a_var_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("_array "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_device_local_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_varDecls, a_varInits, a_auxFunction) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_836;

public function parVarInit
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_outStruct;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varFrees, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_varDecls, in_a_varInits, in_a_varFrees, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varFrees;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      SimCode.Variable i_var;
      Option<DAE.Exp> i_var_value;
      list<DAE.Exp> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCode.VARIABLE(parallelism = DAE.PARGLOBAL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_831(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varFrees, a_varInits, a_auxFunction, a_varDecls) = fun_833(txt, i_instDims, a_varFrees, a_outStruct, l_instDimsInit, i_var_ty, a_varInits, a_auxFunction, i_var_name, l_varName, i_var, a_varDecls, i_var_value);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(parallelism = DAE.PARLOCAL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_834(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_836(txt, i_instDims, a_outStruct, l_instDimsInit, i_var_ty, a_varInits, a_auxFunction, i_var_name, l_varName, i_var, a_varDecls, i_var_value);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("#error Unknown parallel variable type"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6282, 9), "parVarInit:error Unknown parallel variable type");
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);
  end match;
end parVarInit;

protected function fun_838
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_outStruct, in_a_auxFunction, in_a_var_name, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      SimCode.Variable a_var;

    case ( txt,
           "",
           a_auxFunction,
           a_var_name,
           a_var )
      equation
        txt = varType(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCref(txt, a_var_name, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           _,
           _ )
      then (txt, a_auxFunction);
  end match;
end fun_838;

protected function fun_839
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Integer in_a_i;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_outStruct, in_a_i, in_a_auxFunction, in_a_var_name)
    local
      Tpl.Text txt;
      Integer a_i;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      String i_outStruct;

    case ( txt,
           "",
           _,
           a_auxFunction,
           a_var_name )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_var_name, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           i_outStruct,
           a_i,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeStr(txt, i_outStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".targ"));
        txt = Tpl.writeStr(txt, intString(a_i));
      then (txt, a_auxFunction);
  end match;
end fun_839;

protected function lm_840
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_840(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_840;

protected function fun_841
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var_value, in_a_varDecls, in_a_varInits, in_a_auxFunction, in_a_var_name)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varDecls,
           a_varInits,
           a_auxFunction,
           a_var_name )
      equation
        (l_defaultValue, a_auxFunction) = contextCref(Tpl.emptyTxt, a_var_name, SimCode.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           _ )
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_841;

protected function fun_842
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input String in_a_outStruct;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_instDims, in_a_outStruct, in_a_var, in_a_instDimsInit, in_a_varName, in_a_var_ty, in_a_varDecls, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_var_value)
    local
      Tpl.Text txt;
      String a_outStruct;
      SimCode.Variable a_var;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      list<DAE.Exp> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_var_value )
      equation
        (txt, a_varDecls, a_varInits, a_auxFunction) = fun_841(txt, a_var_value, a_varDecls, a_varInits, a_auxFunction, a_var_name);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           i_instDims,
           a_outStruct,
           a_var,
           a_instDimsInit,
           a_varName,
           a_var_ty,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           _,
           _ )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array_c99_"));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_1));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", memory_state);"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_varDecls, a_varInits, a_auxFunction) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_842;

protected function fun_843
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_outStruct;
  input Integer in_a_i;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_i, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_outStruct;
      Integer a_i;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_var_value;
      list<DAE.Exp> i_instDims;
      DAE.ComponentRef i_var_name;
      SimCode.Variable i_var;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_i,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        (a_varDecls, a_auxFunction) = fun_838(a_varDecls, a_outStruct, a_auxFunction, i_var_name, i_var);
        (l_varName, a_auxFunction) = fun_839(Tpl.emptyTxt, a_outStruct, a_i, a_auxFunction, i_var_name);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_840(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varDecls, a_varInits, a_auxFunction) = fun_842(txt, i_instDims, a_outStruct, i_var, l_instDimsInit, l_varName, i_var_ty, a_varDecls, a_varInits, a_auxFunction, i_var_name, i_var_value);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = _),
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("#error Unknown local variable type"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6313, 9), "varInitParallel:error Unknown local variable type");
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_843;

public function varInitParallel
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input String a_outStruct;
  input Integer a_i;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varFrees;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) := fun_843(txt, a_var, a_outStruct, a_i, a_varDecls, a_varInits, a_auxFunction);
  out_a_varFrees := a_varFrees;
end varInitParallel;

protected function fun_845
  input Tpl.Text in_txt;
  input Boolean in_a_arr_scalar;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_arr_scalar, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           _,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = expTypeFromExpModelica(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_845;

protected function lm_846
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_rec__name;
  input Boolean in_a_arr_scalar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_varName, in_a_rec__name, in_a_arr_scalar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_varName;
      Tpl.Text a_rec__name;
      Boolean a_arr_scalar;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_prefix;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_varName,
           a_rec__name,
           a_arr_scalar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_prefix = fun_845(Tpl.emptyTxt, a_arr_scalar, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*(("));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)generic_array_element_addr(&"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), 1, "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))) = "));
        txt = Tpl.writeText(txt, l_prefix);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_846(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_varName, a_rec__name, a_arr_scalar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_846;

protected function fun_847
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input DAE.ComponentRef in_a_var_name;
  input String in_a_lhsVarName;
  input Tpl.Text in_a_auxFunction;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varInits, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_value, in_a_varInits, in_a_varDecls, in_a_var_name, in_a_lhsVarName, in_a_auxFunction, in_a_var_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      DAE.ComponentRef a_var_name;
      String a_lhsVarName;
      Tpl.Text a_auxFunction;
      DAE.Type a_var_ty;
      DAE.Exp i_exp;
      DAE.Exp i_arr;
      Boolean i_arr_scalar;
      list<DAE.Exp> i_arr_array;
      ClassInf.State i_record__state;
      DAE.ComponentRef i_cr;
      Tpl.Text l_arrayExp;
      Tpl.Text l_params;
      Tpl.Text l_preExp;
      Absyn.Path ret_2;
      Tpl.Text l_rec__name;
      Tpl.Text l_varName;

    case ( txt,
           SOME(DAE.CREF(componentRef = i_cr)),
           a_varInits,
           a_varDecls,
           _,
           a_lhsVarName,
           a_auxFunction,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_data("));
        (txt, a_auxFunction) = contextCref(txt, i_cr, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_varDecls, a_auxFunction);

    case ( txt,
           SOME(DAE.ARRAY(ty = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), array = i_arr_array, scalar = i_arr_scalar)),
           a_varInits,
           a_varDecls,
           a_var_name,
           _,
           a_auxFunction,
           _ )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, a_var_name, SimCode.contextFunction, a_auxFunction);
        ret_2 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        l_preExp = Tpl.emptyTxt;
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_auxFunction, a_varDecls, l_preExp) = lm_846(l_params, i_arr_array, a_auxFunction, a_varDecls, l_preExp, l_varName, l_rec__name, i_arr_scalar);
        l_params = Tpl.popIter(l_params);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_params);
      then (txt, a_varInits, a_varDecls, a_auxFunction);

    case ( txt,
           SOME((i_arr as DAE.ARRAY(ty = _))),
           a_varInits,
           a_varDecls,
           _,
           a_lhsVarName,
           a_auxFunction,
           a_var_ty )
      equation
        (l_arrayExp, a_varInits, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_arr, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_data("));
        txt = Tpl.writeText(txt, l_arrayExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_varDecls, a_auxFunction);

    case ( txt,
           SOME(i_exp),
           a_varInits,
           a_varDecls,
           _,
           a_lhsVarName,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varInits,
           a_varDecls,
           _,
           _,
           a_auxFunction,
           _ )
      then (txt, a_varInits, a_varDecls, a_auxFunction);
  end match;
end fun_847;

protected function fun_848
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_lhsVarName;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_lhsVarName, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_lhsVarName;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_var_name;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_value;

    case ( txt,
           SimCode.VARIABLE(value = i_value, ty = i_var_ty, name = i_var_name),
           a_lhsVarName,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = fun_847(txt, i_value, a_varInits, a_varDecls, i_var_name, a_lhsVarName, a_auxFunction, i_var_ty);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_848;

public function varDefaultValue
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input String a_outStruct;
  input String a_lhsVarName;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) := fun_848(txt, a_var, a_lhsVarName, a_varDecls, a_varInits, a_auxFunction);
end varDefaultValue;

protected function fun_850
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.FUNCTION_PTR(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_fnptr)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_850;

public function varOutput
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input Tpl.Text a_varAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
protected
  Tpl.Text l_cast;
algorithm
  l_cast := fun_850(Tpl.emptyTxt, a_var);
  out_a_varAssign := Tpl.writeTok(a_varAssign, Tpl.ST_STRING("if (out"));
  out_a_varAssign := funArgName(out_a_varAssign, a_var);
  out_a_varAssign := Tpl.writeTok(out_a_varAssign, Tpl.ST_STRING(") { *out"));
  out_a_varAssign := funArgName(out_a_varAssign, a_var);
  out_a_varAssign := Tpl.writeTok(out_a_varAssign, Tpl.ST_STRING(" = "));
  out_a_varAssign := Tpl.writeText(out_a_varAssign, l_cast);
  out_a_varAssign := funArgName(out_a_varAssign, a_var);
  out_a_varAssign := Tpl.writeTok(out_a_varAssign, Tpl.ST_STRING("; }"));
  out_a_varAssign := Tpl.writeTok(out_a_varAssign, Tpl.ST_NEW_LINE());
  out_txt := txt;
end varOutput;

protected function fun_852
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_varCopy;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varCopy;
algorithm
  (out_txt, out_a_varAssign, out_a_varCopy) :=
  match(in_txt, in_mArg, in_a_varAssign, in_a_varCopy)
    local
      Tpl.Text txt;
      Tpl.Text a_varAssign;
      Tpl.Text a_varCopy;

    case ( txt,
           false,
           a_varAssign,
           a_varCopy )
      equation
        a_varCopy = Tpl.writeTok(a_varCopy, Tpl.ST_STRING("String Variables not Allowed in ParModelica."));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("   String Variables not Allowed in ParModelica."));
      then (txt, a_varAssign, a_varCopy);

    case ( txt,
           _,
           a_varAssign,
           a_varCopy )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("How did you get here??"));
      then (txt, a_varAssign, a_varCopy);
  end match;
end fun_852;

protected function lm_853
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_853(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_853;

protected function fun_854
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varAssign;
  input DAE.Type in_a_var_ty;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varAssign, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_auxFunction, in_a_var_name, in_a_varAssign, in_a_var_ty, in_a_ix, in_a_dest, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varAssign;
      DAE.Type a_var_ty;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varInits;
      list<DAE.Exp> i_instDims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_var_name,
           a_varAssign,
           a_var_ty,
           a_ix,
           a_dest,
           a_varInits )
      equation
        a_varInits = Tpl.writeStr(a_varInits, a_dest);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(".c"));
        a_varInits = Tpl.writeStr(a_varInits, intString(a_ix));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(" = ocl_device_alloc(sizeof(modelica_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("));"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("copy_assignment_helper_"));
        a_varAssign = expTypeShort(a_varAssign, a_var_ty);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("(&"));
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(", &"));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_auxFunction,
           a_var_name,
           a_varAssign,
           a_var_ty,
           a_ix,
           a_dest,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array_c99_"));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("(&"));
        a_varInits = Tpl.writeStr(a_varInits, a_dest);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(".c"));
        a_varInits = Tpl.writeStr(a_varInits, intString(a_ix));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_1));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", memory_state);"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("copy_"));
        a_varAssign = expTypeShort(a_varAssign, a_var_ty);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("_array_data("));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(", &"));
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);
  end match;
end fun_854;

protected function lm_855
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_855(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_855;

protected function fun_856
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varAssign;
  input DAE.Type in_a_var_ty;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varAssign, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_auxFunction, in_a_var_name, in_a_varAssign, in_a_var_ty, in_a_ix, in_a_dest, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varAssign;
      DAE.Type a_var_ty;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varInits;
      list<DAE.Exp> i_instDims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_var_name,
           a_varAssign,
           a_var_ty,
           a_ix,
           a_dest,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("LOCAL HERE!! "));
        a_varInits = Tpl.writeStr(a_varInits, a_dest);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(".c"));
        a_varInits = Tpl.writeStr(a_varInits, intString(a_ix));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(" = ocl_device_alloc(sizeof(modelica_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("));"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("LOCAL HERE!! copy_assignment_helper_"));
        a_varAssign = expTypeShort(a_varAssign, a_var_ty);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("(&"));
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(", &"));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_auxFunction,
           a_var_name,
           a_varAssign,
           a_var_ty,
           a_ix,
           a_dest,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array_c99_"));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("(&"));
        a_varInits = Tpl.writeStr(a_varInits, a_dest);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(".c"));
        a_varInits = Tpl.writeStr(a_varInits, intString(a_ix));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_1));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", memory_state);"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("copy_"));
        a_varAssign = expTypeShort(a_varAssign, a_var_ty);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("_array_data("));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(", &"));
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);
  end match;
end fun_856;

protected function lm_857
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_857(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_857;

protected function fun_858
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input DAE.ComponentRef in_a_var_name;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_varAssign, out_a_auxFunction, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty, in_a_var_name, in_a_ix, in_a_dest, in_a_varAssign, in_a_auxFunction, in_a_var, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      DAE.ComponentRef a_var_name;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      Tpl.Text a_auxFunction;
      SimCode.Variable a_var;
      Tpl.Text a_varInits;
      list<DAE.Exp> i_instDims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_auxFunction,
           a_var,
           a_varInits )
      equation
        (a_varInits, a_auxFunction) = initRecordMembers(a_varInits, a_var, a_auxFunction);
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_auxFunction, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_auxFunction,
           _,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array_c99_"));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("(&"));
        a_varInits = Tpl.writeStr(a_varInits, a_dest);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(".c"));
        a_varInits = Tpl.writeStr(a_varInits, intString(a_ix));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_1));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", memory_state);"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("copy_"));
        a_varAssign = expTypeShort(a_varAssign, a_var_ty);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("_array_data("));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(", &"));
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_auxFunction, a_varInits);
  end match;
end fun_858;

public function varOutputParallel
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_dest;
  input Integer in_a_ix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varCopy;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varCopy, out_a_varAssign, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_dest, in_a_ix, in_a_varDecls, in_a_varInits, in_a_varCopy, in_a_varAssign, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_dest;
      Integer a_ix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varCopy;
      Tpl.Text a_varAssign;
      Tpl.Text a_auxFunction;
      String i_var_name_1;
      SimCode.Variable i_var;
      DAE.ComponentRef i_var_name;
      DAE.Type i_var_ty;
      list<DAE.Exp> i_instDims;
      Tpl.Text l_instDimsInit;
      Boolean ret_0;

    case ( txt,
           SimCode.VARIABLE(ty = DAE.T_STRING(varLst = _)),
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varCopy,
           a_varAssign,
           a_auxFunction )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        (txt, a_varAssign, a_varCopy) = fun_852(txt, ret_0, a_varAssign, a_varCopy);
      then (txt, a_varDecls, a_varInits, a_varCopy, a_varAssign, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(parallelism = DAE.PARGLOBAL(), instDims = i_instDims, ty = i_var_ty, name = i_var_name),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varCopy,
           a_varAssign,
           a_auxFunction )
      equation
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_853(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_auxFunction, a_varAssign, a_varInits) = fun_854(txt, i_instDims, l_instDimsInit, a_auxFunction, i_var_name, a_varAssign, i_var_ty, a_ix, a_dest, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varCopy, a_varAssign, a_auxFunction);

    case ( txt,
           SimCode.VARIABLE(parallelism = DAE.PARLOCAL(), instDims = i_instDims, ty = i_var_ty, name = i_var_name),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varCopy,
           a_varAssign,
           a_auxFunction )
      equation
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_855(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_auxFunction, a_varAssign, a_varInits) = fun_856(txt, i_instDims, l_instDimsInit, a_auxFunction, i_var_name, a_varAssign, i_var_ty, a_ix, a_dest, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varCopy, a_varAssign, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(instDims = i_instDims, name = i_var_name, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varCopy,
           a_varAssign,
           a_auxFunction )
      equation
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_857(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varAssign, a_auxFunction, a_varInits) = fun_858(txt, i_instDims, l_instDimsInit, i_var_ty, i_var_name, a_ix, a_dest, a_varAssign, a_auxFunction, i_var, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varCopy, a_varAssign, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_var_name_1),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varCopy,
           a_varAssign,
           a_auxFunction )
      equation
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = (modelica_fnptr) _"));
        a_varAssign = Tpl.writeStr(a_varAssign, i_var_name_1);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_varInits, a_varCopy, a_varAssign, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varCopy,
           a_varAssign,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_varCopy, a_varAssign, a_auxFunction);
  end match;
end varOutputParallel;

protected function lm_860
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_860(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_860;

protected function fun_861
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varAssign, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_auxFunction, in_a_var_name, in_a_ix, in_a_dest, in_a_varAssign, in_a_var_ty, in_a_varName, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      DAE.Type a_var_ty;
      Tpl.Text a_varName;
      Tpl.Text a_varInits;
      list<DAE.Exp> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(" = ocl_device_alloc(sizeof(modelica_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("));"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_auxFunction,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);
  end match;
end fun_861;

protected function lm_862
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_862(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_862;

protected function fun_863
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varAssign, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_auxFunction, in_a_var_name, in_a_ix, in_a_dest, in_a_varAssign, in_a_var_ty, in_a_varName, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      DAE.Type a_var_ty;
      Tpl.Text a_varName;
      Tpl.Text a_varInits;
      list<DAE.Exp> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(" = ocl_device_alloc(sizeof(modelica_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("));"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_auxFunction,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varAssign, a_varInits);
  end match;
end fun_863;

protected function lm_864
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_864(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_864;

protected function fun_865
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input DAE.ComponentRef in_a_var_name;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_varAssign, out_a_auxFunction, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_varName, in_a_var_ty, in_a_var_name, in_a_ix, in_a_dest, in_a_varAssign, in_a_auxFunction, in_a_var, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      DAE.ComponentRef a_var_name;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      Tpl.Text a_auxFunction;
      SimCode.Variable a_var;
      Tpl.Text a_varInits;
      list<DAE.Exp> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_auxFunction,
           a_var,
           a_varInits )
      equation
        (a_varInits, a_auxFunction) = initRecordMembers(a_varInits, a_var, a_auxFunction);
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_auxFunction, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_varName,
           a_var_ty,
           a_var_name,
           a_ix,
           a_dest,
           a_varAssign,
           a_auxFunction,
           _,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        (a_varAssign, a_auxFunction) = contextCref(a_varAssign, a_var_name, SimCode.contextFunction, a_auxFunction);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_auxFunction, a_varInits);
  end match;
end fun_865;

protected function fun_866
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input String in_a_dest;
  input Integer in_a_ix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varAssign, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_dest, in_a_ix, in_a_varDecls, in_a_varInits, in_a_varAssign, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_dest;
      Integer a_ix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varAssign;
      Tpl.Text a_auxFunction;
      String i_var_name_1;
      DAE.Type i_var_ty;
      list<DAE.Exp> i_instDims;
      DAE.ComponentRef i_var_name;
      SimCode.Variable i_var;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCode.VARIABLE(parallelism = DAE.PARGLOBAL(), name = i_var_name, instDims = i_instDims, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        (a_varDecls, a_auxFunction) = contextCref(a_varDecls, i_var_name, SimCode.contextFunction, a_auxFunction);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_860(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_auxFunction, a_varAssign, a_varInits) = fun_861(txt, i_instDims, l_instDimsInit, a_auxFunction, i_var_name, a_ix, a_dest, a_varAssign, i_var_ty, l_varName, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(parallelism = DAE.PARLOCAL(), name = i_var_name, instDims = i_instDims, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        (a_varDecls, a_auxFunction) = contextCref(a_varDecls, i_var_name, SimCode.contextFunction, a_auxFunction);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_862(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_auxFunction, a_varAssign, a_varInits) = fun_863(txt, i_instDims, l_instDimsInit, a_auxFunction, i_var_name, a_ix, a_dest, a_varAssign, i_var_ty, l_varName, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        (a_varDecls, a_auxFunction) = contextCref(a_varDecls, i_var_name, SimCode.contextFunction, a_auxFunction);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_var_name, SimCode.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_864(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varAssign, a_auxFunction, a_varInits) = fun_865(txt, i_instDims, l_instDimsInit, l_varName, i_var_ty, i_var_name, a_ix, a_dest, a_varAssign, a_auxFunction, i_var, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           SimCode.FUNCTION_PTR(name = i_var_name_1),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = (modelica_fnptr) _"));
        a_varAssign = Tpl.writeStr(a_varAssign, i_var_name_1);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);
  end match;
end fun_866;

public function varOutputKernelInterface
  input Tpl.Text txt;
  input SimCode.Variable a_var;
  input String a_dest;
  input Integer a_ix;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varCopy;
  input Tpl.Text a_varAssign;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varAssign, out_a_auxFunction) := fun_866(txt, a_var, a_dest, a_ix, a_varDecls, a_varInits, a_varAssign, a_auxFunction);
  out_a_varCopy := a_varCopy;
end varOutputKernelInterface;

protected function lm_868
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varName;
algorithm
  (out_txt, out_a_varName) :=
  match(in_txt, in_items, in_a_varName)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_varName;
      DAE.Var i_v;

    case ( txt,
           {},
           a_varName )
      then (txt, a_varName);

    case ( txt,
           i_v :: rest,
           a_varName )
      equation
        (txt, a_varName) = recordMemberInit(txt, i_v, a_varName);
        txt = Tpl.nextIter(txt);
        (txt, a_varName) = lm_868(txt, rest, a_varName);
      then (txt, a_varName);
  end match;
end lm_868;

public function initRecordMembers
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      list<DAE.Var> i_ty_varLst;
      DAE.ComponentRef i_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCode.VARIABLE(ty = DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _), varLst = i_ty_varLst), name = i_name),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCref(Tpl.emptyTxt, i_name, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, l_varName) = lm_868(txt, i_ty_varLst, l_varName);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end initRecordMembers;

protected function lm_870
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_870(txt, rest);
      then txt;
  end match;
end lm_870;

protected function fun_871
  input Tpl.Text in_txt;
  input DAE.Var in_a_v;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_v, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Ident i_name;
      DAE.Dimensions i_ty_dims;
      DAE.Type i_ty;
      Integer ret_2;
      Tpl.Text l_dims;
      Tpl.Text l_arrayType;

    case ( txt,
           DAE.TYPES_VAR(ty = (i_ty as DAE.T_ARRAY(dims = i_ty_dims)), name = i_name),
           a_varName )
      equation
        l_arrayType = expType(Tpl.emptyTxt, i_ty, true);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_870(l_dims, i_ty_dims);
        l_dims = Tpl.popIter(l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_"));
        txt = Tpl.writeText(txt, l_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_2 = listLength(i_ty_dims);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_871;

public function recordMemberInit
  input Tpl.Text txt;
  input DAE.Var a_v;
  input Tpl.Text a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varName;
algorithm
  out_txt := fun_871(txt, a_v, a_varName);
  out_a_varName := a_varName;
end recordMemberInit;

public function extVarName
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  DAE.ComponentRef ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("_"));
  ret_0 := ComponentReference.appendStringFirstIdent("_ext", a_cr);
  out_txt := crefToMStr(out_txt, ret_0);
end extVarName;

protected function fun_874
  input Tpl.Text in_txt;
  input String in_a_language;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Function in_a_fun;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_language, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_fun)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Function a_fun;

    case ( txt,
           "C",
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallC(txt, a_fun, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           "FORTRAN 77",
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallF77(txt, a_fun, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_874;

public function extFunCall
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.Function i_fun;
      String i_language;

    case ( txt,
           (i_fun as SimCode.EXTERNAL_FUNCTION(language = i_language)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_874(txt, i_language, a_auxFunction, a_varDecls, a_preExp, i_fun);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCall;

protected function lm_876
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardecl(txt, i_arg, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_876(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_876;

protected function lm_877
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Variable i_bivar;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_bivar :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallBiVar(txt, i_bivar, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_877(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_877;

protected function fun_878
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;

    case ( txt,
           false,
           _,
           a_extName )
      equation
        txt = Tpl.writeStr(txt, a_extName);
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ptr_"));
        txt = extFunctionName(txt, a_extName, a_language);
      then txt;
  end match;
end fun_878;

protected function fun_879
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;
  input Absyn.Info in_a_info;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName, in_a_info, in_a_fname)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;
      Absyn.Info a_info;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName,
           a_info,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "==NULL)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_terminate(info, \"dynamic external function "
                                }, false));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" not set!\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} else"));
      then txt;
  end match;
end fun_879;

protected function lm_880
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extArg(txt, i_arg, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_880(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_880;

protected function fun_881
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extReturn)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c) )
      equation
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_881;

protected function fun_882
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCode.SIMEXTARG(cref = _)),
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardecl(txt, i_extReturn, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_882;

protected function lm_883
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           i_arg :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopy(txt, i_arg, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_883(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_883;

protected function fun_884
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCode.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCode.SIMEXTARG(cref = _)),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopy(txt, i_extReturn, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_884;

public function extFunCallC
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimExtArg i_extReturn;
      Absyn.Info i_info;
      String i_language;
      String i_extName;
      Boolean i_dynamicLoad;
      list<SimCode.Variable> i_biVars;
      list<SimCode.SimExtArg> i_extArgs;
      Tpl.Text l_returnAssign;
      Tpl.Text l_args;
      Tpl.Text l_dynamicCheck;
      Tpl.Text l_fname;
      Tpl.Text l_0__;
      list<SimCode.SimExtArg> ret_1;
      Tpl.Text l_varDecs;

    case ( txt,
           SimCode.EXTERNAL_FUNCTION(extArgs = i_extArgs, biVars = i_biVars, dynamicLoad = i_dynamicLoad, extName = i_extName, language = i_language, info = i_info, extReturn = i_extReturn),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = List.union(i_extArgs, i_extArgs);
        l_varDecs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_varDecs, a_auxFunction, a_varDecls) = lm_876(l_varDecs, ret_1, a_auxFunction, a_varDecls);
        l_varDecs = Tpl.popIter(l_varDecs);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, a_auxFunction, a_varDecls, a_preExp) = lm_877(l_0__, i_biVars, a_auxFunction, a_varDecls, a_preExp);
        l_0__ = Tpl.popIter(l_0__);
        l_fname = fun_878(Tpl.emptyTxt, i_dynamicLoad, i_language, i_extName);
        l_dynamicCheck = fun_879(Tpl.emptyTxt, i_dynamicLoad, i_language, i_extName, i_info, l_fname);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_auxFunction, a_varDecls, a_preExp) = lm_880(l_args, i_extArgs, a_auxFunction, a_varDecls, a_preExp);
        l_args = Tpl.popIter(l_args);
        l_returnAssign = fun_881(Tpl.emptyTxt, i_extReturn);
        txt = Tpl.writeText(txt, l_varDecs);
        txt = Tpl.softNewLine(txt);
        (txt, a_auxFunction, a_varDecls) = fun_882(txt, i_extReturn, a_auxFunction, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_dynamicCheck);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_returnAssign);
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction) = lm_883(txt, i_extArgs, a_auxFunction);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        (txt, a_auxFunction) = fun_884(txt, i_extReturn, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallC;

protected function lm_886
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardeclF77(txt, i_arg, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_886(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_886;

protected function lm_887
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Variable i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallBiVarF77(txt, i_arg, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_887(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_887;

protected function lm_888
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extArgF77(txt, i_arg, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_888(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_888;

protected function fun_889
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extReturn)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c) )
      equation
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_889;

protected function fun_890
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCode.SIMEXTARG(cref = _)),
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardeclF77(txt, i_extReturn, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_890;

protected function lm_891
  input Tpl.Text in_txt;
  input list<SimCode.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCode.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      SimCode.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           i_arg :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopyF77(txt, i_arg, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_891(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_891;

protected function fun_892
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCode.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCode.SIMEXTARG(cref = _)),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopyF77(txt, i_extReturn, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_892;

public function extFunCallF77
  input Tpl.Text in_txt;
  input SimCode.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      String i_extName;
      SimCode.SimExtArg i_extReturn;
      list<SimCode.Variable> i_biVars;
      list<SimCode.SimExtArg> i_extArgs;
      list<SimCode.SimExtArg> ret_5;
      Tpl.Text l_returnAssign;
      Tpl.Text l_args;
      Tpl.Text l_biVarDecs;
      list<SimCode.SimExtArg> ret_1;
      Tpl.Text l_varDecs;

    case ( txt,
           SimCode.EXTERNAL_FUNCTION(extArgs = i_extArgs, biVars = i_biVars, extReturn = i_extReturn, extName = i_extName),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("/* extFunCallF77: varDecs */"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        ret_1 = List.union(i_extArgs, i_extArgs);
        l_varDecs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_varDecs, a_auxFunction, a_varDecls) = lm_886(l_varDecs, ret_1, a_auxFunction, a_varDecls);
        l_varDecs = Tpl.popIter(l_varDecs);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("/* extFunCallF77: biVarDecs */"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* extFunCallF77: biVarDecs */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_biVarDecs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_biVarDecs, a_auxFunction, a_varDecls, a_preExp) = lm_887(l_biVarDecs, i_biVars, a_auxFunction, a_varDecls, a_preExp);
        l_biVarDecs = Tpl.popIter(l_biVarDecs);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("/* extFunCallF77: args */"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* extFunCallF77: args */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_auxFunction, a_varDecls, a_preExp) = lm_888(l_args, i_extArgs, a_auxFunction, a_varDecls, a_preExp);
        l_args = Tpl.popIter(l_args);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* extFunCallF77: end args */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_returnAssign = fun_889(Tpl.emptyTxt, i_extReturn);
        txt = Tpl.writeText(txt, l_varDecs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_biVarDecs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extFunCallF77: extReturn */\n"));
        (txt, a_auxFunction, a_varDecls) = fun_890(txt, i_extReturn, a_auxFunction, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extFunCallF77: CALL */\n"));
        txt = Tpl.writeText(txt, l_returnAssign);
        txt = Tpl.writeStr(txt, i_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/* extFunCallF77: copy args */\n"
                                }, true));
        ret_5 = List.union(i_extArgs, i_extArgs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction) = lm_891(txt, ret_5, a_auxFunction);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extFunCallF77: copy return */\n"));
        (txt, a_auxFunction) = fun_892(txt, i_extReturn, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallF77;

protected function fun_894
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;

    case ( txt,
           "integer",
           a_auxFunction,
           a_c )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pack_integer_array(&"));
        (txt, a_auxFunction) = contextCref(txt, a_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);
  end match;
end fun_894;

protected function fun_895
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_c;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_c, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Tpl.Text a_varDecls;
      DAE.Ident i_ident;
      DAE.ComponentRef i_c;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           (i_c as DAE.CREF_IDENT(ident = i_ident)),
           _,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("modelica_fnptr "));
        a_varDecls = extVarName(a_varDecls, i_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "), 2))) {\n",
                                    "  MMC_THROW_INTERNAL(); /* The FFI does not allow closures */\n",
                                    "}\n"
                                }, true));
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), 1));"));
      then (txt, a_varDecls);

    case ( txt,
           i_c,
           a_ty,
           a_varDecls )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Got function pointer that is not a CREF_IDENT: "));
        txt_0 = CodegenUtil.crefStr(txt_0, i_c);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(", "));
        ret_0 = Types.unparseType(a_ty);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6594, 15), Tpl.textString(txt_0));
      then (txt, a_varDecls);
  end match;
end fun_895;

protected function fun_896
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_auxFunction, in_a_varDecls, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.ComponentRef a_c;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_ty as DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           a_auxFunction,
           a_varDecls,
           a_c )
      equation
        (txt, a_varDecls) = fun_895(txt, a_c, i_ty, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_ty,
           a_auxFunction,
           a_varDecls,
           a_c )
      equation
        a_varDecls = extType(a_varDecls, i_ty, true, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = extVarName(txt, a_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = extType(txt, i_ty, true, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        (txt, a_auxFunction) = contextCref(txt, a_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_896;

protected function fun_897
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input DAE.ComponentRef in_a_c;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_oi, in_a_c, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      DAE.Type a_ty;
      Tpl.Text a_varDecls;

    case ( txt,
           0,
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_c,
           a_ty,
           a_varDecls )
      equation
        a_varDecls = extType(a_varDecls, a_ty, true, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls);
  end match;
end fun_897;

public function extFunCallVardecl
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_arg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_ty;
      String str_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.SIMEXTARG(isInput = true, isArray = true, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        txt_0 = expTypeShort(Tpl.emptyTxt, i_ty);
        str_1 = Tpl.textString(txt_0);
        (txt, a_auxFunction) = fun_894(txt, str_1, a_auxFunction, i_c);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(isInput = true, isArray = false, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_896(txt, i_ty, a_auxFunction, a_varDecls, i_c);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(outputIndex = i_oi, isArray = false, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls) = fun_897(txt, i_oi, i_c, i_ty, a_varDecls);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end extFunCallVardecl;

protected function fun_899
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_default__val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_default__val)
    local
      Tpl.Text txt;
      Tpl.Text a_default__val;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_default__val )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= "));
        txt = Tpl.writeText(txt, a_default__val);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_899;

protected function fun_900
  input Tpl.Text in_txt;
  input Boolean in_a_ea_hasBinding;
  input Tpl.Text in_a_default__val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ea_hasBinding, in_a_default__val)
    local
      Tpl.Text txt;
      Tpl.Text a_default__val;
      String str_0;

    case ( txt,
           false,
           a_default__val )
      equation
        str_0 = Tpl.textString(a_default__val);
        txt = fun_899(txt, str_0, a_default__val);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_900;

protected function fun_901
  input Tpl.Text in_txt;
  input Boolean in_a_ia;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_ea_hasBinding;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_ia, in_a_auxFunction, in_a_c, in_a_varDecls, in_a_ea_hasBinding, in_a_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text a_varDecls;
      Boolean a_ea_hasBinding;
      DAE.Type a_ty;
      Tpl.Text l_default__exp;
      Tpl.Text l_default__val;

    case ( txt,
           false,
           a_auxFunction,
           a_c,
           a_varDecls,
           a_ea_hasBinding,
           a_ty )
      equation
        l_default__val = typeDefaultValue(Tpl.emptyTxt, a_ty);
        l_default__exp = fun_900(Tpl.emptyTxt, a_ea_hasBinding, l_default__val);
        a_varDecls = extTypeF77(a_varDecls, a_ty, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeText(a_varDecls, l_default__exp);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_c,
           a_varDecls,
           _,
           a_ty )
      equation
        a_varDecls = expTypeArrayIf(a_varDecls, a_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convert_alloc_"));
        txt = expTypeArray(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_to_f77(&"));
        (txt, a_auxFunction) = contextCref(txt, a_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = extVarName(txt, a_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_901;

protected function fun_902
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_ea_hasBinding;
  input DAE.Type in_a_ty;
  input Boolean in_a_ia;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_oi, in_a_auxFunction, in_a_c, in_a_varDecls, in_a_ea_hasBinding, in_a_ty, in_a_ia)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text a_varDecls;
      Boolean a_ea_hasBinding;
      DAE.Type a_ty;
      Boolean a_ia;

    case ( txt,
           0,
           a_auxFunction,
           _,
           a_varDecls,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_c,
           a_varDecls,
           a_ea_hasBinding,
           a_ty,
           a_ia )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_901(txt, a_ia, a_auxFunction, a_c, a_varDecls, a_ea_hasBinding, a_ty);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_902;

public function extFunCallVardeclF77
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_arg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean i_ea_hasBinding;
      Boolean i_ia;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_ty;

    case ( txt,
           SimCode.SIMEXTARG(isInput = true, isArray = true, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        a_varDecls = expTypeArrayIf(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, i_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convert_alloc_"));
        txt = expTypeArray(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_to_f77(&"));
        (txt, a_auxFunction) = contextCref(txt, i_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(outputIndex = i_oi, isArray = i_ia, type_ = i_ty, cref = i_c, hasBinding = i_ea_hasBinding),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_902(txt, i_oi, a_auxFunction, i_c, a_varDecls, i_ea_hasBinding, i_ty, i_ia);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        a_varDecls = extTypeF77(a_varDecls, i_ty, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, i_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end extFunCallVardeclF77;

public function typeDefaultValue
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0.0"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end typeDefaultValue;

protected function fun_905
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_value, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_v, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_905;

protected function fun_906
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name )
      equation
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_906;

public function extFunCallBiVar
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<DAE.Exp> i_value;
      SimCode.Variable i_var;
      DAE.ComponentRef i_name;
      Tpl.Text l_defaultValue;
      Tpl.Text l_var__name;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_name, value = i_value)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_var__name = extVarName(Tpl.emptyTxt, i_name);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_var__name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction, a_varDecls, a_preExp) = fun_905(Tpl.emptyTxt, i_value, a_auxFunction, a_varDecls, a_preExp);
        a_preExp = fun_906(a_preExp, l_defaultValue, l_var__name);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallBiVar;

protected function fun_908
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_value, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_v, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_908;

protected function lm_909
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_909(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_909;

protected function fun_910
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name )
      equation
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_910;

protected function fun_911
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text a_type;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_911;

protected function fun_912
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input DAE.ComponentRef in_a_name;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_instDims, in_a_name, in_a_instDimsInit, in_a_var_ty, in_a_var__name, in_a_defaultValue, in_a_preExp)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_var__name;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preExp;
      list<DAE.Exp> i_instDims;
      Integer ret_1;
      Tpl.Text l_type;

    case ( txt,
           {},
           _,
           _,
           _,
           a_var__name,
           a_defaultValue,
           a_preExp )
      equation
        a_preExp = fun_910(a_preExp, a_defaultValue, a_var__name);
      then (txt, a_preExp);

    case ( txt,
           i_instDims,
           a_name,
           a_instDimsInit,
           a_var_ty,
           a_var__name,
           a_defaultValue,
           a_preExp )
      equation
        l_type = expTypeArray(Tpl.emptyTxt, a_var_ty);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, a_var__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_1));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_instDimsInit);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = fun_911(a_preExp, a_defaultValue, a_var__name, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("convert_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_f77(&"));
        a_preExp = Tpl.writeText(a_preExp, a_var__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = extVarName(a_preExp, a_name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp);
  end match;
end fun_912;

public function extFunCallBiVarF77
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      list<DAE.Exp> i_instDims;
      Option<DAE.Exp> i_value;
      SimCode.Variable i_var;
      DAE.ComponentRef i_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_defaultValue;
      Tpl.Text l_var__name;

    case ( txt,
           (i_var as SimCode.VARIABLE(name = i_name, value = i_value, instDims = i_instDims, ty = i_var_ty)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var__name, a_auxFunction) = contextCref(Tpl.emptyTxt, i_name, SimCode.contextFunction, a_auxFunction);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_var__name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, i_name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction, a_varDecls, a_preExp) = fun_908(Tpl.emptyTxt, i_value, a_auxFunction, a_varDecls, a_preExp);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_preExp) = lm_909(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_preExp);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_preExp) = fun_912(txt, i_instDims, i_name, l_instDimsInit, i_var_ty, l_var__name, l_defaultValue, a_preExp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallBiVarF77;

protected function fun_914
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;

    case ( txt,
           "integer",
           a_auxFunction,
           a_c )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unpack_integer_array(&"));
        (txt, a_auxFunction) = contextCref(txt, a_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);
  end match;
end fun_914;

protected function fun_915
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_cr;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
      then txt;
  end match;
end fun_915;

protected function fun_916
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ty, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Tpl.Text a_cr;

    case ( txt,
           false,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
      then txt;

    case ( txt,
           _,
           a_ty,
           a_cr )
      equation
        txt = fun_915(txt, a_ty, a_cr);
      then txt;
  end match;
end fun_916;

public function extFunCallVarcopy
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_arg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_c;
      DAE.Type i_ty;
      Boolean ret_3;
      Tpl.Text l_cr;
      String str_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCode.SIMEXTARG(outputIndex = 0),
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(outputIndex = _, isArray = true, cref = i_c, type_ = i_ty),
           a_auxFunction )
      equation
        txt_0 = expTypeShort(Tpl.emptyTxt, i_ty);
        str_1 = Tpl.textString(txt_0);
        (txt, a_auxFunction) = fun_914(txt, str_1, a_auxFunction, i_c);
      then (txt, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(outputIndex = _, isArray = false, type_ = i_ty, cref = i_c),
           a_auxFunction )
      equation
        l_cr = extVarName(Tpl.emptyTxt, i_c);
        (txt, a_auxFunction) = contextCref(txt, i_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = expTypeModelica(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        ret_3 = Config.acceptMetaModelicaGrammar();
        txt = fun_916(txt, ret_3, i_ty, l_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end extFunCallVarcopy;

protected function fun_918
  input Tpl.Text in_txt;
  input Boolean in_a_ai;
  input Tpl.Text in_a_ext__name;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_outarg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ai, in_a_ext__name, in_a_ty, in_a_outarg)
    local
      Tpl.Text txt;
      Tpl.Text a_ext__name;
      DAE.Type a_ty;
      Tpl.Text a_outarg;

    case ( txt,
           false,
           a_ext__name,
           a_ty,
           a_outarg )
      equation
        txt = Tpl.writeText(txt, a_outarg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = expTypeModelica(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.writeText(txt, a_ext__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           true,
           a_ext__name,
           a_ty,
           a_outarg )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convert_alloc_"));
        txt = expTypeArray(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_f77(&"));
        txt = Tpl.writeText(txt, a_ext__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_outarg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_918;

protected function fun_919
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input DAE.Type in_a_ty;
  input Boolean in_a_ai;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_oi, in_a_ty, in_a_ai, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Boolean a_ai;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text l_ext__name;
      Tpl.Text l_outarg;

    case ( txt,
           0,
           _,
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_ty,
           a_ai,
           a_auxFunction,
           a_c )
      equation
        (l_outarg, a_auxFunction) = contextCref(Tpl.emptyTxt, a_c, SimCode.contextFunction, a_auxFunction);
        l_ext__name = extVarName(Tpl.emptyTxt, a_c);
        txt = fun_918(txt, a_ai, l_ext__name, a_ty, l_outarg);
      then (txt, a_auxFunction);
  end match;
end fun_919;

public function extFunCallVarcopyF77
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_arg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      Boolean i_ai;
      DAE.ComponentRef i_c;
      Integer i_oi;

    case ( txt,
           SimCode.SIMEXTARG(outputIndex = i_oi, isArray = i_ai, type_ = i_ty, cref = i_c),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_919(txt, i_oi, i_ty, i_ai, a_auxFunction, i_c);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end extFunCallVarcopyF77;

protected function fun_921
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_t, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_auxFunction,
           a_c )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_c, SimCode.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           a_c )
      equation
        txt = extVarName(txt, a_c);
      then (txt, a_auxFunction);
  end match;
end fun_921;

protected function fun_922
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_cr;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
      then txt;
  end match;
end fun_922;

protected function fun_923
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_t, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Type a_t;
      Tpl.Text a_cr;

    case ( txt,
           false,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
      then txt;

    case ( txt,
           _,
           a_t,
           a_cr )
      equation
        txt = fun_922(txt, a_t, a_cr);
      then txt;
  end match;
end fun_923;

public function extArg
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_type__;
      DAE.Exp i_exp;
      Boolean i_isInput;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_dim;
      Tpl.Text l_typeStr;
      Boolean ret_3;
      Tpl.Text l_cr;
      Tpl.Text l_shortTypeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, outputIndex = _, isArray = true, type_ = i_t, isInput = i_isInput),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_name, a_auxFunction) = contextCref(Tpl.emptyTxt, i_c, SimCode.contextFunction, a_auxFunction);
        l_shortTypeStr = expTypeShort(Tpl.emptyTxt, i_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = extType(txt, i_t, i_isInput, true);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") data_of_"));
        txt = Tpl.writeText(txt, l_shortTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&("));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, isInput = _, outputIndex = 0, type_ = i_t),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_cr, a_auxFunction) = fun_921(Tpl.emptyTxt, i_t, a_auxFunction, i_c);
        ret_3 = Config.acceptMetaModelicaGrammar();
        txt = fun_923(txt, ret_3, i_t, l_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, isInput = _, outputIndex = _, type_ = _),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = extVarName(txt, i_c);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGEXP(exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExternalCExp(txt, i_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGSIZE(cref = i_c, type_ = i_type__, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeStr = expTypeShort(Tpl.emptyTxt, i_type__);
        (l_name, a_auxFunction) = contextCref(Tpl.emptyTxt, i_c, SimCode.contextFunction, a_auxFunction);
        (l_dim, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extArg;

protected function fun_925
  input Tpl.Text in_txt;
  input Integer in_a_oi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oi)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ext"));
      then txt;
  end match;
end fun_925;

protected function fun_926
  input Tpl.Text in_txt;
  input Integer in_a_oi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oi)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ext"));
      then txt;
  end match;
end fun_926;

public function extArgF77
  input Tpl.Text in_txt;
  input SimCode.SimExtArg in_a_extArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_t;
      Tpl.Text l_dim;
      Tpl.Text l_sizeVar;
      Tpl.Text l_sizeVarName;
      Tpl.Text txt_3;
      Tpl.Text l_tvar;
      Tpl.Text l_texp;
      Tpl.Text l_suffix;

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, isArray = true, type_ = i_t),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data_of_"));
        txt = expTypeShort(txt, i_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_f77_array(&("));
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, outputIndex = i_oi, type_ = DAE.T_INTEGER(varLst = _)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_suffix = fun_925(Tpl.emptyTxt, i_oi);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int*) &"));
        (txt, a_auxFunction) = contextCref(txt, i_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeText(txt, l_suffix);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, outputIndex = _, type_ = DAE.T_STRING(varLst = _)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char*)"));
        (txt, a_auxFunction) = contextCref(txt, i_c, SimCode.contextFunction, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARG(cref = i_c, outputIndex = i_oi, type_ = _),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_suffix = fun_926(Tpl.emptyTxt, i_oi);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        (txt, a_auxFunction) = contextCref(txt, i_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeText(txt, l_suffix);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGEXP(exp = i_exp, type_ = DAE.T_STRING(varLst = _)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_texp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt_3 = expTypeFromExpFlag(Tpl.emptyTxt, i_exp, 8);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_texp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char*)"));
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGEXP(exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExternalF77Exp(txt, i_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SIMEXTARGSIZE(cref = i_c, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_sizeVarName, a_auxFunction) = tempSizeVarName(Tpl.emptyTxt, i_c, i_exp, a_auxFunction);
        (l_sizeVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "int", a_varDecls);
        (l_dim, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_sizeVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        (a_preExp, a_auxFunction) = contextCref(a_preExp, i_c, SimCode.contextFunction, a_auxFunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dim);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_sizeVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extArgF77;

protected function fun_928
  input Tpl.Text in_txt;
  input DAE.Exp in_a_indices;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_indices, in_a_c, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      Tpl.Text a_auxFunction;
      Integer i_integer;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           a_c,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_c, SimCode.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_size_"));
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           _,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6783, 14), "tempSizeVarName:UNHANDLED_EXPRESSION");
      then (txt, a_auxFunction);
  end match;
end fun_928;

public function tempSizeVarName
  input Tpl.Text txt;
  input DAE.ComponentRef a_c;
  input DAE.Exp a_indices;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_928(txt, a_indices, a_c, a_auxFunction);
end tempSizeVarName;

protected function lm_930
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, SimCode.contextFunction, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_930(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_930;

public function funStatement
  input Tpl.Text in_txt;
  input SimCode.Statement in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_statementLst;

    case ( txt,
           SimCode.ALGORITHM(statementLst = i_statementLst),
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_930(txt, i_statementLst, a_auxFunction, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6795, 11), "funStatement:NOT IMPLEMENTED FUN STATEMENT");
      then (txt, a_varDecls, a_auxFunction);
  end match;
end funStatement;

protected function lm_932
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, SimCode.contextParallelFunction, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_932(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_932;

public function parModelicafunStatement
  input Tpl.Text in_txt;
  input SimCode.Statement in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_statementLst;

    case ( txt,
           SimCode.ALGORITHM(statementLst = i_statementLst),
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_932(txt, i_statementLst, a_auxFunction, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6808, 11), "parModelicafunStatement:NOT IMPLEMENTED FUN STATEMENT");
      then (txt, a_varDecls, a_auxFunction);
  end match;
end parModelicafunStatement;

protected function lm_934
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extractParFors_impl(txt, i_stmt, SimCode.contextParallelFunction, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_934(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_934;

public function extractParFors
  input Tpl.Text in_txt;
  input SimCode.Statement in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_statementLst;

    case ( txt,
           SimCode.ALGORITHM(statementLst = i_statementLst),
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_934(txt, i_statementLst, a_auxFunction, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6822, 11), "extractParFors:NOT IMPLEMENTED FUN STATEMENT");
      then (txt, a_varDecls, a_auxFunction);
  end match;
end extractParFors;

protected function fun_936
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForBody(txt, i_s, SimCode.contextParallelFunction, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_936;

public function extractParFors_impl
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_936(txt, a_stmt, a_varDecls, a_auxFunction);
end extractParFors_impl;

protected function fun_938
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_stmt, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = _))),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssignPattern(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSIGN(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssign(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSIGN_ARR(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssignArr(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_TUPLE_ASSIGN(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtTupleAssign(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_IF(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtIf(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_FOR(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtFor(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForInterface(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_WHILE(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtWhile(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSERT(cond = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssert(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_TERMINATE(msg = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtTerminate(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_WHEN(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtWhen(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           DAE.STMT_BREAK(source = _),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_FAILURE(body = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtFailure(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           DAE.STMT_RETURN(source = _),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto _return;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_NORETCALL(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtNoretcall(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_REINIT(var = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtReinit(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6857, 14), "ALG_STATEMENT NYI");
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_938;

protected function fun_939
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Statement a_stmt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer i_oldIndex;
      Absyn.Info ret_2;
      DAE.ElementSource ret_1;
      Tpl.Text l_res;

    case ( txt,
           i_oldIndex,
           a_stmt,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (l_res, a_auxFunction, a_varDecls) = fun_938(Tpl.emptyTxt, a_stmt, a_auxFunction, a_varDecls, a_context);
        System.tmpTickSetIndex(i_oldIndex, 1);
        ret_1 = Algorithm.getStatementSource(a_stmt);
        ret_2 = DAEUtil.getElementSourceFileInfo(ret_1);
        txt = modelicaLine(txt, ret_2);
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.softNewLine(txt);
        txt = endModelicaLine(txt);
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_939;

public function algStatement
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Integer ret_0;
algorithm
  ret_0 := System.tmpTickIndexReserve(1, 0);
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_939(txt, ret_0, a_stmt, a_context, a_varDecls, a_auxFunction);
end algStatement;

protected function fun_941
  input Tpl.Text in_txt;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Ident in_a_var_name;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var_ty, in_a_auxFunction, in_a_context, in_a_cr, in_a_var_name, in_a_tmp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Ident a_var_name;
      Tpl.Text a_tmp;
      DAE.Type i_var_ty;
      DAE.ComponentRef ret_3;
      Tpl.Text l_varPart;
      DAE.ComponentRef ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_var_ty as DAE.T_ARRAY(ty = _)),
           a_auxFunction,
           a_context,
           a_cr,
           a_var_name,
           a_tmp )
      equation
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_tmp);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("._"));
        txt_0 = Tpl.writeStr(txt_0, a_var_name);
        ret_1 = ComponentReference.appendStringCref(a_var_name, a_cr);
        txt = copyArrayData(txt, i_var_ty, Tpl.textString(txt_0), ret_1, a_context);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           a_context,
           a_cr,
           a_var_name,
           a_tmp )
      equation
        ret_3 = ComponentReference.appendStringCref(a_var_name, a_cr);
        (l_varPart, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_3, a_context, a_auxFunction);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction);
  end match;
end fun_941;

protected function lm_942
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_context, in_a_cr, in_a_tmp)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text a_tmp;
      DAE.Ident i_var_name;
      DAE.Type i_var_ty;

    case ( txt,
           {},
           a_auxFunction,
           _,
           _,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           DAE.TYPES_VAR(ty = i_var_ty, name = i_var_name) :: rest,
           a_auxFunction,
           a_context,
           a_cr,
           a_tmp )
      equation
        (txt, a_auxFunction) = fun_941(txt, i_var_ty, a_auxFunction, a_context, a_cr, i_var_name, a_tmp);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_942(txt, rest, a_auxFunction, a_context, a_cr, a_tmp);
      then (txt, a_auxFunction);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_context,
           a_cr,
           a_tmp )
      equation
        (txt, a_auxFunction) = lm_942(txt, rest, a_auxFunction, a_context, a_cr, a_tmp);
      then (txt, a_auxFunction);
  end match;
end lm_942;

protected function lm_943
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_rec;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_rec, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_rec;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<DAE.Exp> a_expLst;
      Integer x_i1;
      DAE.Ident i_var_name;
      DAE.Exp ret_1;
      Tpl.Text l_re;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_rec,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_1 = listNth(a_expLst, x_i1);
        (l_re, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, ret_1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_re);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_943(txt, rest, a_rec, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_rec,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_943(txt, rest, a_rec, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_943;

protected function fun_944
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input DAE.Exp in_a_val;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_exp, in_a_val, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      DAE.Exp a_val;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Exp i_idx;
      DAE.Exp i_arr;
      Tpl.Text l_val1;
      Tpl.Text l_idx1;
      Tpl.Text l_arr1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.ASUB(exp = i_arr, sub = {i_idx}),
           a_val,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_arr1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_arr, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_idx1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_val1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_val, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayUpdate("));
        txt = Tpl.writeText(txt, l_arr1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_idx1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_val1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_944;

protected function fun_945
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_exp1;
  input DAE.Exp in_a_val;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_exp1, in_a_val, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp1;
      DAE.Exp a_val;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Exp a_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_varPart;
      Tpl.Text l_preExp;

    case ( txt,
           "metatype",
           _,
           a_val,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_exp )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_944(txt, a_exp, a_val, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_exp1,
           a_val,
           a_auxFunction,
           a_varDecls,
           a_context,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExpAsub(Tpl.emptyTxt, a_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_val, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_945;

public function algStmtAssign
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_val;
      list<DAE.Exp> i_expLst;
      DAE.ComponentRef i_cr;
      list<DAE.Var> i_varLst;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      DAE.Exp i_exp1;
      DAE.Exp i_e;
      Tpl.Text l_expPart2;
      Tpl.Text l_expPart1;
      String str_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text l_tmp;
      Tpl.Text l_rec;
      Tpl.Text l_varPart;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CREF(componentRef = DAE.WILD()), exp = i_e),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr) "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr) "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CREF(componentRef = i_cr, ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_rec, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt_5 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_rec);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction) = lm_942(txt, i_varLst, a_auxFunction, a_context, i_cr, l_tmp);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CALL(path = _, expLst = i_expLst, attr = DAE.CALL_ATTR(ty = DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_rec, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, l_preExp) = lm_943(txt, i_varLst, l_rec, a_auxFunction, a_varDecls, l_preExp, a_context, i_expLst);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(componentRef = _)), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.ASUB(exp = _)), exp = (i_exp as i_val)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt_6 = expTypeFromExpShort(Tpl.emptyTxt, i_exp);
        str_7 = Tpl.textString(txt_6);
        (txt, a_auxFunction, a_varDecls) = fun_945(txt, str_7, i_exp1, i_val, a_auxFunction, a_varDecls, a_context, i_exp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = i_exp1, exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart2, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssign;

protected function fun_947
  input Tpl.Text in_txt;
  input Tpl.Text in_a_ispec;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_expPart;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ispec, in_a_varDecls, in_a_context, in_a_cr, in_a_expPart, in_a_t, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text a_expPart;
      DAE.Type a_t;
      Tpl.Text a_preExp;
      Tpl.Text i_ispec;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_varDecls,
           a_context,
           a_cr,
           a_expPart,
           a_t,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = copyArrayDataAndFreeMemAfterCall(txt, a_t, Tpl.textString(a_expPart), a_cr, a_context);
      then (txt, a_varDecls);

    case ( txt,
           i_ispec,
           a_varDecls,
           a_context,
           a_cr,
           a_expPart,
           a_t,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        (txt, a_varDecls) = indexedAssign(txt, a_t, Tpl.textString(a_expPart), a_cr, Tpl.textString(i_ispec), a_context, a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_947;

protected function fun_948
  input Tpl.Text in_txt;
  input Tpl.Text in_a_ispec;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_expPart;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ispec, in_a_varDecls, in_a_context, in_a_cr, in_a_expPart, in_a_t, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text a_expPart;
      DAE.Type a_t;
      Tpl.Text a_preExp;
      Tpl.Text i_ispec;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_varDecls,
           a_context,
           a_cr,
           a_expPart,
           a_t,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = copyArrayData(txt, a_t, Tpl.textString(a_expPart), a_cr, a_context);
      then (txt, a_varDecls);

    case ( txt,
           i_ispec,
           a_varDecls,
           a_context,
           a_cr,
           a_expPart,
           a_t,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        (txt, a_varDecls) = indexedAssign(txt, a_t, Tpl.textString(a_expPart), a_cr, Tpl.textString(i_ispec), a_context, a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_948;

public function algStmtAssignArr
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_e;
      DAE.ComponentRef i_cr;
      DAE.Exp i_exp;
      DAE.Type i_t;
      Tpl.Text l_ispec;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN_ARR(exp = (i_exp as DAE.RANGE(ty = _)), componentRef = i_cr, type_ = i_t),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = fillArrayFromRange(txt, i_t, i_exp, i_cr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN_ARR(exp = (i_e as DAE.CALL(path = _)), componentRef = i_cr, type_ = i_t),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_ispec, l_preExp, a_varDecls, a_auxFunction) = indexSpecFromCref(Tpl.emptyTxt, i_cr, a_context, l_preExp, a_varDecls, a_auxFunction);
        (txt, a_varDecls) = fun_947(txt, l_ispec, a_varDecls, a_context, i_cr, l_expPart, i_t, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN_ARR(exp = i_e, componentRef = i_cr, type_ = i_t),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_ispec, l_preExp, a_varDecls, a_auxFunction) = indexSpecFromCref(Tpl.emptyTxt, i_cr, a_context, l_preExp, a_varDecls, a_auxFunction);
        (txt, a_varDecls) = fun_948(txt, l_ispec, a_varDecls, a_context, i_cr, l_expPart, i_t, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssignArr;

protected function fun_950
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_stepExp;

    case ( txt,
           SOME(i_stepExp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_stepExp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_950;

protected function fun_951
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input DAE.ComponentRef in_a_cr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_cr, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<DAE.Exp> i_step;
      DAE.Exp i_stop;
      DAE.Exp i_start;
      DAE.Type i_ty;
      Tpl.Text l_step__exp;
      Tpl.Text l_stop__exp;
      Tpl.Text l_start__exp;
      Tpl.Text l_ty__str;
      Tpl.Text l_cref;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.RANGE(ty = i_ty, start = i_start, stop = i_stop, step = i_step),
           a_cr,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_cref = contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_start__exp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_stop__exp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_step__exp, a_auxFunction, a_varDecls, l_preExp) = fun_950(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, l_preExp, a_context);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fill_"));
        txt = Tpl.writeText(txt, l_ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_range(&"));
        txt = Tpl.writeText(txt, l_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_start__exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_step__exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stop__exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_951;

public function fillArrayFromRange
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input DAE.Exp a_exp;
  input DAE.ComponentRef a_cr;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_951(txt, a_exp, a_cr, a_context, a_varDecls, a_auxFunction);
end fillArrayFromRange;

protected function lm_953
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_953(txt, rest);
      then txt;
  end match;
end lm_953;

protected function fun_954
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_cref;
  input String in_a_ispec;
  input String in_a_exp;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_cr, in_a_cref, in_a_ispec, in_a_exp, in_a_type, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_cref;
      String a_ispec;
      String a_exp;
      Tpl.Text a_type;
      Tpl.Text a_varDecls;
      DAE.ComponentRef i_cr;
      DAE.Dimensions i_adims;
      DAE.Type i_aty;
      Tpl.Text l_atype;
      Tpl.Text l_dimsValuesStr;
      Integer ret_3;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_1;
      Tpl.Text l_tmpArr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(identType = DAE.T_ARRAY(ty = i_aty, dims = i_adims))),
           a_cref,
           a_ispec,
           a_exp,
           a_type,
           a_varDecls )
      equation
        txt_1 = expTypeArray(Tpl.emptyTxt, i_aty);
        (l_tmpArr, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_3 = listLength(i_adims);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dimsValuesStr = lm_953(l_dimsValuesStr, i_adims);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_atype = expTypeShort(Tpl.emptyTxt, i_aty);
        txt = Tpl.writeText(txt, l_atype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_create(&"));
        txt = Tpl.writeText(txt, l_tmpArr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", ((modelica_"));
        txt = Tpl.writeText(txt, l_atype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)&("));
        txt = arrayCrefCStr(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")), "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "indexed_assign_"
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, l_tmpArr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_ispec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "copy_"
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data_mem("));
        txt = Tpl.writeText(txt, l_tmpArr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_varDecls )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7036, 13), "indexedAssign simulationContext failed");
      then (txt, a_varDecls);
  end match;
end fun_954;

protected function fun_955
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input DAE.ComponentRef in_a_cr;
  input String in_a_ispec;
  input Tpl.Text in_a_cref;
  input String in_a_exp;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_varDecls, in_a_cr, in_a_ispec, in_a_cref, in_a_exp, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      DAE.ComponentRef a_cr;
      String a_ispec;
      Tpl.Text a_cref;
      String a_exp;
      Tpl.Text a_type;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_varDecls,
           _,
           a_ispec,
           a_cref,
           a_exp,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("indexed_assign_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_ispec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_varDecls,
           _,
           a_ispec,
           a_cref,
           a_exp,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("indexed_assign_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_ispec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           a_cr,
           a_ispec,
           a_cref,
           a_exp,
           a_type )
      equation
        (txt, a_varDecls) = fun_954(txt, a_cr, a_cref, a_ispec, a_exp, a_type, a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_955;

public function indexedAssign
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input String a_exp;
  input DAE.ComponentRef a_cr;
  input String a_ispec;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_cref;
  Tpl.Text l_type;
algorithm
  l_type := expTypeArray(Tpl.emptyTxt, a_ty);
  l_cref := contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
  (out_txt, out_a_varDecls) := fun_955(txt, a_context, a_varDecls, a_cr, a_ispec, l_cref, a_exp, l_type);
end indexedAssign;

protected function fun_957
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data"));
      then txt;
  end match;
end fun_957;

protected function fun_958
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_cref;
  input String in_a_exp;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cref, in_a_exp, in_a_ty, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_cref;
      String a_exp;
      DAE.Type a_ty;
      Tpl.Text a_type;
      Boolean ret_0;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_cref,
           a_exp,
           a_ty,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        ret_0 = Types.dimensionsKnown(a_ty);
        txt = fun_957(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_cref,
           a_exp,
           _,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_cref,
           a_exp,
           _,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data_mem("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_958;

public function copyArrayData
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input String a_exp;
  input DAE.ComponentRef a_cr;
  input SimCode.Context a_context;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_cref;
  Tpl.Text l_type;
algorithm
  l_type := expTypeArray(Tpl.emptyTxt, a_ty);
  l_cref := contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
  out_txt := fun_958(txt, a_context, l_cref, a_exp, a_ty, l_type);
end copyArrayData;

protected function fun_960
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_cref;
  input String in_a_exp;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cref, in_a_exp, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_cref;
      String a_exp;
      Tpl.Text a_type;

    case ( txt,
           false,
           a_cref,
           a_exp,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_960;

protected function fun_961
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_exp;
  input Tpl.Text in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_exp, in_a_cref)
    local
      Tpl.Text txt;
      String a_exp;
      Tpl.Text a_cref;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_exp,
           a_cref )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("free_device_array(&"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); "));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_961;

protected function fun_962
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_cref;
  input String in_a_exp;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cref, in_a_exp, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_cref;
      String a_exp;
      Tpl.Text a_type;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_cref,
           a_exp,
           a_type )
      equation
        ret_0 = Config.acceptParModelicaGrammar();
        txt = fun_960(txt, ret_0, a_cref, a_exp, a_type);
        txt = Tpl.softNewLine(txt);
        ret_1 = Config.acceptParModelicaGrammar();
        txt = fun_961(txt, ret_1, a_exp, a_cref);
      then txt;

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_cref,
           a_exp,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_cref,
           a_exp,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data_mem("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_962;

public function copyArrayDataAndFreeMemAfterCall
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input String a_exp;
  input DAE.ComponentRef a_cr;
  input SimCode.Context a_context;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_cref;
  Tpl.Text l_type;
algorithm
  l_type := expTypeArray(Tpl.emptyTxt, a_ty);
  l_cref := contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
  out_txt := fun_962(txt, a_context, l_cref, a_exp, l_type);
end copyArrayDataAndFreeMemAfterCall;

protected function fun_964
  input Tpl.Text in_txt;
  input DAE.Exp in_a_e;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_postExp, out_a_varDecls) :=
  match(in_txt, in_a_e, in_a_auxFunction, in_a_postExp, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_postExp;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Type i_ty;
      DAE.Exp i_e;
      DAE.ComponentRef i_cr;
      Tpl.Text txt_1;
      String ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           DAE.ARRAY(array = {}),
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", NULL"));
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()),
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", NULL"));
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           (i_e as DAE.CREF(componentRef = i_cr, ty = i_ty)),
           a_auxFunction,
           a_postExp,
           a_varDecls,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        (txt, a_varDecls, a_postExp, a_auxFunction) = contextArrayReferenceCrefAndCopy(txt, i_cr, i_e, i_ty, a_context, a_varDecls, a_postExp, a_auxFunction);
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           (i_e as DAE.CALL(attr = DAE.CALL_ATTR(ty = i_ty))),
           a_auxFunction,
           a_postExp,
           a_varDecls,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        ret_0 = ComponentReference.makeUntypedCrefIdent("#error");
        (txt, a_varDecls, a_postExp, a_auxFunction) = contextArrayReferenceCrefAndCopy(txt, ret_0, i_e, i_ty, a_context, a_varDecls, a_postExp, a_auxFunction);
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           i_e,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown expression to assign to: "));
        ret_1 = ExpressionDump.printExpStr(i_e);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7085, 16), Tpl.textString(txt_1));
      then (txt, a_auxFunction, a_postExp, a_varDecls);
  end match;
end fun_964;

protected function lm_965
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_postExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_postExp, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_postExp;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_postExp, a_varDecls) = fun_964(txt, i_e, a_auxFunction, a_postExp, a_varDecls, a_context);
        (txt, a_auxFunction, a_postExp, a_varDecls) = lm_965(txt, rest, a_auxFunction, a_postExp, a_varDecls, a_context);
      then (txt, a_auxFunction, a_postExp, a_varDecls);
  end match;
end lm_965;

protected function lm_966
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_966(txt, rest);
      then txt;
  end match;
end lm_966;

protected function fun_967
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_expExpLst;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_ret;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_postExp, out_a_varDecls) :=
  match(in_txt, in_a_expExpLst, in_a_auxFunction, in_a_postExp, in_a_varDecls, in_a_context, in_a_ret)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_postExp;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      Tpl.Text a_ret;
      DAE.Type i_ty;
      DAE.Exp i_e;
      DAE.ComponentRef i_cr;
      Tpl.Text txt_1;
      String ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           DAE.ARRAY(array = {}) :: _,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _,
           a_ret )
      equation
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()) :: _,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _,
           a_ret )
      equation
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           (i_e as DAE.CREF(componentRef = i_cr, ty = i_ty)) :: _,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           a_context,
           a_ret )
      equation
        (txt, a_varDecls, a_postExp, a_auxFunction) = contextArrayReferenceCrefAndCopy(txt, i_cr, i_e, i_ty, a_context, a_varDecls, a_postExp, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           (i_e as DAE.CALL(attr = DAE.CALL_ATTR(ty = i_ty))) :: _,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           a_context,
           a_ret )
      equation
        ret_0 = ComponentReference.makeUntypedCrefIdent("#error");
        (txt, a_varDecls, a_postExp, a_auxFunction) = contextArrayReferenceCrefAndCopy(txt, ret_0, i_e, i_ty, a_context, a_varDecls, a_postExp, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           i_e :: _,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown expression to assign to: "));
        ret_1 = ExpressionDump.printExpStr(i_e);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7095, 26), Tpl.textString(txt_1));
      then (txt, a_auxFunction, a_postExp, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_postExp,
           a_varDecls,
           _,
           _ )
      then (txt, a_auxFunction, a_postExp, a_varDecls);
  end match;
end fun_967;

protected function lm_968
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_afterExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_prefix;
  input list<DAE.Exp> in_a_expExpLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_afterExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_afterExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_afterExp, in_a_context, in_a_startIndexOutputs, in_a_prefix, in_a_expExpLst)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_afterExp;
      SimCode.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_prefix;
      list<DAE.Exp> a_expExpLst;
      Integer x_i0;
      DAE.Exp i_cr;
      Tpl.Text l_rhsStr;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           i_cr :: rest,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context,
           a_startIndexOutputs,
           a_prefix,
           a_expExpLst )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_rhsStr = getTempDeclMatchOutputName(Tpl.emptyTxt, a_expExpLst, Tpl.textString(a_prefix), Tpl.textString(a_startIndexOutputs), x_i0);
        (txt, a_afterExp, a_varDecls, a_auxFunction) = writeLhsCref(txt, i_cr, Tpl.textString(l_rhsStr), a_context, a_afterExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_afterExp) = lm_968(txt, rest, a_auxFunction, a_varDecls, a_afterExp, a_context, a_startIndexOutputs, a_prefix, a_expExpLst);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);
  end match;
end lm_968;

protected function lm_969
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_prefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_varDecls, in_a_startIndexOutputs, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_varDecls;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_prefix;
      Integer x_i0;
      DAE.Exp i_cr;
      Tpl.Text l_decl;
      Tpl.Text l_typ;

    case ( txt,
           {},
           a_varDecls,
           _,
           _ )
      then (txt, a_varDecls);

    case ( txt,
           i_cr :: rest,
           a_varDecls,
           a_startIndexOutputs,
           a_prefix )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_typ = expTypeFromExpModelica(Tpl.emptyTxt, i_cr);
        (l_decl, a_varDecls) = tempDeclMatchOutput(Tpl.emptyTxt, Tpl.textString(l_typ), Tpl.textString(a_prefix), Tpl.textString(a_startIndexOutputs), intString(x_i0), a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_969(txt, rest, a_varDecls, a_startIndexOutputs, a_prefix);
      then (txt, a_varDecls);
  end match;
end lm_969;

public function algStmtTupleAssign
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      list<DAE.Type> i_ntys;
      list<DAE.Exp> i_expExpLst;
      Tpl.Text l_0__;
      Integer ret_16;
      Integer ret_15;
      Tpl.Text l_startIndexOutputs;
      Integer ret_13;
      Tpl.Text l_prefix;
      Tpl.Text l_afterExp;
      Tpl.Text l_ret;
      list<String> ret_9;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text l_lhsCrefs2;
      list<DAE.Exp> ret_3;
      Tpl.Text l_lhsCrefs;
      Tpl.Text l_postExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_TUPLE_ASSIGN(exp = (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(tupleType = i_ntys)))), expExpLst = i_expExpLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_postExp = Tpl.emptyTxt;
        ret_3 = List.rest(i_expExpLst);
        (l_lhsCrefs, a_auxFunction, l_postExp, a_varDecls) = lm_965(Tpl.emptyTxt, ret_3, a_auxFunction, l_postExp, a_varDecls, a_context);
        l_lhsCrefs2 = Tpl.writeText(Tpl.emptyTxt, l_lhsCrefs);
        ret_5 = listLength(i_ntys);
        ret_6 = listLength(i_expExpLst);
        ret_7 = intSub(ret_5, ret_6);
        ret_8 = intMax(0, ret_7);
        ret_9 = List.fill(", NULL", ret_8);
        l_lhsCrefs2 = lm_966(l_lhsCrefs2, ret_9);
        (l_ret, l_lhsCrefs2, l_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_lhsCrefs2, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_preExp, a_auxFunction, l_postExp, a_varDecls) = fun_967(l_preExp, i_expExpLst, a_auxFunction, l_postExp, a_varDecls, a_context, l_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* tuple assignment */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeText(txt, l_postExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_TUPLE_ASSIGN(exp = (i_exp as DAE.MATCHEXPRESSION(matchType = _)), expExpLst = i_expExpLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_afterExp = Tpl.emptyTxt;
        l_prefix = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_13 = System.tmpTick();
        l_prefix = Tpl.writeStr(l_prefix, intString(ret_13));
        ret_15 = listLength(i_expExpLst);
        ret_16 = System.tmpTickIndexReserve(1, ret_15);
        l_startIndexOutputs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        (l_0__, l_prefix, l_startIndexOutputs, l_preExp, a_varDecls, a_auxFunction) = daeExpMatch2(Tpl.emptyTxt, i_exp, i_expExpLst, l_prefix, l_startIndexOutputs, a_context, l_preExp, a_varDecls, a_auxFunction);
        l_lhsCrefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_lhsCrefs, a_auxFunction, a_varDecls, l_afterExp) = lm_968(l_lhsCrefs, i_expExpLst, a_auxFunction, a_varDecls, l_afterExp, a_context, l_startIndexOutputs, l_prefix, i_expExpLst);
        l_lhsCrefs = Tpl.popIter(l_lhsCrefs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_varDecls) = lm_969(txt, i_expExpLst, a_varDecls, l_startIndexOutputs, l_prefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhsCrefs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_afterExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7118, 12), "algStmtTupleAssign failed");
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtTupleAssign;

protected function fun_971
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_lhsStr;
  input String in_a_rhsStr;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_lhsStr, in_a_rhsStr, in_a_t)
    local
      Tpl.Text txt;
      Tpl.Text a_lhsStr;
      String a_rhsStr;
      DAE.Type a_t;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = _),
           a_lhsStr,
           a_rhsStr,
           a_t )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = expTypeShort(txt, a_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_data_mem("));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_lhsStr,
           a_rhsStr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_971;

protected function fun_972
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_lhsStr;
  input String in_a_rhsStr;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_lhsStr, in_a_rhsStr, in_a_t)
    local
      Tpl.Text txt;
      Tpl.Text a_lhsStr;
      String a_rhsStr;
      DAE.Type a_t;

    case ( txt,
           SimCode.SIMULATION_CONTEXT(genDiscrete = _),
           a_lhsStr,
           a_rhsStr,
           a_t )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("usub_"));
        txt = expTypeShort(txt, a_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "copy_"
                                }, false));
        txt = expTypeShort(txt, a_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_data_mem("));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_lhsStr,
           a_rhsStr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = -"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_972;

protected function fun_973
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.FUNCTION_CONTEXT() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
      then txt;
  end match;
end fun_973;

protected function lm_974
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_lhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_tmp, in_a_context, in_a_lhsStr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      SimCode.Context a_context;
      Tpl.Text a_lhsStr;
      DAE.Ident i_var_name;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_context,
           a_lhsStr )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = fun_973(txt, a_context);
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_974(txt, rest, a_tmp, a_context, a_lhsStr);
      then txt;

    case ( txt,
           _ :: rest,
           a_tmp,
           a_context,
           a_lhsStr )
      equation
        txt = lm_974(txt, rest, a_tmp, a_context, a_lhsStr);
      then txt;
  end match;
end lm_974;

protected function lm_975
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_lhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_tmp, in_a_lhsStr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_lhsStr;
      DAE.Ident i_var_name;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_lhsStr )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = -"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_975(txt, rest, a_tmp, a_lhsStr);
      then txt;

    case ( txt,
           _ :: rest,
           a_tmp,
           a_lhsStr )
      equation
        txt = lm_975(txt, rest, a_tmp, a_lhsStr);
      then txt;
  end match;
end lm_975;

protected function lm_976
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_lhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_tmp, in_a_lhsStr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_lhsStr;
      DAE.Ident i_var_name;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_lhsStr )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = !"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_976(txt, rest, a_tmp, a_lhsStr);
      then txt;

    case ( txt,
           _ :: rest,
           a_tmp,
           a_lhsStr )
      equation
        txt = lm_976(txt, rest, a_tmp, a_lhsStr);
      then txt;
  end match;
end lm_976;

protected function lm_977
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<DAE.Exp> a_expLst;
      Integer x_i1;
      DAE.Ident i_var_name;
      DAE.Exp ret_1;
      Tpl.Text l_re;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_1 = listNth(a_expLst, x_i1);
        (l_re, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, ret_1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_re);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_977(txt, rest, a_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_tmp,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_977(txt, rest, a_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_977;

protected function fun_978
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           1 )
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("D"));
      then txt;
  end match;
end fun_978;

protected function lm_979
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.nextIter(txt);
        txt = lm_979(txt, rest);
      then txt;
  end match;
end lm_979;

protected function lm_980
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<Integer>>> in_items;
  input String in_a_rhsStr;
  input Tpl.Text in_a_fcallsuf;
  input Tpl.Text in_a_typeShort;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_rhsStr, in_a_fcallsuf, in_a_typeShort, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<Integer>>> rest;
      String a_rhsStr;
      Tpl.Text a_fcallsuf;
      Tpl.Text a_typeShort;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<Integer> i_indxs;
      DAE.Exp i_lhs;
      Tpl.Text l_indxstr;
      Tpl.Text l_lhsstr;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_lhs, i_indxs) :: rest,
           a_rhsStr,
           a_fcallsuf,
           a_typeShort,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_lhsstr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_lhs, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_indxstr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indxstr = lm_979(l_indxstr, i_indxs);
        l_indxstr = Tpl.popIter(l_indxstr);
        txt = Tpl.writeText(txt, l_lhsstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get"));
        txt = Tpl.writeText(txt, a_fcallsuf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_indxstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_980(txt, rest, a_rhsStr, a_fcallsuf, a_typeShort, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_980;

public function writeLhsCref
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input String in_a_rhsStr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_inExp, in_a_rhsStr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_rhsStr;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_expl;
      DAE.Dimensions i_dims;
      list<DAE.Exp> i_expLst;
      list<DAE.Var> i_varLst;
      DAE.Type i_ty;
      DAE.Exp i_e;
      DAE.Type i_t;
      DAE.Exp i_inExp;
      Tpl.Text txt_15;
      String ret_15;
      Tpl.Text txt_13;
      String ret_13;
      list<tuple<DAE.Exp, list<Integer>>> ret_12;
      list<list<Integer>> ret_11;
      Tpl.Text l_body;
      Integer ret_9;
      Tpl.Text l_fcallsuf;
      Tpl.Text l_typeShort;
      Tpl.Text txt_6;
      Tpl.Text l_preExp;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text l_tmp;
      Tpl.Text l_lhsStr;

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()),
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.CREF(ty = (i_t as DAE.T_ARRAY(ty = _)))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = fun_971(txt, a_context, l_lhsStr, a_rhsStr, i_t);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.UNARY(exp = (i_e as DAE.CREF(ty = (i_t as DAE.T_ARRAY(ty = _))))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = fun_972(txt, a_context, l_lhsStr, a_rhsStr, i_t);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.CREF(ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _))))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_2 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_974(txt, i_varLst, l_tmp, a_context, l_lhsStr);
        txt = Tpl.popIter(txt);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.UNARY(exp = (i_e as DAE.CREF(ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_3 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_975(txt, i_varLst, l_tmp, l_lhsStr);
        txt = Tpl.popIter(txt);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.LUNARY(operator = DAE.NOT(ty = _), exp = (i_e as DAE.CREF(ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_4 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_4), a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_976(txt, i_varLst, l_tmp, l_lhsStr);
        txt = Tpl.popIter(txt);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = _, expLst = i_expLst, attr = DAE.CALL_ATTR(ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _))))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        txt_6 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_6), a_varDecls);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, l_preExp) = lm_977(txt, i_varLst, l_tmp, a_auxFunction, a_varDecls, l_preExp, a_context, i_expLst);
        txt = Tpl.popIter(txt);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.CREF(componentRef = _)),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.UNARY(operator = DAE.UMINUS(ty = _), exp = (i_e as DAE.CREF(componentRef = _))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = -"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.LUNARY(operator = DAE.NOT(ty = _), exp = (i_e as DAE.CREF(componentRef = _))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = !"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ARRAY(array = {}),
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.RCONST(real = _),
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.ARRAY(ty = DAE.T_ARRAY(ty = _, dims = i_dims), array = i_expl)),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeShort = expTypeFromExpShort(Tpl.emptyTxt, i_inExp);
        ret_9 = listLength(i_dims);
        l_fcallsuf = fun_978(Tpl.emptyTxt, ret_9);
        ret_11 = SimCodeUtil.dimsToAllIndexes(i_dims);
        ret_12 = List.threadTuple(i_expl, ret_11);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_auxFunction, a_varDecls, a_preExp) = lm_980(l_body, ret_12, a_rhsStr, l_fcallsuf, l_typeShort, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeText(txt, l_body);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.ASUB(exp = _)),
           a_rhsStr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_13 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("writeLhsCref UNHANDLED ASUB (should never be part of a lhs expression): "));
        ret_13 = ExpressionDump.printExpStr(i_inExp);
        txt_13 = Tpl.writeStr(txt_13, ret_13);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING(" = "));
        txt_13 = Tpl.writeStr(txt_13, a_rhsStr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7224, 9), Tpl.textString(txt_13));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_inExp,
           a_rhsStr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_15 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("writeLhsCref UNHANDLED: "));
        ret_15 = ExpressionDump.printExpStr(i_inExp);
        txt_15 = Tpl.writeStr(txt_15, ret_15);
        txt_15 = Tpl.writeTok(txt_15, Tpl.ST_STRING(" = "));
        txt_15 = Tpl.writeStr(txt_15, a_rhsStr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7226, 9), Tpl.textString(txt_15));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end writeLhsCref;

protected function lm_982
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_982(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_982;

public function algStmtIf
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Else i_else__;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_condExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_IF(exp = i_exp, statementLst = i_statementLst, else_ = i_else__),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_condExp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_condExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_982(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, a_varDecls, a_auxFunction) = elseExpr(txt, i_else__, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtIf;

public function algStmtParForBody
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_PARFOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForRangeBody(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtParForBody;

protected function lm_985
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_loopVarDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_loopVarDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_loopVarDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_loopVarDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_loopVarDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_loopVarDecls,
           _ )
      then (txt, a_auxFunction, a_loopVarDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_loopVarDecls,
           a_context )
      equation
        (txt, a_loopVarDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_loopVarDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_loopVarDecls) = lm_985(txt, rest, a_auxFunction, a_loopVarDecls, a_context);
      then (txt, a_auxFunction, a_loopVarDecls);
  end match;
end lm_985;

protected function lm_986
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, Absyn.Info>> in_items;
  input Tpl.Text in_a_reconstrucedArrays;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstrucedArrays;
algorithm
  (out_txt, out_a_reconstrucedArrays) :=
  match(in_txt, in_items, in_a_reconstrucedArrays)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, Absyn.Info>> rest;
      Tpl.Text a_reconstrucedArrays;
      tuple<DAE.ComponentRef, Absyn.Info> i_var;

    case ( txt,
           {},
           a_reconstrucedArrays )
      then (txt, a_reconstrucedArrays);

    case ( txt,
           i_var :: rest,
           a_reconstrucedArrays )
      equation
        (txt, a_reconstrucedArrays) = reconstructKernelArraysFromLooptupleVars(txt, i_var, a_reconstrucedArrays);
        (txt, a_reconstrucedArrays) = lm_986(txt, rest, a_reconstrucedArrays);
      then (txt, a_reconstrucedArrays);
  end match;
end lm_986;

protected function lm_987
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, Absyn.Info>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, Absyn.Info>> rest;
      tuple<DAE.ComponentRef, Absyn.Info> i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = parFunArgDefinitionFromLooptupleVar(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_987(txt, rest);
      then txt;
  end match;
end lm_987;

protected function fun_988
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_auxFunction;
      list<tuple<DAE.ComponentRef, Absyn.Info>> i_loopPrlVars;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      DAE.Ident i_iter;
      Tpl.Text l_argStr;
      Tpl.Text l_0__;
      Tpl.Text l_reconstrucedArrays;
      Tpl.Text l_body;
      Tpl.Text l_loopVarDecls;
      Integer ret_4;
      Tpl.Text l_parforKernelName;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;
      Tpl.Text l_iterName;

    case ( txt,
           DAE.STMT_PARFOR(range = DAE.RANGE(ty = _), iter = i_iter, type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, loopPrlVars = i_loopPrlVars),
           a_context,
           a_auxFunction )
      equation
        l_iterName = contextIteratorName(Tpl.emptyTxt, i_iter, a_context);
        l_identType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = expTypeShort(Tpl.emptyTxt, i_type__);
        l_parforKernelName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("parfor_"));
        ret_4 = System.tmpTickIndex(20);
        l_parforKernelName = Tpl.writeStr(l_parforKernelName, intString(ret_4));
        l_loopVarDecls = Tpl.emptyTxt;
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_auxFunction, l_loopVarDecls) = lm_985(l_body, i_statementLst, a_auxFunction, l_loopVarDecls, a_context);
        l_body = Tpl.popIter(l_body);
        l_reconstrucedArrays = Tpl.emptyTxt;
        (l_0__, l_reconstrucedArrays) = lm_986(Tpl.emptyTxt, i_loopPrlVars, l_reconstrucedArrays);
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(", \n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_argStr = lm_987(l_argStr, i_loopPrlVars);
        l_argStr = Tpl.popIter(l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "__kernel void "
                                }, false));
        txt = Tpl.writeText(txt, l_parforKernelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(\n",
                                    "      modelica_integer loop_start,\n",
                                    "      modelica_integer loop_step,\n",
                                    "      modelica_integer loop_end,\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "  /* algStmtParForRangeBody : Thread managment for parfor loops */\n",
                                    "  modelica_integer inner_start = (get_global_id(0) * loop_step) + (loop_start);\n",
                                    "  modelica_integer stride = get_global_size(0) * loop_step;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for(modelica_integer "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_integer) inner_start; in_range_integer("));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", loop_start, loop_end); "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " += stride)\n",
                                    "{\n",
                                    "  /* algStmtParForRangeBody : Reconstruct Arrays */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_reconstrucedArrays);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* algStmtParForRangeBody : locals */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_loopVarDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_988;

public function algStmtParForRangeBody
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_988(txt, a_stmt, a_context, a_auxFunction);
  out_a_varDecls := a_varDecls;
end algStmtParForRangeBody;

public function algStmtParForInterface
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_PARFOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForRangeInterface(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtParForInterface;

protected function lm_991
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_991(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_991;

public function algStmtParForRangeInterface
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<tuple<DAE.ComponentRef, Absyn.Info>> i_loopPrlVars;
      DAE.Ident i_iter;
      DAE.Exp i_rng;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;

    case ( txt,
           DAE.STMT_PARFOR(range = (i_rng as DAE.RANGE(ty = _)), type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, iter = i_iter, loopPrlVars = i_loopPrlVars),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_identType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = expTypeShort(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_auxFunction, a_varDecls) = lm_991(l_stmtStr, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_auxFunction) = algStmtParForRangeInterface_impl(txt, i_rng, i_iter, Tpl.textString(l_identType), Tpl.textString(l_identTypeShort), i_loopPrlVars, l_stmtStr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtParForRangeInterface;

protected function fun_993
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_eo;

    case ( txt,
           SOME(i_eo),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_eo, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_993;

protected function lm_994
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, Absyn.Info>> in_items;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_kernelArgSets;
  input Tpl.Text in_a_kerArgNr;
  input Tpl.Text in_a_cl__kernelVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_kernelArgSets;
  output Tpl.Text out_a_kerArgNr;
  output Tpl.Text out_a_cl__kernelVar;
algorithm
  (out_txt, out_a_kernelArgSets, out_a_kerArgNr, out_a_cl__kernelVar) :=
  match(in_txt, in_items, in_a_context, in_a_kernelArgSets, in_a_kerArgNr, in_a_cl__kernelVar)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, Absyn.Info>> rest;
      SimCode.Context a_context;
      Tpl.Text a_kernelArgSets;
      Tpl.Text a_kerArgNr;
      Tpl.Text a_cl__kernelVar;
      tuple<DAE.ComponentRef, Absyn.Info> i_varTuple;

    case ( txt,
           {},
           _,
           a_kernelArgSets,
           a_kerArgNr,
           a_cl__kernelVar )
      then (txt, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar);

    case ( txt,
           i_varTuple :: rest,
           a_context,
           a_kernelArgSets,
           a_kerArgNr,
           a_cl__kernelVar )
      equation
        (txt, a_cl__kernelVar, a_kerArgNr, a_kernelArgSets) = setKernelArgFormTupleLoopVars_ith(txt, i_varTuple, a_cl__kernelVar, a_kerArgNr, a_kernelArgSets, a_context);
        (txt, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar) = lm_994(txt, rest, a_context, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar);
      then (txt, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar);
  end match;
end lm_994;

protected function fun_995
  input Tpl.Text in_txt;
  input DAE.Exp in_a_range;
  input Absyn.Ident in_a_iterator;
  input String in_a_type;
  input list<tuple<DAE.ComponentRef, Absyn.Info>> in_a_loopPrlVars;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_range, in_a_iterator, in_a_type, in_a_loopPrlVars, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Absyn.Ident a_iterator;
      String a_type;
      list<tuple<DAE.ComponentRef, Absyn.Info>> a_loopPrlVars;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_stop;
      Option<DAE.Exp> i_step;
      DAE.Exp i_start;
      Tpl.Text l_0__;
      Tpl.Text l_kernelArgSets;
      Tpl.Text l_kerArgNr;
      Integer ret_10;
      Tpl.Text l_parforKernelName;
      Tpl.Text l_cl__kernelVar;
      Tpl.Text l_stopValue;
      Tpl.Text l_stepValue;
      Tpl.Text l_startValue;
      Tpl.Text l_preExp;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_startVar;
      Tpl.Text l_iterName;

    case ( txt,
           DAE.RANGE(start = i_start, step = i_step, stop = i_stop),
           a_iterator,
           a_type,
           a_loopPrlVars,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_iterName = contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
        (l_startVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stepVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stopVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        l_preExp = Tpl.emptyTxt;
        (l_startValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_stepValue, a_auxFunction, a_varDecls, l_preExp) = fun_993(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, l_preExp, a_context);
        (l_stopValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_cl__kernelVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "cl_kernel", a_varDecls);
        l_parforKernelName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("parfor_"));
        ret_10 = System.tmpTickIndex(20);
        l_parforKernelName = Tpl.writeStr(l_parforKernelName, intString(ret_10));
        l_kerArgNr = Tpl.writeText(Tpl.emptyTxt, l_parforKernelName);
        l_kerArgNr = Tpl.writeTok(l_kerArgNr, Tpl.ST_STRING("_arg_nr"));
        l_kernelArgSets = Tpl.emptyTxt;
        (l_0__, l_kernelArgSets, l_kerArgNr, l_cl__kernelVar) = lm_994(Tpl.emptyTxt, a_loopPrlVars, a_context, l_kernelArgSets, l_kerArgNr, l_cl__kernelVar);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stepValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stopValue);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ocl_create_kernel(omc_ocl_program, \""));
        txt = Tpl.writeText(txt, l_parforKernelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0;\n",
                                    "\n",
                                    "ocl_set_kernel_arg("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); ++"));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ocl_set_kernel_arg("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); ++"));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ocl_set_kernel_arg("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); ++"));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_kernelArgSets);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ocl_execute_kernel("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "clReleaseKernel("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n",
                                    "\n"
                                }, true));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_995;

public function algStmtParForRangeInterface_impl
  input Tpl.Text txt;
  input DAE.Exp a_range;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_shortType;
  input list<tuple<DAE.ComponentRef, Absyn.Info>> a_loopPrlVars;
  input Tpl.Text a_body;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_995(txt, a_range, a_iterator, a_type, a_loopPrlVars, a_context, a_varDecls, a_auxFunction);
  out_a_body := a_body;
end algStmtParForRangeInterface_impl;

public function algStmtFor
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_FOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForRange(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_s as DAE.STMT_FOR(type_ = _)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtFor;

protected function lm_998
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_998(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_998;

public function algStmtForRange
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Ident i_iter;
      DAE.Exp i_rng;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;

    case ( txt,
           DAE.STMT_FOR(range = (i_rng as DAE.RANGE(ty = _)), type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, iter = i_iter),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_identType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = expTypeShort(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_auxFunction, a_varDecls) = lm_998(l_stmtStr, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_auxFunction) = algStmtForRange_impl(txt, i_rng, i_iter, Tpl.textString(l_identType), Tpl.textString(l_identTypeShort), l_stmtStr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtForRange;

protected function fun_1000
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_eo;

    case ( txt,
           SOME(i_eo),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_eo, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1000;

protected function fun_1001
  input Tpl.Text in_txt;
  input DAE.Exp in_a_range;
  input Absyn.Ident in_a_iterator;
  input String in_a_type;
  input String in_a_shortType;
  input Tpl.Text in_a_body;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_range, in_a_iterator, in_a_type, in_a_shortType, in_a_body, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Absyn.Ident a_iterator;
      String a_type;
      String a_shortType;
      Tpl.Text a_body;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_stop;
      Option<DAE.Exp> i_step;
      DAE.Exp i_start;
      Tpl.Text l_stopValue;
      Tpl.Text l_stepValue;
      Tpl.Text l_startValue;
      Tpl.Text l_preExp;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_startVar;
      Tpl.Text l_iterName;

    case ( txt,
           DAE.RANGE(start = i_start, step = i_step, stop = i_stop),
           a_iterator,
           a_type,
           a_shortType,
           a_body,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_iterName = contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
        (l_startVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stepVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stopVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        l_preExp = Tpl.emptyTxt;
        (l_startValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_stepValue, a_auxFunction, a_varDecls, l_preExp) = fun_1000(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, l_preExp, a_context);
        (l_stopValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stepValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stopValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "if(!"
                                }, false));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "  FILE_INFO info = omc_dummyFileInfo;\n",
                                    "  omc_assert(threadData, info, \"assertion range step != 0 failed\");\n",
                                    "}\n",
                                    "else if(!((("
                                }, false));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0) && ("));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) || (("));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < 0) && ("));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "for("
                                }, false));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; in_range_"));
        txt = Tpl.writeStr(txt, a_shortType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_1001;

public function algStmtForRange_impl
  input Tpl.Text txt;
  input DAE.Exp a_range;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_shortType;
  input Tpl.Text a_body;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_1001(txt, a_range, a_iterator, a_type, a_shortType, a_body, a_context, a_varDecls, a_auxFunction);
  out_a_body := a_body;
end algStmtForRange_impl;

protected function lm_1003
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1003(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1003;

public function algStmtForGeneric
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Ident i_iter;
      DAE.Exp i_range;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_arrayType;
      Tpl.Text l_iterType;

    case ( txt,
           DAE.STMT_FOR(type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, range = i_range, iter = i_iter),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_iterType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_arrayType = expTypeArray(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_auxFunction, a_varDecls) = lm_1003(l_stmtStr, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_auxFunction) = algStmtForGeneric_impl(txt, i_range, i_iter, Tpl.textString(l_iterType), Tpl.textString(l_arrayType), i_iterIsArray, l_stmtStr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtForGeneric;

protected function fun_1005
  input Tpl.Text in_txt;
  input Boolean in_a_iterIsArray;
  input Tpl.Text in_a_ivar;
  input String in_a_type;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_evar;
  input String in_a_arrayType;
  input Tpl.Text in_a_iterName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterIsArray, in_a_ivar, in_a_type, in_a_tvar, in_a_evar, in_a_arrayType, in_a_iterName)
    local
      Tpl.Text txt;
      Tpl.Text a_ivar;
      String a_type;
      Tpl.Text a_tvar;
      Tpl.Text a_evar;
      String a_arrayType;
      Tpl.Text a_iterName;

    case ( txt,
           false,
           _,
           _,
           a_tvar,
           a_evar,
           a_arrayType,
           a_iterName )
      equation
        txt = Tpl.writeText(txt, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = *("));
        txt = Tpl.writeStr(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr1(&"));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then txt;

    case ( txt,
           _,
           a_ivar,
           a_type,
           a_tvar,
           a_evar,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simple_index_alloc_"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1(&"));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_ivar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1005;

public function algStmtForGeneric_impl
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_arrayType;
  input Boolean a_iterIsArray;
  input Tpl.Text a_body;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_stmtStuff;
  Tpl.Text l_evar;
  Tpl.Text l_preExp;
  Tpl.Text l_ivar;
  Tpl.Text l_tvar;
  Tpl.Text l_iterName;
algorithm
  l_iterName := contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
  (l_tvar, out_a_varDecls) := tempDecl(Tpl.emptyTxt, "int", a_varDecls);
  (l_ivar, out_a_varDecls) := tempDecl(Tpl.emptyTxt, a_type, out_a_varDecls);
  l_preExp := Tpl.emptyTxt;
  (l_evar, l_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_exp, a_context, l_preExp, out_a_varDecls, a_auxFunction);
  l_stmtStuff := fun_1005(Tpl.emptyTxt, a_iterIsArray, l_ivar, a_type, l_tvar, l_evar, a_arrayType, l_iterName);
  out_txt := Tpl.writeText(txt, l_preExp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("{\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_type);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeText(out_txt, l_iterName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "\n",
                                       "for("
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_tvar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" = 1; "));
  out_txt := Tpl.writeText(out_txt, l_tvar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
  out_txt := Tpl.writeText(out_txt, l_evar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", 1); ++"));
  out_txt := Tpl.writeText(out_txt, l_tvar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ")\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_stmtStuff);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, a_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_body := a_body;
end algStmtForGeneric_impl;

protected function lm_1007
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1007(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1007;

public function algStmtWhile
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_var;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_WHILE(exp = i_exp, statementLst = i_statementLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_var, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "while(1)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, l_var);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") break;\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_1007(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtWhile;

public function algStmtAssert
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Absyn.Info i_info;
      DAE.Exp i_level;
      DAE.Exp i_msg;
      DAE.Exp i_cond;
      list<DAE.Exp> ret_0;

    case ( txt,
           DAE.STMT_ASSERT(source = DAE.SOURCE(info = i_info), cond = i_cond, msg = i_msg, level = i_level),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = List.fill(i_msg, 1);
        (txt, a_varDecls, a_auxFunction) = assertCommon(txt, i_cond, ret_0, i_level, a_context, a_varDecls, a_auxFunction, i_info);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssert;

public function algStmtTerminate
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ElementSource i_source;
      DAE.Exp i_msg;
      Absyn.Info ret_2;
      Tpl.Text l_msgVar;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_TERMINATE(msg = i_msg, source = i_source),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_msgVar, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_msg, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        ret_2 = DAEUtil.getElementSourceFileInfo(i_source);
        txt = infoArgs(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_terminate(info, "
                                }, false));
        txt = Tpl.writeText(txt, l_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtTerminate;

protected function lm_1011
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1011(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1011;

public function algStmtFailure
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_body;
      Tpl.Text l_stmtBody;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.STMT_FAILURE(body = i_body),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        l_stmtBody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtBody, a_auxFunction, a_varDecls) = lm_1011(l_stmtBody, i_body, a_auxFunction, a_varDecls, a_context);
        l_stmtBody = Tpl.popIter(l_stmtBody);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0; /* begin failure */\n",
                                    "MMC_TRY_INTERNAL(mmc_jumper)\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_stmtBody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MMC_CATCH_INTERNAL(mmc_jumper)\n",
                                    "if ("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") MMC_THROW_INTERNAL(); /* end failure */"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtFailure;

protected function fun_1013
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expPart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expPart)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;

    case ( txt,
           false,
           a_expPart )
      equation
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1013;

public function algStmtNoretcall
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_NORETCALL(exp = (i_exp as DAE.MATCHEXPRESSION(matchType = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, _, _, l_preExp, a_varDecls, a_auxFunction) = daeExpMatch2(Tpl.emptyTxt, i_exp, SimCode.listExpLength1, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_NORETCALL(exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        ret_2 = Util.isCIdentifier(Tpl.textString(l_expPart));
        txt = fun_1013(txt, ret_2, l_expPart);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtNoretcall;

protected function lm_1015
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_1015(txt, rest);
      then txt;
  end match;
end lm_1015;

protected function lm_1016
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1016(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1016;

protected function fun_1017
  input Tpl.Text in_txt;
  input Boolean in_a_initialCall;
  input Tpl.Text in_a_statements;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialCall, in_a_statements)
    local
      Tpl.Text txt;
      Tpl.Text a_statements;

    case ( txt,
           true,
           a_statements )
      equation
        txt = Tpl.writeText(txt, a_statements);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* nothing to do */"));
      then txt;
  end match;
end fun_1017;

protected function fun_1018
  input Tpl.Text in_txt;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_when, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      Option<DAE.Statement> i_elseWhen;
      Boolean i_initialCall;
      list<DAE.Statement> i_statementLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_else;
      Tpl.Text l_initial__statements;
      Tpl.Text l_statements;
      Tpl.Text l_helpIf;

    case ( txt,
           DAE.STMT_WHEN(conditions = i_conditions, statementLst = i_statementLst, initialCall = i_initialCall, elseWhen = i_elseWhen),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        l_helpIf = lm_1015(Tpl.emptyTxt, i_conditions);
        l_statements = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_statements, a_auxFunction, a_varDecls) = lm_1016(l_statements, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_statements = Tpl.popIter(l_statements);
        l_initial__statements = fun_1017(Tpl.emptyTxt, i_initialCall, l_statements);
        (l_else, a_varDecls, a_auxFunction) = algStatementWhenElse(Tpl.emptyTxt, i_elseWhen, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(data->simulationInfo.discreteCall == 1)\n",
                                    "{\n",
                                    "  if(initial())\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_initial__statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  }\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if(0"));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_else);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_1018;

protected function fun_1019
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_when, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Statement a_when;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.Context i_context;

    case ( txt,
           (i_context as SimCode.SIMULATION_CONTEXT(genDiscrete = _)),
           a_when,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_1018(txt, a_when, a_auxFunction, a_varDecls, i_context);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_1019;

public function algStmtWhen
  input Tpl.Text txt;
  input DAE.Statement a_when;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_1019(txt, a_context, a_when, a_varDecls, a_auxFunction);
end algStmtWhen;

protected function lm_1021
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, SimCode.contextSimulationDiscrete, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1021(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1021;

protected function lm_1022
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.popBlock(txt);
        txt = lm_1022(txt, rest);
      then txt;
  end match;
end lm_1022;

public function algStatementWhenElse
  input Tpl.Text in_txt;
  input Option<DAE.Statement> in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.ComponentRef> i_when_conditions;
      Option<DAE.Statement> i_when_elseWhen;
      list<DAE.Statement> i_when_statementLst;
      Tpl.Text l_elseCondStr;
      Tpl.Text l_else;
      Tpl.Text l_statements;

    case ( txt,
           SOME(DAE.STMT_WHEN(statementLst = i_when_statementLst, elseWhen = i_when_elseWhen, conditions = i_when_conditions)),
           a_varDecls,
           a_auxFunction )
      equation
        l_statements = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_statements, a_auxFunction, a_varDecls) = lm_1021(l_statements, i_when_statementLst, a_auxFunction, a_varDecls);
        l_statements = Tpl.popIter(l_statements);
        (l_else, a_varDecls, a_auxFunction) = algStatementWhenElse(Tpl.emptyTxt, i_when_elseWhen, a_varDecls, a_auxFunction);
        l_elseCondStr = lm_1022(Tpl.emptyTxt, i_when_conditions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if(0"));
        txt = Tpl.writeText(txt, l_elseCondStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_else);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStatementWhenElse;

public function algStmtReinit
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_value;
      DAE.Exp i_var;
      Tpl.Text l_expPart2;
      Tpl.Text l_expPart1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_REINIT(var = i_var, value = i_value),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_var, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart2, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_value, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "infoStreamPrint(LOG_EVENTS, 0, \"reinit "
                                }, false));
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = %f\", "));
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "data->simulationInfo.needToIterate = 1;"
                                }, false));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtReinit;

public function indexSpecFromCref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Subscript> i_subs;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = (i_subs as _ :: _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhsIndexSpec(txt, i_subs, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end indexSpecFromCref;

protected function lm_1026
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1026(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1026;

protected function lm_1027
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_1027(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_1027;

public function elseExpr
  input Tpl.Text in_txt;
  input DAE.Else in_a_else__;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_else__, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Else i_else__;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_condExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.NOELSE(),
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ELSEIF(exp = i_exp, statementLst = i_statementLst, else_ = i_else__),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_condExp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_condExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_1026(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, a_varDecls, a_auxFunction) = elseExpr(txt, i_else__, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ELSE(statementLst = i_statementLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_1027(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end elseExpr;

protected function fun_1029
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_ecr_componentRef;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_ecr_componentRef, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_ecr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_ecr_componentRef;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_ecr;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_ecr )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(txt, a_ecr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_ecr_componentRef,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           _ )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_ecr_componentRef, a_context, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1029;

protected function fun_1030
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_preExp, in_a_auxFunction, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      list<DAE.Subscript> ret_3;
      list<DAE.Dimension> ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text l_arrName;

    case ( txt,
           false,
           a_varDecls,
           a_preExp,
           a_auxFunction,
           a_context,
           a_cr )
      equation
        ret_1 = ComponentReference.crefStripSubs(a_cr);
        (l_arrName, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_1, a_context, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, l_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")["));
        ret_2 = ComponentReference.crefDims(a_cr);
        ret_3 = ComponentReference.crefSubs(a_cr);
        (txt, a_preExp, a_varDecls, a_auxFunction) = threadDimSubList(txt, ret_2, ret_3, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1]"));
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_preExp,
           a_auxFunction,
           a_context,
           a_cr )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_cr, a_context, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);
  end match;
end fun_1030;

public function scalarLhsCref
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_ecr;
      DAE.ComponentRef i_ecr_componentRef;
      DAE.ComponentRef i_cr;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.crefStr(txt, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = (i_ecr_componentRef as DAE.CREF_IDENT(ident = _)))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = SimCodeUtil.crefNoSub(i_ecr_componentRef);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1029(txt, ret_0, i_ecr_componentRef, a_auxFunction, a_varDecls, a_preExp, a_context, i_ecr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = (i_cr as DAE.CREF_QUAL(ident = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = SimCodeUtil.crefIsScalar(i_cr, a_context);
        (txt, a_varDecls, a_preExp, a_auxFunction) = fun_1030(txt, ret_1, a_varDecls, a_preExp, a_auxFunction, a_context, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7688, 11), "scalarLhsCref:ONLY_IDENT_OR_QUAL_CREF_SUPPORTED_SLHS");
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end scalarLhsCref;

public function rhsCref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident),
           a_ty )
      equation
        txt = rhsCrefType(txt, a_ty);
        txt = Tpl.writeStr(txt, i_ident);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef),
           a_ty )
      equation
        txt = rhsCrefType(txt, a_ty);
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = rhsCref(txt, i_componentRef, a_ty);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7697, 14), "rhsCref:ERROR");
      then txt;
  end match;
end rhsCref;

public function rhsCrefType
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end rhsCrefType;

protected function fun_1034
  input Tpl.Text in_txt;
  input Boolean in_a_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1034;

public function daeExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Exp i_e;
      Integer i_index;
      Boolean i_bool;
      String i_string;
      Real i_real;
      Integer i_integer;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer) "));
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.RCONST(real = i_real),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.SCONST(string = i_string),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSconst(txt, i_string);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.BCONST(bool = i_bool),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = fun_1034(txt, i_bool);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CREF(componentRef = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.BINARY(exp1 = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpBinary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.UNARY(operator = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpUnary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.LBINARY(exp1 = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpLbinary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.LUNARY(operator = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpLunary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RELATION(exp1 = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRelation(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.IFEXP(expCond = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpIf(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CALL(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCall(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RECORD(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRecord(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.PARTEVALFUNCTION(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpPartEvalFunction(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.ARRAY(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpArray(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.MATRIX(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMatrix(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RANGE(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRange(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CAST(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCast(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.ASUB(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpAsub(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.TSUB(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpTsub(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.SIZE(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpSize(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.REDUCTION(reductionInfo = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpReduction(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.TUPLE(PR = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpTuple(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.LIST(valList = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpList(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CONS(car = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCons(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.META_TUPLE(listExp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMetaTuple(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.META_OPTION(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMetaOption(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.METARECORDCALL(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMetarecordcall(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.MATCHEXPRESSION(matchType = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMatch(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.BOX(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpBox(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.UNBOX(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpUnbox(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.SHARED_LITERAL(index = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSharedLiteral(txt, i_e);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown expression: "));
        ret_0 = ExpressionDump.printExpStr(i_exp);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7748, 14), Tpl.textString(txt_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExp;

protected function fun_1036
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type ret_2;
      DAE.Type ret_1;
      Tpl.Text l_shortTypeStr;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(a_exp);
        l_shortTypeStr = expTypeShort(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        ret_2 = Expression.typeof(a_exp);
        txt = extType(txt, ret_2, true, true);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") data_of_"));
        txt = Tpl.writeText(txt, l_shortTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_1036;

public function daeExternalCExp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  DAE.Type ret_0;
algorithm
  ret_0 := Expression.typeof(a_exp);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_1036(txt, ret_0, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExternalCExp;

protected function fun_1038
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Tpl.Text txt_5;
      Tpl.Text l_tvar;
      Tpl.Text l_texp;
      DAE.Type ret_2;
      DAE.Type ret_1;
      Tpl.Text l_shortTypeStr;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(a_exp);
        l_shortTypeStr = expTypeShort(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        ret_2 = Expression.typeof(a_exp);
        txt = extType(txt, ret_2, true, true);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") data_of_"));
        txt = Tpl.writeText(txt, l_shortTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_texp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_exp, SimCode.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt_5 = expTypeFromExpFlag(Tpl.emptyTxt, a_exp, 8);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_texp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_1038;

public function daeExternalF77Exp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  DAE.Type ret_0;
algorithm
  ret_0 := Expression.typeof(a_exp);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_1038(txt, ret_0, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExternalF77Exp;

public function daeExpSconst
  input Tpl.Text txt;
  input String a_string;

  output Tpl.Text out_txt;
protected
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("\""));
  ret_0 := Util.escapeModelicaStringToCString(a_string);
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
end daeExpSconst;

protected function lm_1041
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1041(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1041(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1041;

protected function fun_1042
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_varDecls, in_a_preExp, in_a_exp, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef i_cr_componentRef;
      DAE.Ident i_cr_ident;
      DAE.ComponentRef i_cr;
      ClassInf.State i_record__state;
      list<DAE.Subscript> ret_10;
      Tpl.Text l_dimsValuesStr;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_5;
      Tpl.Text l_recPtr;
      Absyn.Path ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(identType = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), ident = i_cr_ident, componentRef = i_cr_componentRef)),
           a_varDecls,
           a_preExp,
           _,
           a_auxFunction,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        ret_3 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_3);
        txt_5 = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("*"));
        (l_recPtr, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), l_varDecls);
        ret_7 = ComponentReference.crefSubs(i_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = ComponentReference.crefSubs(i_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, l_varDecls, l_preExp) = lm_1041(l_dimsValuesStr, ret_10, a_auxFunction, l_varDecls, l_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_element_addr(&_"));
        txt = Tpl.writeStr(txt, i_cr_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))->"));
        (txt, a_auxFunction) = contextCref(txt, i_cr_componentRef, a_context, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_preExp,
           a_exp,
           a_auxFunction,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs2(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);
  end match;
end fun_1042;

protected function lm_1043
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1043(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1043(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1043;

protected function fun_1044
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_varDecls, in_a_preExp, in_a_exp, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.ComponentRef i_cr_componentRef;
      DAE.Ident i_cr_ident;
      DAE.ComponentRef i_cr;
      ClassInf.State i_record__state;
      list<DAE.Subscript> ret_10;
      Tpl.Text l_dimsValuesStr;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_5;
      Tpl.Text l_recPtr;
      Absyn.Path ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(identType = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), ident = i_cr_ident, componentRef = i_cr_componentRef)),
           a_varDecls,
           a_preExp,
           _,
           a_auxFunction,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        ret_3 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_3);
        txt_5 = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("*"));
        (l_recPtr, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), l_varDecls);
        ret_7 = ComponentReference.crefSubs(i_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = ComponentReference.crefSubs(i_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, l_varDecls, l_preExp) = lm_1043(l_dimsValuesStr, ret_10, a_auxFunction, l_varDecls, l_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_element_addr(&_"));
        txt = Tpl.writeStr(txt, i_cr_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))->"));
        (txt, a_auxFunction) = contextCref(txt, i_cr_componentRef, a_context, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_preExp,
           a_exp,
           a_auxFunction,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs2(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);
  end match;
end fun_1044;

protected function fun_1045
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_t, in_a_varDecls, in_a_preExp, in_a_exp, in_a_auxFunction, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Type a_t;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_cr;
      SimCode.Context i_context;

    case ( txt,
           (i_context as SimCode.FUNCTION_CONTEXT()),
           _,
           a_varDecls,
           a_preExp,
           a_exp,
           a_auxFunction,
           a_cr )
      equation
        (txt, a_varDecls, a_preExp, a_auxFunction) = fun_1042(txt, a_cr, a_varDecls, a_preExp, a_exp, a_auxFunction, i_context);
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           (i_context as SimCode.PARALLEL_FUNCTION_CONTEXT()),
           _,
           a_varDecls,
           a_preExp,
           a_exp,
           a_auxFunction,
           a_cr )
      equation
        (txt, a_varDecls, a_preExp, a_auxFunction) = fun_1044(txt, a_cr, a_varDecls, a_preExp, a_exp, a_auxFunction, i_context);
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           i_context,
           a_t,
           a_varDecls,
           a_preExp,
           _,
           a_auxFunction,
           a_cr )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRecordCrefRhs(txt, a_t, a_cr, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);
  end match;
end fun_1045;

public function daeExpCrefRhs
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Ident i_cr_ident;
      list<DAE.Var> i_ty_fields;
      DAE.Ident i_cri_ident;
      DAE.Type i_t;
      DAE.Exp i_exp;
      DAE.ComponentRef i_cr;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_offset;

    case ( txt,
           (i_exp as DAE.CREF(componentRef = i_cr, ty = (i_t as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_preExp, a_auxFunction) = fun_1045(txt, a_context, i_t, a_varDecls, a_preExp, i_exp, a_auxFunction, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxvar_"));
        txt = crefFunctionName(txt, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_fnptr) _"));
        txt = CodegenUtil.crefStr(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = DAE.CREF_QUAL(subscriptLst = {}, identType = DAE.T_METATYPE(ty = DAE.T_METARECORD(fields = i_ty_fields)), componentRef = DAE.CREF_IDENT(ident = i_cri_ident), ident = i_cr_ident)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Types.findVarIndex(i_cri_ident, i_ty_fields);
        ret_2 = intAdd(ret_1, 2);
        l_offset = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_cr_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_offset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs2(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefRhs;

protected function lm_1047
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1047(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1047(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1047;

protected function lm_1048
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeDimensionExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1048(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1048(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1048;

protected function fun_1049
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_dimsValuesStr;
  input Tpl.Text in_a_dimsLenStr;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_arrayType, in_a_dimsValuesStr, in_a_dimsLenStr, in_a_arrName)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_dimsValuesStr;
      Tpl.Text a_dimsLenStr;
      Tpl.Text a_arrName;
      ClassInf.State i_record__state;
      Absyn.Path ret_2;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)),
           _,
           a_dimsValuesStr,
           a_dimsLenStr,
           a_arrName )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*(("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_element_addr(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))))"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           a_dimsValuesStr,
           a_dimsLenStr,
           a_arrName )
      equation
        ret_2 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*(("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_element_addr(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))))"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_dimsValuesStr,
           a_dimsLenStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;
  end match;
end fun_1049;

protected function lm_1050
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1050(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1050(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1050;

protected function fun_1051
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr, in_a_arrName)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text a_arrName;
      Tpl.Text txt_2;
      String ret_2;
      list<DAE.Subscript> ret_1;
      list<DAE.Dimension> ret_0;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")["));
        ret_0 = ComponentReference.crefDims(a_cr);
        ret_1 = ComponentReference.crefSubs(a_cr);
        (txt, a_preExp, a_varDecls, a_auxFunction) = threadDimSubList(txt, ret_0, ret_1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1]"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _ )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Indexing non-array "));
        ret_2 = ExpressionDump.printExpStr(a_ecr);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7897, 28), Tpl.textString(txt_2));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1051;

protected function fun_1052
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_dimsLenStr;
  input Tpl.Text in_a_arrName;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_ecr, in_a_arrayType, in_a_dimsLenStr, in_a_arrName, in_a_ty, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_arrayType;
      Tpl.Text a_dimsLenStr;
      Tpl.Text a_arrName;
      DAE.Type a_ty;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.ComponentRef a_cr;
      SimCode.Context i_context;
      DAE.Type ret_3;
      list<DAE.Subscript> ret_2;
      list<DAE.Subscript> ret_1;
      Tpl.Text l_dimsValuesStr;

    case ( txt,
           (i_context as SimCode.FUNCTION_CONTEXT()),
           _,
           a_arrayType,
           a_dimsLenStr,
           a_arrName,
           a_ty,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_cr )
      equation
        ret_1 = ComponentReference.crefSubs(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_1048(l_dimsValuesStr, ret_1, a_auxFunction, a_varDecls, a_preExp, i_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = fun_1049(txt, a_ty, a_arrayType, l_dimsValuesStr, a_dimsLenStr, a_arrName);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_context as SimCode.PARALLEL_FUNCTION_CONTEXT()),
           _,
           a_arrayType,
           a_dimsLenStr,
           a_arrName,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_cr )
      equation
        ret_2 = ComponentReference.crefSubs(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_1050(l_dimsValuesStr, ret_2, a_auxFunction, a_varDecls, a_preExp, i_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr_c99_"));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_ecr,
           _,
           _,
           a_arrName,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_cr )
      equation
        ret_3 = ComponentReference.crefLastType(a_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1051(txt, ret_3, a_ecr, a_auxFunction, a_varDecls, a_preExp, i_context, a_cr, a_arrName);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1052;

protected function fun_1053
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_dimsLenStr;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_arrName;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_arrayType, in_a_dimsLenStr, in_a_ty, in_a_arrName, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_arrayType;
      Tpl.Text a_dimsLenStr;
      DAE.Type a_ty;
      Tpl.Text a_arrName;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      list<DAE.Subscript> ret_1;
      Tpl.Text l_dimsValuesStr;

    case ( txt,
           "metatype_array",
           _,
           _,
           _,
           _,
           a_arrName,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        ret_1 = ComponentReference.crefSubs(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_1047(l_dimsValuesStr, ret_1, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.CREF */"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_ecr,
           a_arrayType,
           a_dimsLenStr,
           a_ty,
           a_arrName,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1052(txt, a_context, a_ecr, a_arrayType, a_dimsLenStr, a_arrName, a_ty, a_auxFunction, a_varDecls, a_preExp, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1053;

protected function fun_1054
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      String str_9;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      DAE.ComponentRef ret_5;
      list<DAE.Subscript> ret_4;
      Tpl.Text l_spec1;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayType;
      Tpl.Text l_arrName;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        l_arrName = contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), a_varDecls);
        ret_4 = ComponentReference.crefSubs(a_cr);
        (l_spec1, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhsIndexSpec(Tpl.emptyTxt, ret_4, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("index_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayType);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_spec1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_5 = ComponentReference.crefStripLastSubs(a_cr);
        (l_arrName, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_5, a_context, a_auxFunction);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        ret_7 = ComponentReference.crefSubs(a_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        str_9 = Tpl.textString(l_arrayType);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1053(txt, str_9, a_ecr, l_arrayType, l_dimsLenStr, a_ty, l_arrName, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1054;

protected function fun_1055
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1055;

protected function fun_1056
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text l_cast;
      Boolean ret_0;

    case ( txt,
           false,
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeUtil.crefSubIsScalar(a_cr);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1054(txt, ret_0, a_ecr, a_auxFunction, a_preExp, a_varDecls, a_ty, a_context, a_cr);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        l_cast = fun_1055(Tpl.emptyTxt, a_ty);
        txt = Tpl.writeText(txt, l_cast);
        (txt, a_auxFunction) = contextCref(txt, a_cr, a_context, a_auxFunction);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1056;

protected function fun_1057
  input Tpl.Text in_txt;
  input Tpl.Text in_a_box;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_box, in_a_ecr, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text i_box;
      Boolean ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeUtil.crefIsScalar(a_cr, a_context);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1056(txt, ret_0, a_ecr, a_auxFunction, a_preExp, a_varDecls, a_ty, a_context, a_cr);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           i_box,
           _,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_box);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1057;

public function daeExpCrefRhs2
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      DAE.ComponentRef i_cr;
      DAE.Exp i_ecr;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text l_box;

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_box, a_preExp, a_varDecls) = daeExpCrefRhsArrayBox(Tpl.emptyTxt, i_ecr, a_context, a_preExp, a_varDecls);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1057(txt, l_box, i_ecr, a_auxFunction, a_preExp, a_varDecls, i_ty, a_context, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_ecr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefRhs2: UNHANDLED EXPRESSION: "));
        ret_1 = ExpressionDump.printExpStr(i_ecr);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7908, 11), Tpl.textString(txt_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefRhs2;

protected function fun_1059
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_dims;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_sub_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_dims, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_sub_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_sub_exp;
      Tpl.Text l_estr;

    case ( txt,
           {_},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_sub_exp )
      equation
        (l_estr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_sub_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_estr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7922, 16), "Less subscripts that dimensions in indexing cref? That\'s odd!");
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1059;

protected function fun_1060
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_dim;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dim)
    local
      Tpl.Text txt;
      Integer i_size;
      Integer i_integer;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1)*"));
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.DIM_BOOLEAN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*2"));
      then txt;

    case ( txt,
           DAE.DIM_ENUM(size = i_size) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeStr(txt, intString(i_size));
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7935, 22), "Non-constant dimension in simulation context");
      then txt;
  end match;
end fun_1060;

protected function lm_1061
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = fun_1060(txt, i_dim);
        txt = lm_1061(txt, rest);
      then txt;
  end match;
end lm_1061;

protected function fun_1062
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subrest;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<DAE.Dimension> in_a_dimrest;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_subrest, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_dimrest)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<DAE.Dimension> a_dimrest;
      list<DAE.Subscript> i_subrest;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_subrest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_dimrest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = threadDimSubList(txt, a_dimrest, i_subrest, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1062;

protected function fun_1063
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_dims;
  input list<DAE.Subscript> in_a_subrest;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_sub_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_dims, in_a_subrest, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_sub_exp)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subrest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_sub_exp;
      list<DAE.Dimension> i_dimrest;
      Tpl.Text l_estr;

    case ( txt,
           _ :: i_dimrest,
           a_subrest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_sub_exp )
      equation
        (l_estr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_sub_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_estr);
        txt = lm_1061(txt, i_dimrest);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1062(txt, a_subrest, a_auxFunction, a_varDecls, a_preExp, a_context, i_dimrest);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7937, 18), "Less subscripts that dimensions in indexing cref? That\'s odd!");
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1063;

protected function fun_1064
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subs;
  input list<DAE.Dimension> in_a_dims;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_subs, in_a_dims, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<DAE.Dimension> a_dims;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Subscript> i_subrest;
      DAE.Exp i_sub_exp;

    case ( txt,
           {},
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7915, 22), "Empty dimensions in indexing cref?");
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           {DAE.INDEX(exp = i_sub_exp)},
           a_dims,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1059(txt, a_dims, a_auxFunction, a_varDecls, a_preExp, a_context, i_sub_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.INDEX(exp = i_sub_exp) :: i_subrest,
           a_dims,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1063(txt, a_dims, i_subrest, a_auxFunction, a_varDecls, a_preExp, a_context, i_sub_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 7938, 14), "Non-index subscript in indexing cref? That\'s odd!");
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_1064;

public function threadDimSubList
  input Tpl.Text txt;
  input list<DAE.Dimension> a_dims;
  input list<DAE.Subscript> a_subs;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_1064(txt, a_subs, a_dims, a_context, a_preExp, a_varDecls, a_auxFunction);
end threadDimSubList;

protected function fun_1066
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_sub;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_sub, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_tmp;
      Tpl.Text l_str;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.INDEX(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(0), make_index_array(1, (int) "));
        l_str = Tpl.writeText(l_str, l_expPart);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("), \'S\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.WHOLEDIM(),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(1), (int*)0, \'W\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.SLICE(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 1);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(int) "));
        l_str = Tpl.writeText(l_str, l_tmp);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING(", integer_array_make_index_array(&"));
        l_str = Tpl.writeText(l_str, l_expPart);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("), \'A\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1066;

protected function lm_1067
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1066(txt, i_sub, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1067(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1067;

public function daeExpCrefRhsIndexSpec
  input Tpl.Text txt;
  input list<DAE.Subscript> a_subs;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_tmp;
  Tpl.Text l_idx__str;
  Integer ret_1;
  Tpl.Text l_nridx__str;
algorithm
  ret_1 := listLength(a_subs);
  l_nridx__str := Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
  l_idx__str := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_idx__str, out_a_auxFunction, out_a_varDecls, out_a_preExp) := lm_1067(l_idx__str, a_subs, a_auxFunction, a_varDecls, a_preExp, a_context);
  l_idx__str := Tpl.popIter(l_idx__str);
  (l_tmp, out_a_varDecls) := tempDecl(Tpl.emptyTxt, "index_spec_t", out_a_varDecls);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("create_index_spec(&"));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_tmp);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(", "));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_nridx__str);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(", "));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_idx__str);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(");"));
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_tmp);
end daeExpCrefRhsIndexSpec;

protected function lm_1069
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_1069(txt, rest);
      then txt;
  end match;
end lm_1069;

protected function fun_1070
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_ecr_componentRef;
  input Tpl.Text in_a_preExp;
  input DAE.Dimensions in_a_dims;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_aty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_ecr_componentRef, in_a_preExp, in_a_dims, in_a_varDecls, in_a_aty)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_ecr_componentRef;
      Tpl.Text a_preExp;
      DAE.Dimensions a_dims;
      Tpl.Text a_varDecls;
      DAE.Type a_aty;
      Tpl.Text l_type;
      Tpl.Text l_dimsValuesStr;
      Integer ret_3;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_1;
      Tpl.Text l_tmpArr;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           _,
           a_preExp,
           _,
           a_varDecls,
           _ )
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           _,
           a_preExp,
           _,
           a_varDecls,
           _ )
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_ecr_componentRef,
           a_preExp,
           a_dims,
           a_varDecls,
           a_aty )
      equation
        txt_1 = expTypeArray(Tpl.emptyTxt, a_aty);
        (l_tmpArr, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_3 = listLength(a_dims);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dimsValuesStr = lm_1069(l_dimsValuesStr, a_dims);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_type = expTypeShort(Tpl.emptyTxt, a_aty);
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array_create(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmpArr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", ((modelica_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("*)&("));
        a_preExp = arrayCrefCStr(a_preExp, a_ecr_componentRef);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")), "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsLenStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsValuesStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmpArr);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1070;

public function daeExpCrefRhsArrayBox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.ComponentRef i_ecr_componentRef;
      DAE.Dimensions i_dims;
      DAE.Type i_aty;

    case ( txt,
           DAE.CREF(ty = DAE.T_ARRAY(ty = i_aty, dims = i_dims), componentRef = i_ecr_componentRef),
           a_context,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls) = fun_1070(txt, a_context, i_ecr_componentRef, a_preExp, i_dims, a_varDecls, i_aty);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);
  end match;
end daeExpCrefRhsArrayBox;

protected function lm_1072
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Var i_v;
      DAE.Exp ret_0;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_v :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_0 = SimCodeUtil.makeCrefRecordExp(a_cr, i_v);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, ret_0, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1072(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1072;

public function daeExpRecordCrefRhs
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ty, in_a_cr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      ClassInf.State i_record__state;
      list<DAE.Var> i_var__lst;
      Absyn.Path ret_2;
      Tpl.Text l_record__type__name;
      Tpl.Text l_vars;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state, varLst = i_var__lst),
           a_cr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_vars, a_auxFunction, a_varDecls, a_preExp) = lm_1072(Tpl.emptyTxt, i_var__lst, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
        ret_2 = ClassInf.getStateName(i_record__state);
        l_record__type__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = Tpl.writeText(txt, l_record__type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData"));
        txt = Tpl.writeText(txt, l_vars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRecordCrefRhs;

protected function fun_1074
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_afterExp;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_afterExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_afterExp) :=
  match(in_txt, in_a_context, in_a_cr, in_a_t, in_a_auxFunction, in_a_varDecls, in_a_afterExp, in_a_exp)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      DAE.Type a_t;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_afterExp;
      DAE.Exp a_exp;
      SimCode.Context i_context;

    case ( txt,
           (i_context as SimCode.FUNCTION_CONTEXT()),
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_exp )
      equation
        (txt, a_afterExp, a_varDecls, a_auxFunction) = daeExpCrefLhs2(txt, a_exp, i_context, a_afterExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           (i_context as SimCode.PARALLEL_FUNCTION_CONTEXT()),
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_exp )
      equation
        (txt, a_afterExp, a_varDecls, a_auxFunction) = daeExpCrefLhs2(txt, a_exp, i_context, a_afterExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           i_context,
           a_cr,
           a_t,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _ )
      equation
        (txt, a_afterExp, a_varDecls, a_auxFunction) = daeExpRecordCrefLhs(txt, a_t, a_cr, i_context, a_afterExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);
  end match;
end fun_1074;

public function daeExpCrefLhs
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_afterExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_afterExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_cr;
      DAE.Type i_t;
      DAE.Exp i_exp;

    case ( txt,
           (i_exp as DAE.CREF(componentRef = i_cr, ty = (i_t as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))))),
           a_context,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_afterExp) = fun_1074(txt, a_context, i_cr, i_t, a_auxFunction, a_varDecls, a_afterExp, i_exp);
      then (txt, a_afterExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _)),
           _,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_fnptr)boxptr_"));
        txt = crefFunctionName(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_afterExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           _,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_fnptr) omc_"));
        txt = CodegenUtil.crefStr(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_afterExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           a_context,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_afterExp, a_varDecls, a_auxFunction) = daeExpCrefLhs2(txt, i_exp, a_context, a_afterExp, a_varDecls, a_auxFunction);
      then (txt, a_afterExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefLhs;

protected function lm_1076
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_afterExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_afterExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_afterExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_afterExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_afterExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context )
      equation
        (txt, a_afterExp, a_varDecls, a_auxFunction) = daeDimensionExp(txt, i_exp, a_context, a_afterExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_afterExp) = lm_1076(txt, rest, a_auxFunction, a_varDecls, a_afterExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_afterExp) = lm_1076(txt, rest, a_auxFunction, a_varDecls, a_afterExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);
  end match;
end lm_1076;

protected function fun_1077
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_cr, in_a_arrName)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text a_arrName;
      Tpl.Text txt_3;
      String ret_3;
      list<DAE.Subscript> ret_2;
      list<DAE.Dimension> ret_1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_cr,
           a_arrName )
      equation
        l_preExp = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")["));
        ret_1 = ComponentReference.crefDims(a_cr);
        ret_2 = ComponentReference.crefSubs(a_cr);
        (txt, l_preExp, a_varDecls, a_auxFunction) = threadDimSubList(txt, ret_1, ret_2, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1]"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_varDecls,
           _,
           _,
           _ )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Indexing non-array "));
        ret_3 = ExpressionDump.printExpStr(a_ecr);
        txt_3 = Tpl.writeStr(txt_3, ret_3);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8085, 30), Tpl.textString(txt_3));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_1077;

protected function fun_1078
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_dimsValuesStr;
  input Tpl.Text in_a_arrName;
  input Tpl.Text in_a_dimsLenStr;
  input Tpl.Text in_a_arrayType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_ecr, in_a_auxFunction, in_a_varDecls, in_a_cr, in_a_dimsValuesStr, in_a_arrName, in_a_dimsLenStr, in_a_arrayType)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.ComponentRef a_cr;
      Tpl.Text a_dimsValuesStr;
      Tpl.Text a_arrName;
      Tpl.Text a_dimsLenStr;
      Tpl.Text a_arrayType;
      SimCode.Context i_context;
      DAE.Type ret_0;

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           _,
           a_auxFunction,
           a_varDecls,
           _,
           a_dimsValuesStr,
           a_arrName,
           a_dimsLenStr,
           a_arrayType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr_c99_"));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           _,
           a_auxFunction,
           a_varDecls,
           _,
           a_dimsValuesStr,
           a_arrName,
           a_dimsLenStr,
           a_arrayType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_context,
           a_ecr,
           a_auxFunction,
           a_varDecls,
           a_cr,
           _,
           a_arrName,
           _,
           _ )
      equation
        ret_0 = ComponentReference.crefLastType(a_cr);
        (txt, a_auxFunction, a_varDecls) = fun_1077(txt, ret_0, a_ecr, a_auxFunction, a_varDecls, i_context, a_cr, a_arrName);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_1078;

protected function fun_1079
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_dimsLenStr;
  input Tpl.Text in_a_arrayType;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_dimsValuesStr;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_varDecls, in_a_cr, in_a_dimsLenStr, in_a_arrayType, in_a_context, in_a_dimsValuesStr, in_a_arrName)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.ComponentRef a_cr;
      Tpl.Text a_dimsLenStr;
      Tpl.Text a_arrayType;
      SimCode.Context a_context;
      Tpl.Text a_dimsValuesStr;
      Tpl.Text a_arrName;

    case ( txt,
           "metatype_array",
           _,
           a_auxFunction,
           a_varDecls,
           _,
           _,
           _,
           _,
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.CREF */"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_varDecls,
           a_cr,
           a_dimsLenStr,
           a_arrayType,
           a_context,
           a_dimsValuesStr,
           a_arrName )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_1078(txt, a_context, a_ecr, a_auxFunction, a_varDecls, a_cr, a_dimsValuesStr, a_arrName, a_dimsLenStr, a_arrayType);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_1079;

protected function fun_1080
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_afterExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_afterExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      String str_11;
      list<DAE.Subscript> ret_10;
      Tpl.Text l_dimsValuesStr;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      DAE.ComponentRef ret_5;
      list<DAE.Subscript> ret_4;
      Tpl.Text l_spec1;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayType;
      Tpl.Text l_arrName;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_afterExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        l_arrName = contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), a_varDecls);
        ret_4 = ComponentReference.crefSubs(a_cr);
        (l_spec1, a_afterExp, a_varDecls, a_auxFunction) = daeExpCrefLhsIndexSpec(Tpl.emptyTxt, ret_4, a_context, a_afterExp, a_varDecls, a_auxFunction);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING("indexed_assign_"));
        a_afterExp = Tpl.writeText(a_afterExp, l_arrayType);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING("("));
        a_afterExp = Tpl.writeText(a_afterExp, l_tmp);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(", &"));
        a_afterExp = Tpl.writeText(a_afterExp, l_arrName);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(", &"));
        a_afterExp = Tpl.writeText(a_afterExp, l_spec1);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(");"));
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_afterExp, a_varDecls);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_afterExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_5 = ComponentReference.crefStripLastSubs(a_cr);
        (l_arrName, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_5, a_context, a_auxFunction);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        ret_7 = ComponentReference.crefSubs(a_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = ComponentReference.crefSubs(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_afterExp) = lm_1076(l_dimsValuesStr, ret_10, a_auxFunction, a_varDecls, a_afterExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        str_11 = Tpl.textString(l_arrayType);
        (txt, a_auxFunction, a_varDecls) = fun_1079(txt, str_11, a_ecr, a_auxFunction, a_varDecls, a_cr, l_dimsLenStr, l_arrayType, a_context, l_dimsValuesStr, l_arrName);
      then (txt, a_auxFunction, a_afterExp, a_varDecls);
  end match;
end fun_1080;

protected function fun_1081
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_afterExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_afterExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Boolean ret_0;

    case ( txt,
           false,
           a_ecr,
           a_auxFunction,
           a_afterExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeUtil.crefSubIsScalar(a_cr);
        (txt, a_auxFunction, a_afterExp, a_varDecls) = fun_1080(txt, ret_0, a_ecr, a_auxFunction, a_afterExp, a_varDecls, a_ty, a_context, a_cr);
      then (txt, a_auxFunction, a_afterExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_afterExp,
           a_varDecls,
           _,
           a_context,
           a_cr )
      equation
        (txt, a_auxFunction) = contextCref(txt, a_cr, a_context, a_auxFunction);
      then (txt, a_auxFunction, a_afterExp, a_varDecls);
  end match;
end fun_1081;

protected function fun_1082
  input Tpl.Text in_txt;
  input Tpl.Text in_a_box;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_afterExp, out_a_varDecls) :=
  match(in_txt, in_a_box, in_a_ecr, in_a_auxFunction, in_a_afterExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text i_box;
      Boolean ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_ecr,
           a_auxFunction,
           a_afterExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeUtil.crefIsScalar(a_cr, a_context);
        (txt, a_auxFunction, a_afterExp, a_varDecls) = fun_1081(txt, ret_0, a_ecr, a_auxFunction, a_afterExp, a_varDecls, a_ty, a_context, a_cr);
      then (txt, a_auxFunction, a_afterExp, a_varDecls);

    case ( txt,
           i_box,
           _,
           a_auxFunction,
           a_afterExp,
           a_varDecls,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_box);
      then (txt, a_auxFunction, a_afterExp, a_varDecls);
  end match;
end fun_1082;

public function daeExpCrefLhs2
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_afterExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_afterExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      DAE.ComponentRef i_cr;
      DAE.Exp i_ecr;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text l_box;

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = i_ty)),
           a_context,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_box, a_afterExp, a_varDecls) = daeExpCrefLhsArrayBox(Tpl.emptyTxt, i_ecr, a_context, a_afterExp, a_varDecls);
        (txt, a_auxFunction, a_afterExp, a_varDecls) = fun_1082(txt, l_box, i_ecr, a_auxFunction, a_afterExp, a_varDecls, i_ty, a_context, i_cr);
      then (txt, a_afterExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_ecr,
           _,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("SimCodeC.tpl template: daeExpCrefLhs2: UNHANDLED EXPRESSION:  "));
        ret_1 = ExpressionDump.printExpStr(i_ecr);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8097, 11), Tpl.textString(txt_1));
      then (txt, a_afterExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefLhs2;

protected function fun_1084
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_sub;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_afterExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_afterExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_afterExp) :=
  match(in_txt, in_a_sub, in_a_auxFunction, in_a_varDecls, in_a_afterExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_afterExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_tmp;
      Tpl.Text l_str;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.INDEX(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context )
      equation
        (l_expPart, a_afterExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_afterExp, a_varDecls, a_auxFunction);
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(0), make_index_array(1, (int) "));
        l_str = Tpl.writeText(l_str, l_expPart);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("), \'S\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           DAE.WHOLEDIM(),
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _ )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(1), (int*)0, \'W\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           DAE.SLICE(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context )
      equation
        (l_expPart, a_afterExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_afterExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        a_afterExp = Tpl.writeText(a_afterExp, l_tmp);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        a_afterExp = Tpl.writeText(a_afterExp, l_expPart);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(", 1);"));
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_NEW_LINE());
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(int) "));
        l_str = Tpl.writeText(l_str, l_tmp);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING(", integer_array_make_index_array(&"));
        l_str = Tpl.writeText(l_str, l_expPart);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("), \'A\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_afterExp);
  end match;
end fun_1084;

protected function lm_1085
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_afterExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_afterExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_afterExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_afterExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_afterExp;
      SimCode.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_afterExp) = fun_1084(txt, i_sub, a_auxFunction, a_varDecls, a_afterExp, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_afterExp) = lm_1085(txt, rest, a_auxFunction, a_varDecls, a_afterExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);
  end match;
end lm_1085;

public function daeExpCrefLhsIndexSpec
  input Tpl.Text txt;
  input list<DAE.Subscript> a_subs;
  input SimCode.Context a_context;
  input Tpl.Text a_afterExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_tmp;
  Tpl.Text l_idx__str;
  Integer ret_1;
  Tpl.Text l_nridx__str;
algorithm
  ret_1 := listLength(a_subs);
  l_nridx__str := Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
  l_idx__str := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_idx__str, out_a_auxFunction, out_a_varDecls, out_a_afterExp) := lm_1085(l_idx__str, a_subs, a_auxFunction, a_varDecls, a_afterExp, a_context);
  l_idx__str := Tpl.popIter(l_idx__str);
  (l_tmp, out_a_varDecls) := tempDecl(Tpl.emptyTxt, "index_spec_t", out_a_varDecls);
  out_a_afterExp := Tpl.writeTok(out_a_afterExp, Tpl.ST_STRING("create_index_spec(&"));
  out_a_afterExp := Tpl.writeText(out_a_afterExp, l_tmp);
  out_a_afterExp := Tpl.writeTok(out_a_afterExp, Tpl.ST_STRING(", "));
  out_a_afterExp := Tpl.writeText(out_a_afterExp, l_nridx__str);
  out_a_afterExp := Tpl.writeTok(out_a_afterExp, Tpl.ST_STRING(", "));
  out_a_afterExp := Tpl.writeText(out_a_afterExp, l_idx__str);
  out_a_afterExp := Tpl.writeTok(out_a_afterExp, Tpl.ST_STRING(");"));
  out_a_afterExp := Tpl.writeTok(out_a_afterExp, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_tmp);
end daeExpCrefLhsIndexSpec;

protected function lm_1087
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_1087(txt, rest);
      then txt;
  end match;
end lm_1087;

protected function fun_1088
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_ecr_componentRef;
  input Tpl.Text in_a_afterExp;
  input DAE.Dimensions in_a_dims;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_aty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_afterExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_ecr_componentRef, in_a_afterExp, in_a_dims, in_a_varDecls, in_a_aty)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_ecr_componentRef;
      Tpl.Text a_afterExp;
      DAE.Dimensions a_dims;
      Tpl.Text a_varDecls;
      DAE.Type a_aty;
      Tpl.Text l_type;
      Tpl.Text l_dimsValuesStr;
      Integer ret_3;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_1;
      Tpl.Text l_tmpArr;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           _,
           a_afterExp,
           _,
           a_varDecls,
           _ )
      then (txt, a_afterExp, a_varDecls);

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           _,
           a_afterExp,
           _,
           a_varDecls,
           _ )
      then (txt, a_afterExp, a_varDecls);

    case ( txt,
           _,
           a_ecr_componentRef,
           a_afterExp,
           a_dims,
           a_varDecls,
           a_aty )
      equation
        txt_1 = expTypeArray(Tpl.emptyTxt, a_aty);
        (l_tmpArr, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_3 = listLength(a_dims);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dimsValuesStr = lm_1087(l_dimsValuesStr, a_dims);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_type = expTypeShort(Tpl.emptyTxt, a_aty);
        a_afterExp = Tpl.writeText(a_afterExp, l_type);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING("_array_create(&"));
        a_afterExp = Tpl.writeText(a_afterExp, l_tmpArr);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(", ((modelica_"));
        a_afterExp = Tpl.writeText(a_afterExp, l_type);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING("*)&("));
        a_afterExp = arrayCrefCStr(a_afterExp, a_ecr_componentRef);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(")), "));
        a_afterExp = Tpl.writeText(a_afterExp, l_dimsLenStr);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(", "));
        a_afterExp = Tpl.writeText(a_afterExp, l_dimsValuesStr);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(");"));
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmpArr);
      then (txt, a_afterExp, a_varDecls);
  end match;
end fun_1088;

public function daeExpCrefLhsArrayBox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_afterExp, out_a_varDecls) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_afterExp, in_a_varDecls)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      DAE.ComponentRef i_ecr_componentRef;
      DAE.Dimensions i_dims;
      DAE.Type i_aty;

    case ( txt,
           DAE.CREF(ty = DAE.T_ARRAY(ty = i_aty, dims = i_dims), componentRef = i_ecr_componentRef),
           a_context,
           a_afterExp,
           a_varDecls )
      equation
        (txt, a_afterExp, a_varDecls) = fun_1088(txt, a_context, i_ecr_componentRef, a_afterExp, i_dims, a_varDecls, i_aty);
      then (txt, a_afterExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_afterExp,
           a_varDecls )
      then (txt, a_afterExp, a_varDecls);
  end match;
end daeExpCrefLhsArrayBox;

protected function lm_1090
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_afterExp;
  input SimCode.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_afterExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_afterExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_afterExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_afterExp;
      SimCode.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Var i_v;
      DAE.Exp ret_0;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_afterExp);

    case ( txt,
           i_v :: rest,
           a_auxFunction,
           a_varDecls,
           a_afterExp,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeUtil.makeCrefRecordExp(a_cr, i_v);
        (txt, a_afterExp, a_varDecls, a_auxFunction) = daeExp(txt, ret_0, a_context, a_afterExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_afterExp) = lm_1090(txt, rest, a_auxFunction, a_varDecls, a_afterExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_afterExp);
  end match;
end lm_1090;

public function daeExpRecordCrefLhs
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_afterExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_afterExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ty, in_a_cr, in_a_context, in_a_afterExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCode.Context a_context;
      Tpl.Text a_afterExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      ClassInf.State i_record__state;
      list<DAE.Var> i_var__lst;
      Tpl.Text txt_5;
      Tpl.Text l_ret__var;
      Tpl.Text l_ret__type;
      Absyn.Path ret_2;
      Tpl.Text l_record__type__name;
      Tpl.Text l_vars;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state, varLst = i_var__lst),
           a_cr,
           a_context,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_vars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_vars, a_auxFunction, a_varDecls, a_afterExp) = lm_1090(l_vars, i_var__lst, a_auxFunction, a_varDecls, a_afterExp, a_context, a_cr);
        l_vars = Tpl.popIter(l_vars);
        ret_2 = ClassInf.getStateName(i_record__state);
        l_record__type__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        l_ret__type = Tpl.writeText(Tpl.emptyTxt, l_record__type__name);
        l_ret__type = Tpl.writeTok(l_ret__type, Tpl.ST_STRING("_rettype"));
        (l_ret__var, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ret__type), a_varDecls);
        a_afterExp = Tpl.writeText(a_afterExp, l_ret__var);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(" = _"));
        a_afterExp = Tpl.writeText(a_afterExp, l_record__type__name);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING("("));
        a_afterExp = Tpl.writeText(a_afterExp, l_vars);
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_STRING(");"));
        a_afterExp = Tpl.writeTok(a_afterExp, Tpl.ST_NEW_LINE());
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpRecordCrefLhs "));
        txt_5 = CodegenUtil.crefStr(txt_5, a_cr);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING(" does not make sense. Assigning to records is handled in a different way in the code generator, and reaching here is probably an error..."));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8157, 9), Tpl.textString(txt_5));
      then (txt, a_afterExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_afterExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_afterExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRecordCrefLhs;

protected function fun_1092
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;

    case ( txt,
           false,
           a_varDecls )
      equation
        (txt, a_varDecls) = tempDecl(txt, "modelica_string", a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      equation
        (txt, a_varDecls) = tempDecl(txt, "modelica_metatype", a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_1092;

protected function fun_1093
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_tmpStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e2, in_a_e1, in_a_tmpStr)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_tmpStr;

    case ( txt,
           false,
           a_e2,
           a_e1,
           a_tmpStr )
      equation
        txt = Tpl.writeText(txt, a_tmpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = cat_modelica_string("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_e2,
           a_e1,
           a_tmpStr )
      equation
        txt = Tpl.writeText(txt, a_tmpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = stringAppend("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1093;

protected function fun_1094
  input Tpl.Text in_txt;
  input Option<Integer> in_mArg;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Integer i_i;
      Tpl.Text l_tmp;

    case ( txt,
           SOME(2),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SOME(3),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SOME(4),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" *= "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SOME(i_i),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_int_pow(threadData, "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pow("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1094;

protected function fun_1095
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls, in_a_exp2)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp2;
      Option<Integer> ret_0;

    case ( txt,
           false,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls,
           a_exp2 )
      equation
        ret_0 = Expression.realExpIntLit(a_exp2);
        (txt, a_preExp, a_varDecls) = fun_1094(txt, ret_0, a_e2, a_e1, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_e1,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1095;

protected function fun_1096
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1096;

protected function fun_1097
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1097;

protected function fun_1098
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1098;

protected function fun_1099
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1099;

protected function fun_1100
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1100;

protected function fun_1101
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_scalar"));
      then txt;
  end match;
end fun_1101;

protected function fun_1102
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;
  end match;
end fun_1102;

protected function fun_1103
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1103;

protected function fun_1104
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1104;

protected function fun_1105
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1105;

protected function fun_1106
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_exp;
  input DAE.Exp in_a_exp2;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_auxFunction, in_a_context, in_a_exp, in_a_exp2, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      DAE.Exp a_exp;
      DAE.Exp a_exp2;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;
      Tpl.Text l_typeShort;
      Tpl.Text txt_7;
      String ret_7;
      Tpl.Text txt_5;
      String ret_5;
      Tpl.Text l_type;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_tmpStr;

    case ( txt,
           DAE.ADD(ty = DAE.T_STRING(varLst = _)),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        ret_1 = Config.acceptMetaModelicaGrammar();
        (l_tmpStr, a_varDecls) = fun_1092(Tpl.emptyTxt, ret_1, a_varDecls);
        ret_2 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_1093(a_preExp, ret_2, a_e2, a_e1, l_tmpStr);
        txt = Tpl.writeText(txt, l_tmpStr);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" / "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW(ty = _),
           a_auxFunction,
           _,
           _,
           a_exp2,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        ret_3 = Expression.isHalf(a_exp2);
        (txt, a_preExp, a_varDecls) = fun_1095(txt, ret_3, a_e2, a_e1, a_preExp, a_varDecls, a_exp2);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS(ty = _),
           a_auxFunction,
           a_context,
           a_exp,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpUnary(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1096(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("add_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1097(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sub_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1098(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1099(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("div_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1100(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = _),
           a_auxFunction,
           _,
           a_exp,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support ADD_ARRAY_SCALAR "));
        ret_5 = ExpressionDump.printExpStr(a_exp);
        txt_5 = Tpl.writeStr(txt_5, ret_5);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8234, 40), Tpl.textString(txt_5));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = _),
           a_auxFunction,
           _,
           a_exp,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt_7 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support SUB_SCALAR_ARRAY "));
        ret_7 = ExpressionDump.printExpStr(a_exp);
        txt_7 = Tpl.writeStr(txt_7, ret_7);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8235, 40), Tpl.textString(txt_7));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1101(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_product("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_typeShort = fun_1102(Tpl.emptyTxt, i_ty);
        l_type = Tpl.writeText(Tpl.emptyTxt, l_typeShort);
        l_type = Tpl.writeTok(l_type, Tpl.ST_STRING("_array"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, l_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_product_smart("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1103(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("div_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1104(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("div_alloc_scalar_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_1105(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pow_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_ARRAY_SCALAR"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_SCALAR_ARRAY"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARR(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_ARR"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARR2(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_ARR2"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8268, 14), "daeExpBinary:ERR");
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1106;

public function daeExpBinary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Operator i_operator;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           (i_exp as DAE.BINARY(exp1 = i_exp1, exp2 = i_exp2, operator = i_operator)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1106(txt, i_operator, a_auxFunction, a_context, i_exp, i_exp2, l_e2, l_e1, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpBinary;

protected function fun_1108
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_e;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_preExp, in_a_varDecls, in_a_e)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_e;
      Tpl.Text l_var;

    case ( txt,
           DAE.UMINUS(ty = _),
           a_preExp,
           a_varDecls,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(-"));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _))),
           a_preExp,
           a_varDecls,
           a_e )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "real_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("usub_alloc_real_array("));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = _),
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8285, 34), "unary minus for non-real arrays not implemented");
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8286, 14), "daeExpUnary:ERR");
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1108;

public function daeExpUnary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_operator;
      DAE.Exp i_exp;
      Tpl.Text l_e;

    case ( txt,
           DAE.UNARY(exp = i_exp, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_1108(txt, i_operator, a_preExp, a_varDecls, l_e);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpUnary;

protected function fun_1110
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text l_var;

    case ( txt,
           DAE.AND(ty = DAE.T_ARRAY(ty = _)),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("and_boolean_array(&"));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.AND(ty = _),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.OR(ty = DAE.T_ARRAY(ty = _)),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("or_boolean_array(&"));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.OR(ty = _),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8311, 14), "daeExpLbinary:ERR");
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1110;

public function daeExpLbinary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_operator;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           DAE.LBINARY(exp1 = i_exp1, exp2 = i_exp2, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_1110(txt, i_operator, l_e2, l_e1, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpLbinary;

protected function fun_1112
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_e;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_e, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_e;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text l_var;

    case ( txt,
           DAE.NOT(ty = DAE.T_ARRAY(ty = _)),
           a_e,
           a_preExp,
           a_varDecls )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("not_boolean_array(&"));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_e,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1112;

public function daeExpLunary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_operator;
      DAE.Exp i_exp;
      Tpl.Text l_e;

    case ( txt,
           DAE.LUNARY(exp = i_exp, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_1112(txt, i_operator, l_e, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpLunary;

protected function fun_1114
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           DAE.LESS(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") < 0)"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") > 0)"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") <= 0)"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") >= 0)"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringEqual("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!stringEqual("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8387, 16), "daeExpRelation:ERR");
      then txt;
  end match;
end fun_1114;

protected function fun_1115
  input Tpl.Text in_txt;
  input Tpl.Text in_a_simRel;
  input Tpl.Text in_a_preExp2;
  input Tpl.Text in_a_varDecls2;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_simRel, in_a_preExp2, in_a_varDecls2, in_a_rel_operator, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp2;
      Tpl.Text a_varDecls2;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_rel_exp1;
      Tpl.Text i_simRel;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = fun_1114(txt, a_rel_operator, l_e2, l_e1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_simRel,
           a_preExp2,
           a_varDecls2,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        a_varDecls = Tpl.writeText(a_varDecls, a_varDecls2);
        a_preExp = Tpl.writeText(a_preExp, a_preExp2);
        txt = Tpl.writeText(txt, i_simRel);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1115;

public function daeExpRelation
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_rel_operator;
      DAE.Exp i_rel_exp2;
      DAE.Exp i_rel_exp1;
      DAE.Exp i_rel;
      Tpl.Text l_simRel;
      Tpl.Text l_preExp2;
      Tpl.Text l_varDecls2;

    case ( txt,
           (i_rel as DAE.RELATION(exp1 = i_rel_exp1, exp2 = i_rel_exp2, operator = i_rel_operator)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_varDecls2 = Tpl.emptyTxt;
        l_preExp2 = Tpl.emptyTxt;
        (l_simRel, l_preExp2, l_varDecls2, a_auxFunction) = daeExpRelationSim(Tpl.emptyTxt, i_rel, a_context, l_preExp2, l_varDecls2, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1115(txt, l_simRel, l_preExp2, l_varDecls2, i_rel_operator, i_rel_exp2, a_auxFunction, a_varDecls, a_preExp, a_context, i_rel_exp1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRelation;

protected function fun_1117
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_1117;

protected function fun_1118
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_1117(txt, ret_1);
      then txt;
  end match;
end fun_1118;

protected function fun_1119
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_1119;

protected function fun_1120
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_1120;

protected function fun_1121
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_1121;

protected function fun_1122
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_1118(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_1119(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_1120(txt, a_rel_operator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_1121(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_1122;

protected function fun_1123
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_1123;

protected function fun_1124
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_1123(txt, ret_1);
      then txt;
  end match;
end fun_1124;

protected function fun_1125
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_1125;

protected function fun_1126
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_1126;

protected function fun_1127
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_1127;

protected function fun_1128
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_1124(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_1125(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_1126(txt, a_rel_operator, a_j, a_i, a_iterator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_1127(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_1128;

protected function fun_1129
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_rel_exp1;
      Integer i_j;
      Integer i_i;
      DAE.Exp i_exp;
      Boolean ret_5;
      Tpl.Text l_iterator;
      Boolean ret_3;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_3 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_1122(txt, ret_3, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SOME((i_exp, i_i, i_j)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_iterator, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_5 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_1128(txt, ret_5, i_j, i_i, l_iterator, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1129;

protected function fun_1130
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_1130;

protected function fun_1131
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_1130(txt, ret_1);
      then txt;
  end match;
end fun_1131;

protected function fun_1132
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Less("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1132;

protected function fun_1133
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1133;

protected function fun_1134
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Greater("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1134;

protected function fun_1135
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1135;

protected function fun_1136
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_isReal)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_isReal;
      Tpl.Text l_hysteresisfunction;

    case ( txt,
           DAE.LESS(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1132(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1133(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1134(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1135(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_preExp,
           _,
           _,
           _,
           _ )
      then (txt, a_preExp);
  end match;
end fun_1136;

protected function fun_1137
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_1137;

protected function fun_1138
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_1131(Tpl.emptyTxt, ret_2, a_rel_exp2);
        (txt, a_preExp) = fun_1136(txt, a_rel_operator, a_res, a_preExp, a_rel_index, a_e2, a_e1, l_isReal);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_res,
           a_preExp,
           _,
           a_e2,
           a_e1,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_1137(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_1138;

protected function fun_1139
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_1139;

protected function fun_1140
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_1139(txt, ret_1);
      then txt;
  end match;
end fun_1140;

protected function fun_1141
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Less("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1141;

protected function fun_1142
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1142;

protected function fun_1143
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Greater("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1143;

protected function fun_1144
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo.storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_1144;

protected function fun_1145
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_isReal)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_isReal;
      Tpl.Text l_hysteresisfunction;

    case ( txt,
           DAE.LESS(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1141(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1142(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1143(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_1144(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_preExp,
           _,
           _,
           _,
           _ )
      then (txt, a_preExp);
  end match;
end fun_1145;

protected function fun_1146
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_1146;

protected function fun_1147
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_1140(Tpl.emptyTxt, ret_2, a_rel_exp2);
        (txt, a_preExp) = fun_1145(txt, a_rel_operator, a_res, a_preExp, a_rel_index, a_e2, a_e1, l_isReal);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_res,
           a_preExp,
           _,
           a_e2,
           a_e1,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_1146(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_1147;

protected function fun_1148
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_rel_exp1;
      Boolean ret_4;
      Boolean ret_3;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_3 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_1138(txt, ret_3, l_res, a_preExp, a_rel_index, l_e2, l_e1, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SOME((_, _, _)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_4 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_1147(txt, ret_4, l_res, a_preExp, a_rel_index, l_e2, l_e1, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1148;

protected function fun_1149
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_rel_exp1;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_rel_exp1, in_a_rel_optionExpisASUB)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_rel_exp1;
      Option<tuple<DAE.Exp, Integer, Integer>> a_rel_optionExpisASUB;
      SimCode.Context i_context;

    case ( txt,
           (i_context as SimCode.SIMULATION_CONTEXT(genDiscrete = _)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1,
           a_rel_optionExpisASUB )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1129(txt, a_rel_optionExpisASUB, a_rel_operator, a_rel_index, a_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_context, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_context as SimCode.ZEROCROSSINGS_CONTEXT()),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1,
           a_rel_optionExpisASUB )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1148(txt, a_rel_optionExpisASUB, a_rel_operator, a_rel_index, a_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_context, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1149;

public function daeExpRelationSim
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_rel_operator;
      Integer i_rel_index;
      DAE.Exp i_rel_exp2;
      DAE.Exp i_rel_exp1;
      Option<tuple<DAE.Exp, Integer, Integer>> i_rel_optionExpisASUB;

    case ( txt,
           DAE.RELATION(optionExpisASUB = i_rel_optionExpisASUB, exp1 = i_rel_exp1, exp2 = i_rel_exp2, index = i_rel_index, operator = i_rel_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1149(txt, a_context, i_rel_operator, i_rel_index, i_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_rel_exp1, i_rel_optionExpisASUB);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRelationSim;

protected function fun_1151
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("x"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1151;

protected function fun_1152
  input Tpl.Text in_txt;
  input Tpl.Text in_a_preExpElse;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_preExpElse, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        ret_1 = Expression.isArrayType(ret_0);
        txt = fun_1151(txt, ret_1);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1152;

protected function fun_1153
  input Tpl.Text in_txt;
  input Tpl.Text in_a_preExpThen;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_preExpElse;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_preExpThen, in_a_exp, in_a_preExpElse)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Tpl.Text a_preExpElse;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_exp,
           a_preExpElse )
      equation
        txt = fun_1152(txt, a_preExpElse, a_exp);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1153;

protected function fun_1154
  input Tpl.Text in_txt;
  input Tpl.Text in_a_eThen;
  input Tpl.Text in_a_resVar;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_resVar;
algorithm
  (out_txt, out_a_resVar) :=
  match(in_txt, in_a_eThen, in_a_resVar, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_resVar;
      DAE.Exp a_exp;
      Tpl.Text i_eThen;
      DAE.Type ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_resVar,
           _ )
      then (txt, a_resVar);

    case ( txt,
           i_eThen,
           a_resVar,
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        (txt, a_resVar, i_eThen) = resultVarAssignment(txt, ret_0, a_resVar, i_eThen);
      then (txt, a_resVar);
  end match;
end fun_1154;

protected function fun_1155
  input Tpl.Text in_txt;
  input Tpl.Text in_a_eElse;
  input Tpl.Text in_a_resVar;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_resVar;
algorithm
  (out_txt, out_a_resVar) :=
  match(in_txt, in_a_eElse, in_a_resVar, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_resVar;
      DAE.Exp a_exp;
      Tpl.Text i_eElse;
      DAE.Type ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_resVar,
           _ )
      then (txt, a_resVar);

    case ( txt,
           i_eElse,
           a_resVar,
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        (txt, a_resVar, i_eElse) = resultVarAssignment(txt, ret_0, a_resVar, i_eElse);
      then (txt, a_resVar);
  end match;
end fun_1155;

protected function fun_1156
  input Tpl.Text in_txt;
  input Tpl.Text in_a_shortIfExp;
  input Tpl.Text in_a_eElse;
  input Tpl.Text in_a_preExpElse;
  input Tpl.Text in_a_eThen;
  input Tpl.Text in_a_preExpThen;
  input Tpl.Text in_a_condExp;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_shortIfExp, in_a_eElse, in_a_preExpElse, in_a_eThen, in_a_preExpThen, in_a_condExp, in_a_preExp, in_a_exp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_eElse;
      Tpl.Text a_preExpElse;
      Tpl.Text a_eThen;
      Tpl.Text a_preExpThen;
      Tpl.Text a_condExp;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_varDecls;
      DAE.Type ret_2;
      Tpl.Text l_resVar;
      Tpl.Text l_condVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_eElse,
           a_preExpElse,
           a_eThen,
           a_preExpThen,
           a_condExp,
           a_preExp,
           a_exp,
           a_varDecls )
      equation
        (l_condVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_2 = Expression.typeof(a_exp);
        (l_resVar, a_varDecls) = tempDeclTuple(Tpl.emptyTxt, ret_2, a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_condVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = (modelica_boolean)"));
        a_preExp = Tpl.writeText(a_preExp, a_condExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ";\n",
                                              "if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_condVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ")\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, a_preExpThen);
        a_preExp = Tpl.softNewLine(a_preExp);
        (a_preExp, l_resVar) = fun_1154(a_preExp, a_eThen, l_resVar, a_exp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "else\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, a_preExpElse);
        a_preExp = Tpl.softNewLine(a_preExp);
        (a_preExp, l_resVar) = fun_1155(a_preExp, a_eElse, l_resVar, a_exp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_eElse,
           _,
           a_eThen,
           _,
           a_condExp,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_condExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("?"));
        txt = Tpl.writeText(txt, a_eThen);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        txt = Tpl.writeText(txt, a_eElse);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1156;

public function daeExpIf
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Exp i_expElse;
      DAE.Exp i_expThen;
      DAE.Exp i_expCond;
      Tpl.Text l_shortIfExp;
      Tpl.Text l_eElse;
      Tpl.Text l_preExpElse;
      Tpl.Text l_eThen;
      Tpl.Text l_preExpThen;
      Tpl.Text l_condExp;

    case ( txt,
           (i_exp as DAE.IFEXP(expCond = i_expCond, expThen = i_expThen, expElse = i_expElse)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_condExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_expCond, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_preExpThen = Tpl.emptyTxt;
        (l_eThen, l_preExpThen, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_expThen, a_context, l_preExpThen, a_varDecls, a_auxFunction);
        l_preExpElse = Tpl.emptyTxt;
        (l_eElse, l_preExpElse, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_expElse, a_context, l_preExpElse, a_varDecls, a_auxFunction);
        l_shortIfExp = fun_1153(Tpl.emptyTxt, l_preExpThen, i_exp, l_preExpElse);
        (txt, a_preExp, a_varDecls) = fun_1156(txt, l_shortIfExp, l_eElse, l_preExpElse, l_eThen, l_preExpThen, l_condExp, a_preExp, i_exp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpIf;

protected function lm_1158
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_lhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_rhs, in_a_lhs)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_rhs;
      Tpl.Text a_lhs;
      Integer x_i1;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_rhs,
           a_lhs )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeText(txt, a_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_1158(txt, rest, a_rhs, a_lhs);
      then txt;
  end match;
end lm_1158;

protected function fun_1159
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_lhs;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_lhs, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_lhs;
      Tpl.Text a_rhs;
      list<DAE.Type> i_tupleType;

    case ( txt,
           DAE.T_TUPLE(tupleType = i_tupleType),
           a_lhs,
           a_rhs )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1158(txt, i_tupleType, a_rhs, a_lhs);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           a_lhs,
           a_rhs )
      equation
        txt = Tpl.writeText(txt, a_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1159;

public function resultVarAssignment
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Tpl.Text a_lhs;
  input Tpl.Text a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_lhs;
  output Tpl.Text out_a_rhs;
algorithm
  out_txt := fun_1159(txt, a_ty, a_lhs, a_rhs);
  out_a_lhs := a_lhs;
  out_a_rhs := a_rhs;
end resultVarAssignment;

protected function lm_1161
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, String>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, String>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Tpl.Text a_name;
      DAE.Exp i_exp;
      String i_compn;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_exp, i_compn) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_compn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1161(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_name);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1161;

public function daeExpRecord
  input Tpl.Text in_txt;
  input DAE.Exp in_a_rec;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_rec, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<String> i_comp;
      list<DAE.Exp> i_exps;
      Absyn.Path i_path;
      list<tuple<DAE.Exp, String>> ret_3;
      Tpl.Text l_ass;
      Tpl.Text txt_1;
      Tpl.Text l_name;

    case ( txt,
           DAE.RECORD(path = i_path, exps = i_exps, comp = i_comp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        (l_name, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_3 = List.threadTuple(i_exps, i_comp);
        (l_ass, a_auxFunction, a_varDecls, a_preExp) = lm_1161(Tpl.emptyTxt, ret_3, a_auxFunction, a_varDecls, a_preExp, a_context, l_name);
        a_preExp = Tpl.writeText(a_preExp, l_ass);
        txt = Tpl.writeText(txt, l_name);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRecord;

protected function lm_1163
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_ret;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ret;
algorithm
  (out_txt, out_a_ret) :=
  match(in_txt, in_items, in_a_ret)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_ret;
      DAE.Type i_ty;
      Integer ret_1;
      Tpl.Text l_name;

    case ( txt,
           {},
           a_ret )
      then (txt, a_ret);

    case ( txt,
           i_ty :: rest,
           a_ret )
      equation
        l_name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_1 = System.tmpTick();
        l_name = Tpl.writeStr(l_name, intString(ret_1));
        a_ret = Tpl.writeTok(a_ret, Tpl.ST_STRING(", "));
        a_ret = Tpl.writeText(a_ret, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_name);
        (txt, a_ret) = lm_1163(txt, rest, a_ret);
      then (txt, a_ret);
  end match;
end lm_1163;

protected function fun_1164
  input Tpl.Text in_txt;
  input DAE.Type in_a_t_funcResultType;
  input Tpl.Text in_a_ret;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ret;
algorithm
  (out_txt, out_a_ret) :=
  match(in_txt, in_a_t_funcResultType, in_a_ret)
    local
      Tpl.Text txt;
      Tpl.Text a_ret;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_TUPLE(tupleType = _ :: i_tys),
           a_ret )
      equation
        (txt, a_ret) = lm_1163(txt, i_tys, a_ret);
      then (txt, a_ret);

    case ( txt,
           _,
           a_ret )
      then (txt, a_ret);
  end match;
end fun_1164;

protected function fun_1165
  input Tpl.Text in_txt;
  input DAE.Type in_a_t_funcResultType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t_funcResultType)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL(source = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
      then txt;
  end match;
end fun_1165;

protected function lm_1166
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1166(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1166;

protected function fun_1167
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointer;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_isFunctionPointer, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", _"));
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;
  end match;
end fun_1167;

protected function fun_1168
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointer;
  input list<DAE.Exp> in_a_expList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_isFunctionPointer, in_a_expList)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_expList;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_expList )
      equation
        ret_0 = listLength(a_expList);
        txt = daeExpMetaHelperBoxStart(txt, ret_0);
      then txt;

    case ( txt,
           _,
           a_expList )
      equation
        ret_1 = listLength(a_expList);
        ret_2 = SimCodeUtil.incrementInt(ret_1, 1);
        txt = daeExpMetaHelperBoxStart(txt, ret_2);
      then txt;
  end match;
end fun_1168;

protected function fun_1169
  input Tpl.Text in_txt;
  input DAE.Type in_a_t_funcResultType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t_funcResultType)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL(source = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1169;

protected function lm_1170
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_1170(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1170(txt, rest);
      then txt;
  end match;
end lm_1170;

protected function lm_1171
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      Integer x_i1;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = expTypeArrayIf(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(closure),"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        txt = lm_1171(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1171(txt, rest);
      then txt;
  end match;
end lm_1171;

protected function lm_1172
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_1172(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1172(txt, rest);
      then txt;
  end match;
end lm_1172;

protected function lm_1173
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_1173(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1173(txt, rest);
      then txt;
  end match;
end lm_1173;

protected function lm_1174
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_1174(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1174(txt, rest);
      then txt;
  end match;
end lm_1174;

protected function fun_1175
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointer;
  input list<DAE.FuncArg> in_a_t_funcArg;
  input DAE.Type in_a_orig;
  input Tpl.Text in_a_ret;
  input list<DAE.FuncArg> in_a_orig_funcArg;
  input Absyn.Path in_a_name;
  input Tpl.Text in_a_return;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_isFunctionPointer, in_a_t_funcArg, in_a_orig, in_a_ret, in_a_orig_funcArg, in_a_name, in_a_return)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> a_t_funcArg;
      DAE.Type a_orig;
      Tpl.Text a_ret;
      list<DAE.FuncArg> a_orig_funcArg;
      Absyn.Path a_name;
      Tpl.Text a_return;
      Integer ret_6;
      Integer ret_5;
      list<DAE.FuncArg> ret_4;
      Tpl.Text l_typeCast2;
      Tpl.Text l_typeCast1;
      Tpl.Text l_func;
      Tpl.Text l_fname;

    case ( txt,
           false,
           _,
           _,
           a_ret,
           a_orig_funcArg,
           a_name,
           a_return )
      equation
        txt = Tpl.writeText(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxptr_"));
        txt = CodegenUtil.underscorePath(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(thData"));
        txt = lm_1172(txt, a_orig_funcArg);
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_t_funcArg,
           a_orig,
           a_ret,
           a_orig_funcArg,
           a_name,
           a_return )
      equation
        l_fname = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        l_fname = CodegenUtil.underscorePath(l_fname, a_name);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_func = Tpl.writeText(l_func, l_fname);
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("), 1)))"));
        l_typeCast1 = generateTypeCastFromType(Tpl.emptyTxt, a_orig, true);
        l_typeCast2 = generateTypeCastFromType(Tpl.emptyTxt, a_orig, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(closure),"));
        ret_4 = List.setDifference(a_orig_funcArg, a_t_funcArg);
        ret_5 = listLength(ret_4);
        ret_6 = SimCodeUtil.incrementInt(ret_5, 1);
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "if (MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("),2))) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_typeCast1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") (thData, MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),2))"));
        txt = lm_1173(txt, a_orig_funcArg);
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("} else { /* No closure in the called variable */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_typeCast2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") (thData"));
        txt = lm_1174(txt, a_orig_funcArg);
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1175;

public function daeExpPartEvalFunction
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_origType;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      DAE.Type i_orig;
      list<DAE.FuncArg> i_orig_funcArg;
      list<DAE.FuncArg> i_t_funcArg;
      Boolean i_attr_isFunctionPointer;
      list<DAE.Exp> i_expList;
      Absyn.Path i_name;
      DAE.Type i_t_funcResultType;
      Tpl.Text txt_9;
      String ret_11;
      String ret_10;
      String ret_9;
      list<DAE.FuncArg> ret_8;
      Tpl.Text l_createClosure;
      Tpl.Text l_closure;
      Tpl.Text l_return;
      Integer ret_4;
      Tpl.Text l_func;
      Tpl.Text l_retInput;
      Tpl.Text l_ret;
      Tpl.Text l_varDeclInner;

    case ( txt,
           DAE.PARTEVALFUNCTION(ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = DAE.T_FUNCTION(funcResultType = i_t_funcResultType, funcArg = i_t_funcArg)), origType = DAE.T_FUNCTION_REFERENCE_VAR(functionType = (i_orig as DAE.T_FUNCTION(functionAttributes = DAE.FUNCTION_ATTRIBUTES(isFunctionPointer = i_attr_isFunctionPointer), source = {i_name}, funcArg = i_orig_funcArg))), expList = i_expList),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_varDeclInner = Tpl.emptyTxt;
        l_ret = Tpl.emptyTxt;
        (l_retInput, l_ret) = fun_1164(Tpl.emptyTxt, i_t_funcResultType, l_ret);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("closure"));
        ret_4 = System.tmpTickIndex(2);
        l_func = Tpl.writeStr(l_func, intString(ret_4));
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("_"));
        l_func = CodegenUtil.underscorePath(l_func, i_name);
        l_return = fun_1165(Tpl.emptyTxt, i_t_funcResultType);
        (l_closure, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_createClosure, a_auxFunction, a_varDecls, a_preExp) = lm_1166(Tpl.emptyTxt, i_expList, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_createClosure = fun_1167(l_createClosure, i_attr_isFunctionPointer, i_name);
        a_preExp = Tpl.writeText(a_preExp, l_closure);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_mk_box"));
        a_preExp = fun_1168(a_preExp, i_attr_isFunctionPointer, i_expList);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("0"));
        a_preExp = Tpl.writeText(a_preExp, l_createClosure);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING("static "));
        a_auxFunction = fun_1169(a_auxFunction, i_t_funcResultType);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING(" "));
        a_auxFunction = Tpl.writeText(a_auxFunction, l_func);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING("(threadData_t *thData, modelica_metatype closure"));
        a_auxFunction = lm_1170(a_auxFunction, i_t_funcArg);
        a_auxFunction = Tpl.writeText(a_auxFunction, l_retInput);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING_LIST({
                                                        ")\n",
                                                        "{\n"
                                                    }, true));
        a_auxFunction = Tpl.pushBlock(a_auxFunction, Tpl.BT_INDENT(2));
        a_auxFunction = Tpl.writeText(a_auxFunction, l_varDeclInner);
        a_auxFunction = Tpl.softNewLine(a_auxFunction);
        ret_8 = List.setDifference(i_orig_funcArg, i_t_funcArg);
        a_auxFunction = Tpl.pushIter(a_auxFunction, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_auxFunction = lm_1171(a_auxFunction, ret_8);
        a_auxFunction = Tpl.popIter(a_auxFunction);
        a_auxFunction = Tpl.softNewLine(a_auxFunction);
        a_auxFunction = fun_1175(a_auxFunction, i_attr_isFunctionPointer, i_t_funcArg, i_orig, l_ret, i_orig_funcArg, i_name, l_return);
        a_auxFunction = Tpl.softNewLine(a_auxFunction);
        a_auxFunction = Tpl.popBlock(a_auxFunction);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_fnptr) mmc_mk_box2(0,"));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_closure);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp as DAE.PARTEVALFUNCTION(ty = i_ty, origType = i_origType)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_9 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("PARTEVALFUNCTION: "));
        ret_9 = ExpressionDump.printExpStr(i_exp);
        txt_9 = Tpl.writeStr(txt_9, ret_9);
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING(", ty="));
        ret_10 = Types.unparseType(i_ty);
        txt_9 = Tpl.writeStr(txt_9, ret_10);
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING(", origType="));
        ret_11 = Types.unparseType(i_origType);
        txt_9 = Tpl.writeStr(txt_9, ret_11);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8660, 13), Tpl.textString(txt_9));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpPartEvalFunction;

protected function fun_1177
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_var3;
  input Tpl.Text in_a_var2;
  input Tpl.Text in_a_var1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_var3, in_a_var2, in_a_var1)
    local
      Tpl.Text txt;
      Tpl.Text a_var3;
      Tpl.Text a_var2;
      Tpl.Text a_var1;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_var3,
           a_var2,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DIVISION("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = Tpl.writeText(txt, a_var3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;

    case ( txt,
           _,
           a_var3,
           a_var2,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DIVISION_SIM("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = Tpl.writeText(txt, a_var3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",equationIndexes)"));
      then txt;
  end match;
end fun_1177;

protected function fun_1178
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_1178;

protected function fun_1179
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_var1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var1)
    local
      Tpl.Text txt;
      Tpl.Text a_var1;

    case ( txt,
           false,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fputs("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",stdout)"));
      then txt;

    case ( txt,
           _,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("print("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1179;

protected function fun_1180
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_argStr;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_e1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_argStr, in_a_preExp, in_a_context, in_a_varDecls, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_argStr;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      DAE.Exp a_e1;
      Tpl.Text txt_5;
      String ret_6;
      String ret_5;
      Tpl.Text l_retPre;
      Tpl.Text l_preExpMsg;
      Tpl.Text l_ass;
      Tpl.Text txt_1;
      Tpl.Text l_tmp;

    case ( txt,
           false,
           a_argStr,
           a_preExp,
           a_context,
           a_varDecls,
           a_e1 )
      equation
        txt_1 = expTypeFromExpModelica(Tpl.emptyTxt, a_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        l_ass = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("("));
        l_ass = Tpl.writeText(l_ass, l_tmp);
        l_ass = Tpl.writeTok(l_ass, Tpl.ST_STRING(" >= 0.0)"));
        l_preExpMsg = Tpl.emptyTxt;
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of sqrt("));
        ret_5 = ExpressionDump.printExpStr(a_e1);
        ret_6 = Util.escapeModelicaStringToCString(ret_5);
        txt_5 = Tpl.writeStr(txt_5, ret_6);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING(") was %g should be >= 0\", "));
        txt_5 = Tpl.writeText(txt_5, l_tmp);
        (l_retPre, l_ass, txt_5, l_preExpMsg, a_varDecls) = assertCommonVar(Tpl.emptyTxt, l_ass, txt_5, a_context, l_preExpMsg, a_varDecls, Absyn.dummyInfo);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("; "));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_retPre);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_argStr,
           a_preExp,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1180;

protected function lm_1181
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1181(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1181;

protected function lm_1182
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_array;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_array :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_array, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1182(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1182;

protected function fun_1183
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_leftjustExp;
  input Tpl.Text in_a_minlenExp;
  input Tpl.Text in_a_sExp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_leftjustExp, in_a_minlenExp, in_a_sExp, in_a_typeStr, in_a_tvar, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_leftjustExp;
      Tpl.Text a_minlenExp;
      Tpl.Text a_sExp;
      Tpl.Text a_typeStr;
      Tpl.Text a_tvar;
      Tpl.Text a_preExp;

    case ( txt,
           "modelica_real",
           a_leftjustExp,
           a_minlenExp,
           a_sExp,
           a_typeStr,
           a_tvar,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_modelica_string("));
        a_preExp = Tpl.writeText(a_preExp, a_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_minlenExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_leftjustExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 6);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tvar);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_leftjustExp,
           a_minlenExp,
           a_sExp,
           a_typeStr,
           a_tvar,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_modelica_string("));
        a_preExp = Tpl.writeText(a_preExp, a_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_minlenExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_leftjustExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tvar);
      then (txt, a_preExp);
  end match;
end fun_1183;

protected function fun_1184
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1184;

protected function fun_1185
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1185;

protected function fun_1186
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1186;

protected function fun_1187
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1187;

protected function fun_1188
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1188;

protected function fun_1189
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1189;

protected function lm_1190
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_1190(txt, rest);
      then txt;
  end match;
end lm_1190;

protected function fun_1191
  input Tpl.Text in_txt;
  input DAE.Type in_a_attr_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_ts;
      list<String> ret_1;
      Integer ret_0;

    case ( txt,
           DAE.T_TUPLE(tupleType = _ :: i_ts) )
      equation
        ret_0 = listLength(i_ts);
        ret_1 = List.fill(", NULL", ret_0);
        txt = lm_1190(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1191;

protected function fun_1192
  input Tpl.Text in_txt;
  input DAE.Type in_a_attr_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_attr_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      DAE.Type i_t;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_NORETCALL(source = _),
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_TUPLE(tupleType = i_t :: _),
           a_varDecls )
      equation
        txt_0 = expTypeArrayIf(Tpl.emptyTxt, i_t);
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(txt_0), a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           i_t,
           a_varDecls )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, i_t);
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(txt_1), a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_1192;

protected function fun_1193
  input Tpl.Text in_txt;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tvar, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_tvar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_tvar,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1193;

protected function fun_1194
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_attr_ty;
  input Absyn.Path in_a_exp_path;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_preExp, in_a_varDecls, in_a_attr_ty, in_a_exp_path, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_attr_ty;
      Absyn.Path a_exp_path;
      Tpl.Text a_res;
      Tpl.Text l_tvar;
      Tpl.Text l_funName;

    case ( txt,
           false,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_attr_ty,
           a_exp_path,
           a_res )
      equation
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, a_exp_path);
        (l_tvar, a_varDecls) = fun_1192(Tpl.emptyTxt, a_attr_ty, a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("SIM_PROF_TICK_FN("));
        a_preExp = Tpl.writeText(a_preExp, l_funName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_index);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = fun_1193(a_preExp, l_tvar, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("SIM_PROF_ACC_FN("));
        a_preExp = Tpl.writeText(a_preExp, l_funName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_index);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1194;

protected function fun_1195
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_attr_ty;
  input Absyn.Path in_a_exp_path;
  input Boolean in_a_attr_builtin;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_preExp, in_a_varDecls, in_a_attr_ty, in_a_exp_path, in_a_attr_builtin, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_attr_ty;
      Absyn.Path a_exp_path;
      Boolean a_attr_builtin;
      Tpl.Text a_res;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_attr_ty,
           a_exp_path,
           a_attr_builtin,
           a_res )
      equation
        ret_0 = Config.profileFunctions();
        ret_1 = boolNot(a_attr_builtin);
        ret_2 = boolAnd(ret_0, ret_1);
        (txt, a_preExp, a_varDecls) = fun_1194(txt, ret_2, a_preExp, a_varDecls, a_attr_ty, a_exp_path, a_res);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1195;

public function daeExpCall
  input Tpl.Text in_txt;
  input DAE.Exp in_a_call;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_call, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Absyn.Path i_exp_path;
      Boolean i_attr_builtin;
      DAE.Type i_attr_ty;
      list<String> i_tail_vars;
      list<DAE.Exp> i_expLst;
      String i_name;
      Integer i_i;
      DAE.Exp i_s1;
      DAE.Exp i_toBeCasted;
      Integer i_index_1;
      DAE.Exp i_delayMax;
      DAE.Exp i_d;
      DAE.Exp i_signdig;
      DAE.Exp i_leftjust;
      DAE.Exp i_minlen;
      DAE.Exp i_format;
      DAE.Exp i_s;
      DAE.Exp i_v2;
      DAE.Exp i_v1;
      DAE.Exp i_n;
      DAE.Exp i_A;
      list<DAE.Exp> i_arrays;
      DAE.Exp i_dim;
      DAE.Exp i_call;
      list<DAE.Exp> i_dims;
      DAE.Exp i_val;
      DAE.Exp i_array;
      DAE.Exp i_inExp;
      DAE.Exp i_index;
      DAE.Exp i_e;
      DAE.Exp i_arg;
      DAE.ComponentRef i_arg_componentRef;
      DAE.Exp i_exp;
      DAE.Type i_ty;
      DAE.Exp i_e2;
      DAE.Exp i_e1;
      Tpl.Text l_additionalOutputs;
      Tpl.Text l_res;
      Tpl.Text l_tail;
      Tpl.Text l_postExp;
      Tpl.Text l_op;
      Tpl.Text l_i2;
      Tpl.Text l_i1;
      Tpl.Text l_e1;
      Tpl.Text l_expPart;
      Tpl.Text l_castedVar;
      Tpl.Text l_signdigExp;
      String str_55;
      Tpl.Text l_leftjustExp;
      Tpl.Text l_minlenExp;
      Tpl.Text l_typeStr;
      Tpl.Text l_formatExp;
      Tpl.Text l_sExp;
      Integer ret_49;
      Tpl.Text l_arrays__exp;
      Tpl.Text l_dim__exp;
      Tpl.Text txt_45;
      String ret_45;
      Integer ret_44;
      Tpl.Text l_dimsExp;
      Tpl.Text l_valExp;
      Tpl.Text txt_41;
      Tpl.Text txt_40;
      Tpl.Text l_tvar;
      Tpl.Text l_arr__tp__str;
      Tpl.Text l_expVar;
      Tpl.Text l_exp;
      Tpl.Text l_constIndex;
      Tpl.Text txt_32;
      String ret_33;
      String ret_32;
      Tpl.Text txt_31;
      Tpl.Text txt_28;
      String ret_29;
      String ret_28;
      Tpl.Text l_retPre;
      Tpl.Text l_preExpMsg;
      Tpl.Text l_ass;
      Tpl.Text txt_24;
      Tpl.Text l_tmp;
      Boolean ret_22;
      Tpl.Text l_argStr;
      Tpl.Text l_ty__str;
      Tpl.Text l_arr;
      Boolean ret_18;
      Tpl.Text txt_16;
      String ret_16;
      Tpl.Text txt_14;
      String ret_14;
      Tpl.Text txt_12;
      String ret_12;
      Tpl.Text txt_10;
      String ret_10;
      Tpl.Text txt_8;
      String ret_8;
      String ret_7;
      String ret_6;
      Tpl.Text l_type;
      String ret_4;
      String ret_3;
      Tpl.Text l_var3;
      Tpl.Text l_var2;
      Tpl.Text l_var1;

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "smooth"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_var2);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "DIVISION"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_3 = ExpressionDump.printExpStr(i_e2);
        ret_4 = Util.escapeModelicaStringToCString(ret_3);
        l_var3 = Tpl.writeStr(Tpl.emptyTxt, ret_4);
        txt = fun_1177(txt, a_context, l_var3, l_var2, l_var1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = i_ty), path = Absyn.IDENT(name = "DIVISION_ARRAY_SCALAR"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_type = fun_1178(Tpl.emptyTxt, i_ty);
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_6 = ExpressionDump.printExpStr(i_e2);
        ret_7 = Util.escapeModelicaStringToCString(ret_6);
        l_var3 = Tpl.writeStr(Tpl.emptyTxt, ret_7);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("division_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar(threadData,"));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = Tpl.writeText(txt, l_var3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = _), path = Absyn.IDENT(name = "DIVISION_ARRAY_SCALAR"))),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_8 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support "));
        ret_8 = ExpressionDump.printExpStr(i_exp);
        txt_8 = Tpl.writeStr(txt_8, ret_8);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8698, 11), Tpl.textString(txt_8));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "der"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$DER"));
        txt = cref(txt, i_arg_componentRef);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "der"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_10 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support der("));
        ret_10 = ExpressionDump.printExpStr(i_exp);
        txt_10 = Tpl.writeStr(txt_10, ret_10);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8703, 11), Tpl.textString(txt_10));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "pre"), expLst = {i_arg}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCallPre(txt, i_arg, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$_start"), expLst = {i_arg}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCallStart(txt, i_arg, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !$P$PRE"));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {DAE.LUNARY(exp = DAE.CREF(componentRef = i_arg_componentRef))}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && $P$PRE"));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_12 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support edge("));
        ret_12 = ExpressionDump.printExpStr(i_exp);
        txt_12 = Tpl.writeStr(txt_12, ret_12);
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8714, 11), Tpl.textString(txt_12));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "change"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != $P$PRE"));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "change"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_14 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support change("));
        ret_14 = ExpressionDump.printExpStr(i_exp);
        txt_14 = Tpl.writeStr(txt_14, ret_14);
        txt_14 = Tpl.writeTok(txt_14, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8718, 11), Tpl.textString(txt_14));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cardinality"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_16 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support cardinality("));
        ret_16 = ExpressionDump.printExpStr(i_exp);
        txt_16 = Tpl.writeStr(txt_16, ret_16);
        txt_16 = Tpl.writeTok(txt_16, Tpl.ST_STRING("). It should have been handled somewhere else in the compiler."));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8720, 11), Tpl.textString(txt_16));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "print"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_18 = Config.acceptMetaModelicaGrammar();
        txt = fun_1179(txt, ret_18, l_var1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), attr = DAE.CALL_ATTR(ty = DAE.T_REAL(varLst = _)), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmax("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer_max((modelica_integer)"));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",(modelica_integer)"));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sum"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_e}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_arr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sum_"));
        txt = Tpl.writeText(txt, l_ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), attr = DAE.CALL_ATTR(ty = DAE.T_REAL(varLst = _)), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmin("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer_min((modelica_integer)"));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",(modelica_integer)"));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "abs"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = DAE.T_INTEGER(varLst = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("labs("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "abs"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fabs("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sqrt"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_22 = Expression.isPositiveOrZero(i_e1);
        (txt, a_preExp, a_varDecls) = fun_1180(txt, ret_22, l_argStr, a_preExp, a_context, a_varDecls, i_e1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "log"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_24 = expTypeFromExpModelica(Tpl.emptyTxt, i_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_24), a_varDecls);
        l_ass = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("("));
        l_ass = Tpl.writeText(l_ass, l_tmp);
        l_ass = Tpl.writeTok(l_ass, Tpl.ST_STRING(" > 0.0)"));
        l_preExpMsg = Tpl.emptyTxt;
        txt_28 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of log("));
        ret_28 = ExpressionDump.printExpStr(i_e1);
        ret_29 = Util.escapeModelicaStringToCString(ret_28);
        txt_28 = Tpl.writeStr(txt_28, ret_29);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING(") was %g should be > 0\", "));
        txt_28 = Tpl.writeText(txt_28, l_tmp);
        (l_retPre, l_ass, txt_28, l_preExpMsg, a_varDecls) = assertCommonVar(Tpl.emptyTxt, l_ass, txt_28, a_context, l_preExpMsg, a_varDecls, Absyn.dummyInfo);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeText(a_preExp, l_retPre);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("log("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "log10"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_31 = expTypeFromExpModelica(Tpl.emptyTxt, i_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_31), a_varDecls);
        l_ass = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("("));
        l_ass = Tpl.writeText(l_ass, l_tmp);
        l_ass = Tpl.writeTok(l_ass, Tpl.ST_STRING(" > 0.0)"));
        l_preExpMsg = Tpl.emptyTxt;
        txt_32 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of log10("));
        ret_32 = ExpressionDump.printExpStr(i_e1);
        ret_33 = Util.escapeModelicaStringToCString(ret_32);
        txt_32 = Tpl.writeStr(txt_32, ret_33);
        txt_32 = Tpl.writeTok(txt_32, Tpl.ST_STRING(") was %g should be > 0\", "));
        txt_32 = Tpl.writeText(txt_32, l_tmp);
        (l_retPre, l_ass, txt_32, l_preExpMsg, a_varDecls) = assertCommonVar(Tpl.emptyTxt, l_ass, txt_32, a_context, l_preExpMsg, a_varDecls, Absyn.dummyInfo);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeText(a_preExp, l_retPre);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("log10("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_event_div_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_inExp, i_index}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_event_integer("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "floor"), expLst = {i_inExp, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")_event_floor("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "ceil"), expLst = {i_inExp, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")_event_ceil("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_inExp}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)floor("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = DAE.T_INTEGER(varLst = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ldiv("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").quot"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("trunc("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_mod_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt_40 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_40), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = max_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt_41 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_41), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = min_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "fill"), expLst = i_val :: i_dims, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_valExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_val, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_dimsExp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsExp, a_auxFunction, a_varDecls, a_preExp) = lm_1181(l_dimsExp, i_dims, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsExp = Tpl.popIter(l_dimsExp);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("fill_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_valExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_44 = listLength(i_dims);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_44));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "vector"))),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_45 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("vector() call does not have a C implementation "));
        ret_45 = ExpressionDump.printExpStr(i_call);
        txt_45 = Tpl.writeStr(txt_45, ret_45);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 8858, 11), Tpl.textString(txt_45));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cat"), expLst = i_dim :: i_arrays, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_dim__exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arrays__exp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", &")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_arrays__exp, a_auxFunction, a_varDecls, a_preExp) = lm_1182(l_arrays__exp, i_arrays, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_arrays__exp = Tpl.popIter(l_arrays__exp);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cat_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_dim__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_49 = listLength(i_arrays);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_49));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_arrays__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "promote"), expLst = {i_A, i_n}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_n, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("promote_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "transpose"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("transpose_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cross"), expLst = {i_v1, i_v2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_v1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_v2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_v1);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cross_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "identity"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("identity_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_format}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_formatExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_format, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_typeStr = expTypeFromExpModelica(Tpl.emptyTxt, i_s);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_modelica_string_format("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_formatExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_minlen, i_leftjust}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_minlenExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_minlen, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_leftjustExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_leftjust, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_typeStr = expTypeFromExpModelica(Tpl.emptyTxt, i_s);
        str_55 = Tpl.textString(l_typeStr);
        (txt, a_preExp) = fun_1183(txt, str_55, l_leftjustExp, l_minlenExp, l_sExp, l_typeStr, l_tvar, a_preExp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_minlen, i_leftjust, i_signdig}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_minlenExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_minlen, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_leftjustExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_leftjust, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_signdigExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_signdig, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = modelica_real_to_modelica_string("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_minlenExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_leftjustExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_signdigExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "delay"), expLst = {DAE.ICONST(integer = i_index_1), i_e, i_d, i_delayMax}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_d, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var3, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_delayMax, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = delayImpl(data, "));
        a_preExp = Tpl.writeStr(a_preExp, intString(i_index_1));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", time, "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "Integer"), expLst = {i_toBeCasted}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_castedVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_toBeCasted, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)"));
        txt = Tpl.writeText(txt, l_castedVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "clock"), expLst = {}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_clock()"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "noEvent"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {DAE.ICONST(integer = i_index_1), _, _}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$sample"));
        txt = Tpl.writeStr(txt, intString(i_index_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "anyString"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_anyString("));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "fail"), attr = DAE.CALL_ATTR(builtin = true)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_THROW_INTERNAL()"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mmc_get_field"), expLst = {i_s1, DAE.ICONST(integer = i_i)}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s1, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("), "));
        a_preExp = Tpl.writeStr(a_preExp, intString(i_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mmc_unbox_record"), expLst = {i_s1}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = unboxRecord(txt, Tpl.textString(l_argStr), i_ty, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "threadData")),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("threadData"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "intBitNot"), expLst = {i_e}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(~"));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitNot")), expLst = {i_e1, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_1184(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitAnd")), expLst = {i_e1, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_1185(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitOr")), expLst = {i_e1, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_1186(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitXor")), expLst = {i_e1, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_1187(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitLShift")), expLst = {i_e1, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_1188(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitRShift")), expLst = {i_e1, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_1189(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(tailCall = DAE.TAIL(vars = i_tail_vars)), expLst = i_expLst),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_postExp = Tpl.emptyTxt;
        (l_tail, a_preExp, l_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(Tpl.emptyTxt, i_expLst, i_tail_vars, a_context, a_preExp, l_postExp, a_varDecls, a_auxFunction);
        l_res = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_LINE("/* Tail recursive call */\n"));
        l_res = Tpl.writeText(l_res, l_tail);
        l_res = Tpl.writeText(l_res, l_postExp);
        l_res = Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                        "goto _tailrecursive;\n",
                                        "/* TODO: Make sure any eventual dead code below is never generated */"
                                    }, false));
        a_preExp = Tpl.writeText(a_preExp, l_res);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = i_attr_ty, builtin = i_attr_builtin), path = i_exp_path)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_additionalOutputs = fun_1191(Tpl.emptyTxt, i_attr_ty);
        (l_res, l_additionalOutputs, a_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_additionalOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_1195(txt, a_context, a_preExp, a_varDecls, i_attr_ty, i_exp_path, i_attr_builtin, l_res);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCall;

protected function lm_1197
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1197(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1197;

protected function lm_1198
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1198(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1198;

protected function fun_1199
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<DAE.Exp> a_expLst;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("threadData"));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1197(txt, a_expLst, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1198(txt, a_expLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1199;

protected function fun_1200
  input Tpl.Text in_txt;
  input Boolean in_a_attr_builtin;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_builtin)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1200;

protected function lm_1201
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1201(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1201;

protected function fun_1202
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointerCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;
  input DAE.Type in_a_attr_ty;
  input Tpl.Text in_a_additionalOutputs;
  input Tpl.Text in_a_argStr;
  input Absyn.Path in_a_path;
  input Boolean in_a_attr_builtin;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_attr_isFunctionPointerCall, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst, in_a_attr_ty, in_a_additionalOutputs, in_a_argStr, in_a_path, in_a_attr_builtin)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<DAE.Exp> a_expLst;
      DAE.Type a_attr_ty;
      Tpl.Text a_additionalOutputs;
      Tpl.Text a_argStr;
      Absyn.Path a_path;
      Boolean a_attr_builtin;
      Tpl.Text l_argStrPointer;
      Tpl.Text l_closure;
      Tpl.Text l_func;
      Tpl.Text l_typeCast2;
      Tpl.Text l_typeCast1;
      Tpl.Text l_name;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _,
           a_additionalOutputs,
           a_argStr,
           a_path,
           a_attr_builtin )
      equation
        l_name = fun_1200(Tpl.emptyTxt, a_attr_builtin);
        l_name = CodegenUtil.underscorePath(l_name, a_path);
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst,
           a_attr_ty,
           a_additionalOutputs,
           a_argStr,
           a_path,
           _ )
      equation
        l_typeCast1 = generateTypeCast(Tpl.emptyTxt, a_attr_ty, a_expLst, true);
        l_typeCast2 = generateTypeCast(Tpl.emptyTxt, a_attr_ty, a_expLst, false);
        l_name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        l_name = CodegenUtil.underscorePath(l_name, a_path);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_func = Tpl.writeText(l_func, l_name);
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("), 1)))"));
        l_closure = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_closure = Tpl.writeText(l_closure, l_name);
        l_closure = Tpl.writeTok(l_closure, Tpl.ST_STRING("), 2)))"));
        l_argStrPointer = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("threadData, "));
        l_argStrPointer = Tpl.writeText(l_argStrPointer, l_closure);
        (l_argStrPointer, a_auxFunction, a_varDecls, a_preExp) = lm_1201(l_argStrPointer, a_expLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*Closure?*/"));
        txt = Tpl.writeText(txt, l_closure);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? ("));
        txt = Tpl.writeText(txt, l_typeCast1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, l_argStrPointer);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") : ("));
        txt = Tpl.writeText(txt, l_typeCast2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1202;

protected function fun_1203
  input Tpl.Text in_txt;
  input DAE.Exp in_a_call;
  input Tpl.Text in_a_additionalOutputs;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_call, in_a_additionalOutputs, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_additionalOutputs;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_attr_ty;
      Absyn.Path i_path;
      Boolean i_attr_isFunctionPointerCall;
      list<DAE.Exp> i_expLst;
      Boolean i_attr_builtin;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_argStr;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(builtin = i_attr_builtin, isFunctionPointerCall = i_attr_isFunctionPointerCall, ty = i_attr_ty), expLst = i_expLst, path = i_path),
           a_additionalOutputs,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = SimCodeUtil.isParallelFunctionContext(a_context);
        ret_2 = boolOr(i_attr_builtin, ret_1);
        (l_argStr, a_auxFunction, a_varDecls, a_preExp) = fun_1199(Tpl.emptyTxt, ret_2, a_auxFunction, a_varDecls, a_preExp, a_context, i_expLst);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1202(txt, i_attr_isFunctionPointerCall, a_auxFunction, a_varDecls, a_preExp, a_context, i_expLst, i_attr_ty, a_additionalOutputs, l_argStr, i_path, i_attr_builtin);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_1203;

public function daeExpCallTuple
  input Tpl.Text txt;
  input DAE.Exp a_call;
  input Tpl.Text a_additionalOutputs;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalOutputs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_1203(txt, a_call, a_additionalOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_a_additionalOutputs := a_additionalOutputs;
end daeExpCallTuple;

protected function fun_1205
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL(source = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1205;

protected function lm_1206
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeFromExpArrayIf(txt, i_e);
        txt = lm_1206(txt, rest);
      then txt;
  end match;
end lm_1206;

protected function lm_1207
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type i_t;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_t :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_t);
        txt = lm_1207(txt, rest);
      then txt;
  end match;
end lm_1207;

protected function fun_1208
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_TUPLE(tupleType = _ :: i_tys) )
      equation
        txt = lm_1207(txt, i_tys);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1208;

protected function fun_1209
  input Tpl.Text in_txt;
  input Boolean in_a_isClosure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isClosure)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", modelica_metatype"));
      then txt;
  end match;
end fun_1209;

public function generateTypeCast
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input list<DAE.Exp> a_es;
  input Boolean a_isClosure;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_outputs;
  Tpl.Text l_inputs;
  Tpl.Text l_ret;
algorithm
  l_ret := fun_1205(Tpl.emptyTxt, a_ty);
  l_inputs := lm_1206(Tpl.emptyTxt, a_es);
  l_outputs := fun_1208(Tpl.emptyTxt, a_ty);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_ret);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(*)(threadData_t*"));
  out_txt := fun_1209(out_txt, a_isClosure);
  out_txt := Tpl.writeText(out_txt, l_inputs);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("))"));
end generateTypeCast;

protected function fun_1211
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_FUNCTION(funcResultType = DAE.T_NORETCALL(source = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1211;

protected function lm_1212
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      DAE.Type i_fa_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_fa_ty) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_fa_ty);
        txt = lm_1212(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1212(txt, rest);
      then txt;
  end match;
end lm_1212;

protected function fun_1213
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> i_funcArg;

    case ( txt,
           DAE.T_FUNCTION(funcArg = i_funcArg) )
      equation
        txt = lm_1212(txt, i_funcArg);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1213;

protected function lm_1214
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type i_t;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_t :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_t);
        txt = lm_1214(txt, rest);
      then txt;
  end match;
end lm_1214;

protected function fun_1215
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_FUNCTION(funcResultType = DAE.T_TUPLE(tupleType = _ :: i_tys)) )
      equation
        txt = lm_1214(txt, i_tys);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1215;

protected function fun_1216
  input Tpl.Text in_txt;
  input Boolean in_a_isClosure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isClosure)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", modelica_metatype"));
      then txt;
  end match;
end fun_1216;

public function generateTypeCastFromType
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Boolean a_isClosure;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_outputs;
  Tpl.Text l_inputs;
  Tpl.Text l_ret;
algorithm
  l_ret := fun_1211(Tpl.emptyTxt, a_ty);
  l_inputs := fun_1213(Tpl.emptyTxt, a_ty);
  l_outputs := fun_1215(Tpl.emptyTxt, a_ty);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_ret);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(*)(threadData_t*"));
  out_txt := fun_1216(out_txt, a_isClosure);
  out_txt := Tpl.writeText(out_txt, l_inputs);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("))"));
end generateTypeCastFromType;

protected function fun_1218
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<String> in_a_vrest;
  input list<DAE.Exp> in_a_erest;
  input Tpl.Text in_a_exp;
  input String in_a_v;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_postExp, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_postExp, in_a_preExp, in_a_context, in_a_vrest, in_a_erest, in_a_exp, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<String> a_vrest;
      list<DAE.Exp> a_erest;
      Tpl.Text a_exp;
      String a_v;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           a_exp,
           a_v )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(txt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           _,
           _ )
      equation
        (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(txt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);
  end match;
end fun_1218;

protected function fun_1219
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_restText;
  input Tpl.Text in_a_exp;
  input Tpl.Text in_a_v2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_restText, in_a_exp, in_a_v2)
    local
      Tpl.Text txt;
      Tpl.Text a_restText;
      Tpl.Text a_exp;
      Tpl.Text a_v2;

    case ( txt,
           false,
           a_restText,
           a_exp,
           a_v2 )
      equation
        txt = Tpl.writeText(txt, a_v2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_restText);
      then txt;

    case ( txt,
           _,
           a_restText,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_restText);
      then txt;
  end match;
end fun_1219;

protected function fun_1220
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_e;
  input Tpl.Text in_a_exp;
  input String in_a_v;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<String> in_a_vrest;
  input list<DAE.Exp> in_a_erest;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_postExp, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_e, in_a_exp, in_a_v, in_a_auxFunction, in_a_varDecls, in_a_postExp, in_a_preExp, in_a_context, in_a_vrest, in_a_erest)
    local
      Tpl.Text txt;
      DAE.Exp a_e;
      Tpl.Text a_exp;
      String a_v;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<String> a_vrest;
      list<DAE.Exp> a_erest;
      Tpl.Text txt_4;
      Tpl.Text l_tmp;
      Boolean ret_2;
      Tpl.Text l_v2;
      Tpl.Text l_restText;

    case ( txt,
           false,
           _,
           a_exp,
           a_v,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest )
      equation
        (l_restText, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(Tpl.emptyTxt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
        l_v2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        l_v2 = Tpl.writeStr(l_v2, a_v);
        ret_2 = stringEq(Tpl.textString(l_v2), Tpl.textString(a_exp));
        txt = fun_1219(txt, ret_2, l_restText, a_exp, l_v2);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);

    case ( txt,
           _,
           a_e,
           a_exp,
           a_v,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest )
      equation
        txt_4 = expTypeFromExpModelica(Tpl.emptyTxt, a_e);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_4), a_varDecls);
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_STRING("_"));
        a_postExp = Tpl.writeStr(a_postExp, a_v);
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_STRING(" = "));
        a_postExp = Tpl.writeText(a_postExp, l_tmp);
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_STRING(";"));
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(txt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);
  end match;
end fun_1220;

protected function fun_1221
  input Tpl.Text in_txt;
  input DAE.Exp in_a_e;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<String> in_a_vrest;
  input list<DAE.Exp> in_a_erest;
  input Tpl.Text in_a_exp;
  input String in_a_v;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_postExp, out_a_preExp) :=
  match(in_txt, in_a_e, in_a_auxFunction, in_a_varDecls, in_a_postExp, in_a_preExp, in_a_context, in_a_vrest, in_a_erest, in_a_exp, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<String> a_vrest;
      list<DAE.Exp> a_erest;
      Tpl.Text a_exp;
      String a_v;
      DAE.Exp i_e;
      DAE.ComponentRef i_cr;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           a_exp,
           a_v )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_cr);
        ret_1 = stringEq(a_v, Tpl.textString(txt_0));
        (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp) = fun_1218(txt, ret_1, a_auxFunction, a_varDecls, a_postExp, a_preExp, a_context, a_vrest, a_erest, a_exp, a_v);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);

    case ( txt,
           i_e,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           a_exp,
           a_v )
      equation
        ret_2 = Expression.anyExpHasCrefName(a_erest, a_v);
        (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp) = fun_1220(txt, ret_2, i_e, a_exp, a_v, a_auxFunction, a_varDecls, a_postExp, a_preExp, a_context, a_vrest, a_erest);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);
  end match;
end fun_1221;

protected function fun_1222
  input Tpl.Text in_txt;
  input list<String> in_a_vs;
  input Tpl.Text in_a_postExp;
  input list<DAE.Exp> in_a_erest;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_postExp, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_vs, in_a_postExp, in_a_erest, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_e)
    local
      Tpl.Text txt;
      Tpl.Text a_postExp;
      list<DAE.Exp> a_erest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp a_e;
      list<String> i_vrest;
      String i_v;
      Tpl.Text l_exp;

    case ( txt,
           i_v :: i_vrest,
           a_postExp,
           a_erest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_e )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp) = fun_1221(txt, a_e, a_auxFunction, a_varDecls, a_postExp, a_preExp, a_context, i_vrest, a_erest, l_exp, i_v);
      then (txt, a_postExp, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_postExp,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_postExp, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1222;

public function daeExpTailCall
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_es;
  input list<String> in_a_vs;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_postExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_es, in_a_vs, in_a_context, in_a_preExp, in_a_postExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<String> a_vs;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_postExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_erest;
      DAE.Exp i_e;

    case ( txt,
           i_e :: i_erest,
           a_vs,
           a_context,
           a_preExp,
           a_postExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_postExp, a_auxFunction, a_varDecls, a_preExp) = fun_1222(txt, a_vs, a_postExp, i_erest, a_auxFunction, a_varDecls, a_preExp, a_context, i_e);
      then (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_postExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction);
  end match;
end daeExpTailCall;

protected function fun_1224
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           _,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = expTypeFromExpModelica(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1224;

protected function lm_1225
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_arrayVar;
  input Tpl.Text in_a_rec__name;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_arrayVar, in_a_rec__name, in_a_scalar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Tpl.Text a_arrayVar;
      Tpl.Text a_rec__name;
      Boolean a_scalar;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_prefix;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_arrayVar,
           a_rec__name,
           a_scalar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_prefix = fun_1224(Tpl.emptyTxt, a_scalar, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*(("));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)generic_array_element_addr(&"));
        txt = Tpl.writeText(txt, a_arrayVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), 1, "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))) = "));
        txt = Tpl.writeText(txt, l_prefix);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1225(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_arrayVar, a_rec__name, a_scalar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1225;

protected function fun_1226
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("scalar_"));
      then txt;
  end match;
end fun_1226;

protected function fun_1227
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_1227;

protected function fun_1228
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           _,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = expTypeFromExpModelica(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1228;

protected function lm_1229
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_scalar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Boolean a_scalar;
      DAE.Exp i_e;
      Tpl.Text l_prefix;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_scalar )
      equation
        l_prefix = fun_1228(Tpl.emptyTxt, a_scalar, i_e);
        txt = Tpl.writeText(txt, l_prefix);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1229(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_scalar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1229;

protected function fun_1230
  input Tpl.Text in_txt;
  input Tpl.Text in_a_params;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_params)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_1230;

public function daeExpArray
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean i_scalar;
      list<DAE.Exp> i_array;
      DAE.Type i_t;
      DAE.Type i_ty;
      Integer ret_7;
      Tpl.Text l_scalarRef;
      Tpl.Text l_scalarPrefix;
      Tpl.Text l_params;
      Integer ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_arrayVar;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.ARRAY(array = i_array, scalar = i_scalar, ty = (i_ty as DAE.T_ARRAY(ty = (i_t as DAE.T_COMPLEX(complexClassType = _))))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_arrayVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        l_rec__name = expTypeShort(Tpl.emptyTxt, i_t);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_generic_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", sizeof("));
        a_preExp = Tpl.writeText(a_preExp, l_rec__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("), 1, "));
        ret_3 = listLength(i_array);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_3));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_auxFunction, a_varDecls, a_preExp) = lm_1225(l_params, i_array, a_auxFunction, a_varDecls, a_preExp, a_context, l_arrayVar, l_rec__name, i_scalar);
        l_params = Tpl.popIter(l_params);
        a_preExp = Tpl.writeText(a_preExp, l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ARRAY(array = {}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_arrayVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "base_array_t", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("simple_alloc_1d_base_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 0, NULL);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ARRAY(ty = i_ty, scalar = i_scalar, array = i_array),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_arrayVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        l_scalarPrefix = fun_1226(Tpl.emptyTxt, i_scalar);
        l_scalarRef = fun_1227(Tpl.emptyTxt, i_scalar);
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_auxFunction, a_varDecls, a_preExp) = lm_1229(l_params, i_array, a_auxFunction, a_varDecls, a_preExp, a_context, i_scalar);
        l_params = Tpl.popIter(l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("array_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_scalarPrefix);
        a_preExp = Tpl.writeText(a_preExp, l_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_7 = listLength(i_array);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_7));
        a_preExp = fun_1230(a_preExp, l_params);
        a_preExp = Tpl.writeText(a_preExp, l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpArray;

protected function lm_1232
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;
  input Integer in_a_i0;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_i0, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer a_i0;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_j0;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_tmp,
           a_i0,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_j0 = Tpl.getIteri_i0(txt);
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("put_"));
        txt = Tpl.writeText(txt, a_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_element("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_j0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1232(txt, rest, a_tmp, a_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1232;

protected function lm_1233
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_i0;
      list<DAE.Exp> i_row;
      Tpl.Text l_els;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_row :: rest,
           a_tmp,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_els = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_els, a_auxFunction, a_varDecls, a_preExp) = lm_1232(l_els, i_row, a_tmp, x_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_els = Tpl.popIter(l_els);
        txt = Tpl.writeText(txt, l_els);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1233(txt, rest, a_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1233;

protected function lm_1234
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;
  input Integer in_a_i0;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_i0, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer a_i0;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_j0;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_tmp,
           a_i0,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_j0 = Tpl.getIteri_i0(txt);
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("put_"));
        txt = Tpl.writeText(txt, a_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_element("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_j0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1234(txt, rest, a_tmp, a_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1234;

protected function lm_1235
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_i0;
      list<DAE.Exp> i_row;
      Tpl.Text l_els;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_row :: rest,
           a_tmp,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_els = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_els, a_auxFunction, a_varDecls, a_preExp) = lm_1234(l_els, i_row, a_tmp, x_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_els = Tpl.popIter(l_els);
        txt = Tpl.writeText(txt, l_els);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1235(txt, rest, a_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1235;

protected function lm_1236
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;
  input Integer in_a_i0;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_i0, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer a_i0;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_j0;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_tmp,
           a_i0,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_j0 = Tpl.getIteri_i0(txt);
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("put_"));
        txt = Tpl.writeText(txt, a_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_element("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_j0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1236(txt, rest, a_tmp, a_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1236;

protected function lm_1237
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Integer x_i0;
      list<DAE.Exp> i_row;
      Tpl.Text l_els;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_row :: rest,
           a_tmp,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_els = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_els, a_auxFunction, a_varDecls, a_preExp) = lm_1236(l_els, i_row, a_tmp, x_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_els = Tpl.popIter(l_els);
        txt = Tpl.writeText(txt, l_els);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1237(txt, rest, a_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1237;

protected function lm_1238
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_vars2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_promote;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrayTypeStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_vars2;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_promote;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_vars2, out_a_auxFunction, out_a_promote, out_a_varDecls) :=
  match(in_txt, in_items, in_a_vars2, in_a_auxFunction, in_a_promote, in_a_context, in_a_varDecls, in_a_arrayTypeStr)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_vars2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_promote;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrayTypeStr;
      list<DAE.Exp> i_row;
      Integer ret_2;
      Tpl.Text l_vars;
      Tpl.Text l_tmp;

    case ( txt,
           {},
           a_vars2,
           a_auxFunction,
           a_promote,
           _,
           a_varDecls,
           _ )
      then (txt, a_vars2, a_auxFunction, a_promote, a_varDecls);

    case ( txt,
           i_row :: rest,
           a_vars2,
           a_auxFunction,
           a_promote,
           a_context,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        (l_vars, a_promote, a_varDecls, a_auxFunction) = daeExpMatrixRow(Tpl.emptyTxt, i_row, Tpl.textString(a_arrayTypeStr), a_context, a_promote, a_varDecls, a_auxFunction);
        a_vars2 = Tpl.writeTok(a_vars2, Tpl.ST_STRING(", &"));
        a_vars2 = Tpl.writeText(a_vars2, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cat_alloc_"));
        txt = Tpl.writeText(txt, a_arrayTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(2, &"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_2 = listLength(i_row);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeText(txt, l_vars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_vars2, a_auxFunction, a_promote, a_varDecls) = lm_1238(txt, rest, a_vars2, a_auxFunction, a_promote, a_context, a_varDecls, a_arrayTypeStr);
      then (txt, a_vars2, a_auxFunction, a_promote, a_varDecls);
  end match;
end lm_1238;

protected function fun_1239
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input list<list<DAE.Exp>> in_a_m_matrix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrayTypeStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_typeStr, in_a_auxFunction, in_a_preExp, in_a_context, in_a_m_matrix, in_a_varDecls, in_a_arrayTypeStr)
    local
      Tpl.Text txt;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<list<DAE.Exp>> a_m_matrix;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrayTypeStr;
      Integer ret_16;
      Tpl.Text l_catAlloc;
      Tpl.Text l_promote;
      Tpl.Text l_vars2;
      Integer ret_12;
      list<DAE.Exp> ret_11;
      Integer ret_10;
      Integer ret_9;
      list<DAE.Exp> ret_8;
      Integer ret_7;
      Tpl.Text l_matrix;
      Integer ret_5;
      list<DAE.Exp> ret_4;
      Tpl.Text l_cols;
      Integer ret_2;
      Tpl.Text l_rows;
      Tpl.Text l_tmp;

    case ( txt,
           "real",
           a_typeStr,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        ret_2 = listLength(a_m_matrix);
        l_rows = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        ret_4 = listGet(a_m_matrix, 1);
        ret_5 = listLength(ret_4);
        l_cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_matrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_matrix, a_auxFunction, a_varDecls, a_preExp) = lm_1233(l_matrix, a_m_matrix, l_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_matrix = Tpl.popIter(l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- start: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, "));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- end: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           "integer",
           a_typeStr,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        ret_7 = listLength(a_m_matrix);
        l_rows = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        ret_8 = listGet(a_m_matrix, 1);
        ret_9 = listLength(ret_8);
        l_cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_9));
        l_matrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_matrix, a_auxFunction, a_varDecls, a_preExp) = lm_1235(l_matrix, a_m_matrix, l_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_matrix = Tpl.popIter(l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- start: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, "));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- end: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           "boolean",
           a_typeStr,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        ret_10 = listLength(a_m_matrix);
        l_rows = Tpl.writeStr(Tpl.emptyTxt, intString(ret_10));
        ret_11 = listGet(a_m_matrix, 1);
        ret_12 = listLength(ret_11);
        l_cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_12));
        l_matrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_matrix, a_auxFunction, a_varDecls, a_preExp) = lm_1237(l_matrix, a_m_matrix, l_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_matrix = Tpl.popIter(l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- start: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, "));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- end: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        l_vars2 = Tpl.emptyTxt;
        l_promote = Tpl.emptyTxt;
        l_catAlloc = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_catAlloc, l_vars2, a_auxFunction, l_promote, a_varDecls) = lm_1238(l_catAlloc, a_m_matrix, l_vars2, a_auxFunction, l_promote, a_context, a_varDecls, a_arrayTypeStr);
        l_catAlloc = Tpl.popIter(l_catAlloc);
        a_preExp = Tpl.writeText(a_preExp, l_promote);
        a_preExp = Tpl.writeText(a_preExp, l_catAlloc);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cat_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(1, &"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_16 = listLength(a_m_matrix);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_16));
        a_preExp = Tpl.writeText(a_preExp, l_vars2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1239;

public function daeExpMatrix
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<list<DAE.Exp>> i_m_matrix;
      DAE.Type i_m_ty;
      DAE.Type i_ty;
      String str_3;
      Tpl.Text l_typeStr;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.MATRIX(matrix = {{}}, ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, 0, 1);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.MATRIX(matrix = {}, ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, 0, 1);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.MATRIX(ty = i_m_ty, matrix = i_m_matrix),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeStr = expTypeShort(Tpl.emptyTxt, i_m_ty);
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_m_ty);
        str_3 = Tpl.textString(l_typeStr);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1239(txt, str_3, l_typeStr, a_auxFunction, a_preExp, a_context, i_m_matrix, a_varDecls, l_arrayTypeStr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMatrix;

protected function lm_1241
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_varLstStr;
  input String in_a_arrayTypeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varLstStr;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_varLstStr, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_varLstStr, in_a_arrayTypeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_varLstStr;
      String a_arrayTypeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_e;
      Tpl.Text l_tmp;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           a_varLstStr,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_varLstStr, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_varLstStr,
           a_arrayTypeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, a_arrayTypeStr, a_varDecls);
        a_varLstStr = Tpl.writeTok(a_varLstStr, Tpl.ST_STRING(", &"));
        a_varLstStr = Tpl.writeText(a_varLstStr, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("promote_scalar_"));
        txt = Tpl.writeStr(txt, a_arrayTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 2, &"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_varLstStr, a_auxFunction, a_varDecls, a_preExp) = lm_1241(txt, rest, a_varLstStr, a_arrayTypeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_varLstStr, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1241;

public function daeExpMatrixRow
  input Tpl.Text txt;
  input list<DAE.Exp> a_row;
  input String a_arrayTypeStr;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_preExp2;
  Tpl.Text l_varLstStr;
algorithm
  l_varLstStr := Tpl.emptyTxt;
  l_preExp2 := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_preExp2, l_varLstStr, out_a_auxFunction, out_a_varDecls, out_a_preExp) := lm_1241(l_preExp2, a_row, l_varLstStr, a_arrayTypeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
  l_preExp2 := Tpl.popIter(l_preExp2);
  l_preExp2 := Tpl.writeTok(l_preExp2, Tpl.ST_NEW_LINE());
  out_a_preExp := Tpl.writeText(out_a_preExp, l_preExp2);
  out_txt := Tpl.writeText(txt, l_varLstStr);
end daeExpMatrixRow;

protected function fun_1243
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_stepExp;

    case ( txt,
           SOME(i_stepExp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_stepExp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1243;

public function daeExpRange
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<DAE.Exp> i_step;
      DAE.Exp i_stop;
      DAE.Exp i_start;
      DAE.Type i_ty;
      Tpl.Text l_step__exp;
      Tpl.Text l_tmp;
      Tpl.Text l_stop__exp;
      Tpl.Text l_start__exp;
      Tpl.Text l_ty__str;

    case ( txt,
           DAE.RANGE(ty = i_ty, start = i_start, stop = i_stop, step = i_step),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_start__exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_stop__exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        (l_step__exp, a_auxFunction, a_varDecls, a_preExp) = fun_1243(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, a_preExp, a_context);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("create_"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_from_range(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_start__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_step__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_stop__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRange;

protected function lm_1245
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_tmp, in_a_res)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_res;
      DAE.Ident i_var_name;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lm_1245(txt, rest, a_tmp, a_res);
      then txt;

    case ( txt,
           _ :: rest,
           a_tmp,
           a_res )
      equation
        txt = lm_1245(txt, rest, a_tmp, a_res);
      then txt;
  end match;
end lm_1245;

protected function fun_1246
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.Var> in_a_ty1_varLst;
  input Tpl.Text in_a_expVar;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty1;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ty1_varLst, in_a_expVar, in_a_preExp, in_a_ty1, in_a_varDecls, in_a_ty2)
    local
      Tpl.Text txt;
      list<DAE.Var> a_ty1_varLst;
      Tpl.Text a_expVar;
      Tpl.Text a_preExp;
      DAE.Type a_ty1;
      Tpl.Text a_varDecls;
      DAE.Type a_ty2;
      Tpl.Text txt_3;
      Tpl.Text l_res;
      Tpl.Text txt_1;
      Tpl.Text l_tmp;

    case ( txt,
           false,
           a_ty1_varLst,
           a_expVar,
           a_preExp,
           a_ty1,
           a_varDecls,
           a_ty2 )
      equation
        txt_1 = expTypeModelica(Tpl.emptyTxt, a_ty2);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        txt_3 = expTypeModelica(Tpl.emptyTxt, a_ty1);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = lm_1245(a_preExp, a_ty1_varLst, l_tmp, l_res);
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_expVar,
           a_preExp,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeText(txt, a_expVar);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1246;

protected function fun_1247
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_expVar;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty1;
  input Tpl.Text in_a_varDecls;
  input list<DAE.Var> in_a_ty1_varLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_expVar, in_a_preExp, in_a_ty1, in_a_varDecls, in_a_ty1_varLst)
    local
      Tpl.Text txt;
      Tpl.Text a_expVar;
      Tpl.Text a_preExp;
      DAE.Type a_ty1;
      Tpl.Text a_varDecls;
      list<DAE.Var> a_ty1_varLst;
      DAE.Type i_ty2;
      list<DAE.Var> i_ty2_varLst;
      Boolean ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           (i_ty2 as DAE.T_COMPLEX(varLst = i_ty2_varLst)),
           a_expVar,
           a_preExp,
           a_ty1,
           a_varDecls,
           a_ty1_varLst )
      equation
        ret_0 = listLength(a_ty1_varLst);
        ret_1 = listLength(i_ty2_varLst);
        ret_2 = intEq(ret_0, ret_1);
        (txt, a_preExp, a_varDecls) = fun_1246(txt, ret_2, a_ty1_varLst, a_expVar, a_preExp, a_ty1, a_varDecls, i_ty2);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_expVar,
           a_preExp,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* could not cast, using the variable as it is */"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1247;

protected function fun_1248
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_expVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_preExp, in_a_exp, in_a_varDecls, in_a_expVar)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_varDecls;
      Tpl.Text a_expVar;
      DAE.Type i_ty1;
      list<DAE.Var> i_ty1_varLst;
      DAE.Type i_ty;
      DAE.Type ret_4;
      Tpl.Text l_from;
      Tpl.Text l_to;
      Tpl.Text l_tvar;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_preExp,
           _,
           a_varDecls,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_preExp,
           _,
           a_varDecls,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_real)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_preExp,
           _,
           a_varDecls,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_preExp,
           _,
           a_varDecls,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_boolean)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(ty = i_ty),
           a_preExp,
           a_exp,
           a_varDecls,
           a_expVar )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        l_to = expTypeShort(Tpl.emptyTxt, i_ty);
        l_from = expTypeFromExpShort(Tpl.emptyTxt, a_exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cast_"));
        a_preExp = Tpl.writeText(a_preExp, l_from);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array_to_"));
        a_preExp = Tpl.writeText(a_preExp, l_to);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, a_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           (i_ty1 as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _), varLst = i_ty1_varLst)),
           a_preExp,
           a_exp,
           a_varDecls,
           a_expVar )
      equation
        ret_4 = Expression.typeof(a_exp);
        (txt, a_preExp, a_varDecls) = fun_1247(txt, ret_4, a_expVar, a_preExp, i_ty1, a_varDecls, i_ty1_varLst);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           _,
           a_varDecls,
           _ )
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1248;

public function daeExpCast
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      Tpl.Text l_expVar;

    case ( txt,
           DAE.CAST(exp = i_exp, ty = i_ty),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_1248(txt, i_ty, a_preExp, i_exp, a_varDecls, l_expVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCast;

protected function fun_1250
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_v;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", NULL"));
      then txt;

    case ( txt,
           _,
           a_v )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_v);
      then txt;
  end match;
end fun_1250;

protected function lm_1251
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_v;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_v, in_a_ix)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_v;
      Integer a_ix;
      Integer x_i1;
      Boolean ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_v,
           a_ix )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_0 = intEq(x_i1, a_ix);
        txt = fun_1250(txt, ret_0, a_v);
        txt = Tpl.nextIter(txt);
        txt = lm_1251(txt, rest, a_v, a_ix);
      then txt;
  end match;
end lm_1251;

public function daeExpTsub
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_inExp;
      Integer i_ix;
      list<DAE.Type> i_tys;
      DAE.Exp i_exp;
      Tpl.Text txt_6;
      String ret_6;
      Tpl.Text l_res;
      list<DAE.Type> ret_4;
      Tpl.Text l_additionalOutputs;
      Tpl.Text txt_2;
      DAE.Type ret_1;
      Tpl.Text l_v;

    case ( txt,
           DAE.TSUB(ix = 1, exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.TSUB(exp = (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(tupleType = i_tys)))), ix = i_ix),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listGet(i_tys, i_ix);
        txt_2 = expTypeArrayIf(Tpl.emptyTxt, ret_1);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        ret_4 = List.restOrEmpty(i_tys);
        l_additionalOutputs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(2, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_additionalOutputs = lm_1251(l_additionalOutputs, ret_4, l_v, i_ix);
        l_additionalOutputs = Tpl.popIter(l_additionalOutputs);
        (l_res, l_additionalOutputs, a_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_additionalOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_v);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.TSUB(exp = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_6 = ExpressionDump.printExpStr(i_inExp);
        txt_6 = Tpl.writeStr(Tpl.emptyTxt, ret_6);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING(": TSUB only makes sense if the subscripted expression is a function call of tuple type"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9268, 11), Tpl.textString(txt_6));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpTsub;

protected function fun_1253
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_inExp, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_idx;
      DAE.Exp i_e;
      Tpl.Text l_idx1;
      Tpl.Text l_e1;

    case ( txt,
           DAE.ASUB(exp = i_e, sub = {i_idx}),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_idx1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_idx1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.ASUB */"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1253;

protected function lm_1254
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_res, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_res;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_v;
      Tpl.Text l_casePreExp;
      Tpl.Text l_caseVarDecls;

    case ( txt,
           {},
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           i_e :: rest,
           a_res,
           a_auxFunction,
           a_context )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_caseVarDecls = Tpl.emptyTxt;
        l_casePreExp = Tpl.emptyTxt;
        (l_v, l_casePreExp, l_caseVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_casePreExp, l_caseVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(": {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_caseVarDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_casePreExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "break;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_1254(txt, rest, a_res, a_auxFunction, a_context);
      then (txt, a_auxFunction);
  end match;
end lm_1254;

protected function fun_1255
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input list<DAE.Exp> in_a_subs;
  input DAE.Type in_a_ecr_ty;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_subs, in_a_ecr_ty, in_a_arrName)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      list<DAE.Exp> a_subs;
      DAE.Type a_ecr_ty;
      Tpl.Text a_arrName;
      SimCode.Context i_context;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_arrName )
      equation
        txt = Tpl.writeText(txt, a_arrName);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_arrName )
      equation
        txt = Tpl.writeText(txt, a_arrName);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_subs,
           a_ecr_ty,
           a_arrName )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = arrayScalarRhs(txt, a_ecr_ty, a_subs, Tpl.textString(a_arrName), i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1255;

protected function lm_1256
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_index;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_index :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpASubIndex(txt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1256(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1256;

protected function fun_1257
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           1 )
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("D"));
      then txt;
  end match;
end fun_1257;

protected function fun_1258
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_inExp, in_a_auxFunction, in_a_preExp, in_a_context, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      list<DAE.Exp> i_indexes;
      DAE.Exp i_e;
      DAE.Type i_ecr_ty;
      list<DAE.Exp> i_subs;
      DAE.Exp i_ecr;
      DAE.Type i_t;
      DAE.Exp i_range;
      DAE.Exp i_range_stop;
      DAE.Exp i_range_start;
      list<DAE.Exp> i_exp_array;
      DAE.Exp i_idx;
      DAE.Exp i_exp;
      Tpl.Text txt_23;
      String ret_23;
      Integer ret_22;
      Tpl.Text l_expIndexes;
      Tpl.Text l_typeShort;
      Tpl.Text l_exp;
      DAE.Exp ret_18;
      Tpl.Text l_arrName;
      Tpl.Text txt_13;
      String ret_15;
      String ret_14;
      String ret_13;
      String ret_12;
      String ret_11;
      Tpl.Text l_stop;
      Tpl.Text l_start;
      String ret_8;
      String ret_7;
      Integer ret_6;
      Tpl.Text l_expl;
      Tpl.Text l_idx1;
      Tpl.Text txt_3;
      Tpl.Text l_res;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.ASUB(exp = _))),
           a_auxFunction,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Nested array subscripting *should* have been handled by the routine creating the asub, but for some reason it was not: "));
        ret_0 = ExpressionDump.printExpStr(i_exp);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9286, 11), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.ARRAY(scalar = true, array = i_exp_array)), sub = {i_idx}),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        txt_3 = expTypeFromExpModelica(Tpl.emptyTxt, i_exp);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        (l_idx1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_expl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_expl, a_auxFunction) = lm_1254(l_expl, i_exp_array, l_res, a_auxFunction, a_context);
        l_expl = Tpl.popIter(l_expl);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("switch("));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ")\n",
                                              "{ /* ASUB */\n"
                                          }, true));
        a_preExp = Tpl.writeText(a_preExp, l_expl);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("default:\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("throwStreamPrint(threadData, \"Index %ld out of bounds [1.."));
        ret_6 = listLength(i_exp_array);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_6));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] for array "));
        ret_7 = ExpressionDump.printExpStr(i_exp);
        ret_8 = Util.escapeModelicaStringToCString(ret_7);
        a_preExp = Tpl.writeStr(a_preExp, ret_8);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("\", (long) "));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_range as DAE.RANGE(ty = DAE.T_INTEGER(varLst = _), step = NONE(), start = i_range_start, stop = i_range_stop)), sub = {i_idx}),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        (l_idx1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_start, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_range_start, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_stop, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_range_stop, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + "));
        a_preExp = Tpl.writeText(a_preExp, l_start);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " - 1;\n",
                                              "if ("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" > "));
        a_preExp = Tpl.writeText(a_preExp, l_stop);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(") {\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("throwStreamPrint(threadData, \"Value %ld out of bounds for range "));
        ret_11 = ExpressionDump.printExpStr(i_range);
        ret_12 = Util.escapeModelicaStringToCString(ret_11);
        a_preExp = Tpl.writeStr(a_preExp, ret_12);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("\", (long) "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.RANGE(ty = i_t)), sub = {i_idx}),
           a_auxFunction,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_13 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ASUB_EASY_CASE type:"));
        ret_13 = Types.unparseType(i_t);
        txt_13 = Tpl.writeStr(txt_13, ret_13);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING(" range:"));
        ret_14 = ExpressionDump.printExpStr(i_exp);
        txt_13 = Tpl.writeStr(txt_13, ret_14);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING(" index:"));
        ret_15 = ExpressionDump.printExpStr(i_idx);
        txt_13 = Tpl.writeStr(txt_13, ret_15);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9330, 11), Tpl.textString(txt_13));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_ecr as DAE.CREF(ty = i_ecr_ty)), sub = i_subs),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        ret_18 = SimCodeUtil.buildCrefExpFromAsub(i_ecr, i_subs);
        (l_arrName, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs(Tpl.emptyTxt, ret_18, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1255(txt, a_context, a_auxFunction, a_varDecls, a_preExp, i_subs, i_ecr_ty, l_arrName);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = i_e, sub = i_indexes),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_typeShort = expTypeFromExpShort(Tpl.emptyTxt, i_e);
        l_expIndexes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_expIndexes, a_auxFunction, a_varDecls, a_preExp) = lm_1256(l_expIndexes, i_indexes, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_expIndexes = Tpl.popIter(l_expIndexes);
        txt = Tpl.writeText(txt, l_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get"));
        ret_22 = listLength(i_indexes);
        txt = fun_1257(txt, ret_22);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expIndexes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           i_exp,
           a_auxFunction,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_23 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OTHER_ASUB "));
        ret_23 = ExpressionDump.printExpStr(i_exp);
        txt_23 = Tpl.writeStr(txt_23, ret_23);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9350, 11), Tpl.textString(txt_23));
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1258;

protected function fun_1259
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_inExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_inExp;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;

    case ( txt,
           "metatype",
           a_inExp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1253(txt, a_inExp, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_inExp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1258(txt, a_inExp, a_auxFunction, a_preExp, a_context, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_1259;

public function daeExpAsub
  input Tpl.Text txt;
  input DAE.Exp a_inExp;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := expTypeFromExpShort(Tpl.emptyTxt, a_inExp);
  str_1 := Tpl.textString(txt_0);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_1259(txt, str_1, a_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExpAsub;

public function daeExpASubIndex
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Integer i_index;
      Integer i_integer;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = SimCodeUtil.incrementInt(i_integer, -1);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = SimCodeUtil.incrementInt(i_index, -1);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")-1"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpASubIndex;

protected function lm_1262
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = dimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_1262(txt, rest);
      then txt;
  end match;
end lm_1262;

public function daeExpCallPre
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      list<DAE.Exp> i_subs;
      DAE.Dimensions i_dims;
      DAE.Type i_aty;
      DAE.ComponentRef i_cr_componentRef;
      Tpl.Text txt_7;
      String ret_7;
      Tpl.Text l_type;
      Tpl.Text l_dimsValuesStr;
      Integer ret_4;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_2;
      Tpl.Text l_tmpArr;
      Tpl.Text l_cref;

    case ( txt,
           DAE.CREF(componentRef = i_cr_componentRef),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$PRE"));
        txt = cref(txt, i_cr_componentRef);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.LUNARY(operator = _, exp = DAE.CREF(componentRef = i_cr_componentRef)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!$P$PRE"));
        txt = cref(txt, i_cr_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ASUB(exp = DAE.CREF(ty = DAE.T_ARRAY(ty = i_aty, dims = i_dims), componentRef = i_cr_componentRef), sub = i_subs),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_cref = cref(Tpl.emptyTxt, i_cr_componentRef);
        txt_2 = expTypeArray(Tpl.emptyTxt, i_aty);
        (l_tmpArr, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        ret_4 = listLength(i_dims);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_4));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dimsValuesStr = lm_1262(l_dimsValuesStr, i_dims);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_type = expTypeShort(Tpl.emptyTxt, i_aty);
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array_create(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmpArr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", ((modelica_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("*)&($P$PRE"));
        a_preExp = arrayCrefCStr(a_preExp, i_cr_componentRef);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")), "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsLenStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsValuesStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        (txt, a_preExp, a_varDecls, a_auxFunction) = arrayScalarRhs(txt, i_aty, i_subs, Tpl.textString(l_tmpArr), a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_7 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support pre("));
        ret_7 = ExpressionDump.printExpStr(i_exp);
        txt_7 = Tpl.writeStr(txt_7, ret_7);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9378, 11), Tpl.textString(txt_7));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCallPre;

public function daeExpCallStart
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Exp i_sub__exp;
      DAE.ComponentRef i_cr_componentRef;
      Tpl.Text txt_2;
      String ret_2;
      Tpl.Text l_cref;
      Tpl.Text l_offset;

    case ( txt,
           DAE.CREF(componentRef = i_cr_componentRef),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P$ATTRIBUTE"));
        txt = cref(txt, i_cr_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ASUB(exp = DAE.CREF(componentRef = i_cr_componentRef), sub = {i_sub__exp}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_offset, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_sub__exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_cref = cref(Tpl.emptyTxt, i_cr_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*(&$P$ATTRIBUTE"));
        txt = cref(txt, i_cr_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start + "));
        txt = Tpl.writeText(txt, l_offset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support start("));
        ret_2 = ExpressionDump.printExpStr(i_exp);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9393, 11), Tpl.textString(txt_2));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCallStart;

public function daeExpSize
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_dim;
      DAE.Exp i_exp;
      Tpl.Text txt_3;
      String ret_3;
      Tpl.Text l_resVar;
      Tpl.Text l_dimPart;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.SIZE(exp = (i_exp as DAE.CREF(componentRef = _)), sz = SOME(i_dim)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_dimPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_resVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_resVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.SIZE(exp = (i_exp as DAE.CREF(componentRef = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_resVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "integer_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("sizes_of_dimensions_base_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_resVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_3 = ExpressionDump.printExpStr(i_exp);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(" not implemented"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9412, 14), Tpl.textString(txt_3));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpSize;

protected function fun_1266
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_arrayType, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;

    case ( txt,
           "modelica_metatype",
           _,
           a_tmpVarDecls,
           a_identType )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, Tpl.textString(a_identType), a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_arrayType,
           a_tmpVarDecls,
           _ )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, Tpl.textString(a_arrayType), a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1266;

protected function fun_1267
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           "modelica_metatype",
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1267;

protected function fun_1268
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1268;

protected function fun_1269
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_defaultValue, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           NONE(),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1269;

protected function fun_1270
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "list"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_metatype*", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1270;

protected function fun_1271
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_defaultValue, in_a_auxFunction, in_a_tmpVarDecls, in_a_preDefault, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCode.Context a_context;
      Values.Value i_v;
      DAE.Exp ret_0;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           a_context )
      equation
        ret_0 = ValuesUtil.valueExp(i_v);
        (txt, a_preDefault, a_tmpVarDecls, a_auxFunction) = daeExp(txt, ret_0, a_context, a_preDefault, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);
  end match;
end fun_1271;

protected function fun_1272
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCode.Context in_a_context;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_path, in_a_auxFunction, in_a_tmpVarDecls, in_a_preDefault, in_a_context, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCode.Context a_context;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           _,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           a_context,
           a_ri_defaultValue )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_preDefault) = fun_1271(txt, a_ri_defaultValue, a_auxFunction, a_tmpVarDecls, a_preDefault, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);
  end match;
end fun_1272;

protected function fun_1273
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_iter_guardExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_guardExpPre;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_guardExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_guardExpPre) :=
  match(in_txt, in_a_iter_guardExp, in_a_auxFunction, in_a_tmpVarDecls, in_a_guardExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_guardExpPre;
      SimCode.Context a_context;
      DAE.Exp i_grd;

    case ( txt,
           SOME(i_grd),
           a_auxFunction,
           a_tmpVarDecls,
           a_guardExpPre,
           a_context )
      equation
        (txt, a_guardExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_grd, a_context, a_guardExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_guardExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_guardExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_guardExpPre);
  end match;
end fun_1273;

protected function fun_1274
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;

    case ( txt,
           "modelica_metatype",
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("listEmpty("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0 == size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1)"));
      then txt;
  end match;
end fun_1274;

protected function fun_1275
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;

    case ( txt,
           "modelica_metatype",
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("listLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1)"));
      then txt;
  end match;
end fun_1275;

protected function fun_1276
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_fExpStr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ri_defaultValue, in_a_reductionBodyExpr, in_a_fExpStr, in_a_res, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_fExpStr;
      Tpl.Text a_res;
      Tpl.Text a_foundFirst;

    case ( txt,
           NONE(),
           a_reductionBodyExpr,
           a_fExpStr,
           a_res,
           a_foundFirst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           a_fExpStr,
           a_res,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1276;

protected function fun_1277
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_foundFirst;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_bodyExpPre) :=
  match(in_txt, in_a_ri_foldExp, in_a_reductionBodyExpr, in_a_res, in_a_foundFirst, in_a_ri_defaultValue, in_a_auxFunction, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_res;
      Tpl.Text a_foundFirst;
      Option<Values.Value> a_ri_defaultValue;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCode.Context a_context;
      DAE.Exp i_fExp;
      Tpl.Text l_fExpStr;
      Tpl.Text l_foldExpPre;

    case ( txt,
           SOME(i_fExp),
           a_reductionBodyExpr,
           a_res,
           a_foundFirst,
           a_ri_defaultValue,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context )
      equation
        l_foldExpPre = Tpl.emptyTxt;
        (l_fExpStr, a_bodyExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_fExp, a_context, a_bodyExpPre, a_tmpVarDecls, a_auxFunction);
        txt = fun_1276(txt, a_ri_defaultValue, a_reductionBodyExpr, l_fExpStr, a_res, a_foundFirst);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);
  end match;
end fun_1277;

protected function fun_1278
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_foundFirst;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCode.Context in_a_context;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_arrIndex;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_bodyExpPre) :=
  match(in_txt, in_a_ri_path, in_a_foundFirst, in_a_ri_defaultValue, in_a_auxFunction, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context, in_a_ri_foldExp, in_a_arrIndex, in_a_arrayTypeResult, in_a_res, in_a_reductionBodyExpr, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text a_foundFirst;
      Option<Values.Value> a_ri_defaultValue;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCode.Context a_context;
      Option<DAE.Exp> a_ri_foldExp;
      Tpl.Text a_arrIndex;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_res;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_resTail;

    case ( txt,
           Absyn.IDENT(name = "list"),
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           _,
           _,
           _,
           a_reductionBodyExpr,
           a_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",0);\n"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &MMC_CDR(*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           Absyn.IDENT(name = "listReverse"),
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_arrIndex,
           a_arrayTypeResult,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*("));
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr1(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           _,
           a_foundFirst,
           a_ri_defaultValue,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context,
           a_ri_foldExp,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre) = fun_1277(txt, a_ri_foldExp, a_reductionBodyExpr, a_res, a_foundFirst, a_ri_defaultValue, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);
  end match;
end fun_1278;

protected function fun_1279
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preDefault;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ri_defaultValue, in_a_defaultValue, in_a_res, in_a_preDefault, in_a_ri_path, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text a_defaultValue;
      Tpl.Text a_res;
      Tpl.Text a_preDefault;
      Absyn.Path a_ri_path;
      Tpl.Text a_foundFirst;

    case ( txt,
           NONE(),
           _,
           _,
           _,
           a_ri_path,
           a_foundFirst )
      equation
        txt = Tpl.writeText(txt, a_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0; /* "));
        txt = CodegenUtil.dotPath(txt, a_ri_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" lacks default-value */"));
      then txt;

    case ( txt,
           _,
           a_defaultValue,
           a_res,
           a_preDefault,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_preDefault);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* defaultValue */"));
      then txt;
  end match;
end fun_1279;

protected function fun_1280
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preDefault;
  input Tpl.Text in_a_foundFirst;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_arrIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ri_path, in_a_defaultValue, in_a_preDefault, in_a_foundFirst, in_a_ri_defaultValue, in_a_length, in_a_res, in_a_arrayTypeResult, in_a_arrIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preDefault;
      Tpl.Text a_foundFirst;
      Option<Values.Value> a_ri_defaultValue;
      Tpl.Text a_length;
      Tpl.Text a_res;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_arrIndex;
      Absyn.Path i_ri_path;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           _,
           _,
           a_length,
           a_res,
           a_arrayTypeResult,
           a_arrIndex )
      equation
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 1;\n",
                                    "simple_alloc_1d_"
                                }, false));
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           i_ri_path,
           a_defaultValue,
           a_preDefault,
           a_foundFirst,
           a_ri_defaultValue,
           _,
           a_res,
           _,
           _ )
      equation
        txt = fun_1279(txt, a_ri_defaultValue, a_defaultValue, a_res, a_preDefault, i_ri_path, a_foundFirst);
      then txt;
  end match;
end fun_1280;

protected function fun_1281
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_identType;
  input Tpl.Text in_a_empty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_arrayType, in_a_firstIndex, in_a_loopVar, in_a_iteratorName, in_a_identType, in_a_empty)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      Tpl.Text a_iteratorName;
      Tpl.Text a_identType;
      Tpl.Text a_empty;

    case ( txt,
           "modelica_metatype",
           _,
           _,
           a_loopVar,
           a_iteratorName,
           a_identType,
           a_empty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while(!"));
        txt = Tpl.writeText(txt, a_empty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_identType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_firstIndex,
           a_loopVar,
           a_iteratorName,
           a_identType,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", 1))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_identType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = *("));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr1(&"));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++));"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1281;

protected function fun_1282
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_firstIndex )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1;"));
      then txt;
  end match;
end fun_1282;

protected function fun_1283
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_resTail,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1283;

protected function fun_1284
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ri_defaultValue, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text a_foundFirst;

    case ( txt,
           NONE(),
           a_foundFirst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, a_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") MMC_THROW_INTERNAL();"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1284;

protected function fun_1285
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_nil();"));
      then txt;
  end match;
end fun_1285;

public function daeExpReduction
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      String i_iter_id;
      Option<DAE.Exp> i_ri_foldExp;
      DAE.Exp i_r_expr;
      String i_ri_foldName;
      Option<DAE.Exp> i_iter_guardExp;
      String i_ri_resultName;
      Option<Values.Value> i_ri_defaultValue;
      Absyn.Path i_ri_path;
      DAE.Exp i_r;
      DAE.Exp i_iter_exp;
      Tpl.Text txt_38;
      String ret_38;
      String str_37;
      Tpl.Text l_loopHead;
      Tpl.Text l_iteratorName;
      Tpl.Text l_firstValue;
      Tpl.Text l_foldExp;
      Tpl.Text l_reductionBodyExprWork;
      DAE.Type ret_31;
      Tpl.Text l_bodyExprType;
      DAE.ComponentRef ret_29;
      Tpl.Text l_reductionBodyExpr;
      String str_27;
      Tpl.Text l_length;
      String str_25;
      Tpl.Text l_empty;
      Tpl.Text l_guardCond;
      Tpl.Text l_defaultValue;
      Tpl.Text l_resTail;
      Tpl.Text l_preDefault;
      Tpl.Text l_resTmp;
      DAE.ComponentRef ret_18;
      Tpl.Text l_res;
      DAE.Type ret_16;
      Tpl.Text l_resType;
      Tpl.Text l_rangeExp;
      Tpl.Text l_foundFirst;
      Tpl.Text l_arrIndex;
      String str_11;
      Tpl.Text l_firstIndex;
      String str_9;
      Tpl.Text l_loopVar;
      Tpl.Text l_arrayTypeResult;
      Tpl.Text l_arrayType;
      Tpl.Text l_identType;
      Tpl.Text l_rangeExpPre;
      Tpl.Text l_guardExpPre;
      Tpl.Text l_bodyExpPre;
      Tpl.Text l_tmpExpPre;
      Tpl.Text l_tmpVarDecls;

    case ( txt,
           (i_r as DAE.REDUCTION(reductionInfo = DAE.REDUCTIONINFO(iterType = DAE.COMBINE(), path = i_ri_path, defaultValue = i_ri_defaultValue, resultName = i_ri_resultName, foldName = i_ri_foldName, foldExp = i_ri_foldExp), iterators = {DAE.REDUCTIONITER(exp = i_iter_exp, guardExp = i_iter_guardExp, id = i_iter_id)}, expr = i_r_expr)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_tmpVarDecls = Tpl.emptyTxt;
        l_tmpExpPre = Tpl.emptyTxt;
        l_bodyExpPre = Tpl.emptyTxt;
        l_guardExpPre = Tpl.emptyTxt;
        l_rangeExpPre = Tpl.emptyTxt;
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        l_arrayType = expTypeFromExpArray(Tpl.emptyTxt, i_iter_exp);
        l_arrayTypeResult = expTypeFromExpArray(Tpl.emptyTxt, i_r);
        str_9 = Tpl.textString(l_identType);
        (l_loopVar, l_tmpVarDecls) = fun_1266(Tpl.emptyTxt, str_9, l_arrayType, l_tmpVarDecls, l_identType);
        str_11 = Tpl.textString(l_identType);
        (l_firstIndex, l_tmpVarDecls) = fun_1267(Tpl.emptyTxt, str_11, l_tmpVarDecls);
        (l_arrIndex, l_tmpVarDecls) = fun_1268(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_foundFirst, l_tmpVarDecls) = fun_1269(Tpl.emptyTxt, i_ri_defaultValue, l_tmpVarDecls);
        (l_rangeExp, l_rangeExpPre, l_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_iter_exp, a_context, l_rangeExpPre, l_tmpVarDecls, a_auxFunction);
        ret_16 = Expression.typeof(i_r);
        l_resType = expTypeArrayIf(Tpl.emptyTxt, ret_16);
        ret_18 = ComponentReference.makeUntypedCrefIdent(i_ri_resultName);
        (l_res, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_18, a_context, a_auxFunction);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_resType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_res);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_resTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resType), a_varDecls);
        l_preDefault = Tpl.emptyTxt;
        (l_resTail, l_tmpVarDecls) = fun_1270(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_defaultValue, a_auxFunction, l_tmpVarDecls, l_preDefault) = fun_1272(Tpl.emptyTxt, i_ri_path, a_auxFunction, l_tmpVarDecls, l_preDefault, a_context, i_ri_defaultValue);
        (l_guardCond, a_auxFunction, l_tmpVarDecls, l_guardExpPre) = fun_1273(Tpl.emptyTxt, i_iter_guardExp, a_auxFunction, l_tmpVarDecls, l_guardExpPre, a_context);
        str_25 = Tpl.textString(l_identType);
        l_empty = fun_1274(Tpl.emptyTxt, str_25, l_loopVar);
        str_27 = Tpl.textString(l_identType);
        l_length = fun_1275(Tpl.emptyTxt, str_27, l_loopVar);
        ret_29 = ComponentReference.makeUntypedCrefIdent(i_ri_foldName);
        (l_reductionBodyExpr, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_29, a_context, a_auxFunction);
        ret_31 = Expression.typeof(i_r_expr);
        l_bodyExprType = expTypeArrayIf(Tpl.emptyTxt, ret_31);
        (l_reductionBodyExprWork, l_bodyExpPre, l_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_r_expr, a_context, l_bodyExpPre, l_tmpVarDecls, a_auxFunction);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_bodyExprType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_reductionBodyExpr);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExpr);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(" = "));
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExprWork);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(";"));
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_NEW_LINE());
        (l_foldExp, a_auxFunction, l_tmpVarDecls, l_bodyExpPre) = fun_1278(Tpl.emptyTxt, i_ri_path, l_foundFirst, i_ri_defaultValue, a_auxFunction, l_tmpVarDecls, l_bodyExpPre, a_context, i_ri_foldExp, l_arrIndex, l_arrayTypeResult, l_res, l_reductionBodyExpr, l_resTail);
        l_firstValue = fun_1280(Tpl.emptyTxt, i_ri_path, l_defaultValue, l_preDefault, l_foundFirst, i_ri_defaultValue, l_length, l_res, l_arrayTypeResult, l_arrIndex);
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        str_37 = Tpl.textString(l_identType);
        l_loopHead = fun_1281(Tpl.emptyTxt, str_37, l_arrayType, l_firstIndex, l_loopVar, l_iteratorName, l_identType, l_empty);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("{\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmpVarDecls);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_rangeExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_loopVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_rangeExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = fun_1282(a_preExp, l_firstIndex);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_firstValue);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1283(a_preExp, l_resTail, l_res);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_loopHead);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_guardExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("if("));
        a_preExp = Tpl.writeText(a_preExp, l_guardCond);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ")\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_bodyExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_foldExp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = fun_1284(a_preExp, i_ri_defaultValue, l_foundFirst);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1285(a_preExp, l_resTail);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_resTmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resTmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_38 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support multiple iterators: "));
        ret_38 = ExpressionDump.printExpStr(i_exp);
        txt_38 = Tpl.writeStr(txt_38, ret_38);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9535, 14), Tpl.textString(txt_38));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpReduction;

protected function fun_1287
  input Tpl.Text in_txt;
  input DAE.Type in_a_et;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_et, in_a_varDecls, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp;
      DAE.Type i_et;
      Tpl.Text txt_4;
      Tpl.Text txt_2;
      String ret_2;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_NORETCALL(source = _),
           a_varDecls,
           a_exp )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("match expression not returning anything should be caught in a noretcall statement and not reach this code: "));
        ret_0 = ExpressionDump.printExpStr(a_exp);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9544, 37), Tpl.textString(txt_0));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_TUPLE(tupleType = {}),
           a_varDecls,
           a_exp )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("match expression returning an empty tuple should be caught in a noretcall statement and not reach this code: "));
        ret_2 = ExpressionDump.printExpStr(a_exp);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9545, 43), Tpl.textString(txt_2));
      then (txt, a_varDecls);

    case ( txt,
           i_et,
           a_varDecls,
           _ )
      equation
        txt_4 = expTypeModelica(Tpl.emptyTxt, i_et);
        (txt, a_varDecls) = tempDeclZero(txt, Tpl.textString(txt_4), a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_1287;

public function daeExpMatch
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Type i_et;
      Tpl.Text l_startIndexOutputs;
      Tpl.Text l_res;

    case ( txt,
           (i_exp as DAE.MATCHEXPRESSION(et = i_et)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_res, a_varDecls) = fun_1287(Tpl.emptyTxt, i_et, a_varDecls, i_exp);
        l_startIndexOutputs = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ERROR_INDEX"));
        (txt, l_res, l_startIndexOutputs, a_preExp, a_varDecls, a_auxFunction) = daeExpMatch2(txt, i_exp, SimCode.listExpLength1, l_res, l_startIndexOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMatch;

protected function lm_1289
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_preExpInner;
  input Tpl.Text in_a_varDeclsInner;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_preExpInner;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_preExpInner, out_a_varDeclsInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_preExpInner, in_a_varDeclsInner)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_preExpInner;
      Tpl.Text a_varDeclsInner;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_preExpInner,
           a_varDeclsInner )
      then (txt, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_preExpInner,
           a_varDeclsInner )
      equation
        (txt, a_varDeclsInner, a_preExpInner, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDeclsInner, a_preExpInner, a_varFrees, a_auxFunction);
        (txt, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner) = lm_1289(txt, rest, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner);
      then (txt, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner);
  end match;
end lm_1289;

protected function lm_1290
  input Tpl.Text in_txt;
  input list<String> in_items;
  input Tpl.Text in_a_decl;
  input Tpl.Text in_a_typ;
  input Tpl.Text in_a_varDeclsInput;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsInput;
algorithm
  (out_txt, out_a_varDeclsInput) :=
  match(in_txt, in_items, in_a_decl, in_a_typ, in_a_varDeclsInput)
    local
      Tpl.Text txt;
      list<String> rest;
      Tpl.Text a_decl;
      Tpl.Text a_typ;
      Tpl.Text a_varDeclsInput;
      String i_a;

    case ( txt,
           {},
           _,
           _,
           a_varDeclsInput )
      then (txt, a_varDeclsInput);

    case ( txt,
           i_a :: rest,
           a_decl,
           a_typ,
           a_varDeclsInput )
      equation
        a_varDeclsInput = Tpl.writeText(a_varDeclsInput, a_typ);
        a_varDeclsInput = Tpl.writeTok(a_varDeclsInput, Tpl.ST_STRING(" _"));
        a_varDeclsInput = Tpl.writeStr(a_varDeclsInput, i_a);
        a_varDeclsInput = Tpl.writeTok(a_varDeclsInput, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, i_a);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_decl);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_varDeclsInput) = lm_1290(txt, rest, a_decl, a_typ, a_varDeclsInput);
      then (txt, a_varDeclsInput);
  end match;
end lm_1290;

protected function lm_1291
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<String>>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExpInput;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_expInput;
  input Tpl.Text in_a_varDeclsInput;
  input Tpl.Text in_a_startIndexInputs;
  input Tpl.Text in_a_prefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExpInput;
  output Tpl.Text out_a_expInput;
  output Tpl.Text out_a_varDeclsInput;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExpInput, out_a_expInput, out_a_varDeclsInput) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_preExpInput, in_a_context, in_a_expInput, in_a_varDeclsInput, in_a_startIndexInputs, in_a_prefix)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<String>>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExpInput;
      SimCode.Context a_context;
      Tpl.Text a_expInput;
      Tpl.Text a_varDeclsInput;
      Tpl.Text a_startIndexInputs;
      Tpl.Text a_prefix;
      Integer x_i0;
      list<String> i_alias;
      DAE.Exp i_exp;
      Tpl.Text l_decl;
      Tpl.Text l_typ;

    case ( txt,
           {},
           a_auxFunction,
           a_preExpInput,
           _,
           a_expInput,
           a_varDeclsInput,
           _,
           _ )
      then (txt, a_auxFunction, a_preExpInput, a_expInput, a_varDeclsInput);

    case ( txt,
           (i_exp, i_alias) :: rest,
           a_auxFunction,
           a_preExpInput,
           a_context,
           a_expInput,
           a_varDeclsInput,
           a_startIndexInputs,
           a_prefix )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_typ = expTypeFromExpModelica(Tpl.emptyTxt, i_exp);
        (l_decl, a_varDeclsInput) = tempDeclMatchInput(Tpl.emptyTxt, Tpl.textString(l_typ), Tpl.textString(a_prefix), Tpl.textString(a_startIndexInputs), intString(x_i0), a_varDeclsInput);
        a_expInput = Tpl.writeText(a_expInput, l_decl);
        a_expInput = Tpl.writeTok(a_expInput, Tpl.ST_STRING(" = "));
        (a_expInput, a_preExpInput, a_varDeclsInput, a_auxFunction) = daeExp(a_expInput, i_exp, a_context, a_preExpInput, a_varDeclsInput, a_auxFunction);
        a_expInput = Tpl.writeTok(a_expInput, Tpl.ST_STRING(";"));
        a_expInput = Tpl.writeTok(a_expInput, Tpl.ST_NEW_LINE());
        a_expInput = Tpl.pushIter(a_expInput, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_expInput, a_varDeclsInput) = lm_1290(a_expInput, i_alias, l_decl, l_typ, a_varDeclsInput);
        a_expInput = Tpl.popIter(a_expInput);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_preExpInput, a_expInput, a_varDeclsInput) = lm_1291(txt, rest, a_auxFunction, a_preExpInput, a_context, a_expInput, a_varDeclsInput, a_startIndexInputs, a_prefix);
      then (txt, a_auxFunction, a_preExpInput, a_expInput, a_varDeclsInput);
  end match;
end lm_1291;

protected function fun_1292
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input Tpl.Text in_a_varDeclsInner;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_startIndexInputs;
  input Tpl.Text in_a_prefix;
  input list<DAE.Exp> in_a_exp_inputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_varDeclsInner) :=
  match(in_txt, in_a_exp_matchType, in_a_varDeclsInner, in_a_exp, in_a_startIndexInputs, in_a_prefix, in_a_exp_inputs)
    local
      Tpl.Text txt;
      Tpl.Text a_varDeclsInner;
      DAE.Exp a_exp;
      Tpl.Text a_startIndexInputs;
      Tpl.Text a_prefix;
      list<DAE.Exp> a_exp_inputs;
      Integer i_div;
      Integer i_switchIndex;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text l_matchInputVar;

    case ( txt,
           DAE.MATCH(switch = SOME((i_switchIndex, DAE.T_STRING(varLst = _), i_div))),
           a_varDeclsInner,
           _,
           a_startIndexInputs,
           a_prefix,
           a_exp_inputs )
      equation
        l_matchInputVar = getTempDeclMatchInputName(Tpl.emptyTxt, a_exp_inputs, Tpl.textString(a_prefix), Tpl.textString(a_startIndexInputs), i_switchIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("stringHashDjb2Mod("));
        txt = Tpl.writeText(txt, l_matchInputVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_div));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDeclsInner);

    case ( txt,
           DAE.MATCH(switch = SOME((i_switchIndex, DAE.T_METATYPE(ty = _), _))),
           a_varDeclsInner,
           _,
           a_startIndexInputs,
           a_prefix,
           a_exp_inputs )
      equation
        l_matchInputVar = getTempDeclMatchInputName(Tpl.emptyTxt, a_exp_inputs, Tpl.textString(a_prefix), Tpl.textString(a_startIndexInputs), i_switchIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("valueConstructor("));
        txt = Tpl.writeText(txt, l_matchInputVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDeclsInner);

    case ( txt,
           DAE.MATCH(switch = SOME((i_switchIndex, DAE.T_INTEGER(varLst = _), _))),
           a_varDeclsInner,
           _,
           a_startIndexInputs,
           a_prefix,
           a_exp_inputs )
      equation
        l_matchInputVar = getTempDeclMatchInputName(Tpl.emptyTxt, a_exp_inputs, Tpl.textString(a_prefix), Tpl.textString(a_startIndexInputs), i_switchIndex);
        txt = Tpl.writeText(txt, l_matchInputVar);
      then (txt, a_varDeclsInner);

    case ( txt,
           DAE.MATCH(switch = SOME(_)),
           a_varDeclsInner,
           a_exp,
           _,
           _,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown switch: "));
        ret_1 = ExpressionDump.printExpStr(a_exp);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 9587, 13), Tpl.textString(txt_1));
      then (txt, a_varDeclsInner);

    case ( txt,
           _,
           a_varDeclsInner,
           _,
           _,
           _,
           _ )
      equation
        (txt, a_varDeclsInner) = tempDecl(txt, "volatile mmc_switch_type", a_varDeclsInner);
      then (txt, a_varDeclsInner);
  end match;
end fun_1292;

protected function fun_1293
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.MATCHCONTINUE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("matchcontinue expression"));
      then txt;

    case ( txt,
           DAE.MATCH(switch = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("match expression"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1293;

protected function fun_1294
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input Tpl.Text in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType, in_a_prefix)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;

    case ( txt,
           DAE.MATCHCONTINUE(),
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_TRY_INTERNAL(mmc_jumper)\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_top:\n",
                                    "threadData->mmc_jumper = &new_mmc_jumper;"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1294;

protected function fun_1295
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input list<DAE.MatchCase> in_a_exp_cases;
  input Tpl.Text in_a_prefix;
  input Tpl.Text in_a_ix;
  input Tpl.Text in_a_done;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType, in_a_exp_cases, in_a_prefix, in_a_ix, in_a_done)
    local
      Tpl.Text txt;
      list<DAE.MatchCase> a_exp_cases;
      Tpl.Text a_prefix;
      Tpl.Text a_ix;
      Tpl.Text a_done;
      DAE.MatchType i_exp_matchType;
      Integer ret_0;

    case ( txt,
           DAE.MATCH(switch = SOME(_)),
           _,
           _,
           _,
           a_done )
      equation
        txt = Tpl.writeText(txt, a_done);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
      then txt;

    case ( txt,
           i_exp_matchType,
           a_exp_cases,
           a_prefix,
           a_ix,
           a_done )
      equation
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        txt = Tpl.writeText(txt, a_done);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        txt = fun_1294(txt, i_exp_matchType, a_prefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for (; "));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        ret_0 = listLength(a_exp_cases);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_done);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) {"));
      then txt;
  end match;
end fun_1295;

protected function fun_1296
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input Tpl.Text in_a_prefix;
  input list<DAE.MatchCase> in_a_exp_cases;
  input Tpl.Text in_a_ix;
  input Tpl.Text in_a_done;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType, in_a_prefix, in_a_exp_cases, in_a_ix, in_a_done)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;
      list<DAE.MatchCase> a_exp_cases;
      Tpl.Text a_ix;
      Tpl.Text a_done;
      Integer ret_0;

    case ( txt,
           DAE.MATCHCONTINUE(),
           a_prefix,
           a_exp_cases,
           a_ix,
           a_done )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MMC_CATCH_INTERNAL(mmc_jumper);\n",
                                    "if (!"
                                }, false));
        txt = Tpl.writeText(txt, a_done);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && ++"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        ret_0 = listLength(a_exp_cases);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_top;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1296;

public function daeExpMatch2
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_startIndexOutputs;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_res;
  output Tpl.Text out_a_startIndexOutputs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_res, out_a_startIndexOutputs, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_tupleAssignExps, in_a_res, in_a_startIndexOutputs, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_res;
      Tpl.Text a_startIndexOutputs;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.MatchCase> i_exp_cases;
      DAE.Exp i_exp;
      list<DAE.Exp> i_exp_inputs;
      DAE.MatchType i_exp_matchType;
      list<list<String>> i_aliases;
      list<DAE.Exp> i_inputs;
      list<DAE.Element> i_localDecls;
      Integer ret_20;
      Tpl.Text l_onPatternFail;
      Tpl.Text l_done;
      Tpl.Text l_ix;
      list<tuple<DAE.Exp, list<String>>> ret_16;
      Tpl.Text l_ignore3;
      Integer ret_14;
      Integer ret_13;
      Tpl.Text l_startIndexInputs;
      Tpl.Text l_expInput;
      Tpl.Text l_preExpInput;
      Integer ret_9;
      Tpl.Text l_prefix;
      list<SimCode.Variable> ret_7;
      Tpl.Text l_ignore2;
      Tpl.Text l_ignore;
      Tpl.Text l_varFrees;
      Tpl.Text l_varDeclsInner;
      Tpl.Text l_varDeclsInput;
      Tpl.Text l_preExpRes;
      Tpl.Text l_preExpInner;

    case ( txt,
           (i_exp as DAE.MATCHEXPRESSION(localDecls = i_localDecls, inputs = (i_exp_inputs as i_inputs), aliases = i_aliases, matchType = i_exp_matchType, cases = i_exp_cases)),
           a_tupleAssignExps,
           a_res,
           a_startIndexOutputs,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExpInner = Tpl.emptyTxt;
        l_preExpRes = Tpl.emptyTxt;
        l_varDeclsInput = Tpl.emptyTxt;
        l_varDeclsInner = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_ignore = Tpl.emptyTxt;
        ret_7 = SimCodeUtil.elementVars(i_localDecls);
        (l_ignore2, a_auxFunction, l_varFrees, l_preExpInner, l_varDeclsInner) = lm_1289(Tpl.emptyTxt, ret_7, a_auxFunction, l_varFrees, l_preExpInner, l_varDeclsInner);
        l_prefix = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_9 = System.tmpTick();
        l_prefix = Tpl.writeStr(l_prefix, intString(ret_9));
        l_preExpInput = Tpl.emptyTxt;
        l_expInput = Tpl.emptyTxt;
        ret_13 = listLength(i_inputs);
        ret_14 = System.tmpTickIndexReserve(1, ret_13);
        l_startIndexInputs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_14));
        ret_16 = List.threadTuple(i_inputs, i_aliases);
        l_ignore3 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_ignore3, a_auxFunction, l_preExpInput, l_expInput, l_varDeclsInput) = lm_1291(l_ignore3, ret_16, a_auxFunction, l_preExpInput, a_context, l_expInput, l_varDeclsInput, l_startIndexInputs, l_prefix);
        l_ignore3 = Tpl.popIter(l_ignore3);
        (l_ix, l_varDeclsInner) = fun_1292(Tpl.emptyTxt, i_exp_matchType, l_varDeclsInner, i_exp, l_startIndexInputs, l_prefix, i_exp_inputs);
        (l_done, l_varDeclsInner) = tempDecl(Tpl.emptyTxt, "int", l_varDeclsInner);
        l_onPatternFail = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("goto "));
        l_onPatternFail = Tpl.writeText(l_onPatternFail, l_prefix);
        l_onPatternFail = Tpl.writeTok(l_onPatternFail, Tpl.ST_STRING("_end"));
        a_preExp = endModelicaLine(a_preExp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("{ /* "));
        a_preExp = fun_1293(a_preExp, i_exp_matchType);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" */\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_varDeclsInput);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_preExpInput);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_expInput);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("{\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_varDeclsInner);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_preExpInner);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1295(a_preExp, i_exp_matchType, i_exp_cases, l_prefix, l_ix, l_done);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("switch (MMC_SWITCH_CAST("));
        a_preExp = Tpl.writeText(a_preExp, l_ix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(")) {\n"));
        ret_20 = System.tmpTickIndexReserve(1, 0);
        (a_preExp, l_ix, a_res, a_startIndexOutputs, l_prefix, l_startIndexInputs, l_onPatternFail, l_done, a_varDecls, a_auxFunction) = daeExpMatchCases(a_preExp, i_exp_cases, a_tupleAssignExps, i_exp_matchType, l_ix, a_res, a_startIndexOutputs, l_prefix, l_startIndexInputs, i_exp_inputs, l_onPatternFail, l_done, a_context, a_varDecls, a_auxFunction, ret_20);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "goto "
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_prefix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("_end;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_prefix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("_end: ;\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = fun_1296(a_preExp, i_exp_matchType, l_prefix, i_exp_cases, l_ix, l_done);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("if (!"));
        a_preExp = Tpl.writeText(a_preExp, l_done);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(") MMC_THROW_INTERNAL();\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_res, a_startIndexOutputs, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_res,
           a_startIndexOutputs,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_res, a_startIndexOutputs, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMatch2;

protected function lm_1298
  input Tpl.Text in_txt;
  input list<tuple<DAE.Pattern, Integer>> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_startIndexInputs;
  input Tpl.Text in_a_prefix;
  input list<DAE.Exp> in_a_inputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_assignments, out_a_varDeclsCaseInner, out_a_onPatternFail) :=
  match(in_txt, in_items, in_a_assignments, in_a_varDeclsCaseInner, in_a_onPatternFail, in_a_startIndexInputs, in_a_prefix, in_a_inputs)
    local
      Tpl.Text txt;
      list<tuple<DAE.Pattern, Integer>> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_startIndexInputs;
      Tpl.Text a_prefix;
      list<DAE.Exp> a_inputs;
      Integer i_i0;
      DAE.Pattern i_lhs;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_assignments,
           a_varDeclsCaseInner,
           a_onPatternFail,
           _,
           _,
           _ )
      then (txt, a_assignments, a_varDeclsCaseInner, a_onPatternFail);

    case ( txt,
           (i_lhs, i_i0) :: rest,
           a_assignments,
           a_varDeclsCaseInner,
           a_onPatternFail,
           a_startIndexInputs,
           a_prefix,
           a_inputs )
      equation
        txt_0 = getTempDeclMatchInputName(Tpl.emptyTxt, a_inputs, Tpl.textString(a_prefix), Tpl.textString(a_startIndexInputs), i_i0);
        (txt, txt_0, a_onPatternFail, a_varDeclsCaseInner, a_assignments) = patternMatch(txt, i_lhs, txt_0, a_onPatternFail, a_varDeclsCaseInner, a_assignments);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_varDeclsCaseInner, a_onPatternFail) = lm_1298(txt, rest, a_assignments, a_varDeclsCaseInner, a_onPatternFail, a_startIndexInputs, a_prefix, a_inputs);
      then (txt, a_assignments, a_varDeclsCaseInner, a_onPatternFail);
  end match;
end lm_1298;

protected function lm_1299
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      SimCode.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsCaseInner,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_context )
      equation
        (txt, a_varDeclsCaseInner, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsCaseInner) = lm_1299(txt, rest, a_auxFunction, a_varDeclsCaseInner, a_context);
      then (txt, a_auxFunction, a_varDeclsCaseInner);
  end match;
end lm_1299;

protected function fun_1300
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_patternGuard;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preGuardCheck;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preGuardCheck;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preGuardCheck) :=
  match(in_txt, in_a_patternGuard, in_a_onPatternFail, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preGuardCheck, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preGuardCheck;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           SOME(i_exp),
           a_onPatternFail,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preGuardCheck,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        (txt, a_preGuardCheck, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preGuardCheck, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preGuardCheck);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preGuardCheck,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preGuardCheck);
  end match;
end fun_1300;

protected function lm_1301
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preRes;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input list<DAE.Exp> in_a_exps;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preRes) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preRes, in_a_context, in_a_startIndexOutputs, in_a_res, in_a_exps)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preRes;
      SimCode.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      list<DAE.Exp> a_exps;
      Integer x_i1;
      DAE.Exp i_e;
      Integer ret_0;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res,
           a_exps )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_0 = intSub(x_i1, 1);
        txt = getTempDeclMatchOutputName(txt, a_exps, Tpl.textString(a_res), Tpl.textString(a_startIndexOutputs), ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_e, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes) = lm_1301(txt, rest, a_auxFunction, a_varDeclsCaseInner, a_preRes, a_context, a_startIndexOutputs, a_res, a_exps);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);
  end match;
end lm_1301;

protected function lm_1302
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input list<DAE.Exp> in_a_tupleAssignExps;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_startIndexOutputs, in_a_res, in_a_tupleAssignExps)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      list<DAE.Exp> a_tupleAssignExps;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_startIndexOutputs,
           a_res,
           a_tupleAssignExps )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = getTempDeclMatchOutputName(txt, a_tupleAssignExps, Tpl.textString(a_res), Tpl.textString(a_startIndexOutputs), x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_1302(txt, rest, a_startIndexOutputs, a_res, a_tupleAssignExps);
      then txt;
  end match;
end lm_1302;

protected function fun_1303
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_retStruct;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tupleAssignExps, in_a_startIndexOutputs, in_a_res, in_a_retStruct)
    local
      Tpl.Text txt;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      Tpl.Text a_retStruct;
      list<DAE.Exp> i_tupleAssignExps;

    case ( txt,
           {},
           _,
           _,
           a_retStruct )
      equation
        txt = Tpl.writeText(txt, a_retStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           (i_tupleAssignExps as _ :: _),
           a_startIndexOutputs,
           a_res,
           a_retStruct )
      equation
        txt = getTempDeclMatchOutputName(txt, i_tupleAssignExps, Tpl.textString(a_res), Tpl.textString(a_startIndexOutputs), 0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_retStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1303;

protected function fun_1304
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_c_result;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preRes;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preRes) :=
  match(in_txt, in_a_c_result, in_a_tupleAssignExps, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preRes, in_a_context, in_a_startIndexOutputs, in_a_res)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preRes;
      SimCode.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      DAE.Exp i_e;
      DAE.Exp i_exp;
      list<DAE.Exp> i_exps;
      Tpl.Text l_callRet;
      Tpl.Text l_retStruct;
      list<DAE.Exp> ret_1;
      Tpl.Text l_additionalOutputs;

    case ( txt,
           SOME(DAE.TUPLE(PR = i_exps)),
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes) = lm_1301(txt, i_exps, a_auxFunction, a_varDeclsCaseInner, a_preRes, a_context, a_startIndexOutputs, a_res, i_exps);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           SOME((i_exp as DAE.CALL(attr = DAE.CALL_ATTR(tailCall = DAE.TAIL(vars = _))))),
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           _,
           _ )
      equation
        (txt, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           SOME((i_exp as DAE.CALL(attr = DAE.CALL_ATTR(tuple_ = true)))),
           a_tupleAssignExps,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res )
      equation
        ret_1 = List.restOrEmpty(a_tupleAssignExps);
        l_additionalOutputs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_additionalOutputs = lm_1302(l_additionalOutputs, ret_1, a_startIndexOutputs, a_res, a_tupleAssignExps);
        l_additionalOutputs = Tpl.popIter(l_additionalOutputs);
        (l_retStruct, l_additionalOutputs, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_additionalOutputs, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
        l_callRet = fun_1303(Tpl.emptyTxt, a_tupleAssignExps, a_startIndexOutputs, a_res, l_retStruct);
        txt = Tpl.writeText(txt, l_callRet);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           SOME(i_e),
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_e, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);
  end match;
end fun_1304;

protected function lm_1305
  input Tpl.Text in_txt;
  input list<SimCode.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_preExpCaseInner;
  input Tpl.Text in_a_varDeclsCaseInner;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_preExpCaseInner;
  output Tpl.Text out_a_varDeclsCaseInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_preExpCaseInner, out_a_varDeclsCaseInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_preExpCaseInner, in_a_varDeclsCaseInner)
    local
      Tpl.Text txt;
      list<SimCode.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_preExpCaseInner;
      Tpl.Text a_varDeclsCaseInner;
      SimCode.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_preExpCaseInner,
           a_varDeclsCaseInner )
      then (txt, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_preExpCaseInner,
           a_varDeclsCaseInner )
      equation
        (txt, a_varDeclsCaseInner, a_preExpCaseInner, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDeclsCaseInner, a_preExpCaseInner, a_varFrees, a_auxFunction);
        (txt, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner) = lm_1305(txt, rest, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner);
      then (txt, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner);
  end match;
end lm_1305;

protected function fun_1306
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_ty;
  input Integer in_a_i0;
  input list<DAE.Pattern> in_a_c_patterns;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_i0, in_a_c_patterns)
    local
      Tpl.Text txt;
      Integer a_i0;
      list<DAE.Pattern> a_c_patterns;
      Integer i_ea;
      Integer i_n;
      DAE.Pattern ret_0;

    case ( txt,
           DAE.MATCH(switch = SOME((i_n, _, i_ea))),
           _,
           a_c_patterns )
      equation
        ret_0 = listNth(a_c_patterns, i_n);
        txt = switchIndex(txt, ret_0, i_ea);
      then txt;

    case ( txt,
           _,
           a_i0,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i0));
      then txt;
  end match;
end fun_1306;

protected function fun_1307
  input Tpl.Text in_txt;
  input Integer in_a_c_jump;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c_jump, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;
      Integer i_c_jump;

    case ( txt,
           0,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Pattern matching succeeded */"));
      then txt;

    case ( txt,
           i_c_jump,
           a_ix )
      equation
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeStr(txt, intString(i_c_jump));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* Pattern matching succeeded; we may skip some cases if we fail */"));
      then txt;
  end match;
end fun_1307;

protected function fun_1308
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_c_result;
  input Tpl.Text in_a_caseRes;
  input Tpl.Text in_a_preRes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c_result, in_a_caseRes, in_a_preRes)
    local
      Tpl.Text txt;
      Tpl.Text a_caseRes;
      Tpl.Text a_preRes;

    case ( txt,
           NONE(),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_THROW_INTERNAL();"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_caseRes,
           a_preRes )
      equation
        txt = Tpl.writeText(txt, a_preRes);
        txt = Tpl.writeText(txt, a_caseRes);
      then txt;
  end match;
end fun_1308;

protected function lm_1309
  input Tpl.Text in_txt;
  input list<DAE.MatchCase> in_items;
  input Tpl.Text in_a_done;
  input Tpl.Text in_a_ix;
  input DAE.MatchType in_a_ty;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_auxFunction;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_startIndexInputs;
  input Tpl.Text in_a_prefix;
  input list<DAE.Exp> in_a_inputs;
  input Integer in_a_startTmpTickIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_auxFunction, out_a_onPatternFail) :=
  match(in_txt, in_items, in_a_done, in_a_ix, in_a_ty, in_a_tupleAssignExps, in_a_startIndexOutputs, in_a_res, in_a_auxFunction, in_a_context, in_a_onPatternFail, in_a_startIndexInputs, in_a_prefix, in_a_inputs, in_a_startTmpTickIndex)
    local
      Tpl.Text txt;
      list<DAE.MatchCase> rest;
      Tpl.Text a_done;
      Tpl.Text a_ix;
      DAE.MatchType a_ty;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      Tpl.Text a_auxFunction;
      SimCode.Context a_context;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_startIndexInputs;
      Tpl.Text a_prefix;
      list<DAE.Exp> a_inputs;
      Integer a_startTmpTickIndex;
      Integer x_i0;
      Absyn.Info i_c_resultInfo;
      Integer i_c_jump;
      list<DAE.Element> i_c_localDecls;
      Option<DAE.Exp> i_c_result;
      Option<DAE.Exp> i_patternGuard;
      list<DAE.Statement> i_c_body;
      list<DAE.Pattern> i_c_patterns;
      list<SimCode.Variable> ret_12;
      Tpl.Text l_0__;
      Tpl.Text l_caseRes;
      Tpl.Text l_guardCheck;
      Tpl.Text l_preGuardCheck;
      Tpl.Text l_stmts;
      list<tuple<DAE.Pattern, Integer>> ret_6;
      Tpl.Text l_patternMatching;
      Tpl.Text l_varFrees;
      Tpl.Text l_preRes;
      Tpl.Text l_assignments;
      Tpl.Text l_preExpCaseInner;
      Tpl.Text l_varDeclsCaseInner;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           _,
           a_auxFunction,
           _,
           a_onPatternFail,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_onPatternFail);

    case ( txt,
           DAE.CASE(patterns = i_c_patterns, body = i_c_body, patternGuard = i_patternGuard, result = i_c_result, localDecls = i_c_localDecls, jump = i_c_jump, resultInfo = i_c_resultInfo) :: rest,
           a_done,
           a_ix,
           a_ty,
           a_tupleAssignExps,
           a_startIndexOutputs,
           a_res,
           a_auxFunction,
           a_context,
           a_onPatternFail,
           a_startIndexInputs,
           a_prefix,
           a_inputs,
           a_startTmpTickIndex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        System.tmpTickSetIndex(a_startTmpTickIndex, 1);
        l_varDeclsCaseInner = Tpl.emptyTxt;
        l_preExpCaseInner = Tpl.emptyTxt;
        l_assignments = Tpl.emptyTxt;
        l_preRes = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        ret_6 = Patternm.sortPatternsByComplexity(i_c_patterns);
        l_patternMatching = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_patternMatching, l_assignments, l_varDeclsCaseInner, a_onPatternFail) = lm_1298(l_patternMatching, ret_6, l_assignments, l_varDeclsCaseInner, a_onPatternFail, a_startIndexInputs, a_prefix, a_inputs);
        l_patternMatching = Tpl.popIter(l_patternMatching);
        System.tmpTickSetIndex(a_startTmpTickIndex, 1);
        l_stmts = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmts, a_auxFunction, l_varDeclsCaseInner) = lm_1299(l_stmts, i_c_body, a_auxFunction, l_varDeclsCaseInner, a_context);
        l_stmts = Tpl.popIter(l_stmts);
        l_preGuardCheck = Tpl.emptyTxt;
        (l_guardCheck, a_auxFunction, l_varDeclsCaseInner, l_preGuardCheck) = fun_1300(Tpl.emptyTxt, i_patternGuard, a_onPatternFail, a_auxFunction, l_varDeclsCaseInner, l_preGuardCheck, a_context);
        (l_caseRes, a_auxFunction, l_varDeclsCaseInner, l_preRes) = fun_1304(Tpl.emptyTxt, i_c_result, a_tupleAssignExps, a_auxFunction, l_varDeclsCaseInner, l_preRes, a_context, a_startIndexOutputs, a_res);
        ret_12 = SimCodeUtil.elementVars(i_c_localDecls);
        (l_0__, a_auxFunction, l_varFrees, l_preExpCaseInner, l_varDeclsCaseInner) = lm_1305(Tpl.emptyTxt, ret_12, a_auxFunction, l_varFrees, l_preExpCaseInner, l_varDeclsCaseInner);
        txt = fun_1306(txt, a_ty, x_i0, i_c_patterns);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(": {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDeclsCaseInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExpCaseInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_patternMatching);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preGuardCheck);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_guardCheck);
        txt = Tpl.softNewLine(txt);
        txt = fun_1307(txt, i_c_jump, a_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_assignments);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_stmts);
        txt = Tpl.softNewLine(txt);
        txt = modelicaLine(txt, i_c_resultInfo);
        txt = Tpl.softNewLine(txt);
        txt = fun_1308(txt, i_c_result, l_caseRes, l_preRes);
        txt = Tpl.softNewLine(txt);
        txt = endModelicaLine(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_done);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 1;\n",
                                    "break;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_onPatternFail) = lm_1309(txt, rest, a_done, a_ix, a_ty, a_tupleAssignExps, a_startIndexOutputs, a_res, a_auxFunction, a_context, a_onPatternFail, a_startIndexInputs, a_prefix, a_inputs, a_startTmpTickIndex);
      then (txt, a_auxFunction, a_onPatternFail);

    case ( txt,
           _ :: rest,
           a_done,
           a_ix,
           a_ty,
           a_tupleAssignExps,
           a_startIndexOutputs,
           a_res,
           a_auxFunction,
           a_context,
           a_onPatternFail,
           a_startIndexInputs,
           a_prefix,
           a_inputs,
           a_startTmpTickIndex )
      equation
        (txt, a_auxFunction, a_onPatternFail) = lm_1309(txt, rest, a_done, a_ix, a_ty, a_tupleAssignExps, a_startIndexOutputs, a_res, a_auxFunction, a_context, a_onPatternFail, a_startIndexInputs, a_prefix, a_inputs, a_startTmpTickIndex);
      then (txt, a_auxFunction, a_onPatternFail);
  end match;
end lm_1309;

public function daeExpMatchCases
  input Tpl.Text txt;
  input list<DAE.MatchCase> a_cases;
  input list<DAE.Exp> a_tupleAssignExps;
  input DAE.MatchType a_ty;
  input Tpl.Text a_ix;
  input Tpl.Text a_res;
  input Tpl.Text a_startIndexOutputs;
  input Tpl.Text a_prefix;
  input Tpl.Text a_startIndexInputs;
  input list<DAE.Exp> a_inputs;
  input Tpl.Text a_onPatternFail;
  input Tpl.Text a_done;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;
  input Integer a_startTmpTickIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ix;
  output Tpl.Text out_a_res;
  output Tpl.Text out_a_startIndexOutputs;
  output Tpl.Text out_a_prefix;
  output Tpl.Text out_a_startIndexInputs;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_done;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_onPatternFail) := lm_1309(out_txt, a_cases, a_done, a_ix, a_ty, a_tupleAssignExps, a_startIndexOutputs, a_res, a_auxFunction, a_context, a_onPatternFail, a_startIndexInputs, a_prefix, a_inputs, a_startTmpTickIndex);
  out_txt := Tpl.popIter(out_txt);
  out_a_ix := a_ix;
  out_a_res := a_res;
  out_a_startIndexOutputs := a_startIndexOutputs;
  out_a_prefix := a_prefix;
  out_a_startIndexInputs := a_startIndexInputs;
  out_a_done := a_done;
  out_a_varDecls := a_varDecls;
end daeExpMatchCases;

public function switchIndex
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pattern;
  input Integer in_a_extraArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_pattern, in_a_extraArg)
    local
      Tpl.Text txt;
      Integer a_extraArg;
      Integer i_e_integer;
      String i_e_string;
      Integer i_index;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.PAT_CALL(index = i_index),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = Patternm.getValueCtor(i_index);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           DAE.PAT_CONSTANT(exp = DAE.SCONST(string = i_e_string)),
           a_extraArg )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = System.stringHashDjb2Mod(i_e_string, a_extraArg);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* "));
        txt = Tpl.writeStr(txt, i_e_string);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           DAE.PAT_CONSTANT(exp = DAE.ICONST(integer = i_e_integer)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(i_e_integer));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("default"));
      then txt;
  end match;
end switchIndex;

protected function fun_1312
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;

    case ( txt,
           false,
           a_exp )
      equation
        txt = expTypeFromExpShort(txt, a_exp);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_array"));
      then txt;
  end match;
end fun_1312;

public function daeExpBox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Tpl.Text l_res;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_ty;

    case ( txt,
           DAE.BOX(exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(i_exp);
        ret_2 = Expression.isArrayType(ret_1);
        l_ty = fun_1312(Tpl.emptyTxt, ret_2, i_exp);
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_"));
        txt = Tpl.writeText(txt, l_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpBox;

public function daeExpUnbox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp_exp;
      DAE.Type i_exp_ty;
      String ret_2;
      Tpl.Text l_res;
      Tpl.Text l_ty;

    case ( txt,
           DAE.UNBOX(ty = i_exp_ty, exp = i_exp_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_ty = expTypeShort(Tpl.emptyTxt, i_exp_ty);
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_"));
        txt = Tpl.writeText(txt, l_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.UNBOX "));
        ret_2 = Types.unparseType(i_exp_ty);
        txt = Tpl.writeStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpUnbox;

public function daeExpSharedLiteral
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      Integer i_exp_index;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_exp_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_exp_index));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end daeExpSharedLiteral;

protected function lm_1316
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeDimensionExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1316(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1316;

protected function fun_1317
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_dimsValuesStr;
  input String in_a_arrName;
  input Tpl.Text in_a_dimsLenStr;
  input Tpl.Text in_a_arrayType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_dimsValuesStr, in_a_arrName, in_a_dimsLenStr, in_a_arrayType)
    local
      Tpl.Text txt;
      Tpl.Text a_dimsValuesStr;
      String a_arrName;
      Tpl.Text a_dimsLenStr;
      Tpl.Text a_arrayType;

    case ( txt,
           SimCode.PARALLEL_FUNCTION_CONTEXT(),
           a_dimsValuesStr,
           a_arrName,
           a_dimsLenStr,
           a_arrayType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr_c99_"));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           _,
           a_dimsValuesStr,
           a_arrName,
           a_dimsLenStr,
           a_arrayType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr(&"));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;
  end match;
end fun_1317;

protected function fun_1318
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimsLenStr;
  input Tpl.Text in_a_arrayType;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_dimsValuesStr;
  input String in_a_arrName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimsLenStr, in_a_arrayType, in_a_context, in_a_dimsValuesStr, in_a_arrName)
    local
      Tpl.Text txt;
      Tpl.Text a_dimsLenStr;
      Tpl.Text a_arrayType;
      SimCode.Context a_context;
      Tpl.Text a_dimsValuesStr;
      String a_arrName;

    case ( txt,
           "metatype_array",
           _,
           _,
           _,
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /*arrayScalarRhs*/"));
      then txt;

    case ( txt,
           _,
           a_dimsLenStr,
           a_arrayType,
           a_context,
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = fun_1317(txt, a_context, a_dimsValuesStr, a_arrName, a_dimsLenStr, a_arrayType);
      then txt;
  end match;
end fun_1318;

public function arrayScalarRhs
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input list<DAE.Exp> a_subs;
  input String a_arrName;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  String str_4;
  Tpl.Text l_dimsValuesStr;
  Integer ret_2;
  Tpl.Text l_dimsLenStr;
  Tpl.Text l_arrayType;
algorithm
  l_arrayType := expTypeArray(Tpl.emptyTxt, a_ty);
  ret_2 := listLength(a_subs);
  l_dimsLenStr := Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
  l_dimsValuesStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_dimsValuesStr, out_a_auxFunction, out_a_varDecls, out_a_preExp) := lm_1316(l_dimsValuesStr, a_subs, a_auxFunction, a_varDecls, a_preExp, a_context);
  l_dimsValuesStr := Tpl.popIter(l_dimsValuesStr);
  str_4 := Tpl.textString(l_arrayType);
  out_txt := fun_1318(txt, str_4, l_dimsLenStr, l_arrayType, a_context, l_dimsValuesStr, a_arrName);
end arrayScalarRhs;

public function daeExpList
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_valList;
      Tpl.Text l_expPart;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.LIST(valList = i_valList),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExpListToCons(Tpl.emptyTxt, i_valList, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpList;

public function daeExpListToCons
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_listItems;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_listItems, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_rest;
      DAE.Exp i_e;
      Tpl.Text l_restList;
      Tpl.Text l_expPart;

    case ( txt,
           {},
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRUCTLIT(mmc_nil)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_e :: i_rest,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_restList, a_preExp, a_varDecls, a_auxFunction) = daeExpListToCons(Tpl.emptyTxt, i_rest, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_cons("));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_restList);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpListToCons;

public function daeExpCons
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_cdr;
      DAE.Exp i_car;
      Tpl.Text l_cdrExp;
      Tpl.Text l_carExp;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.CONS(car = i_car, cdr = i_cdr),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_carExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_car, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_cdrExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_cdr, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_mk_cons("));
        a_preExp = Tpl.writeText(a_preExp, l_carExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_cdrExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCons;

protected function lm_1323
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Integer x_i1;
      DAE.Type i_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_ty :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = expTypeModelica(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        txt = lm_1323(txt, rest);
      then txt;
  end match;
end lm_1323;

public function tempDeclTuple
  input Tpl.Text in_txt;
  input DAE.Type in_a_inType;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_inType, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      DAE.Type i_inType;
      list<DAE.Type> i_tupleType;
      Tpl.Text txt_2;
      Integer ret_1;
      Tpl.Text l_tmpVar;

    case ( txt,
           DAE.T_TUPLE(tupleType = i_tupleType),
           a_varDecls )
      equation
        l_tmpVar = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_1 = System.tmpTick();
        l_tmpVar = Tpl.writeStr(l_tmpVar, intString(ret_1));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_LINE("struct {\n"));
        a_varDecls = Tpl.pushBlock(a_varDecls, Tpl.BT_INDENT(2));
        a_varDecls = Tpl.pushIter(a_varDecls, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_varDecls = lm_1323(a_varDecls, i_tupleType);
        a_varDecls = Tpl.popIter(a_varDecls);
        a_varDecls = Tpl.softNewLine(a_varDecls);
        a_varDecls = Tpl.popBlock(a_varDecls);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("} "));
        a_varDecls = Tpl.writeText(a_varDecls, l_tmpVar);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_varDecls);

    case ( txt,
           i_inType,
           a_varDecls )
      equation
        txt_2 = expTypeArrayIf(Tpl.emptyTxt, i_inType);
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(txt_2), a_varDecls);
      then (txt, a_varDecls);
  end match;
end tempDeclTuple;

protected function lm_1325
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_tmpVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_tmpVar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      Tpl.Text a_tmpVar;
      Integer x_i1;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_tmpVar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeText(txt, a_tmpVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1325(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_tmpVar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1325;

public function daeExpTuple
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_PR;
      DAE.Exp i_exp;
      Tpl.Text l_tmp;
      DAE.Type ret_1;
      Tpl.Text l_tmpVar;

    case ( txt,
           (i_exp as DAE.TUPLE(PR = i_PR)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(i_exp);
        (l_tmpVar, a_varDecls) = tempDeclTuple(Tpl.emptyTxt, ret_1, a_varDecls);
        l_tmp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_tmp, a_auxFunction, a_varDecls, a_preExp) = lm_1325(l_tmp, i_PR, a_auxFunction, a_varDecls, a_preExp, a_context, l_tmpVar);
        l_tmp = Tpl.popIter(l_tmp);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpTuple;

protected function lm_1327
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1327(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1327;

protected function fun_1328
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_1328;

public function daeExpMetaTuple
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_listExp;
      Tpl.Text l_tmp;
      Tpl.Text l_args;
      Integer ret_1;
      Tpl.Text l_start;

    case ( txt,
           DAE.META_TUPLE(listExp = i_listExp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listLength(i_listExp);
        l_start = daeExpMetaHelperBoxStart(Tpl.emptyTxt, ret_1);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_auxFunction, a_varDecls, a_preExp) = lm_1327(l_args, i_listExp, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_args = Tpl.popIter(l_args);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_mk_box"));
        a_preExp = Tpl.writeText(a_preExp, l_start);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("0"));
        a_preExp = fun_1328(a_preExp, l_args);
        a_preExp = Tpl.writeText(a_preExp, l_args);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMetaTuple;

public function daeExpMetaOption
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_e;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.META_OPTION(exp = NONE()),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_none()"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.META_OPTION(exp = SOME(i_e)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_some("));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMetaOption;

protected function lm_1331
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1331(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1331;

protected function fun_1332
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_args;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_args, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.Context a_context;
      list<DAE.Exp> i_args;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_args,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1331(txt, i_args, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1332;

public function daeExpMetarecordcall
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Absyn.Path i_path;
      list<DAE.Exp> i_args;
      Integer i_index;
      Tpl.Text l_tmp;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_box;
      Tpl.Text l_argsStr;
      Integer ret_1;
      Tpl.Text l_newIndex;

    case ( txt,
           DAE.METARECORDCALL(index = i_index, args = i_args, path = i_path),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Patternm.getValueCtor(i_index);
        l_newIndex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        (l_argsStr, a_auxFunction, a_varDecls, a_preExp) = fun_1332(Tpl.emptyTxt, i_args, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_box = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("mmc_mk_box"));
        ret_4 = listLength(i_args);
        ret_5 = SimCodeUtil.incrementInt(ret_4, 1);
        l_box = daeExpMetaHelperBoxStart(l_box, ret_5);
        l_box = Tpl.writeText(l_box, l_newIndex);
        l_box = Tpl.writeTok(l_box, Tpl.ST_STRING(", &"));
        l_box = CodegenUtil.underscorePath(l_box, i_path);
        l_box = Tpl.writeTok(l_box, Tpl.ST_STRING("__desc"));
        l_box = Tpl.writeText(l_box, l_argsStr);
        l_box = Tpl.writeTok(l_box, Tpl.ST_STRING(")"));
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_box);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMetarecordcall;

protected function fun_1334
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_numVariables;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_numVariables)
    local
      Tpl.Text txt;
      Integer a_numVariables;

    case ( txt,
           false,
           a_numVariables )
      equation
        txt = Tpl.writeStr(txt, intString(a_numVariables));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
      then txt;

    case ( txt,
           _,
           a_numVariables )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, intString(a_numVariables));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_1334;

public function daeExpMetaHelperBoxStart
  input Tpl.Text txt;
  input Integer a_numVariables;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := intGt(a_numVariables, 20);
  out_txt := fun_1334(txt, ret_0, a_numVariables);
end daeExpMetaHelperBoxStart;

public function outDecl
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  l_newVar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVar);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVar);
end outDecl;

protected function fun_1337
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String i_ty;
      Integer ret_4;
      Tpl.Text l_newVarIx;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "modelica_metatype",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_0 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_1 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_2 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls )
      equation
        l_newVarIx = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_4 = System.tmpTick();
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(ret_4));
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_1337;

public function tempDecl
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_1337(Tpl.emptyTxt, a_ty, a_varDecls);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDecl;

protected function fun_1339
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String i_ty;
      Integer ret_4;
      Tpl.Text l_newVarIx;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "modelica_metatype",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_0 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_1 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_2 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls )
      equation
        l_newVarIx = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_4 = System.tmpTick();
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(ret_4));
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" = 0;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_1339;

public function tempDeclZero
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_1339(Tpl.emptyTxt, a_ty, a_varDecls);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclZero;

protected function fun_1341
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;
  input String in_a_prefix;
  input String in_a_index;
  input String in_a_startIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls, in_a_prefix, in_a_index, in_a_startIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String a_prefix;
      String a_index;
      String a_startIndex;
      String i_ty;
      Tpl.Text l_newVarIx;

    case ( txt,
           "modelica_metatype",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls,
           a_prefix,
           a_index,
           _ )
      equation
        l_newVarIx = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newVarIx = Tpl.writeTok(l_newVarIx, Tpl.ST_STRING("_in"));
        l_newVarIx = Tpl.writeStr(l_newVarIx, a_index);
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_1341;

public function tempDeclMatchInput
  input Tpl.Text txt;
  input String a_ty;
  input String a_prefix;
  input String a_startIndex;
  input String a_index;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_1341(Tpl.emptyTxt, a_ty, a_varDecls, a_prefix, a_index, a_startIndex);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclMatchInput;

protected function fun_1343
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_prefix;
  input Integer in_a_index;
  input String in_a_startIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_prefix, in_a_index, in_a_startIndex)
    local
      Tpl.Text txt;
      String a_prefix;
      Integer a_index;
      String a_startIndex;
      Tpl.Text l_newVarIx;

    case ( txt,
           "modelica_metatype",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           "metamodelica_string",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           "metamodelica_string_const",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _,
           a_prefix,
           a_index,
           _ )
      equation
        l_newVarIx = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newVarIx = Tpl.writeTok(l_newVarIx, Tpl.ST_STRING("_in"));
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(a_index));
        txt = Tpl.writeText(txt, l_newVarIx);
      then txt;
  end match;
end fun_1343;

public function getTempDeclMatchInputName
  input Tpl.Text txt;
  input list<DAE.Exp> a_inputs;
  input String a_prefix;
  input String a_startIndex;
  input Integer a_index;

  output Tpl.Text out_txt;
protected
  String str_3;
  Tpl.Text l_newVar;
  DAE.Exp ret_1;
  Tpl.Text l_typ;
algorithm
  ret_1 := listNth(a_inputs, a_index);
  l_typ := expTypeFromExpModelica(Tpl.emptyTxt, ret_1);
  str_3 := Tpl.textString(l_typ);
  l_newVar := fun_1343(Tpl.emptyTxt, str_3, a_prefix, a_index, a_startIndex);
  out_txt := Tpl.writeText(txt, l_newVar);
end getTempDeclMatchInputName;

protected function fun_1345
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;
  input String in_a_prefix;
  input String in_a_index;
  input String in_a_startIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls, in_a_prefix, in_a_index, in_a_startIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String a_prefix;
      String a_index;
      String a_startIndex;
      String i_ty;
      Tpl.Text l_newVarIx;

    case ( txt,
           "modelica_metatype",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls,
           a_prefix,
           a_index,
           _ )
      equation
        l_newVarIx = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newVarIx = Tpl.writeTok(l_newVarIx, Tpl.ST_STRING("_c"));
        l_newVarIx = Tpl.writeStr(l_newVarIx, a_index);
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" __attribute__((unused)) = 0;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_1345;

public function tempDeclMatchOutput
  input Tpl.Text txt;
  input String a_ty;
  input String a_prefix;
  input String a_startIndex;
  input String a_index;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_1345(Tpl.emptyTxt, a_ty, a_varDecls, a_prefix, a_index, a_startIndex);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclMatchOutput;

protected function fun_1347
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_prefix;
  input Integer in_a_index;
  input String in_a_startIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_prefix, in_a_index, in_a_startIndex)
    local
      Tpl.Text txt;
      String a_prefix;
      Integer a_index;
      String a_startIndex;
      Tpl.Text l_newVarIx;

    case ( txt,
           "modelica_metatype",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           "metamodelica_string",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           "metamodelica_string_const",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _,
           a_prefix,
           a_index,
           _ )
      equation
        l_newVarIx = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newVarIx = Tpl.writeTok(l_newVarIx, Tpl.ST_STRING("_c"));
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(a_index));
        txt = Tpl.writeText(txt, l_newVarIx);
      then txt;
  end match;
end fun_1347;

public function getTempDeclMatchOutputName
  input Tpl.Text txt;
  input list<DAE.Exp> a_outputs;
  input String a_prefix;
  input String a_startIndex;
  input Integer a_index;

  output Tpl.Text out_txt;
protected
  String str_3;
  Tpl.Text l_newVar;
  DAE.Exp ret_1;
  Tpl.Text l_typ;
algorithm
  ret_1 := listNth(a_outputs, a_index);
  l_typ := expTypeFromExpModelica(Tpl.emptyTxt, ret_1);
  str_3 := Tpl.textString(l_typ);
  l_newVar := fun_1347(Tpl.emptyTxt, str_3, a_prefix, a_index, a_startIndex);
  out_txt := Tpl.writeText(txt, l_newVar);
end getTempDeclMatchOutputName;

public function tempDeclConst
  input Tpl.Text txt;
  input String a_ty;
  input String a_val;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_newVar;
algorithm
  l_newVar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
  ret_1 := System.tmpTick();
  l_newVar := Tpl.writeStr(l_newVar, intString(ret_1));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVar);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" = "));
  out_a_varDecls := Tpl.writeStr(out_a_varDecls, a_val);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclConst;

protected function fun_1350
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = expTypeArray(txt, a_var_ty);
      then txt;
  end match;
end fun_1350;

protected function fun_1351
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_"));
        txt = expTypeArray(txt, a_var_ty);
      then txt;
  end match;
end fun_1351;

protected function fun_1352
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_local_"));
        txt = expTypeArray(txt, a_var_ty);
      then txt;
  end match;
end fun_1352;

public function varType
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_var_ty;
      list<DAE.Exp> i_instDims;

    case ( txt,
           SimCode.VARIABLE(parallelism = DAE.NON_PARALLEL(), instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_1350(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           SimCode.VARIABLE(parallelism = DAE.PARGLOBAL(), instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_1351(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           SimCode.VARIABLE(parallelism = DAE.PARLOCAL(), instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_1352(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varType;

public function varTypeBoxed
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.VARIABLE(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           SimCode.FUNCTION_PTR(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varTypeBoxed;

public function expTypeRW
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_INT"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_REAL"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_STRING"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_BOOL"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_INT"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ARRAY"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_RECORD"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_MMC"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_MMC"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end expTypeRW;

protected function fun_1356
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;
  end match;
end fun_1356;

protected function fun_1357
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real /* assumming real for uknown type! */"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex /* assumming void* for unknown type! when +g=MetaModelica */ "));
      then txt;
  end match;
end fun_1357;

public function expTypeShort
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      ClassInf.State i_complexClassType;
      DAE.Type i_ty;
      Tpl.Text txt_3;
      String ret_3;
      Boolean ret_2;
      Absyn.Path ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_1356(txt, ret_0);
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_1 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_1);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION(funcArg = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_UNKNOWN(source = _) )
      equation
        ret_2 = Config.acceptMetaModelicaGrammar();
        txt = fun_1357(txt, ret_2);
      then txt;

    case ( txt,
           DAE.T_ANYTYPE(anyClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("expTypeShort: "));
        ret_3 = Types.unparseType(i_type);
        txt_3 = Tpl.writeStr(txt_3, ret_3);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10057, 14), Tpl.textString(txt_3));
      then txt;
  end match;
end expTypeShort;

public function mmcVarType
  input Tpl.Text in_txt;
  input SimCode.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           SimCode.VARIABLE(ty = i_ty) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = mmcTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           SimCode.FUNCTION_PTR(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end mmcVarType;

public function mmcTypeShort
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("array"));
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METALIST(listType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAPOLYMORPHIC(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(optionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("mmcTypeShort:ERROR "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10087, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end mmcTypeShort;

protected function fun_1361
  input Tpl.Text in_txt;
  input Boolean in_a_array;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_array, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           true,
           a_ty )
      equation
        txt = expTypeArray(txt, a_ty);
      then txt;

    case ( txt,
           false,
           a_ty )
      equation
        txt = expTypeModelica(txt, a_ty);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1361;

public function expType
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Boolean a_array;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1361(txt, a_array, a_ty);
end expType;

public function expTypeModelica
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 2);
end expTypeModelica;

public function expTypeArray
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 3);
end expTypeArray;

public function expTypeArrayIf
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 4);
end expTypeArrayIf;

public function expTypeFromExpShort
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 1);
end expTypeFromExpShort;

public function expTypeFromExpModelica
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 2);
end expTypeFromExpModelica;

public function expTypeFromExpArray
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 3);
end expTypeFromExpArray;

public function expTypeFromExpArrayIf
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 4);
end expTypeFromExpArrayIf;

protected function fun_1370
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Type i_t;

    case ( txt,
           DAE.T_ARRAY(ty = (i_t as DAE.T_COMPLEX(complexClassType = _))) )
      equation
        txt = expTypeShort(txt, i_t);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = expTypeShort(txt, i_ty);
      then txt;
  end match;
end fun_1370;

protected function fun_1371
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      ClassInf.State i_complexClassType;
      Absyn.Path ret_0;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_0 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_0);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_1370(txt, i_ty);
      then txt;
  end match;
end fun_1371;

protected function fun_1372
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_1371(txt, i_ty);
      then txt;
  end match;
end fun_1372;

protected function fun_1373
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeFlag(txt, i_ty, 2);
      then txt;
  end match;
end fun_1373;

protected function fun_1374
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeFlag(txt, i_ty, 8);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char*"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("I do not know the external type of "));
        ret_0 = Types.unparseType(i_ty);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10179, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_1374;

protected function fun_1375
  input Tpl.Text in_txt;
  input Integer in_a_flag;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           1,
           a_ty )
      equation
        txt = expTypeShort(txt, a_ty);
      then txt;

    case ( txt,
           2,
           a_ty )
      equation
        txt = fun_1372(txt, a_ty);
      then txt;

    case ( txt,
           3,
           a_ty )
      equation
        txt = expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array"));
      then txt;

    case ( txt,
           4,
           a_ty )
      equation
        txt = fun_1373(txt, a_ty);
      then txt;

    case ( txt,
           8,
           a_ty )
      equation
        txt = fun_1374(txt, a_ty);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1375;

public function expTypeFlag
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Integer a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1375(txt, a_flag, a_ty);
end expTypeFlag;

protected function fun_1377
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           8 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;
  end match;
end fun_1377;

protected function fun_1378
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_real"));
      then txt;
  end match;
end fun_1378;

protected function fun_1379
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           2 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_string_t"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_string"));
      then txt;
  end match;
end fun_1379;

protected function fun_1380
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1380;

protected function fun_1381
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;

    case ( txt,
           false,
           a_flag )
      equation
        txt = fun_1379(txt, a_flag);
      then txt;

    case ( txt,
           _,
           a_flag )
      equation
        txt = fun_1380(txt, a_flag);
      then txt;
  end match;
end fun_1381;

protected function fun_1382
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_1382;

protected function fun_1383
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           8 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;
  end match;
end fun_1383;

protected function fun_1384
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_1384;

protected function fun_1385
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1385;

protected function fun_1386
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1386;

protected function fun_1387
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1387;

protected function fun_1388
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1388;

protected function fun_1389
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_1389;

public function expTypeFromExpFlag
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;
      DAE.Exp i_c_exp;
      DAE.Exp i_exp;
      DAE.Exp i_c;
      DAE.Type i_c_ty;
      DAE.Type i_attr_ty;
      DAE.Exp i_expThen;
      DAE.Operator i_e_operator;
      Tpl.Text txt_6;
      String ret_6;
      DAE.Type ret_5;
      DAE.Type ret_4;
      DAE.Type ret_3;
      DAE.Type ret_2;
      DAE.Type ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.ICONST(integer = _),
           a_flag )
      equation
        txt = fun_1377(txt, a_flag);
      then txt;

    case ( txt,
           DAE.RCONST(real = _),
           a_flag )
      equation
        txt = fun_1378(txt, a_flag);
      then txt;

    case ( txt,
           DAE.SCONST(string = _),
           a_flag )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_1381(txt, ret_0, a_flag);
      then txt;

    case ( txt,
           DAE.BCONST(bool = _),
           a_flag )
      equation
        txt = fun_1382(txt, a_flag);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(name = _),
           a_flag )
      equation
        txt = fun_1383(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BINARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.UNARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.LBINARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.LUNARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.RELATION(exp1 = _),
           a_flag )
      equation
        txt = fun_1384(txt, a_flag);
      then txt;

    case ( txt,
           DAE.IFEXP(expThen = i_expThen),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_expThen, a_flag);
      then txt;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_attr_ty, a_flag);
      then txt;

    case ( txt,
           DAE.RECORD(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ARRAY(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MATRIX(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.RANGE(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CAST(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.TSUB(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CREF(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CODE(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           (i_c as DAE.ASUB(exp = _)),
           a_flag )
      equation
        ret_1 = Expression.typeof(i_c);
        txt = expTypeFlag(txt, ret_1, a_flag);
      then txt;

    case ( txt,
           (i_exp as DAE.REDUCTION(reductionInfo = _)),
           a_flag )
      equation
        ret_2 = Expression.typeof(i_exp);
        txt = expTypeFlag(txt, ret_2, a_flag);
      then txt;

    case ( txt,
           (i_exp as DAE.CONS(car = _)),
           a_flag )
      equation
        ret_3 = Expression.typeof(i_exp);
        txt = expTypeFlag(txt, ret_3, a_flag);
      then txt;

    case ( txt,
           (i_exp as DAE.LIST(valList = _)),
           a_flag )
      equation
        ret_4 = Expression.typeof(i_exp);
        txt = expTypeFlag(txt, ret_4, a_flag);
      then txt;

    case ( txt,
           DAE.SIZE(exp = i_exp),
           a_flag )
      equation
        ret_5 = Expression.typeof(i_exp);
        txt = expTypeFlag(txt, ret_5, a_flag);
      then txt;

    case ( txt,
           DAE.META_TUPLE(listExp = _),
           a_flag )
      equation
        txt = fun_1385(txt, a_flag);
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = _),
           a_flag )
      equation
        txt = fun_1386(txt, a_flag);
      then txt;

    case ( txt,
           DAE.MATCHEXPRESSION(matchType = _),
           a_flag )
      equation
        txt = fun_1387(txt, a_flag);
      then txt;

    case ( txt,
           DAE.METARECORDCALL(path = _),
           a_flag )
      equation
        txt = fun_1388(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BOX(exp = _),
           a_flag )
      equation
        txt = fun_1389(txt, a_flag);
      then txt;

    case ( txt,
           DAE.UNBOX(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(exp = i_c_exp),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_c_exp, a_flag);
      then txt;

    case ( txt,
           i_exp,
           a_flag )
      equation
        txt_6 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("expTypeFromExpFlag(flag="));
        txt_6 = Tpl.writeStr(txt_6, intString(a_flag));
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING("):"));
        ret_6 = ExpressionDump.printExpStr(i_exp);
        txt_6 = Tpl.writeStr(txt_6, ret_6);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10224, 14), Tpl.textString(txt_6));
      then txt;
  end match;
end expTypeFromExpFlag;

protected function fun_1391
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_1391;

protected function fun_1392
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_1392;

protected function fun_1393
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_1393;

public function expTypeFromOpFlag
  input Tpl.Text in_txt;
  input DAE.Operator in_a_op;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;
      DAE.Type i_o_ty;

    case ( txt,
           DAE.ADD(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.UMINUS(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.UMINUS_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ADD_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARR2(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.LESS(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.GREATER(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.AND(ty = _),
           a_flag )
      equation
        txt = fun_1391(txt, a_flag);
      then txt;

    case ( txt,
           DAE.OR(ty = _),
           a_flag )
      equation
        txt = fun_1392(txt, a_flag);
      then txt;

    case ( txt,
           DAE.NOT(ty = _),
           a_flag )
      equation
        txt = fun_1393(txt, a_flag);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10266, 14), "expTypeFromOpFlag:ERROR");
      then txt;
  end match;
end expTypeFromOpFlag;

public function dimension
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_d;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_d)
    local
      Tpl.Text txt;
      DAE.Exp i_e;
      Integer i_size;
      Integer i_integer;

    case ( txt,
           DAE.DIM_BOOLEAN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.DIM_ENUM(size = i_size) )
      equation
        txt = Tpl.writeStr(txt, intString(i_size));
      then txt;

    case ( txt,
           DAE.DIM_EXP(exp = i_e) )
      equation
        txt = dimensionExp(txt, i_e);
      then txt;

    case ( txt,
           DAE.DIM_UNKNOWN() )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10276, 39), "Unknown dimensions may not be part of generated code. This is most likely an error on the part of OpenModelica. Please submit a detailed bug-report.");
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10277, 14), "dimension: INVALID_DIMENSION");
      then txt;
  end match;
end dimension;

public function dimensionExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_dimExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dimExp)
    local
      Tpl.Text txt;
      DAE.Exp i_dimExp;
      DAE.ComponentRef i_cr;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.CREF(componentRef = i_cr) )
      equation
        txt = cref(txt, i_cr);
      then txt;

    case ( txt,
           i_dimExp )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("dimensionExp: INVALID_DIMENSION "));
        ret_0 = ExpressionDump.printExpStr(i_dimExp);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10284, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end dimensionExp;

protected function fun_1397
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pat;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_matchPhase;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_additionalOutputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_matchPhase;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_additionalOutputs;
algorithm
  (out_txt, out_a_assignments, out_a_matchPhase, out_a_varDecls, out_a_additionalOutputs) :=
  match(in_txt, in_a_pat, in_a_assignments, in_a_matchPhase, in_a_varDecls, in_a_ty, in_a_additionalOutputs)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_matchPhase;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      Tpl.Text a_additionalOutputs;
      DAE.Pattern i_pat;
      Tpl.Text txt_1;
      Tpl.Text l_v;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_matchPhase,
           a_varDecls,
           _,
           a_additionalOutputs )
      equation
        a_additionalOutputs = Tpl.writeTok(a_additionalOutputs, Tpl.ST_STRING(", NULL"));
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);

    case ( txt,
           i_pat,
           a_assignments,
           a_matchPhase,
           a_varDecls,
           a_ty,
           a_additionalOutputs )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, a_ty);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_additionalOutputs = Tpl.writeTok(a_additionalOutputs, Tpl.ST_STRING(", &"));
        a_additionalOutputs = Tpl.writeText(a_additionalOutputs, l_v);
        (a_matchPhase, l_v, _, a_varDecls, a_assignments) = patternMatch(a_matchPhase, i_pat, l_v, Tpl.strTokText(Tpl.ST_STRING("MMC_THROW_INTERNAL()")), a_varDecls, a_assignments);
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);
  end match;
end fun_1397;

protected function lm_1398
  input Tpl.Text in_txt;
  input list<tuple<DAE.Pattern, DAE.Type>> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_matchPhase;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_additionalOutputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_matchPhase;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_additionalOutputs;
algorithm
  (out_txt, out_a_assignments, out_a_matchPhase, out_a_varDecls, out_a_additionalOutputs) :=
  match(in_txt, in_items, in_a_assignments, in_a_matchPhase, in_a_varDecls, in_a_additionalOutputs)
    local
      Tpl.Text txt;
      list<tuple<DAE.Pattern, DAE.Type>> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_matchPhase;
      Tpl.Text a_varDecls;
      Tpl.Text a_additionalOutputs;
      DAE.Type i_ty;
      DAE.Pattern i_pat;

    case ( txt,
           {},
           a_assignments,
           a_matchPhase,
           a_varDecls,
           a_additionalOutputs )
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);

    case ( txt,
           (i_pat, i_ty) :: rest,
           a_assignments,
           a_matchPhase,
           a_varDecls,
           a_additionalOutputs )
      equation
        (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs) = fun_1397(txt, i_pat, a_assignments, a_matchPhase, a_varDecls, i_ty, a_additionalOutputs);
        (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs) = lm_1398(txt, rest, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);
  end match;
end lm_1398;

protected function fun_1399
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pat;
  input Tpl.Text in_a_assignments1;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_matchPhase;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments1;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments1, out_a_varDecls) :=
  match(in_txt, in_a_pat, in_a_assignments1, in_a_varDecls, in_a_ty, in_a_assignments, in_a_matchPhase, in_a_expPart, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments1;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      Tpl.Text a_assignments;
      Tpl.Text a_matchPhase;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      DAE.Pattern i_pat;
      Tpl.Text l_res;
      Tpl.Text txt_1;
      Tpl.Text l_v;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments1,
           a_varDecls,
           _,
           a_assignments,
           a_matchPhase,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Pattern-matching tuple assignment, wild first pattern */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_matchPhase);
        txt = Tpl.writeText(txt, a_assignments);
      then (txt, a_assignments1, a_varDecls);

    case ( txt,
           i_pat,
           a_assignments1,
           a_varDecls,
           a_ty,
           a_assignments,
           a_matchPhase,
           a_expPart,
           a_preExp )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, a_ty);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        (l_res, l_v, _, a_varDecls, a_assignments1) = patternMatch(Tpl.emptyTxt, i_pat, l_v, Tpl.strTokText(Tpl.ST_STRING("MMC_THROW_INTERNAL()")), a_varDecls, a_assignments1);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Pattern-matching tuple assignment */\n"));
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeText(txt, a_assignments1);
        txt = Tpl.writeText(txt, a_matchPhase);
        txt = Tpl.writeText(txt, a_assignments);
      then (txt, a_assignments1, a_varDecls);
  end match;
end fun_1399;

public function algStmtAssignPattern
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCode.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Pattern i_lhs_pattern;
      DAE.Exp i_exp;
      DAE.Type i_ty;
      DAE.Pattern i_pat;
      DAE.Exp i_s_exp;
      list<DAE.Type> i_tys;
      list<DAE.Pattern> i_patterns;
      Tpl.Text txt_11;
      Tpl.Text l_v;
      Tpl.Text txt_8;
      String ret_8;
      Tpl.Text l_expPart;
      list<tuple<DAE.Pattern, DAE.Type>> ret_6;
      Tpl.Text l_0__;
      Tpl.Text l_matchPhase;
      Tpl.Text l_additionalOutputs;
      Tpl.Text l_assignments;
      Tpl.Text l_assignments1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = DAE.PAT_CALL_TUPLE(patterns = i_pat :: i_patterns)), exp = (i_s_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(tupleType = i_ty :: i_tys))))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_assignments1 = Tpl.emptyTxt;
        l_assignments = Tpl.emptyTxt;
        l_additionalOutputs = Tpl.emptyTxt;
        l_matchPhase = Tpl.emptyTxt;
        ret_6 = List.threadTuple(i_patterns, i_tys);
        (l_0__, l_assignments, l_matchPhase, a_varDecls, l_additionalOutputs) = lm_1398(Tpl.emptyTxt, ret_6, l_assignments, l_matchPhase, a_varDecls, l_additionalOutputs);
        (l_expPart, l_additionalOutputs, l_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_s_exp, l_additionalOutputs, a_context, l_preExp, a_varDecls, a_auxFunction);
        (txt, l_assignments1, a_varDecls) = fun_1399(txt, i_pat, l_assignments1, a_varDecls, i_ty, l_assignments, l_matchPhase, l_expPart, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = DAE.PAT_WILD()), exp = i_exp),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt_8 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Improve simplifcation, got pattern assignment _ = "));
        ret_8 = ExpressionDump.printExpStr(i_exp);
        txt_8 = Tpl.writeStr(txt_8, ret_8);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING(", expected NORETCALL"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10319, 11), Tpl.textString(txt_8));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = i_lhs_pattern), exp = i_s_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_assignments = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt_11 = expTypeFromExpModelica(Tpl.emptyTxt, i_s_exp);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_11), a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Pattern-matching assignment */\n"));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        (txt, l_v, _, a_varDecls, l_assignments) = patternMatch(txt, i_lhs_pattern, l_v, Tpl.strTokText(Tpl.ST_STRING("MMC_THROW_INTERNAL()")), a_varDecls, l_assignments);
        txt = Tpl.writeText(txt, l_assignments);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssignPattern;

protected function fun_1401
  input Tpl.Text in_txt;
  input Option<DAE.Type> in_a_p_ty;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_unboxBuf;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_unboxBuf;
algorithm
  (out_txt, out_a_varDecls, out_a_unboxBuf) :=
  match(in_txt, in_a_p_ty, in_a_varDecls, in_a_unboxBuf, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_unboxBuf;
      Tpl.Text a_rhs;
      DAE.Type i_et;

    case ( txt,
           SOME(i_et),
           a_varDecls,
           a_unboxBuf,
           a_rhs )
      equation
        (txt, a_unboxBuf, a_varDecls) = unboxVariable(txt, Tpl.textString(a_rhs), i_et, a_unboxBuf, a_varDecls);
      then (txt, a_varDecls, a_unboxBuf);

    case ( txt,
           _,
           a_varDecls,
           a_unboxBuf,
           a_rhs )
      equation
        txt = Tpl.writeText(txt, a_rhs);
      then (txt, a_varDecls, a_unboxBuf);
  end match;
end fun_1401;

protected function fun_1402
  input Tpl.Text in_txt;
  input Boolean in_a_c_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1402;

protected function fun_1403
  input Tpl.Text in_txt;
  input DAE.Exp in_a_p_exp;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_urhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_p_exp, in_a_onPatternFail, in_a_urhs)
    local
      Tpl.Text txt;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_urhs;
      Boolean i_c_bool;
      String i_c_string;
      Real i_c_real;
      Integer i_c_integer;
      Integer ret_2;
      String ret_1;
      Tpl.Text l_escstr;

    case ( txt,
           DAE.ICONST(integer = i_c_integer),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, intString(i_c_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.RCONST(real = i_c_real),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, realString(i_c_real));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.SCONST(string = i_c_string),
           a_onPatternFail,
           a_urhs )
      equation
        ret_1 = Util.escapeModelicaStringToCString(i_c_string);
        l_escstr = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        ret_2 = System.unescapedStringLength(Tpl.textString(l_escstr));
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != MMC_STRLEN("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || strcmp(\""));
        txt = Tpl.writeText(txt, l_escstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) != 0) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_c_bool),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = fun_1402(txt, i_c_bool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.LIST(valList = {}),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!listEmpty("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = NONE()),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!optionNone("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10353, 20), "UNKNOWN_CONSTANT_PATTERN");
      then txt;
  end match;
end fun_1403;

protected function fun_1404
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Integer in_a_i1;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_onPatternFail, in_a_i1, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Integer a_i1;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      DAE.Pattern i_p;
      Tpl.Text l_tvar;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_onPatternFail,
           _,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p,
           a_assignments,
           a_onPatternFail,
           a_i1,
           a_rhs,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("));\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end fun_1404;

protected function lm_1405
  input Tpl.Text in_txt;
  input list<DAE.Pattern> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_items, in_a_assignments, in_a_onPatternFail, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Pattern> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      Integer x_i1;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_onPatternFail,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p :: rest,
           a_assignments,
           a_onPatternFail,
           a_rhs,
           a_varDecls )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = fun_1404(txt, i_p, a_assignments, a_onPatternFail, x_i1, a_rhs, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_1405(txt, rest, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end lm_1405;

protected function fun_1406
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_onPatternFail;
  input Integer in_a_i1;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_assignments, out_a_varDecls, out_a_onPatternFail) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_varDecls, in_a_onPatternFail, in_a_i1, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_varDecls;
      Tpl.Text a_onPatternFail;
      Integer a_i1;
      Tpl.Text a_rhs;
      DAE.Pattern i_p;
      Tpl.Text l_nrhs;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           _,
           _ )
      then (txt, a_assignments, a_varDecls, a_onPatternFail);

    case ( txt,
           i_p,
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           a_i1,
           a_rhs )
      equation
        l_nrhs = Tpl.writeText(Tpl.emptyTxt, a_rhs);
        l_nrhs = Tpl.writeTok(l_nrhs, Tpl.ST_STRING(".c"));
        l_nrhs = Tpl.writeStr(l_nrhs, intString(a_i1));
        (txt, l_nrhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_nrhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_varDecls, a_onPatternFail);
  end match;
end fun_1406;

protected function lm_1407
  input Tpl.Text in_txt;
  input list<DAE.Pattern> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_assignments, out_a_varDecls, out_a_onPatternFail) :=
  match(in_txt, in_items, in_a_assignments, in_a_varDecls, in_a_onPatternFail, in_a_rhs)
    local
      Tpl.Text txt;
      list<DAE.Pattern> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_varDecls;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Integer x_i1;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           _ )
      then (txt, a_assignments, a_varDecls, a_onPatternFail);

    case ( txt,
           i_p :: rest,
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           a_rhs )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_assignments, a_varDecls, a_onPatternFail) = fun_1406(txt, i_p, a_assignments, a_varDecls, a_onPatternFail, x_i1, a_rhs);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_varDecls, a_onPatternFail) = lm_1407(txt, rest, a_assignments, a_varDecls, a_onPatternFail, a_rhs);
      then (txt, a_assignments, a_varDecls, a_onPatternFail);
  end match;
end lm_1407;

protected function fun_1408
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input String in_a_n;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_onPatternFail, in_a_n, in_a_rhs, in_a_varDecls, in_a_t)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      String a_n;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      DAE.Type a_t;
      DAE.Pattern i_p;
      Tpl.Text txt_1;
      Tpl.Text l_tvar;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_onPatternFail,
           _,
           _,
           a_varDecls,
           _ )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p,
           a_assignments,
           a_onPatternFail,
           a_n,
           a_rhs,
           a_varDecls,
           a_t )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, a_t);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_n);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end fun_1408;

protected function lm_1409
  input Tpl.Text in_txt;
  input list<tuple<DAE.Pattern, String, DAE.Type>> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_items, in_a_assignments, in_a_onPatternFail, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<DAE.Pattern, String, DAE.Type>> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      String i_n;
      DAE.Type i_t;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_onPatternFail,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           (i_p, i_n, i_t) :: rest,
           a_assignments,
           a_onPatternFail,
           a_rhs,
           a_varDecls )
      equation
        (txt, a_assignments, a_onPatternFail, a_varDecls) = fun_1408(txt, i_p, a_assignments, a_onPatternFail, i_n, a_rhs, a_varDecls, i_t);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_1409(txt, rest, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end lm_1409;

protected function fun_1410
  input Tpl.Text in_txt;
  input Boolean in_a_knownSingleton;
  input Tpl.Text in_a_onPatternFail;
  input list<DAE.Pattern> in_a_patterns;
  input Integer in_a_index;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_knownSingleton, in_a_onPatternFail, in_a_patterns, in_a_index, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_onPatternFail;
      list<DAE.Pattern> a_patterns;
      Integer a_index;
      Tpl.Text a_rhs;
      Integer ret_0;

    case ( txt,
           false,
           a_onPatternFail,
           a_patterns,
           a_index,
           a_rhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (mmc__uniontype__metarecord__typedef__equal("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(a_patterns);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") == 0) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1410;

protected function fun_1411
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Integer in_a_i2;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_onPatternFail, in_a_i2, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Integer a_i2;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      DAE.Pattern i_p;
      Tpl.Text l_tvar;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_onPatternFail,
           _,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p,
           a_assignments,
           a_onPatternFail,
           a_i2,
           a_rhs,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeStr(txt, intString(a_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("));\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end fun_1411;

protected function lm_1412
  input Tpl.Text in_txt;
  input list<DAE.Pattern> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_items, in_a_assignments, in_a_onPatternFail, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Pattern> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      Integer x_i2;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_onPatternFail,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p :: rest,
           a_assignments,
           a_onPatternFail,
           a_rhs,
           a_varDecls )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = fun_1411(txt, i_p, a_assignments, a_onPatternFail, x_i2, a_rhs, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_1412(txt, rest, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end lm_1412;

public function patternMatch
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pat;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_assignments;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rhs;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_assignments;
algorithm
  (out_txt, out_a_rhs, out_a_onPatternFail, out_a_varDecls, out_a_assignments) :=
  match(in_txt, in_a_pat, in_a_rhs, in_a_onPatternFail, in_a_varDecls, in_a_assignments)
    local
      Tpl.Text txt;
      Tpl.Text a_rhs;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_varDecls;
      Tpl.Text a_assignments;
      DAE.Type i_et;
      String i_p_id;
      Integer i_index;
      Boolean i_knownSingleton;
      list<tuple<DAE.Pattern, String, DAE.Type>> i_patterns_1;
      list<DAE.Pattern> i_patterns;
      DAE.Pattern i_tail;
      DAE.Pattern i_head;
      DAE.Pattern i_p_pat;
      DAE.Exp i_p_exp;
      Option<DAE.Type> i_p_ty;
      Tpl.Text txt_6;
      String ret_5;
      Tpl.Text l_tvarTail;
      Tpl.Text l_tvarHead;
      Tpl.Text l_tvar;
      Tpl.Text l_urhs;
      Tpl.Text l_unboxBuf;

    case ( txt,
           DAE.PAT_WILD(),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CONSTANT(ty = i_p_ty, exp = i_p_exp),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        l_unboxBuf = Tpl.emptyTxt;
        (l_urhs, a_varDecls, l_unboxBuf) = fun_1401(Tpl.emptyTxt, i_p_ty, a_varDecls, l_unboxBuf, a_rhs);
        txt = Tpl.writeText(txt, l_unboxBuf);
        txt = fun_1403(txt, i_p_exp, a_onPatternFail, l_urhs);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_SOME(pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (optionNone("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("), 1));\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CONS(head = i_head, tail = i_tail),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        (l_tvarHead, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_tvarTail, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (listEmpty("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_tvarHead);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_tvarTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        (txt, l_tvarHead, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_head, l_tvarHead, a_onPatternFail, a_varDecls, a_assignments);
        (txt, l_tvarTail, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_tail, l_tvarTail, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_META_TUPLE(patterns = i_patterns),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_1405(txt, i_patterns, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CALL_TUPLE(patterns = i_patterns),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_assignments, a_varDecls, a_onPatternFail) = lm_1407(txt, i_patterns, a_assignments, a_varDecls, a_onPatternFail, a_rhs);
        txt = Tpl.popIter(txt);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CALL_NAMED(patterns = i_patterns_1),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_1409(txt, i_patterns_1, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CALL(knownSingleton = i_knownSingleton, index = i_index, patterns = i_patterns),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt = fun_1410(txt, i_knownSingleton, a_onPatternFail, i_patterns, i_index, a_rhs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(2, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_1412(txt, i_patterns, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_AS_FUNC_PTR(id = i_p_id, pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("_"));
        a_assignments = Tpl.writeStr(a_assignments, i_p_id);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" = "));
        a_assignments = Tpl.writeText(a_assignments, a_rhs);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(";"));
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_NEW_LINE());
        (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_AS(ty = NONE(), id = i_p_id, pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("_"));
        a_assignments = Tpl.writeStr(a_assignments, i_p_id);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" = "));
        a_assignments = Tpl.writeText(a_assignments, a_rhs);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(";"));
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_NEW_LINE());
        (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_AS(ty = SOME(i_et), id = i_p_id, pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        l_unboxBuf = Tpl.emptyTxt;
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("_"));
        a_assignments = Tpl.writeStr(a_assignments, i_p_id);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" = "));
        (a_assignments, l_unboxBuf, a_varDecls) = unboxVariable(a_assignments, Tpl.textString(a_rhs), i_et, l_unboxBuf, a_varDecls);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("  /* pattern as ty="));
        ret_5 = Types.unparseType(i_et);
        a_assignments = Tpl.writeStr(a_assignments, ret_5);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" */;"));
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_unboxBuf);
        txt = Tpl.softNewLine(txt);
        (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           _,
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt_6 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("UNKNOWN_PATTERN /* rhs: "));
        txt_6 = Tpl.writeText(txt_6, a_rhs);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING(" */"));
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_NEW_LINE());
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10426, 14), Tpl.textString(txt_6));
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
  end match;
end patternMatch;

protected function fun_1414
  input Tpl.Text in_txt;
  input Boolean in_a_isReadOnly;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReadOnly)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1414;

public function infoArgs
  input Tpl.Text in_txt;
  input Absyn.Info in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      Boolean i_isReadOnly;
      Integer i_columnNumberEnd;
      Integer i_lineNumberEnd;
      Integer i_columnNumberStart;
      Integer i_lineNumberStart;
      String i_fileName;
      String ret_1;
      String ret_0;

    case ( txt,
           Absyn.INFO(fileName = i_fileName, lineNumberStart = i_lineNumberStart, columnNumberStart = i_columnNumberStart, lineNumberEnd = i_lineNumberEnd, columnNumberEnd = i_columnNumberEnd, isReadOnly = i_isReadOnly) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.testsuiteFriendly(i_fileName);
        ret_1 = Util.escapeModelicaStringToCString(ret_0);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\","));
        txt = Tpl.writeStr(txt, intString(i_lineNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_columnNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_lineNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_columnNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = fun_1414(txt, i_isReadOnly);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end infoArgs;

protected function lm_1416
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExpMsg;
  input SimCode.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExpMsg;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExpMsg) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExpMsg, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExpMsg;
      SimCode.Context a_context;
      DAE.Exp i_message;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExpMsg,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg);

    case ( txt,
           i_message :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExpMsg,
           a_context )
      equation
        (txt, a_preExpMsg, a_varDecls, a_auxFunction) = expToFormatString(txt, i_message, a_context, a_preExpMsg, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExpMsg) = lm_1416(txt, rest, a_auxFunction, a_varDecls, a_preExpMsg, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg);
  end match;
end lm_1416;

protected function fun_1417
  input Tpl.Text in_txt;
  input DAE.Exp in_a_level;
  input Tpl.Text in_a_auxFunction;
  input Absyn.Info in_a_info;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExpMsg;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_msgVar;
  input Tpl.Text in_a_condVar;
  input Tpl.Text in_a_preExpCond;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExpMsg;
  output Tpl.Text out_a_msgVar;
  output Tpl.Text out_a_condVar;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExpMsg, out_a_msgVar, out_a_condVar) :=
  match(in_txt, in_a_level, in_a_auxFunction, in_a_info, in_a_varDecls, in_a_preExpMsg, in_a_context, in_a_msgVar, in_a_condVar, in_a_preExpCond)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Absyn.Info a_info;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExpMsg;
      SimCode.Context a_context;
      Tpl.Text a_msgVar;
      Tpl.Text a_condVar;
      Tpl.Text a_preExpCond;
      DAE.Exp i_level;
      Tpl.Text l_levelVar;
      Tpl.Text l_preExpLevel;
      Tpl.Text l_warningTriggered;

    case ( txt,
           DAE.ENUM_LITERAL(index = 1),
           a_auxFunction,
           a_info,
           a_varDecls,
           a_preExpMsg,
           a_context,
           a_msgVar,
           a_condVar,
           a_preExpCond )
      equation
        txt = Tpl.writeText(txt, a_preExpCond);
        txt = Tpl.softNewLine(txt);
        (txt, a_condVar, a_msgVar, a_preExpMsg, a_varDecls) = assertCommonVar(txt, a_condVar, a_msgVar, a_context, a_preExpMsg, a_varDecls, a_info);
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg, a_msgVar, a_condVar);

    case ( txt,
           DAE.ENUM_LITERAL(index = 2),
           a_auxFunction,
           a_info,
           a_varDecls,
           a_preExpMsg,
           _,
           a_msgVar,
           a_condVar,
           a_preExpCond )
      equation
        (l_warningTriggered, a_varDecls) = tempDeclZero(Tpl.emptyTxt, "static int", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, l_warningTriggered);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_preExpCond);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_preExpMsg);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_assert_warning(info, "
                                }, false));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_warningTriggered);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg, a_msgVar, a_condVar);

    case ( txt,
           i_level,
           a_auxFunction,
           a_info,
           a_varDecls,
           a_preExpMsg,
           a_context,
           a_msgVar,
           a_condVar,
           a_preExpCond )
      equation
        (l_warningTriggered, a_varDecls) = tempDeclZero(Tpl.emptyTxt, "static int", a_varDecls);
        l_preExpLevel = Tpl.emptyTxt;
        (l_levelVar, a_preExpMsg, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_level, a_context, a_preExpMsg, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExpLevel);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_levelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 1 || !"));
        txt = Tpl.writeText(txt, l_warningTriggered);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_preExpCond);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_preExpMsg);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "if ("
                                }, false));
        txt = Tpl.writeText(txt, l_levelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" == 1)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_assert(threadData, info, "));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_assert_warning(info, "));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeText(txt, l_warningTriggered);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg, a_msgVar, a_condVar);
  end match;
end fun_1417;

public function assertCommon
  input Tpl.Text txt;
  input DAE.Exp a_condition;
  input list<DAE.Exp> a_messages;
  input DAE.Exp a_level;
  input SimCode.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;
  input Absyn.Info a_info;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_msgVar;
  Tpl.Text l_preExpMsg;
  Tpl.Text l_condVar;
  Tpl.Text l_preExpCond;
algorithm
  l_preExpCond := Tpl.emptyTxt;
  (l_condVar, l_preExpCond, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_condition, a_context, l_preExpCond, a_varDecls, a_auxFunction);
  l_preExpMsg := Tpl.emptyTxt;
  l_msgVar := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_msgVar, out_a_auxFunction, out_a_varDecls, l_preExpMsg) := lm_1416(l_msgVar, a_messages, out_a_auxFunction, out_a_varDecls, l_preExpMsg, a_context);
  l_msgVar := Tpl.popIter(l_msgVar);
  (out_txt, out_a_auxFunction, out_a_varDecls, l_preExpMsg, l_msgVar, l_condVar) := fun_1417(txt, a_level, out_a_auxFunction, a_info, out_a_varDecls, l_preExpMsg, a_context, l_msgVar, l_condVar, l_preExpCond);
end assertCommon;

protected function fun_1419
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_STRINGDATA("));
      then txt;
  end match;
end fun_1419;

protected function fun_1420
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_1419(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1420;

protected function fun_1421
  input Tpl.Text in_txt;
  input Tpl.Text in_a_pre;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_pre)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1421;

public function expToFormatString
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_post;
  DAE.Type ret_1;
  Tpl.Text l_pre;
algorithm
  ret_1 := Expression.typeof(a_exp);
  l_pre := fun_1420(Tpl.emptyTxt, ret_1);
  l_post := fun_1421(Tpl.emptyTxt, l_pre);
  out_txt := Tpl.writeText(txt, l_pre);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(out_txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_txt := Tpl.writeText(out_txt, l_post);
end expToFormatString;

protected function fun_1423
  input Tpl.Text in_txt;
  input SimCode.Context in_a_context;
  input Tpl.Text in_a_condVar;
  input Tpl.Text in_a_msgVar;
  input Tpl.Text in_a_preExpMsg;
  input Absyn.Info in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_condVar, in_a_msgVar, in_a_preExpMsg, in_a_info)
    local
      Tpl.Text txt;
      Tpl.Text a_condVar;
      Tpl.Text a_msgVar;
      Tpl.Text a_preExpMsg;
      Absyn.Info a_info;

    case ( txt,
           SimCode.FUNCTION_CONTEXT(),
           a_condVar,
           a_msgVar,
           a_preExpMsg,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_preExpMsg);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_assert(threadData, info, "
                                }, false));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_condVar,
           a_msgVar,
           a_preExpMsg,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_preExpMsg);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throwStreamPrintWithEquationIndexes(threadData, equationIndexes, "));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1423;

public function assertCommonVar
  input Tpl.Text txt;
  input Tpl.Text a_condVar;
  input Tpl.Text a_msgVar;
  input SimCode.Context a_context;
  input Tpl.Text a_preExpMsg;
  input Tpl.Text a_varDecls;
  input Absyn.Info a_info;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_condVar;
  output Tpl.Text out_a_msgVar;
  output Tpl.Text out_a_preExpMsg;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_1423(txt, a_context, a_condVar, a_msgVar, a_preExpMsg, a_info);
  out_a_condVar := a_condVar;
  out_a_msgVar := a_msgVar;
  out_a_preExpMsg := a_preExpMsg;
  out_a_varDecls := a_varDecls;
end assertCommonVar;

protected function fun_1425
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_escstr;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_tmp, in_a_escstr, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_tmp;
      Tpl.Text a_escstr;
      Tpl.Text a_name;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           _,
           a_escstr,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data \""));
        txt = Tpl.writeText(txt, a_escstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "static const char "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_0 = System.unescapedStringLength(Tpl.textString(a_escstr));
        ret_1 = intAdd(1, ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data;"));
      then txt;

    case ( txt,
           _,
           a_tmp,
           a_escstr,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data \""));
        txt = Tpl.writeText(txt, a_escstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "static const MMC_DEFSTRINGLIT("
                                }, false));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_2 = System.unescapedStringLength(Tpl.textString(a_escstr));
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_data);\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRINGLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1425;

protected function lm_1426
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dim));
        txt = Tpl.nextIter(txt);
        txt = lm_1426(txt, rest);
      then txt;
  end match;
end lm_1426;

protected function lm_1427
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = literalExpConstArrayVal(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_1427(txt, rest);
      then txt;
  end match;
end lm_1427;

protected function fun_1428
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_data;
  input Tpl.Text in_a_sty;
  input Tpl.Text in_a_ndim;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_data, in_a_sty, in_a_ndim, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_data;
      Tpl.Text a_sty;
      Tpl.Text a_ndim;
      Tpl.Text a_name;

    case ( txt,
           "",
           _,
           _,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static base_array_t const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_dims, (void*) 0\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;

    case ( txt,
           _,
           a_data,
           a_sty,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const modelica_"));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data[] = {"));
        txt = Tpl.writeText(txt, a_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "static "
                                }, false));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims, (void*) "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_data\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_1428;

protected function lm_1429
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dim));
        txt = Tpl.nextIter(txt);
        txt = lm_1429(txt, rest);
      then txt;
  end match;
end lm_1429;

protected function lm_1430
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = literalExpConstArrayVal(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_1430(txt, rest);
      then txt;
  end match;
end lm_1430;

protected function fun_1431
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_data;
  input Tpl.Text in_a_sty;
  input Tpl.Text in_a_ndim;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_data, in_a_sty, in_a_ndim, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_data;
      Tpl.Text a_sty;
      Tpl.Text a_ndim;
      Tpl.Text a_name;

    case ( txt,
           "",
           _,
           _,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static base_array_t const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_dims, (void*) 0\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;

    case ( txt,
           _,
           a_data,
           a_sty,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const modelica_"));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data[] = {"));
        txt = Tpl.writeText(txt, a_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "static "
                                }, false));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims, (void*) "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_data\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_1431;

protected function fun_1432
  input Tpl.Text in_txt;
  input Boolean in_a_exp_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1432;

protected function lm_1433
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_preLit;
  input Integer in_a_index;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preLit;
algorithm
  (out_txt, out_a_preLit) :=
  match(in_txt, in_items, in_a_preLit, in_a_index)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_preLit;
      Integer a_index;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_preLit,
           _ )
      then (txt, a_preLit);

    case ( txt,
           i_exp :: rest,
           a_preLit,
           a_index )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_index));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0, a_preLit) = literalExpConstBoxedVal(txt, i_exp, txt_0, a_preLit);
        txt = Tpl.nextIter(txt);
        (txt, a_preLit) = lm_1433(txt, rest, a_preLit, a_index);
      then (txt, a_preLit);
  end match;
end lm_1433;

protected function lm_1434
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_preLit;
  input Integer in_a_index;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preLit;
algorithm
  (out_txt, out_a_preLit) :=
  match(in_txt, in_items, in_a_preLit, in_a_index)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_preLit;
      Integer a_index;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_preLit,
           _ )
      then (txt, a_preLit);

    case ( txt,
           i_exp :: rest,
           a_preLit,
           a_index )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_index));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0, a_preLit) = literalExpConstBoxedVal(txt, i_exp, txt_0, a_preLit);
        txt = Tpl.nextIter(txt);
        (txt, a_preLit) = lm_1434(txt, rest, a_preLit, a_index);
      then (txt, a_preLit);
  end match;
end lm_1434;

protected function fun_1435
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Tpl.Text in_a_preLit;
  input Integer in_a_index;
  input Tpl.Text in_a_meta;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preLit;
algorithm
  (out_txt, out_a_preLit) :=
  match(in_txt, in_a_lit, in_a_preLit, in_a_index, in_a_meta, in_a_tmp, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_preLit;
      Integer a_index;
      Tpl.Text a_meta;
      Tpl.Text a_tmp;
      Tpl.Text a_name;
      Absyn.Path i_path;
      list<DAE.Exp> i_args;
      Integer i_index;
      DAE.Exp i_exp;
      list<DAE.Exp> i_listExp;
      DAE.Exp i_cdr;
      DAE.Exp i_car;
      Real i_exp_real;
      Boolean i_exp_bool;
      Integer i_exp_integer;
      DAE.Exp i_lit;
      DAE.Type i_ty;
      String i_string;
      Tpl.Text txt_25;
      String ret_25;
      Integer ret_24;
      Integer ret_23;
      Integer ret_22;
      Tpl.Text l_newIndex;
      Tpl.Text txt_20;
      Integer ret_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      String str_16;
      list<DAE.Exp> ret_15;
      list<Integer> ret_14;
      Integer ret_13;
      list<Integer> ret_12;
      String str_11;
      list<DAE.Exp> ret_10;
      Tpl.Text l_data;
      list<Integer> ret_8;
      Tpl.Text l_dims;
      Tpl.Text l_sty;
      Integer ret_5;
      list<Integer> ret_4;
      Tpl.Text l_ndim;
      Boolean ret_2;
      String ret_1;
      Tpl.Text l_escstr;

    case ( txt,
           DAE.SCONST(string = i_string),
           a_preLit,
           _,
           _,
           a_tmp,
           a_name )
      equation
        ret_1 = Util.escapeModelicaStringToCString(i_string);
        l_escstr = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        ret_2 = Config.acceptMetaModelicaGrammar();
        txt = fun_1425(txt, ret_2, a_tmp, l_escstr, a_name);
      then (txt, a_preLit);

    case ( txt,
           (i_lit as DAE.MATRIX(ty = (i_ty as DAE.T_ARRAY(ty = _)))),
           a_preLit,
           _,
           _,
           _,
           a_name )
      equation
        ret_4 = Types.getDimensionSizes(i_ty);
        ret_5 = listLength(ret_4);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_sty = expTypeShort(Tpl.emptyTxt, i_ty);
        ret_8 = Types.getDimensionSizes(i_ty);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_1426(l_dims, ret_8);
        l_dims = Tpl.popIter(l_dims);
        ret_10 = Expression.flattenArrayExpToList(i_lit);
        l_data = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_data = lm_1427(l_data, ret_10);
        l_data = Tpl.popIter(l_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static _index_t "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims["));
        txt = Tpl.writeText(txt, l_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = {"));
        txt = Tpl.writeText(txt, l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        str_11 = Tpl.textString(l_data);
        txt = fun_1428(txt, str_11, l_data, l_sty, l_ndim, a_name);
      then (txt, a_preLit);

    case ( txt,
           (i_lit as DAE.ARRAY(ty = (i_ty as DAE.T_ARRAY(ty = _)))),
           a_preLit,
           _,
           _,
           _,
           a_name )
      equation
        ret_12 = Types.getDimensionSizes(i_ty);
        ret_13 = listLength(ret_12);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_13));
        l_sty = expTypeShort(Tpl.emptyTxt, i_ty);
        ret_14 = Types.getDimensionSizes(i_ty);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_1429(l_dims, ret_14);
        l_dims = Tpl.popIter(l_dims);
        ret_15 = Expression.flattenArrayExpToList(i_lit);
        l_data = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_data = lm_1430(l_data, ret_15);
        l_data = Tpl.popIter(l_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static _index_t "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims["));
        txt = Tpl.writeText(txt, l_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = {"));
        txt = Tpl.writeText(txt, l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        str_16 = Tpl.textString(l_data);
        txt = fun_1431(txt, str_16, l_data, l_sty, l_ndim, a_name);
      then (txt, a_preLit);

    case ( txt,
           DAE.BOX(exp = DAE.ICONST(integer = i_exp_integer)),
           a_preLit,
           _,
           a_meta,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_meta);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = Tpl.writeStr(txt, intString(i_exp_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then (txt, a_preLit);

    case ( txt,
           DAE.BOX(exp = DAE.BCONST(bool = i_exp_bool)),
           a_preLit,
           _,
           a_meta,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_meta);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = fun_1432(txt, i_exp_bool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then (txt, a_preLit);

    case ( txt,
           DAE.BOX(exp = DAE.RCONST(real = i_exp_real)),
           a_preLit,
           _,
           _,
           a_tmp,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFREALLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, realString(i_exp_real));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFREALLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preLit);

    case ( txt,
           DAE.CONS(car = i_car, cdr = i_cdr),
           a_preLit,
           a_index,
           _,
           a_tmp,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",2,1) {"));
        txt_17 = Tpl.writeStr(Tpl.emptyTxt, intString(a_index));
        txt_17 = Tpl.writeTok(txt_17, Tpl.ST_STRING("_car"));
        (txt, txt_17, a_preLit) = literalExpConstBoxedVal(txt, i_car, txt_17, a_preLit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt_18 = Tpl.writeStr(Tpl.emptyTxt, intString(a_index));
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING("_cdr"));
        (txt, txt_18, a_preLit) = literalExpConstBoxedVal(txt, i_cdr, txt_18, a_preLit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preLit);

    case ( txt,
           DAE.META_TUPLE(listExp = i_listExp),
           a_preLit,
           a_index,
           _,
           a_tmp,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_19 = listLength(i_listExp);
        txt = Tpl.writeStr(txt, intString(ret_19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",0) {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_preLit) = lm_1433(txt, i_listExp, a_preLit, a_index);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preLit);

    case ( txt,
           DAE.META_OPTION(exp = SOME(i_exp)),
           a_preLit,
           a_index,
           _,
           a_tmp,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",1,1) {"));
        txt_20 = Tpl.writeStr(Tpl.emptyTxt, intString(a_index));
        txt_20 = Tpl.writeTok(txt_20, Tpl.ST_STRING("_1"));
        (txt, txt_20, a_preLit) = literalExpConstBoxedVal(txt, i_exp, txt_20, a_preLit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preLit);

    case ( txt,
           DAE.METARECORDCALL(index = i_index, args = i_args, path = i_path),
           a_preLit,
           _,
           _,
           a_tmp,
           a_name )
      equation
        ret_22 = Patternm.getValueCtor(i_index);
        l_newIndex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_22));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_23 = listLength(i_args);
        ret_24 = intAdd(1, ret_23);
        txt = Tpl.writeStr(txt, intString(ret_24));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_newIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") {&"));
        txt = CodegenUtil.underscorePath(txt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc,"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_preLit) = lm_1434(txt, i_args, a_preLit, i_index);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preLit);

    case ( txt,
           i_lit,
           a_preLit,
           _,
           _,
           _,
           _ )
      equation
        txt_25 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConst failed: "));
        ret_25 = ExpressionDump.printExpStr(i_lit);
        txt_25 = Tpl.writeStr(txt_25, ret_25);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10602, 14), Tpl.textString(txt_25));
      then (txt, a_preLit);
  end match;
end fun_1435;

public function literalExpConst
  input Tpl.Text txt;
  input DAE.Exp a_lit;
  input Integer a_index;
  input Tpl.Text a_preLit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preLit;
protected
  Tpl.Text l_meta;
  Tpl.Text l_tmp;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
  l_name := Tpl.writeStr(l_name, intString(a_index));
  l_tmp := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT_STRUCT"));
  l_tmp := Tpl.writeStr(l_tmp, intString(a_index));
  l_meta := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("static modelica_metatype const "));
  l_meta := Tpl.writeText(l_meta, l_name);
  (out_txt, out_a_preLit) := fun_1435(txt, a_lit, a_preLit, a_index, l_meta, l_tmp, l_name);
end literalExpConst;

protected function fun_1437
  input Tpl.Text in_txt;
  input Boolean in_a_lit_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1437;

protected function fun_1438
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Tpl.Text in_a_index;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_preLit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_index;
  output Tpl.Text out_a_preLit;
algorithm
  (out_txt, out_a_index, out_a_preLit) :=
  match(in_txt, in_a_lit, in_a_index, in_a_name, in_a_tmp, in_a_preLit)
    local
      Tpl.Text txt;
      Tpl.Text a_index;
      Tpl.Text a_name;
      Tpl.Text a_tmp;
      Tpl.Text a_preLit;
      DAE.Exp i_lit;
      Integer i_lit_index;
      DAE.Exp i_lit_exp;
      Real i_lit_real;
      Boolean i_lit_bool;
      Integer i_integer;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           a_index,
           _,
           _,
           a_preLit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = Tpl.writeStr(txt, intString(i_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_index, a_preLit);

    case ( txt,
           DAE.BCONST(bool = i_lit_bool),
           a_index,
           _,
           _,
           a_preLit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = fun_1437(txt, i_lit_bool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_index, a_preLit);

    case ( txt,
           DAE.RCONST(real = i_lit_real),
           a_index,
           a_name,
           a_tmp,
           a_preLit )
      equation
        a_preLit = Tpl.writeTok(a_preLit, Tpl.ST_STRING("static const MMC_DEFREALLIT("));
        a_preLit = Tpl.writeText(a_preLit, a_tmp);
        a_preLit = Tpl.writeTok(a_preLit, Tpl.ST_STRING(","));
        a_preLit = Tpl.writeStr(a_preLit, realString(i_lit_real));
        a_preLit = Tpl.writeTok(a_preLit, Tpl.ST_STRING_LIST({
                                              ");\n",
                                              "#define "
                                          }, false));
        a_preLit = Tpl.writeText(a_preLit, a_name);
        a_preLit = Tpl.writeTok(a_preLit, Tpl.ST_STRING(" MMC_REFREALLIT("));
        a_preLit = Tpl.writeText(a_preLit, a_tmp);
        a_preLit = Tpl.writeTok(a_preLit, Tpl.ST_STRING(")"));
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_index, a_preLit);

    case ( txt,
           DAE.LIST(valList = {}),
           a_index,
           _,
           _,
           a_preLit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRUCTLIT(mmc_nil)"));
      then (txt, a_index, a_preLit);

    case ( txt,
           DAE.META_OPTION(exp = NONE()),
           a_index,
           _,
           _,
           a_preLit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRUCTLIT(mmc_none)"));
      then (txt, a_index, a_preLit);

    case ( txt,
           DAE.BOX(exp = i_lit_exp),
           a_index,
           _,
           _,
           a_preLit )
      equation
        (txt, a_index, a_preLit) = literalExpConstBoxedVal(txt, i_lit_exp, a_index, a_preLit);
      then (txt, a_index, a_preLit);

    case ( txt,
           DAE.SHARED_LITERAL(index = i_lit_index),
           a_index,
           _,
           _,
           a_preLit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_lit_index));
      then (txt, a_index, a_preLit);

    case ( txt,
           i_lit,
           a_index,
           _,
           _,
           a_preLit )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConstBoxedVal failed: "));
        ret_0 = ExpressionDump.printExpStr(i_lit);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10629, 14), Tpl.textString(txt_0));
      then (txt, a_index, a_preLit);
  end match;
end fun_1438;

public function literalExpConstBoxedVal
  input Tpl.Text txt;
  input DAE.Exp a_lit;
  input Tpl.Text a_index;
  input Tpl.Text a_preLit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_index;
  output Tpl.Text out_a_preLit;
protected
  Tpl.Text l_tmp;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
  l_name := Tpl.writeText(l_name, a_index);
  l_tmp := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT_STRUCT"));
  l_tmp := Tpl.writeText(l_tmp, a_index);
  (out_txt, out_a_index, out_a_preLit) := fun_1438(txt, a_lit, a_index, l_name, l_tmp, a_preLit);
end literalExpConstBoxedVal;

protected function fun_1440
  input Tpl.Text in_txt;
  input Boolean in_a_lit_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1440;

public function literalExpConstArrayVal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit)
    local
      Tpl.Text txt;
      DAE.Exp i_lit;
      Integer i_lit_index;
      Integer i_index;
      Real i_real;
      Boolean i_lit_bool;
      Integer i_integer;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_lit_bool) )
      equation
        txt = fun_1440(txt, i_lit_bool);
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_lit_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_lit_index));
      then txt;

    case ( txt,
           i_lit )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConstArrayVal failed: "));
        ret_0 = ExpressionDump.printExpStr(i_lit);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10640, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end literalExpConstArrayVal;

protected function lm_1442
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           i_eq :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfo1(txt, i_eq, a_preBuf, a_eqnsDefines, a_reverseProf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1442(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1442;

protected function lm_1443
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           (_, i_eqs) :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1442(txt, i_eqs, a_reverseProf, a_eqnsDefines, a_preBuf);
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1443(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1443;

protected function lm_1444
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           i_eq :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfo1(txt, i_eq, a_preBuf, a_eqnsDefines, a_reverseProf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1444(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1444;

protected function lm_1445
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_index;
      Integer x_i0;
      SimCode.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_index )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("equationInfo_crefs"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        ret_0 = SimCodeUtil.varName(i_var);
        txt = cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo;"));
        txt = Tpl.nextIter(txt);
        txt = lm_1445(txt, rest, a_index);
      then txt;
  end match;
end lm_1445;

protected function lm_1446
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.SimEqSystem i_e;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           i_e :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfo1(txt, i_e, a_preBuf, a_eqnsDefines, a_reverseProf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1446(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1446;

protected function fun_1447
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_jacobianMatrix;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_a_jacobianMatrix, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.JacobianMatrix i_mat;

    case ( txt,
           SOME(i_mat),
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfoMatrix(txt, i_mat, a_preBuf, a_eqnsDefines, a_reverseProf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           _,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end fun_1447;

protected function lm_1448
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_index;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_cr :: rest,
           a_index )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("equationInfo_crefs"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        txt = cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo;"));
        txt = Tpl.nextIter(txt);
        txt = lm_1448(txt, rest, a_index);
      then txt;
  end match;
end lm_1448;

protected function fun_1449
  input Tpl.Text in_txt;
  input Tpl.Text in_a_jac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jac)
    local
      Tpl.Text txt;
      Tpl.Text i_jac;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_jac )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, i_jac);
      then txt;
  end match;
end fun_1449;

protected function lm_1450
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_index;
      Integer x_i0;
      SimCode.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_index )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("equationInfo_crefs"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        ret_0 = SimCodeUtil.varName(i_var);
        txt = cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo;"));
        txt = Tpl.nextIter(txt);
        txt = lm_1450(txt, rest, a_index);
      then txt;
  end match;
end lm_1450;

public function equationInfo1
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_preBuf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_reverseProf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preBuf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_reverseProf;
algorithm
  (out_txt, out_a_preBuf, out_a_eqnsDefines, out_a_reverseProf) :=
  match(in_txt, in_a_eq, in_a_preBuf, in_a_eqnsDefines, in_a_reverseProf)
    local
      Tpl.Text txt;
      Tpl.Text a_preBuf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_reverseProf;
      list<SimCode.SimVar> i_discVars;
      SimCode.SimEqSystem i_cont;
      list<DAE.ComponentRef> i_crefs;
      Option<SimCode.JacobianMatrix> i_jacobianMatrix;
      list<SimCode.SimEqSystem> i_eqs;
      list<SimCode.SimVar> i_vars;
      SimCode.SimEqSystem i_eq;
      list<SimCode.SimEqSystem> i_elsebranch;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> i_ifbranches;
      DAE.ComponentRef i_cref;
      Integer i_index;
      Integer ret_17;
      Integer ret_16;
      Integer ret_15;
      Tpl.Text l_conEqn;
      Integer ret_13;
      Integer ret_12;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text l_jac;
      list<SimCode.SimEqSystem> ret_8;
      Tpl.Text l_residuals;
      Integer ret_6;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Tpl.Text l_elsebr;
      Tpl.Text l_branches;
      Tpl.Text l_var;

    case ( txt,
           SimCode.SES_RESIDUAL(index = i_index),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_RESIDUAL "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",0,NULL}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref, index = i_index),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        l_var = cref(Tpl.emptyTxt, i_cref);
        l_var = Tpl.writeTok(l_var, Tpl.ST_STRING("__varInfo"));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("const VAR_INFO** equationInfo_cref"));
        a_preBuf = Tpl.writeStr(a_preBuf, intString(i_index));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(" = (const VAR_INFO**)calloc(1,sizeof(VAR_INFO*));"));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_NEW_LINE());
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("equationInfo_cref"));
        a_preBuf = Tpl.writeStr(a_preBuf, intString(i_index));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("[0] = &"));
        a_preBuf = Tpl.writeText(a_preBuf, l_var);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(";"));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_SIMPLE_ASSIGN "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",1,equationInfo_cref"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(index = i_index),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_ARRAY_CALL_ASSIGN "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",0,NULL}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           SimCode.SES_IFEQUATION(ifbranches = i_ifbranches, elsebranch = i_elsebranch, index = i_index),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        (l_branches, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1443(Tpl.emptyTxt, i_ifbranches, a_reverseProf, a_eqnsDefines, a_preBuf);
        (l_elsebr, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1444(Tpl.emptyTxt, i_elsebranch, a_reverseProf, a_eqnsDefines, a_preBuf);
        txt = Tpl.writeText(txt, l_branches);
        txt = Tpl.writeText(txt, l_elsebr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_IFEQUATION "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",0,NULL}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           SimCode.SES_ALGORITHM(index = i_index),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_ALGORITHM "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", 0, NULL}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           SimCode.SES_WHEN(index = i_index),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_WHEN "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", 0, NULL}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(index = i_index, vars = i_vars)),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        ret_3 = System.tmpTick();
        (a_eqnsDefines, a_reverseProf) = functionSimProfDef(a_eqnsDefines, i_eq, ret_3, a_reverseProf);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("const VAR_INFO** equationInfo_crefs"));
        a_preBuf = Tpl.writeStr(a_preBuf, intString(i_index));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(" = (const VAR_INFO**)malloc("));
        ret_4 = listLength(i_vars);
        a_preBuf = Tpl.writeStr(a_preBuf, intString(ret_4));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("*sizeof(VAR_INFO*));"));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_NEW_LINE());
        a_preBuf = Tpl.pushIter(a_preBuf, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_preBuf = lm_1445(a_preBuf, i_vars, i_index);
        a_preBuf = Tpl.popIter(a_preBuf);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"linear system "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (size "));
        ret_5 = listLength(i_vars);
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        ret_6 = listLength(i_vars);
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", equationInfo_crefs"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           (i_eq as SimCode.SES_NONLINEAR(eqs = i_eqs, jacobianMatrix = i_jacobianMatrix, index = i_index, crefs = i_crefs)),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        ret_8 = SimCodeUtil.sortEqSystems(i_eqs);
        (l_residuals, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1446(Tpl.emptyTxt, ret_8, a_reverseProf, a_eqnsDefines, a_preBuf);
        (l_jac, a_reverseProf, a_eqnsDefines, a_preBuf) = fun_1447(Tpl.emptyTxt, i_jacobianMatrix, a_reverseProf, a_eqnsDefines, a_preBuf);
        ret_10 = System.tmpTick();
        (a_eqnsDefines, a_reverseProf) = functionSimProfDef(a_eqnsDefines, i_eq, ret_10, a_reverseProf);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("const VAR_INFO** equationInfo_crefs"));
        a_preBuf = Tpl.writeStr(a_preBuf, intString(i_index));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(" = (const VAR_INFO**)malloc("));
        ret_11 = listLength(i_crefs);
        a_preBuf = Tpl.writeStr(a_preBuf, intString(ret_11));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("*sizeof(VAR_INFO*));"));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_NEW_LINE());
        a_preBuf = Tpl.pushIter(a_preBuf, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_preBuf = lm_1448(a_preBuf, i_crefs, i_index);
        a_preBuf = Tpl.popIter(a_preBuf);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, l_residuals);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"residualFunc"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (size "));
        ret_12 = listLength(i_crefs);
        txt = Tpl.writeStr(txt, intString(ret_12));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        ret_13 = listLength(i_crefs);
        txt = Tpl.writeStr(txt, intString(ret_13));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", equationInfo_crefs"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = fun_1449(txt, l_jac);
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           (i_eq as SimCode.SES_MIXED(cont = i_cont, index = i_index, discVars = i_discVars)),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        (l_conEqn, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfo1(Tpl.emptyTxt, i_cont, a_preBuf, a_eqnsDefines, a_reverseProf);
        ret_15 = System.tmpTick();
        (a_eqnsDefines, a_reverseProf) = functionSimProfDef(a_eqnsDefines, i_eq, ret_15, a_reverseProf);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_NEW_LINE());
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("const VAR_INFO** equationInfo_crefs"));
        a_preBuf = Tpl.writeStr(a_preBuf, intString(i_index));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(" = (const VAR_INFO**)malloc("));
        ret_16 = listLength(i_discVars);
        a_preBuf = Tpl.writeStr(a_preBuf, intString(ret_16));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING("*sizeof(VAR_INFO*));"));
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_NEW_LINE());
        a_preBuf = Tpl.pushIter(a_preBuf, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_preBuf = lm_1450(a_preBuf, i_discVars, i_index);
        a_preBuf = Tpl.popIter(a_preBuf);
        a_preBuf = Tpl.writeTok(a_preBuf, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, l_conEqn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"MIXED"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", "));
        ret_17 = listLength(i_discVars);
        txt = Tpl.writeStr(txt, intString(ret_17));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", equationInfo_crefs"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);

    case ( txt,
           _,
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10681, 19), "Unkown Equation Type in equationInfo1");
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);
  end match;
end equationInfo1;

protected function lm_1452
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           i_eq :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfo1(txt, i_eq, a_preBuf, a_eqnsDefines, a_reverseProf);
        txt = Tpl.nextIter(txt);
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1452(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1452;

protected function lm_1453
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      list<SimCode.SimEqSystem> i_eqs;
      Tpl.StringToken ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           (i_eqs, _, _) :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(","));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_NEW_LINE());
        ret_1 = Tpl.textStrTok(txt_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(ret_1), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1452(txt, i_eqs, a_reverseProf, a_eqnsDefines, a_preBuf);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1453(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1453;

public function equationInfoMatrix
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input Tpl.Text in_a_preBuf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_reverseProf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preBuf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_reverseProf;
algorithm
  (out_txt, out_a_preBuf, out_a_eqnsDefines, out_a_reverseProf) :=
  match(in_txt, in_a_jacobianMatrix, in_a_preBuf, in_a_eqnsDefines, in_a_reverseProf)
    local
      Tpl.Text txt;
      Tpl.Text a_preBuf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_reverseProf;
      list<SimCode.JacobianColumn> i_cols;
      Tpl.StringToken ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_cols, _, _, _, _, _, _),
           a_preBuf,
           a_eqnsDefines,
           a_reverseProf )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(","));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_NEW_LINE());
        ret_1 = Tpl.textStrTok(txt_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(ret_1), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1453(txt, i_cols, a_reverseProf, a_eqnsDefines, a_preBuf);
        txt = Tpl.popIter(txt);
      then (txt, a_preBuf, a_eqnsDefines, a_reverseProf);
  end match;
end equationInfoMatrix;

protected function lm_1455
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.JacobianMatrix i_jacobianMatrix;
      Integer i_index;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           SimCode.SES_STATESET(index = i_index, jacobianMatrix = i_jacobianMatrix) :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\"SES_STATESET "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",0,NULL},"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfoMatrix(txt, i_jacobianMatrix, a_preBuf, a_eqnsDefines, a_reverseProf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1455(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           _ :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1455(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1455;

protected function lm_1456
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_reverseProf;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_preBuf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_preBuf;
algorithm
  (out_txt, out_a_reverseProf, out_a_eqnsDefines, out_a_preBuf) :=
  match(in_txt, in_items, in_a_reverseProf, in_a_eqnsDefines, in_a_preBuf)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_reverseProf;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_preBuf;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);

    case ( txt,
           i_eq :: rest,
           a_reverseProf,
           a_eqnsDefines,
           a_preBuf )
      equation
        (txt, a_preBuf, a_eqnsDefines, a_reverseProf) = equationInfo1(txt, i_eq, a_preBuf, a_eqnsDefines, a_reverseProf);
        txt = Tpl.nextIter(txt);
        (txt, a_reverseProf, a_eqnsDefines, a_preBuf) = lm_1456(txt, rest, a_reverseProf, a_eqnsDefines, a_preBuf);
      then (txt, a_reverseProf, a_eqnsDefines, a_preBuf);
  end match;
end lm_1456;

protected function fun_1457
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_eqs;
  input list<SimCode.StateSet> in_a_stateSets;
  input Tpl.Text in_a_eqnsDefines;
  input Tpl.Text in_a_reverseProf;
  input Integer in_a_numEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_reverseProf;
algorithm
  (out_txt, out_a_eqnsDefines, out_a_reverseProf) :=
  match(in_txt, in_a_eqs, in_a_stateSets, in_a_eqnsDefines, in_a_reverseProf, in_a_numEquations)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> a_stateSets;
      Tpl.Text a_eqnsDefines;
      Tpl.Text a_reverseProf;
      Integer a_numEquations;
      list<SimCode.SimEqSystem> i_eqs;
      list<SimCode.StateSet> ret_2;
      Tpl.Text l_res;
      Tpl.Text l_preBuf;

    case ( txt,
           {},
           _,
           a_eqnsDefines,
           a_reverseProf,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const struct EQUATION_INFO equation_info[1] = {{0, NULL}};"));
      then (txt, a_eqnsDefines, a_reverseProf);

    case ( txt,
           i_eqs,
           a_stateSets,
           a_eqnsDefines,
           a_reverseProf,
           a_numEquations )
      equation
        l_preBuf = Tpl.emptyTxt;
        l_res = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("const struct EQUATION_INFO equationInfo["));
        l_res = Tpl.writeStr(l_res, intString(a_numEquations));
        l_res = Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                        "] = {\n",
                                        "  {0, \"Dummy Equation so we can index from 1\", 0, NULL},\n"
                                    }, true));
        l_res = Tpl.pushBlock(l_res, Tpl.BT_INDENT(2));
        ret_2 = listReverse(a_stateSets);
        (l_res, a_reverseProf, a_eqnsDefines, l_preBuf) = lm_1455(l_res, ret_2, a_reverseProf, a_eqnsDefines, l_preBuf);
        l_res = Tpl.softNewLine(l_res);
        l_res = Tpl.pushIter(l_res, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_res, a_reverseProf, a_eqnsDefines, l_preBuf) = lm_1456(l_res, i_eqs, a_reverseProf, a_eqnsDefines, l_preBuf);
        l_res = Tpl.popIter(l_res);
        l_res = Tpl.softNewLine(l_res);
        l_res = Tpl.popBlock(l_res);
        l_res = Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                        "};\n",
                                        "/* Verify the data in the array to make sure certain assumptions hold */\n",
                                        "int i;\n",
                                        "for (i=0; i<"
                                    }, false));
        l_res = Tpl.writeStr(l_res, intString(a_numEquations));
        l_res = Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                        "; i++) {\n",
                                        "  if (equationInfo[i].id != i) {\n",
                                        "    fprintf(stderr, \"equationInfo[i].id=%d, i=%d\\n\", equationInfo[i].id, i);\n",
                                        "    assert(equationInfo[i].id == i);\n",
                                        "  }\n",
                                        "}"
                                    }, false));
        txt = Tpl.writeText(txt, l_preBuf);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_eqnsDefines, a_reverseProf);
  end match;
end fun_1457;

public function equationInfo
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_eqs;
  input list<SimCode.StateSet> a_stateSets;
  input Tpl.Text a_eqnsDefines;
  input Tpl.Text a_reverseProf;
  input Integer a_numEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqnsDefines;
  output Tpl.Text out_a_reverseProf;
algorithm
  System.tmpTickReset(0);
  (out_txt, out_a_eqnsDefines, out_a_reverseProf) := fun_1457(txt, a_eqs, a_stateSets, a_eqnsDefines, a_reverseProf, a_numEquations);
end equationInfo;

protected function lm_1459
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "rSta");
        txt = Tpl.nextIter(txt);
        txt = lm_1459(txt, rest);
      then txt;
  end match;
end lm_1459;

protected function lm_1460
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "rDer");
        txt = Tpl.nextIter(txt);
        txt = lm_1460(txt, rest);
      then txt;
  end match;
end lm_1460;

protected function lm_1461
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "rAlg");
        txt = Tpl.nextIter(txt);
        txt = lm_1461(txt, rest);
      then txt;
  end match;
end lm_1461;

protected function lm_1462
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_numAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numAlgVars)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_numAlgVars;
      Integer x_i0;
      SimCode.SimVar i_var;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numAlgVars )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = intAdd(x_i0, a_numAlgVars);
        txt = ScalarVariable(txt, i_var, ret_0, "rAlg");
        txt = Tpl.nextIter(txt);
        txt = lm_1462(txt, rest, a_numAlgVars);
      then txt;
  end match;
end lm_1462;

protected function lm_1463
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;
  input Integer in_a_numDiscreteReal;
  input Integer in_a_numAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numDiscreteReal, in_a_numAlgVars)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer a_numDiscreteReal;
      Integer a_numAlgVars;
      Integer x_i0;
      SimCode.SimVar i_var;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numDiscreteReal,
           a_numAlgVars )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = intAdd(a_numAlgVars, a_numDiscreteReal);
        ret_1 = intAdd(x_i0, ret_0);
        txt = ScalarVariable(txt, i_var, ret_1, "rAlg");
        txt = Tpl.nextIter(txt);
        txt = lm_1463(txt, rest, a_numDiscreteReal, a_numAlgVars);
      then txt;
  end match;
end lm_1463;

protected function lm_1464
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "rPar");
        txt = Tpl.nextIter(txt);
        txt = lm_1464(txt, rest);
      then txt;
  end match;
end lm_1464;

protected function lm_1465
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "rAli");
        txt = Tpl.nextIter(txt);
        txt = lm_1465(txt, rest);
      then txt;
  end match;
end lm_1465;

protected function lm_1466
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "iAlg");
        txt = Tpl.nextIter(txt);
        txt = lm_1466(txt, rest);
      then txt;
  end match;
end lm_1466;

protected function lm_1467
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "iPar");
        txt = Tpl.nextIter(txt);
        txt = lm_1467(txt, rest);
      then txt;
  end match;
end lm_1467;

protected function lm_1468
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "iAli");
        txt = Tpl.nextIter(txt);
        txt = lm_1468(txt, rest);
      then txt;
  end match;
end lm_1468;

protected function lm_1469
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "bAlg");
        txt = Tpl.nextIter(txt);
        txt = lm_1469(txt, rest);
      then txt;
  end match;
end lm_1469;

protected function lm_1470
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "bPar");
        txt = Tpl.nextIter(txt);
        txt = lm_1470(txt, rest);
      then txt;
  end match;
end lm_1470;

protected function lm_1471
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "bAli");
        txt = Tpl.nextIter(txt);
        txt = lm_1471(txt, rest);
      then txt;
  end match;
end lm_1471;

protected function lm_1472
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "sAlg");
        txt = Tpl.nextIter(txt);
        txt = lm_1472(txt, rest);
      then txt;
  end match;
end lm_1472;

protected function lm_1473
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "sPar");
        txt = Tpl.nextIter(txt);
        txt = lm_1473(txt, rest);
      then txt;
  end match;
end lm_1473;

protected function lm_1474
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      SimCode.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = ScalarVariable(txt, i_var, x_i0, "sAli");
        txt = Tpl.nextIter(txt);
        txt = lm_1474(txt, rest);
      then txt;
  end match;
end lm_1474;

public function ModelVariables
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> i_vars_stringAliasVars;
      list<SimCode.SimVar> i_vars_stringParamVars;
      list<SimCode.SimVar> i_vars_stringAlgVars;
      list<SimCode.SimVar> i_vars_boolAliasVars;
      list<SimCode.SimVar> i_vars_boolParamVars;
      list<SimCode.SimVar> i_vars_boolAlgVars;
      list<SimCode.SimVar> i_vars_intAliasVars;
      list<SimCode.SimVar> i_vars_intParamVars;
      list<SimCode.SimVar> i_vars_intAlgVars;
      list<SimCode.SimVar> i_vars_aliasVars;
      list<SimCode.SimVar> i_vars_paramVars;
      Integer i_numDiscreteReal;
      list<SimCode.SimVar> i_vars_realOptimizeConstraintsVars;
      Integer i_numAlgVars;
      list<SimCode.SimVar> i_vars_discreteAlgVars;
      list<SimCode.SimVar> i_vars_algVars;
      list<SimCode.SimVar> i_vars_derivativeVars;
      list<SimCode.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCode.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, realOptimizeConstraintsVars = i_vars_realOptimizeConstraintsVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars), varInfo = SimCode.VARINFO(numAlgVars = i_numAlgVars, numDiscreteReal = i_numDiscreteReal)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ModelVariables>\n"));
        System.tmpTickReset(1000);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1459(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1460(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1461(txt, i_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1462(txt, i_vars_discreteAlgVars, i_numAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1463(txt, i_vars_realOptimizeConstraintsVars, i_numDiscreteReal, i_numAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1464(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1465(txt, i_vars_aliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1466(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1467(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1468(txt, i_vars_intAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1469(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1470(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1471(txt, i_vars_boolAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1472(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1473(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1474(txt, i_vars_stringAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ModelVariables>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ModelVariables;

public function ScalarVariable
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input Integer in_a_classIndex;
  input String in_a_classType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_classIndex, in_a_classType)
    local
      Tpl.Text txt;
      Integer a_classIndex;
      String a_classType;
      DAE.Type i_type__;
      Boolean i_isFixed;
      Option<DAE.Exp> i_nominalValue;
      Option<DAE.Exp> i_initialValue;
      Option<DAE.Exp> i_maxValue;
      Option<DAE.Exp> i_minValue;
      String i_displayUnit;
      String i_unit;
      SimCode.SimVar i_simVar;

    case ( txt,
           (i_simVar as SimCode.SIMVAR(unit = i_unit, displayUnit = i_displayUnit, minValue = i_minValue, maxValue = i_maxValue, initialValue = i_initialValue, nominalValue = i_nominalValue, isFixed = i_isFixed, type_ = i_type__)),
           a_classIndex,
           a_classType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ScalarVariable\n"));
        txt = ScalarVariableAttribute(txt, i_simVar, a_classIndex, a_classType);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = CodegenUtil.ScalarVariableType(txt, i_unit, i_displayUnit, i_minValue, i_maxValue, i_initialValue, i_nominalValue, i_isFixed, i_type__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ScalarVariable>"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end ScalarVariable;

protected function fun_1477
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;
      String ret_0;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description = \""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_1477;

public function ScalarVariableAttribute
  input Tpl.Text in_txt;
  input SimCode.SimVar in_a_simVar;
  input Integer in_a_classIndex;
  input String in_a_classType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_classIndex, in_a_classType)
    local
      Tpl.Text txt;
      Integer a_classIndex;
      String a_classType;
      Absyn.Info i_info;
      Boolean i_isProtected;
      Boolean i_isValueChangeable;
      Boolean i_isDiscrete;
      DAE.ComponentRef i_name;
      SimCode.Causality i_causality;
      SimCode.AliasVariable i_aliasvar;
      String i_comment;
      BackendDAE.VarKind i_varKind;
      String ret_7;
      Tpl.Text txt_6;
      Tpl.Text l_caus;
      Tpl.Text l_alias;
      Tpl.Text l_description;
      Tpl.Text l_variability;
      Integer ret_1;
      Tpl.Text l_valueReference;

    case ( txt,
           SimCode.SIMVAR(source = DAE.SOURCE(info = i_info), varKind = i_varKind, comment = i_comment, aliasvar = i_aliasvar, causality = i_causality, name = i_name, isDiscrete = i_isDiscrete, isValueChangeable = i_isValueChangeable, isProtected = i_isProtected),
           a_classIndex,
           a_classType )
      equation
        ret_1 = System.tmpTick();
        l_valueReference = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_variability = CodegenUtil.getVariablity(Tpl.emptyTxt, i_varKind);
        l_description = fun_1477(Tpl.emptyTxt, i_comment);
        l_alias = CodegenUtil.getAliasVar(Tpl.emptyTxt, i_aliasvar);
        l_caus = getCausality(Tpl.emptyTxt, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name = \""));
        txt_6 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        ret_7 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_6));
        txt = Tpl.writeStr(txt, ret_7);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "valueReference = \""
                                }, false));
        txt = Tpl.writeText(txt, l_valueReference);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\n"));
        txt = Tpl.writeText(txt, l_description);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("variability = \""));
        txt = Tpl.writeText(txt, l_variability);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" isDiscrete = \""));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_isDiscrete));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "causality = \""
                                }, false));
        txt = Tpl.writeText(txt, l_caus);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" isValueChangeable = \""));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_isValueChangeable));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "alias = "
                                }, false));
        txt = Tpl.writeText(txt, l_alias);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("classIndex = \""));
        txt = Tpl.writeStr(txt, intString(a_classIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" classType = \""));
        txt = Tpl.writeStr(txt, a_classType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "isProtected = \""
                                }, false));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_isProtected));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\n"));
        txt = getInfoArgs(txt, i_info);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end ScalarVariableAttribute;

protected function fun_1479
  input Tpl.Text in_txt;
  input Boolean in_a_isReadOnly;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReadOnly)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("false"));
      then txt;
  end match;
end fun_1479;

public function getInfoArgs
  input Tpl.Text in_txt;
  input Absyn.Info in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      Boolean i_isReadOnly;
      Integer i_columnNumberEnd;
      Integer i_lineNumberEnd;
      Integer i_columnNumberStart;
      Integer i_lineNumberStart;
      String i_fileName;
      String ret_0;

    case ( txt,
           Absyn.INFO(fileName = i_fileName, lineNumberStart = i_lineNumberStart, columnNumberStart = i_columnNumberStart, lineNumberEnd = i_lineNumberEnd, columnNumberEnd = i_columnNumberEnd, isReadOnly = i_isReadOnly) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fileName = \""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_fileName);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" startLine = \""));
        txt = Tpl.writeStr(txt, intString(i_lineNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" startColumn = \""));
        txt = Tpl.writeStr(txt, intString(i_columnNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" endLine = \""));
        txt = Tpl.writeStr(txt, intString(i_lineNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" endColumn = \""));
        txt = Tpl.writeStr(txt, intString(i_columnNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" fileWritable = \""));
        txt = fun_1479(txt, i_isReadOnly);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getInfoArgs;

public function getCausality
  input Tpl.Text in_txt;
  input SimCode.Causality in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.NONECAUS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("none"));
      then txt;

    case ( txt,
           SimCode.INTERNAL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("internal"));
      then txt;

    case ( txt,
           SimCode.OUTPUT() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output"));
      then txt;

    case ( txt,
           SimCode.INPUT() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("input"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getCausality;

protected function fun_1482
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype tmpMeta["));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] __attribute__((unused)) = {0};"));
      then txt;
  end match;
end fun_1482;

public function addRootsTempArray
  input Tpl.Text txt;

  output Tpl.Text out_txt;
protected
  Integer ret_0;
algorithm
  ret_0 := System.tmpTickMaximum(1);
  out_txt := fun_1482(txt, ret_0);
end addRootsTempArray;

protected function fun_1484
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Info in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_info)
    local
      Tpl.Text txt;
      Absyn.Info a_info;
      String ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#modelicaLine "));
        ret_0 = Error.infoStr(a_info);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1484;

public function modelicaLine
  input Tpl.Text txt;
  input Absyn.Info a_info;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Config.acceptMetaModelicaGrammar();
  ret_1 := Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
  ret_2 := boolOr(ret_0, ret_1);
  out_txt := fun_1484(txt, ret_2, a_info);
end modelicaLine;

protected function fun_1486
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#endModelicaLine*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1486;

public function endModelicaLine
  input Tpl.Text txt;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Config.acceptMetaModelicaGrammar();
  ret_1 := Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
  ret_2 := boolOr(ret_0, ret_1);
  out_txt := fun_1486(txt, ret_2);
end endModelicaLine;

protected function lm_1488
  input Tpl.Text in_txt;
  input list<DAE.ClassAttributes> in_items;
  input String in_a_modelNamePrefixStr;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ClassAttributes> rest;
      String a_modelNamePrefixStr;
      SimCode.SimCode a_simCode;
      DAE.ClassAttributes i_classAttribute;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_classAttribute :: rest,
           a_modelNamePrefixStr,
           a_simCode )
      equation
        txt = optimizationComponents1(txt, i_classAttribute, a_simCode, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_1488(txt, rest, a_modelNamePrefixStr, a_simCode);
      then txt;
  end match;
end lm_1488;

public function optimizationComponents
  input Tpl.Text in_txt;
  input list<DAE.ClassAttributes> in_a_classAttributes;
  input SimCode.SimCode in_a_simCode;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_classAttributes, in_a_simCode, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_modelNamePrefixStr;
      list<DAE.ClassAttributes> i_classAttributes;

    case ( txt,
           {},
           _,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = symbolName(txt, a_modelNamePrefixStr, "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res,short *i){return -1;}\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefixStr, "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short * i1, short*i2){return -1;}\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefixStr, "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt){return -1;}"));
      then txt;

    case ( txt,
           i_classAttributes,
           a_simCode,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1488(txt, i_classAttributes, a_modelNamePrefixStr, a_simCode);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end optimizationComponents;

protected function fun_1490
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_objetiveE;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_objetiveE)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " *res =  &$P$TMP_mayerTerm;\n",
                                    " *index_Dres = $P$TMP_mayerTerm$pDERC$indexdiffed;\n",
                                    " return 0;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1490;

protected function fun_1491
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_startTimeE;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_startTimeE, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_exp;
      Tpl.Text l_startTimeOptExp;

    case ( txt,
           SOME(i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (l_startTimeOptExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCode.contextOther, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(7));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*startTimeOpt = "));
        txt = Tpl.writeText(txt, l_startTimeOptExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1491;

protected function fun_1492
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_objectiveIntegrandE;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_objectiveIntegrandE)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " *res =  &$P$TMP_lagrangeTerm;\n",
                                    " *index_DresB = $P$TMP_lagrangeTerm$pDERB$indexdiffed;\n",
                                    " *index_DresC = $P$TMP_lagrangeTerm$pDERC$indexdiffed;\n",
                                    " return 0;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1492;

protected function lm_1493
  input Tpl.Text in_txt;
  input list<SimCode.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SIMVAR(name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nominal["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".nominal;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("useNominal["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".useNominal;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] =(char *) "));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__varInfo.name;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = $P$ATTRIBUTE"));
        txt = cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start;"));
        txt = Tpl.nextIter(txt);
        txt = lm_1493(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1493(txt, rest);
      then txt;
  end match;
end lm_1493;

protected function fun_1494
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.SimVar> i_vars_inputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCode.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1493(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1494;

protected function fun_1495
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_1494(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1495;

public function optimizationComponents1
  input Tpl.Text in_txt;
  input DAE.ClassAttributes in_a_classAttribute;
  input SimCode.SimCode in_a_simCode;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_classAttribute, in_a_simCode, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_modelNamePrefixStr;
      Option<DAE.Exp> i_objectiveIntegrandE;
      Option<DAE.Exp> i_startTimeE;
      Option<DAE.Exp> i_objetiveE;
      Tpl.Text l_inputBounds;
      Tpl.Text l_objectiveIntegrand;
      Tpl.Text l_startTimeOpt;
      Tpl.Text l_objectiveFunction;
      Tpl.Text l_auxFunction;
      Tpl.Text l_preExp1;
      Tpl.Text l_varDecls1;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;

    case ( txt,
           DAE.OPTIMIZATION_ATTRS(objetiveE = i_objetiveE, startTimeE = i_startTimeE, objectiveIntegrandE = i_objectiveIntegrandE),
           a_simCode,
           a_modelNamePrefixStr )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        l_varDecls1 = Tpl.emptyTxt;
        l_preExp1 = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_objectiveFunction = fun_1490(Tpl.emptyTxt, i_objetiveE);
        (l_startTimeOpt, l_auxFunction, l_varDecls, l_preExp) = fun_1491(Tpl.emptyTxt, i_startTimeE, l_auxFunction, l_varDecls, l_preExp);
        l_objectiveIntegrand = fun_1492(Tpl.emptyTxt, i_objectiveIntegrandE);
        l_inputBounds = fun_1495(Tpl.emptyTxt, a_simCode);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* objectiveFunction */\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefixStr, "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short * index_Dres)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_objectiveFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return  -1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "/* objectiveIntegrand */\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefixStr, "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short * index_DresB, short *index_DresC)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_objectiveIntegrand);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return -1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/* opt vars  */\n",
                                    "int "
                                }, false));
        txt = symbolName(txt, a_modelNamePrefixStr, "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real* startTimeOpt)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_inputBounds);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*startTimeOpt = data->simulationInfo.startTime - 1.0;\n"));
        txt = Tpl.writeText(txt, l_startTimeOpt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 10913, 16), "Unknown Constraint List");
      then txt;
  end match;
end optimizationComponents1;

protected function fun_1497
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("terminateHpcOmThreads();"));
      then txt;
  end match;
end fun_1497;

public function generateEntryPoint
  input Tpl.Text txt;
  input Absyn.Path a_entryPoint;
  input String a_url;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Tpl.Text txt_1;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("omc_"));
  l_name := CodegenUtil.underscorePath(l_name, a_entryPoint);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* This is an automatically generated entry point to a MetaModelica function */\n",
                                   "\n",
                                   "#include <meta/meta_modelica.h>\n",
                                   "#include <stdio.h>\n",
                                   "extern void "
                               }, false));
  out_txt := Tpl.writeText(out_txt, l_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(threadData_t*,modelica_metatype);\n",
                                       "\n",
                                       "void (*omc_assert)(threadData_t*,FILE_INFO info,const char *msg,...) __attribute__ ((noreturn)) = omc_assert_function;\n",
                                       "void (*omc_assert_warning)(FILE_INFO info,const char *msg,...) = omc_assert_warning_function;\n",
                                       "void (*omc_terminate)(FILE_INFO info,const char *msg,...) = omc_terminate_function;\n",
                                       "void (*omc_throw)(threadData_t*) __attribute__ ((noreturn)) = omc_throw_function;\n",
                                       "\n",
                                       "#ifdef _OPENMP\n",
                                       "#include<omp.h>\n",
                                       "/* Hack to make gcc-4.8 link in the OpenMP runtime if -fopenmp is given */\n",
                                       "int (*force_link_omp)(void) = omp_get_num_threads;\n",
                                       "#endif\n",
                                       "\n",
                                       "static int rml_execution_failed()\n",
                                       "{\n",
                                       "  fflush(NULL);\n",
                                       "  fprintf(stderr, \"Execution failed!\\n\");\n",
                                       "  fflush(NULL);\n",
                                       "  return 1;\n",
                                       "}\n",
                                       "\n",
                                       "int main(int argc, char **argv)\n",
                                       "{\n",
                                       "  MMC_INIT();\n",
                                       "  {\n",
                                       "  void *lst = mmc_mk_nil();\n",
                                       "  int i = 0;\n",
                                       "\n",
                                       "  for (i=argc-1; i>0; i--) {\n",
                                       "    lst = mmc_mk_cons(mmc_mk_scon(argv[i]), lst);\n",
                                       "  }\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  txt_1 := Tpl.writeText(Tpl.emptyTxt, l_name);
  txt_1 := Tpl.writeTok(txt_1, Tpl.ST_STRING("(threadData, lst);"));
  (out_txt, txt_1) := mainTop(out_txt, txt_1, a_url);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n"
                                   }, true));
  ret_2 := Flags.isSet(Flags.HPCOM);
  out_txt := fun_1497(out_txt, ret_2);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "fflush(NULL);\n",
                                       "EXIT(0);\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end generateEntryPoint;

protected function fun_1499
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_exp, in_a_res)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Tpl.Text a_res;

    case ( txt,
           "modelica_boolean",
           _,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1)"));
      then txt;

    case ( txt,
           _,
           a_exp,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = expTypeFromExpModelica(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */ "));
        txt = Tpl.writeText(txt, a_res);
      then txt;
  end match;
end fun_1499;

public function daeDimensionExp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCode.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  String str_2;
  Tpl.Text txt_1;
  Tpl.Text l_res;
algorithm
  (l_res, out_a_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
  txt_1 := expTypeFromExpModelica(Tpl.emptyTxt, a_exp);
  str_2 := Tpl.textString(txt_1);
  out_txt := fun_1499(txt, str_2, a_exp, l_res);
end daeDimensionExp;

end CodegenC;